#include "filters.h"

#include "FPort.h"
#include "interp.h"

#ifdef _HQ2X_
#include "hq2x_c.h"
#endif
#ifdef _ADMAME_
#include "admame.h"
#endif
#ifdef _SAI_
#include "2xSaI.h"
#endif


void filters_init(void) {
#ifdef _SAI_
   Init_2xSaI(565);
#endif   
#ifdef _HQ2X_   
   hq2x_init(16);
#endif   
}

void fgbZ_filterrender(u8 *screen,u8 *source,u32 offset_pitch,u32 src_pitch,u8 bfilter,u32 ws,u32 hs,u32 wd,u32 hd)
{
#ifdef _SAI_
	if ( bfilter == _2XSAI )
		_2xSaI(source, src_pitch, NULL, screen, offset_pitch, ws, hs);
	else if ( bfilter == SUPER_2XSAI )
		Super2xSaI(source, src_pitch, NULL,screen, offset_pitch, ws, hs);
	else if ( bfilter == SUPER_EAGLE )
		SuperEagle(source, src_pitch, NULL, screen, offset_pitch, ws, hs);
	else if ( bfilter == SCALE_2XSAI )
		Scale_2xSaI(source, src_pitch, NULL,screen, offset_pitch, wd, hd, ws, hs);	
#endif		
#ifdef _HQ2X_		
	if ( bfilter == HQ2X )
		hq2x(source, src_pitch, NULL, screen, offset_pitch, ws, hs);
	else if ( bfilter == LQ2X )
		lq2x(source, src_pitch, NULL, screen, offset_pitch, ws, hs);
#endif		
#ifdef _ADMAME_
	if ( bfilter == ADVMAME2X )
		AdMame2x(source,src_pitch, NULL, screen, offset_pitch, ws, hs);
#endif		
}

