#include "palmdep.h"
#include "PNOMain.h"


#include "stretch_nester.h"

typedef struct 
{
	unsigned char r;
	unsigned char g;
	unsigned char b;
} MY_RGB;


#define dest_work2 src_work
#define src_work2 dest_work

unsigned short vert_vals[3 * 32];


#define _SRC_WIDTH_ 256
#define _SRC_ZOOM_HEIGHT_ 300

MY_RGB *temp_buf=NULL;//[320 * 320];

Int32 InitStretchTables()
{
	unsigned int k;
	unsigned int n;
	unsigned int current_fraction;
	unsigned short* tempp;
	
	if (temp_buf) return 0;//1;
	
	temp_buf=(MY_RGB*)ljz_malloc(_SRC_ZOOM_HEIGHT_*_SRC_WIDTH_*sizeof(MY_RGB));
	if (!temp_buf) return 1;
	
	for (k = 0; k < 3; k++)
	{
		current_fraction = ((k + 1) << 8) / 4;
		tempp = vert_vals + (k * 32);
		for (n = 0; n < 32; n++)
			tempp[n] = (current_fraction * n) + 0x40;
	}
	return 0;
}
void DeInitStretchTables(){
	if (temp_buf) ljz_free(temp_buf);
	temp_buf=NULL;
}

#define dest_work2 src_work
#define src_work2 dest_work


void StretchNesterTrue(unsigned short* src, unsigned short* dest,UInt32 pitch_src,UInt32 pitch_dest,UInt32 height)
{
	int x;
	int y;
	unsigned int r[4];
	unsigned int g[4];
	unsigned int b[4];
	unsigned short* src_work = src;
	MY_RGB* dest_work = temp_buf;
	
	for (x = 256; x; x--)
	{
		dest_work = temp_buf + 256-x;
		src_work = src + 256-x;
		for (y = height/4; y  ; y--)
		{
			SEPERATE_RGB(src_work[0], r[0], g[0], b[0]);
			SEPERATE_RGB(src_work[1*pitch_src], r[1], g[1], b[1]);
			SEPERATE_RGB(src_work[2*pitch_src], r[2], g[2], b[2]);
			SEPERATE_RGB(src_work[3*pitch_src], r[3], g[3], b[3]);

			SEPERATE_RGB(src_work[0], dest_work[0].r, dest_work[0].g, dest_work[0].b);
			dest_work[1*_SRC_WIDTH_].r = COMBINE_VERT_VALS(0, r[0], 2, r[1]); dest_work[1*_SRC_WIDTH_].g = COMBINE_VERT_VALS(0, g[0], 2, g[1]); dest_work[1*_SRC_WIDTH_].b = COMBINE_VERT_VALS(0, b[0], 2, b[1]);
			dest_work[2*_SRC_WIDTH_].r = COMBINE_VERT_VALS(1, r[1], 1, r[2]); dest_work[2*_SRC_WIDTH_].g = COMBINE_VERT_VALS(1, g[1], 1, g[2]); dest_work[2*_SRC_WIDTH_].b = COMBINE_VERT_VALS(1, b[1], 1, b[2]);
			dest_work[3*_SRC_WIDTH_].r = COMBINE_VERT_VALS(2, r[2], 0, r[3]); dest_work[3*_SRC_WIDTH_].g = COMBINE_VERT_VALS(2, g[2], 0, g[3]); dest_work[3*_SRC_WIDTH_].b = COMBINE_VERT_VALS(2, b[2], 0, b[3]);
			SEPERATE_RGB(src_work[3*pitch_src], dest_work[4*_SRC_WIDTH_].r, dest_work[4*_SRC_WIDTH_].g, dest_work[4*_SRC_WIDTH_].b);

			dest_work += 5*_SRC_WIDTH_;
			src_work += 4*pitch_src;
		}
	}

	dest_work2 = dest;
	src_work2 = temp_buf;
	
	for (y = (height/4*5); y; y--)
	{
		for (x = 0; x < 64; x++)
		{
			dest_work2[0] = RGB555(src_work2[0].r, src_work2[0].g, src_work2[0].b);
			dest_work2[1] = RGB555(COMBINE_VERT_VALS(0, src_work2[0].r, 2, src_work2[1].r), COMBINE_VERT_VALS(0, src_work2[0].g, 2, src_work2[1].g), COMBINE_VERT_VALS(0, src_work2[0].b, 2, src_work2[1].b));
			dest_work2[2] = RGB555(COMBINE_VERT_VALS(1, src_work2[1].r, 1, src_work2[2].r), COMBINE_VERT_VALS(1, src_work2[1].g, 1, src_work2[2].g), COMBINE_VERT_VALS(1, src_work2[1].b, 1, src_work2[2].b));
			dest_work2[3] = RGB555(COMBINE_VERT_VALS(2, src_work2[2].r, 0, src_work2[3].r), COMBINE_VERT_VALS(2, src_work2[2].g, 0, src_work2[3].g), COMBINE_VERT_VALS(2, src_work2[2].b, 0, src_work2[3].b));
			dest_work2[4] = RGB555(src_work2[3].r, src_work2[3].g, src_work2[3].b);

			dest_work2 += 5;
			src_work2 += 4;
		}
		//src_work2 += pitch_src-256;
		dest_work2 += pitch_dest-320;
	}
}


void StretchNesterTrue_224(unsigned short* src, unsigned short* dest,UInt32 pitch_src,UInt32 pitch_dest,UInt32 height)
{
	int x;
	int y;
	unsigned int r[4];
	unsigned int g[4];
	unsigned int b[4];
	unsigned short* src_work = src;
	MY_RGB* dest_work = temp_buf;
	
	for (x = 224; x; x--)
	{
		dest_work = temp_buf + 224-x;
		src_work = src + 224-x;
		for (y = height/4; y  ; y--)
		{
			SEPERATE_RGB(src_work[0], r[0], g[0], b[0]);
			SEPERATE_RGB(src_work[1*pitch_src], r[1], g[1], b[1]);
			SEPERATE_RGB(src_work[2*pitch_src], r[2], g[2], b[2]);
			SEPERATE_RGB(src_work[3*pitch_src], r[3], g[3], b[3]);

			SEPERATE_RGB(src_work[0], dest_work[0].r, dest_work[0].g, dest_work[0].b);
			dest_work[1*224].r = COMBINE_VERT_VALS(0, r[0], 2, r[1]); dest_work[1*224].g = COMBINE_VERT_VALS(0, g[0], 2, g[1]); dest_work[1*224].b = COMBINE_VERT_VALS(0, b[0], 2, b[1]);
			dest_work[2*224].r = COMBINE_VERT_VALS(1, r[1], 1, r[2]); dest_work[2*224].g = COMBINE_VERT_VALS(1, g[1], 1, g[2]); dest_work[2*224].b = COMBINE_VERT_VALS(1, b[1], 1, b[2]);
			dest_work[3*224].r = COMBINE_VERT_VALS(2, r[2], 0, r[3]); dest_work[3*224].g = COMBINE_VERT_VALS(2, g[2], 0, g[3]); dest_work[3*224].b = COMBINE_VERT_VALS(2, b[2], 0, b[3]);
			SEPERATE_RGB(src_work[3*pitch_src], dest_work[4*224].r, dest_work[4*224].g, dest_work[4*224].b);

			dest_work += 5*224;
			src_work += 4*pitch_src;
		}
	}

	dest_work2 = dest;
	src_work2 = temp_buf;
	
	for (y = (height/4*5); y; y--)
	{
		for (x = 0; x < 56; x++)
		{
			dest_work2[0] = RGB555(src_work2[0].r, src_work2[0].g, src_work2[0].b);
			dest_work2[1] = RGB555(COMBINE_VERT_VALS(0, src_work2[0].r, 2, src_work2[1].r), COMBINE_VERT_VALS(0, src_work2[0].g, 2, src_work2[1].g), COMBINE_VERT_VALS(0, src_work2[0].b, 2, src_work2[1].b));
			dest_work2[2] = RGB555(COMBINE_VERT_VALS(1, src_work2[1].r, 1, src_work2[2].r), COMBINE_VERT_VALS(1, src_work2[1].g, 1, src_work2[2].g), COMBINE_VERT_VALS(1, src_work2[1].b, 1, src_work2[2].b));
			dest_work2[3] = RGB555(COMBINE_VERT_VALS(2, src_work2[2].r, 0, src_work2[3].r), COMBINE_VERT_VALS(2, src_work2[2].g, 0, src_work2[3].g), COMBINE_VERT_VALS(2, src_work2[2].b, 0, src_work2[3].b));
			dest_work2[4] = RGB555(src_work2[3].r, src_work2[3].g, src_work2[3].b);

			dest_work2 += 5;
			src_work2 += 4;
		}
		//src_work2 += pitch_src-224;
		dest_work2 += pitch_dest-280;
	}
}




#undef dest_work2
#undef src_work2
