#ifndef _SHARED_H_
#define _SHARED_H_

#include "zlib.h"



#ifdef __PALM__
//#include "TapWave.h"

#define KEY_UP    		0x00000001
#define KEY_DOWN  		0x00000002
#define KEY_LEFT  		0x00000004
#define KEY_RIGHT 		0x00000008
#define KEY_SEL   		0x00000010
#define KEY_A     		0x00000020
#define KEY_B	  		0x00000040
#define KEY_C	 		0x00000080
#define KEY_START		0x00000100
#define KEY_QUICKLOAD   0x00000200
#define KEY_QUICKSAVE   0x00000400
#define KEY_TURBO  		0x00000800
#define KEY_SCREENMODE	0x00001000
#define KEY_FRAMESKIP	0x00002000


#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "ljPRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif
#include "PNOMain.h"
#include "App_Cst.h"

#include <math.h>

#define LSB_FIRST

#define GENZ_TURBOFSKIP 15
#define AUTO_FSKIP 10
#define SKEEZIX_FSKIP 11

#define GENZ_ROMSDIR "0:/PALM/Programs/LJP/GENZ/Roms/" //"gp:\\snes\\ffmq11.zip"
#define GENZ_SAVESDIR "0:/PALM/Programs/LJP/GENZ/Saves/" //"gp:\\snes\\ffmq11.zip"


#define MAX_FRAME_SKIPPED 10


#endif


//#include <stdio.h>
//#include <math.h>


#include "types.h"
#include "macros.h"


#include "cyclone.h"
#include "m68k.h"
#include "z80.h"
#include "genesis.h"
#include "vdp.h"
#include "render.h"
#include "mem68k.h"
#include "memz80.h"
#include "membnk.h"
#include "memvdp.h"
#include "system.h"
#include "unzip.h"
#include "fileio.h"
#include "loadrom.h"
#include "io.h"
#include "sound\sound.h"
#include "fm.h"
#include "sn76496.h"
#include "osd.h"

#include "ljz_std.h"

extern struct Cyclone CycloneCPU;
extern int32 total_cycles;
extern uint32 rom_size;
extern uint8 emul_z80;

extern unsigned char *saveram; // The actual saveram buffer
extern unsigned save_start, save_len; // Start address and length
extern int save_prot, save_active; // Flags set from $A130F1
extern int genZ_cpu_cyclone;
extern int32 genZ_frameTime,genZ_framecount,genZ_specialfskip;

#endif /* _SHARED_H_ */

