#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "ljPRsc.h"

#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif


#include "PNOMain.h"


#include "App_Cst.h"

#include "lj.h"
#include "stretch_nester.h"

unsigned int g_translateBtn[20]=
{KEY_A,KEY_B,KEY_START,KEY_SELECT,
KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,
KEY_QUICKLOAD,KEY_QUICKSAVE,KEY_FRAMESKIP,
KEY_SCREENMODE,KEY_TURBO,0,0,0,0,0,0,0};
UInt32 g_confinput[20];

extern UInt32 ljp_showFPS,ljp_showBeltbar,ljp_showBattMode,ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;
extern UInt16 *lj_zodvram;
extern uint32 lj_renderingmode;
extern UInt32 device_type;

void lj_pause(int pause);
int lj_ShowMenu(void);

void ClearScreen(void);

UInt32 mStopEmulation=0;

unsigned long Run()
{
	UInt32 pollcpt=0;
	UInt32 keys,keyval;
    Int16 penX,penY;
    Boolean penDown;
    UInt32 *ftrptr;
    Int32 lastTick;
    char text[16];
    Int32 framerate = 0;
    Int32 timecpt,framecpt = 0;
    Int32 autoload_timer;
    
//    SHOW_3D_INTRO(GetTickCount)
    
	//Read the key config
	
 	FtrGet(CREATORID,FTR_OPT_INPUTCONF_ID ,(unsigned long*)&ftrptr);
	for (int i=0;i<20;i++) g_confinput[i]=ByteSwap32(ftrptr[i]);
	//
	FtrGet(CREATORID,FTR_OPT_SHOWFRAMERATE_ID ,(unsigned long*)&ljp_showFPS);
	FtrGet(CREATORID,FTR_OPT_SHOWBELTBAR_ID ,(unsigned long*)&ljp_showBeltbar);
	FtrGet(CREATORID,FTR_OPT_SHOWBATTMODE_ID ,(unsigned long*)&ljp_showBattMode);
	FtrGet(CREATORID,FTR_OPT_ISLOWRES_ID ,(unsigned long*)&ljp_isLowRes);
	FtrGet(CREATORID,FTR_OPT_CONFIRMOW_ID ,(unsigned long*)&ljp_confirmOW);
	FtrGet(CREATORID,FTR_OPT_CONFIRMSL_ID ,(unsigned long*)&ljp_confirmSL);

	//Load the Rom
	mStopEmulation=lj_loadrom();
	
	
	
	if (device_type & BF_ZODIAC) {
		lj_zodvram=(UInt16*) stubzodiacblit ( 0,0,0,0 );
		if (!lj_zodvram) menu_info("Zodiac VRAM NULL ptr!!");
	}
	
	ClearScreen();
	
	//
	//Main Loop
	//autoload?	
	if (g_pnobridge->game_rom){
		autoload_timer=5;
//		LoadStateSnss(g_pnobridge->game_rom-1,0);
	} else autoload_timer=0;
	
	timecpt=GetTickCount();
	while (!mStopEmulation)
	{
	
   	    //Read key state
	    keys = KeyCurrentState();
	    
		keyval=0;
		
			
		//check pen					
		if (!(pollcpt&3)) LJP_CHECK_MENU_ACCESS(lj_ShowMenu,lj_renderingmode>=2)
		
		//handle sys event
		if (!(pollcpt&31)) LJP_HANDLE_EVENT(lj_pause)
		
		//avoid autoff
		//every 1024 frame => 
		if (!(pollcpt&1023)) EvtResetAutoOffTimer(); 
		
		LJP_UPDATE_KEYS
			
		lj_updatevpad(keyval);
		
		if (keyval&KEY_FRAMESKIP) 
		{
			lj_changefskip();
			ClearScreen();
		}
		if (keyval&KEY_SCREENMODE) 
		{
			lj_changerendering();
			stub_DrawBeltBar();
			ClearScreen();
		}
		
		
		
		pollcpt++;

		
	
		//Emulate NES		
		lj_MainLoop();
		
		if (autoload_timer){
			if (!(--autoload_timer)) LoadStateSnss(g_pnobridge->game_rom-1,0);
		}		
		
		
		framecpt++;
		if ((lj_renderingmode<2) &&  ( (ljp_showFPS) || (ljp_showBeltbar) ))
		if (framecpt>=30) {
		  //FPS
		    UInt8 *vr;
			vr=(UInt8*)(g_pnobridge -> vram)/*+(g_pnobridge -> display_pitch)*2*/;		
			framecpt=0;
			framerate=30*1000/(GetTickCount()-timecpt+1);
			timecpt=GetTickCount();

			if (ljp_showBeltbar) {
				beltbar_draw(0,g_pnobridge -> display_height-BELTBAR_SIZE,g_pnobridge -> display_pitch,framerate,0,vr);
			} else if (ljp_showFPS) {
				for (int y=0;y<20;y++)
				{	
					memset(vr,0,80*2);
					vr+=(g_pnobridge -> display_pitch)*2;
				}
				
				text[0]=((framerate/100)%10)+48;
				text[1]=((framerate/10)%10)+48;
				text[2]=((framerate)%10)+48;
				text[3]=0;
				
				menu_messageRaw(5,0,text);
			}
		}
	}
	lj_end();
	
	if (device_type & BF_ZODIAC) {
		stubzodiacblit ( 1,0,0,0 );
	}
	
	return 0;
}



/************************************/


void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height-(lj_renderingmode<2?BELTBAR_SIZE:0);y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}