
#include "lj.h"
#include "datatypes.h"

#include "unes.h"

#include "PNOMain.h"

#include "App_Cst.h"

#include "stretch_nester.h"
#include "filters.h"

extern uint32   ppuScanline;
extern uint32 scalePal[256];
extern VirtualNES Vnes;
extern UInt32 device_type;
extern UInt32 ljp_isLowRes;

// Assertion Support

extern uint16 *lj_curRenderingScreenPtr;//,*lj_RenderingScreenPtr[2];
//extern uint32 lj_curRenderingScreenIndex;


extern uint32 lj_renderingmode;
extern uint32 lj_smoothmode;
UInt16 *lj_zodvram;

void ljp_asmfastrender(uint8 *screen,uint8 *source,int height,int pitch);
void ljp_asmfastrenderX15(uint8 *screen,uint8 *source,int height,int pitch);
void ljp_asmfastrenderX15sm(uint8 *screen,uint8 *source,int height,int pitch);

void XlatNESRender(unsigned char *src, unsigned char *dest, uint8 *nesppupal,uint32 line){
	UInt16 *fline, *tline;
	UInt16 *f, *t, *tline2, *t2;
	int x,y;

  fline = (UInt16*)lj_curRenderingScreenPtr+((240-line)>>1)*256;
  if (!ljp_isLowRes) {
	switch (lj_renderingmode)
	{
		case 0:
		case 2:	
			tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-line-(lj_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-256)>>1);			
			ljp_asmfastrender((uint8*)tline,(uint8*)fline,line,(display_pitch-256)<<1);		
			break;		
		case 1:
		case 3:							
			if (device_type&BF_ZODIAC){				
				if (lj_smoothmode&_ZOD_SMOOTHING_) {
					tline = ((UInt16*) lj_zodvram);				
					ljp_asmfastrender((uint8*)tline,(uint8*)fline,line,(480-256)<<1);
					stubzodiacblit(3,256,line,4);
					break;
				}else if (!lj_smoothmode) {
					tline = ((UInt16*) lj_zodvram);				
					ljp_asmfastrender((uint8*)tline,(uint8*)fline,line,(480-256)<<1);
					stubzodiacblit(3,256,line,0);
					break;
				}
			}
			tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-line*5/4-(lj_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-320)>>1);
			if (lj_smoothmode==0) ljp_asmfastrenderX15((uint8*)tline,(uint8*)fline,line,(display_pitch-320)<<1);
			else if (lj_smoothmode==1) ljp_asmfastrenderX15sm((uint8*)tline,(uint8*)fline,line,(display_pitch-320)<<1);
			else if (lj_smoothmode==2) StretchNesterTrue(fline,tline,256,display_pitch,line);
			else if (lj_smoothmode==3) fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,256*2,SCALE_2XSAI,256,line,320,line*5/4);
			break;		
		case 4:
			if (device_type&BF_ZODIAC){						
				if (lj_smoothmode&_ZOD_SMOOTHING_) {
					tline = ((uint16*) lj_zodvram);
					ljp_asmfastrender((uint8*)tline,(uint8*)fline,line,(480-256)<<1);
					stubzodiacblit(3,256,line,5);
					break;
				} else if (!lj_smoothmode) {
					tline = ((uint16*) lj_zodvram);
					ljp_asmfastrender((uint8*)tline,(uint8*)fline,line,(480-256)<<1);
					stubzodiacblit(3,256,line,1);
					break;
				}
			}
			if (device_type&BF_HIRESPLUS){
				tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-320/*-BELTBAR_SIZE*/)>>1) * display_pitch ) + ((display_width-480)>>1);
				if (lj_smoothmode) fgbZ_filterrender(tline,fline,display_pitch*2,256*2,SCALE_2XSAI,256,line,480,320/*-BELTBAR_SIZE*/);
			}
			break;
	}
  } else {
    tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-140-BELTBAR_SIZE)>>1) * display_pitch ) + ((display_width-160)>>1);
	fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,256*2,SCALE_2XSAI,256,line,160,140);
  }

}

void XlatNESBufferNTSC (unsigned char *src, unsigned char *dest, uint8 *nesppupal){
	XlatNESRender (src,dest,nesppupal,224);
}

void XlatNESBufferPAL (unsigned char *src, unsigned char *dest, uint8 *nesppupal){		
	XlatNESRender (src,dest,nesppupal,240);
}


void XlatNESBufferLine (unsigned char *src, unsigned char *dest,uint8 *nesppupal, uint32 scanl)
{
/*	uint8 *source = (uint8*)(src);//Vnes.var.Vbuffer + scanl*(256+16)+8);
	uint16 *destin = lj_curRenderingScreenPtr+scanl*(256);
	int j;
	for (j=0;j<256;j++)
	{
		*destin++=scalePal[nesppupal[*source++]];		
	}*/
	__asm{
		stmfd r13!,{r9,r10}
	
		ldr   r12, = scalePal		
		add	  r12,r12,r10

		
		mov   r3,#32
	 loop:			
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r5,[r12,r4,lsl #2]
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r6,[r12,r4,lsl #2]
		orr	  r5,r5,r6,lsl #16
		
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r6,[r12,r4,lsl #2]
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r7,[r12,r4,lsl #2]
		orr	  r6,r6,r7,lsl #16
		
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r7,[r12,r4,lsl #2]
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r8,[r12,r4,lsl #2]
		orr	  r7,r7,r8,lsl #16
		
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r8,[r12,r4,lsl #2]
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r9,[r12,r4,lsl #2]
		orr	  r8,r8,r9,lsl #16
		
		//write 8 pixels
		stmia r1!,{r5,r6,r7,r8}
		
		subs  r3,r3,#1
		bne   loop	
		
		ldmfd r13!,{r9,r10}
	}
	


}
void XlatNESBufferLineZ (unsigned char *src, unsigned char *dest,uint8 *nesppupal, uint32 scanl)
{
}
void XlatNESBufferLineZ16 (unsigned char *src, unsigned char *dest,uint8 *nesppupal, uint32 scanl)
{
}
void XlatNESBufferLineZ16B (unsigned char *src, unsigned char *dest,uint8 *nesppupal, uint32 scanl)
{
}
void XlatNESBufferLine16 (unsigned char *src, unsigned char *dest,uint8 *nesppupal, uint32 scanl)
{
}

void XlatNESBufferLineLazy (unsigned char *src, unsigned char *dest,uint8 *nesppupal, uint32 startscanl)
{
/*	uint8 *source = (uint8*)(src);//Vnes.var.Vbuffer + startscanl*(256+16)+8);
	uint16 *destin = lj_curRenderingScreenPtr+startscanl*(256);
	int i,j;
		
	for (i=ppuScanline-startscanl;i;i--,source+=16)
		for (j=0;j<256;j++)
		{
			*destin++=scalePal[nesppupal[*source++]];
		}  	    	*/
	__asm{
		stmfd r13!,{r9,r10}
	
		ldr   r12, = scalePal		
		add	  r12,r12,r10
		
		ldr	  r4, = ppuScanline
		ldr	  r4,[r4,r10]
		sub	  r3,r4,r3

	 loopDep:	
		mov   r10,#32
	 loop:			
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r5,[r12,r4,lsl #2]
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r6,[r12,r4,lsl #2]
		orr	  r5,r5,r6,lsl #16
		
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r6,[r12,r4,lsl #2]
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r7,[r12,r4,lsl #2]
		orr	  r6,r6,r7,lsl #16
		
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r7,[r12,r4,lsl #2]
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r8,[r12,r4,lsl #2]
		orr	  r7,r7,r8,lsl #16
		
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r8,[r12,r4,lsl #2]
		ldrb  r4,[r0],#1
		ldrb  r4,[r2,r4]
		ldr   r9,[r12,r4,lsl #2]
		orr	  r8,r8,r9,lsl #16
		
		//write 8 pixels
		stmia r1!,{r5,r6,r7,r8}
		
		subs  r10,r10,#1
		bne   loop
		subs  r3,r3,#1
		addne r0,r0,#16		
		bne	  loopDep
		
		ldmfd r13!,{r9,r10}	
		}	
}
void XlatNESBufferLineZLazy (unsigned char *src, unsigned char *dest,uint8 *nesppupal, uint32 startscanl)
{
}
