

#include "lj.h"
#include "ljPRsc.h"
#include "App_Cst.h"

#include "datatypes.h"
#include "ljohnGP.h"

#include "unes.h"
#include "unes_ppu.h"

#include "PNOMain.h"


extern VirtualNES Vnes;
extern UInt32 mStopEmulation;

void lj_pause(int pause);

// Assertion Support
static void
assert_check(int error, const char* message)
{
    if (error) {
        ErrDisplayFileLineMsg("PalmOS", (UInt16) error, message);
    }
}

#define xassert(error) {assert_check(error, #error);}

static void showError(const char* aWhat, Err aError) {
    ErrDisplayFileLineMsg("oink", (UInt16) aError, aWhat);
}


static int runcounter;

uint16 *lj_curRenderingScreenPtr/*,*lj_RenderingScreenPtr[2]*/;
uint32 lj_renderingmode,lj_smoothmode;
//uint32 lj_curRenderingScreenIndex;

UInt32 lj_padState;
UInt32 lj_flipping;

extern int fskiprate;
extern int nes_main (void);
extern long lastTick;
extern Int32 snd_stream_vol;

void InitEmuVar()
{	
	unsigned long val;
	lj_padState=0;
}

int LaunchNesEmu(void)
{    
 	InitEmuVar();    
	return nes_main();
}

int lj_loadrom(void)
{
   
	//Init vid

/*	lj_RenderingScreenPtr[0]=(uint16*)ljz_malloc(256*240*2);
	lj_RenderingScreenPtr[1]=(uint16*)ljz_malloc(256*240*2);	
	memset(lj_RenderingScreenPtr[0],0,256*240*2);
	memset(lj_RenderingScreenPtr[1],0,256*240*2);
	
	lj_curRenderingScreenIndex=0;
	lj_curRenderingScreenPtr=lj_RenderingScreenPtr[lj_curRenderingScreenIndex];
*/	
	lj_curRenderingScreenPtr=(uint16*)ljz_malloc(256*(240+6)*2);
	//for the scale2xsai
	lj_curRenderingScreenPtr+=256*3*2;
	memset(lj_curRenderingScreenPtr,0,256*240*2);	

	unsigned long val1,val2;
	FtrGet(CREATORID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(CREATORID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
	lj_renderingmode=val1;
	lj_smoothmode=val2;
	
	filters_init();
	
	if (lj_smoothmode==2){
		if (InitStretchTables()){
			menu_info("Err:InitStretchTables");
			lj_smoothmode=0;
		}
	}
			
	return LaunchNesEmu();
}

void lj_updatevpad(int pad)
{
	lj_padState=pad;
}

int lj_getvpad()
{
	return lj_padState;
}

void lj_changefskip(void)
{
	char tmp[64];
	fskiprate++;
	if (fskiprate>SKEEZIX_FSKIP) fskiprate=0;
	
	
	if (fskiprate==AUTO_FSKIP) strcpy(tmp,"Frameskip : AUTO");
	else if (fskiprate==SKEEZIX_FSKIP) strcpy(tmp,"Frameskip : Skeezix");
	else sprintf(tmp,"Frameskip : %d",fskiprate);
	menu_message(tmp);
	
	LJP_WAIT(300)
	lastTick=GetTickCount()+Vnes.var.frame_time;
	ClearScreen();
}

void lj_changerendering(void)
{
	lj_renderingmode++;	
	if (lj_renderingmode>4) lj_renderingmode=0;
	if (lj_renderingmode==2) {
		stub_fullscreen(1);
		LJP_HANDLE_EVENT(lj_pause)
	}
	if (lj_renderingmode==0) {
		stub_fullscreen(0);
		LJP_HANDLE_EVENT(lj_pause)
	}
	
/*	if (lj_renderingmode>=5) StatHide();
	if (lj_renderingmode==0) StatShow();*/
	
	menu_message("Changing screen mode");
	LJP_WAIT(300)
	lastTick=GetTickCount()+Vnes.var.frame_time;
	ClearScreen();
}

void lj_end(void)
{	
	  int val;
 	
	FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID,lj_smoothmode);	
	FtrSet(CREATORID, FTR_OPT_SOUND_ID,Vnes.var.enablesound);
	FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,Vnes.var.sndfreq);	
	FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,lj_renderingmode);	
	FtrSet(CREATORID, FTR_OPT_FSKIP_ID,fskiprate);	
	FtrSet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,snd_stream_vol/16); 
	
	CloseAll();

//	ljz_free(lj_RenderingScreenPtr[0]);
//	ljz_free(lj_RenderingScreenPtr[1]);	
	lj_curRenderingScreenPtr-=256*3*2;
	ljz_free(lj_curRenderingScreenPtr);
	
	if (lj_smoothmode==1){
		DeInitStretchTables();
	}

	
	ljz_std_showstat();  
}

void lj_pause(int pause)
{
	if (pause)
	{
	}
	else
	{
		lastTick=GetTickCount()+Vnes.var.frame_time;
	}
	ljZ_PauseAudio(pause);	
}