#include "datatypes.h"
#include "unes_mapper.h"
#include "unes.h"

extern int32 num_1k_VROM_banks;
extern int32 num_8k_ROM_banks;

/////////////////////////////////////////////////////////////////////
// Mapper 62
static void map62_Reset()
{
	set_CPU_banks(0,1,2,3);
	set_PPU_banks(0,1,2,3,4,5,6,7);
}

static void map62_MemoryWriteSaveRAM(uint32 addr, uint8 data){
	//LOG("W " << HEX(addr,4) << "  " << HEX(data,2)  << endl);
}

static void map62_MemoryWriteLow(uint32 addr, uint8 data){
	//LOG("W " << HEX(addr,4) << "  " << HEX(data,2)  << endl);
}

static void map62_MemoryWrite(uint32 addr, uint8 data)
{
	//LOG("W " << HEX(addr,4) << "  " << HEX(data,2)  << endl);
	switch(addr & 0xFF00){
		case 0x8100:
			set_CPU_bank4(data);
			set_CPU_bank5(data+1);
			break;
		case 0x8500:
			set_CPU_bank4(data);
			break;
		case 0x8700:
			set_CPU_bank5(data);
			break;
		set_PPU_bank0(data);
		set_PPU_bank1(data+1);
		set_PPU_bank2(data + 2);
		set_PPU_bank3(data + 3);
		set_PPU_bank4(data + 4);
		set_PPU_bank5(data + 5);
		set_PPU_bank6(data + 6);
		set_PPU_bank7(data + 7);
	}

}
/////////////////////////////////////////////////////////////////////

mapintf_t map62_intf =
{
   62, /* mapper number */
   "map62", /* mapper name */
   map62_Reset, /* init routine */
   NULL, /* vblank callback */
   NULL, /* hblank callback */
   map62_getstate, /* get state (snss) */
   map62_setstate, /* set state (snss) */
   NULL,  /*Read low*/
   NULL,  /*Read saveram or rom*/
   NULL,  /*Write high regs 0x4000-0x4017*/
   map62_MemoryWriteLow,  /*Write low   0x4018-0x5FFF*/
   map62_MemoryWriteSaveRAM,  /*Write saveram*/
   map62_MemoryWrite,  /*Write rom*/
   NULL,   /*Latch FDFE*/
   NULL,   /*Latch renderscreen*/
   NULL,   /*Latch Address*/
   NULL    /*SetBarcodeValue*/   
};


