/*************************************
  Little John 
  File : unes.c
  Authors : Yoyo.
  Version : 0.4
  Last update : 4th October 2003
**************************************/

#include "lj.h"
#include "ljPRsc.h"
#include "App_Cst.h"
#include "PNOMain.h"


#define UNES_TURBOFSKIP 15

#ifndef __MWERKS__

#else
#define LJ_ROMSDIR "0:/PALM/Programs/LJP/NES/Roms/" //"gp:\\snes\\ffmq11.zip"
#define LJ_SAVESDIR "0:/PALM/Programs/LJP/NES/Saves/" //"gp:\\snes\\ffmq11.zip"
#endif


#define MAX_LOST_FRAME 10
#define MAX_FRAME_SKIPPED 10


#define __timermul__ 100
#define __timerdiv__ 202

#define __skipsynchro__


//#include "LJ_logo.h"

#include "snss.h"
#include "font.h"
#include "unes.h"
#include "unes_ppu.h"
#include "unes_mapper.h"
#include "unes_io.h"
#include "nes_apu.h"
#include "unes_pal.h"
#include "ljohnGP.h"
#include "unes_crc32.h"

/*#ifndef __testing__
#include "gpfilereq.h"
#endif

#include "mygraphic.h"*/

#include "unzip.h"
#include "unes_db.h"

#include "unes_tables.h"

#ifndef __asmcpu__
static nes6502_memread _NESread[] =
{
   /* $0 - $7FF is RAM */
   { 0x0800, 0xFFFF, Rd6502 },
   { -1,     -1,     NULL }
};
static nes6502_memwrite _NESwrite[] =
{
   /* $0 - $7FF is RAM */
   { 0x0800, 0xFFFF, Wr6502 },
   { -1,     -1,     NULL }
};
static nes6502_context _NEScontext;

#endif

extern UInt32 mStopEmulation;

#ifdef __PALM__
#include "SoundMgr.h"
SndStreamRef snd_stream=NULL;
Int32 snd_stream_vol;

Err lj_sndCallBack (void *userData,SndStreamRef stream, void *buffer,UInt32 frameCount);

reg_sys_t reg_sys;


#endif

//#include "sys/stat.h"


// VNES
VirtualNES Vnes;

// Mapper
//extern Mapper_Info mapfunc;
mmc_t *mapper;
      

int ljz_AudioPaused;

static uint16 key_pressed_delay;


// Emu stuff


byte vbl;
long romsize;
char gamename[256];
int fskiprate;
int fskiprate_adj,fskiprate_adj_ratio;
int frameskipped;
int fastforward;
long framecounter;

int32 lastTick;

int frame,frameRendered;

int32 lj_speedpct;

bool framecompleted;
//bool vblank;
uint32  curscanline;
uint32  synccycles;
uint32  showFPS;
uint32 gamma;

uint32 stepbystep;
uint32 debugison;

volatile unsigned int framecount;

long beginTime;


char CurrentROMFile[256];
char shortrom_filename[256];
char lj_curVolume;
nestoy_info ninfo;

typedef struct {int crc_all;int crc;char name[255];unsigned char header1;unsigned char header2;
unsigned char rom_bank_nb;unsigned char chr_bank_nb;
char country[6];char editor[64];} t_nestoy_entry;
t_nestoy_entry tinfo;
uint8 nestoy_getinfo(uint32 crc,uint32 crcall,t_nestoy_entry *ninfo);


uint32 CYCLES_BEFORE_NMI;


pal normcolors[256],menucolors[256];
char chaine[1024];
char chaineDEB[1024];

uint32 scalePal[256];
uint32 scalePal2[256];


inline uint8 emulate_one_framePAL(void);
inline uint8 emulate_one_frameNTSC(void);

void nes_reset(void);
void CloseAll(void);
int SaveStateSnss(byte b);
int LoadStateSnss(byte b,int only_test);
void SaveSRAM(void);

void Yo_Printc(uint32 x,uint32 y,char c,uint16 *scr,int col);
void reset_asmcpu(void);
void Message (int org_x,int org_y,const char *message,uint16 *buff,int col);

extern UInt32 ljp_isLowRes, ljp_confirmOW, ljp_confirmSL;

/*****************/
#include "LJZmenu.h"
/**************************/

char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};


// Assertion Support
static void
assert_check(int error, const char* message)
{
    if (error) {
        ErrDisplayFileLineMsg("PalmOS", (UInt16) error, message);
    }
}

#define xassert(error) {assert_check(error, #error);}

static void showError(const char* aWhat, Err aError) {
    ErrDisplayFileLineMsg("oink", (UInt16) aError, aWhat);
}

extern uint16 *lj_curRenderingScreenPtr;
extern UInt32 lj_flipping;

#include "unes_ROM_correct.c"




void Cls(int col,int page)
{
	int i;
	uint16 *p=lj_curRenderingScreenPtr;
	for (i=256*240;i;i--)
		*p++=col;
}


void timertps(void) {
	
	framecount++;
}


#ifdef __PALM__
Err lj_sndCallBack (void *userData,SndStreamRef stream, void *buffer,UInt32 frameCount)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}
	apu_process(buffer,frameCount);
   	sync_apu_register();
/*	VirtualNES* vn=(VirtualNES*)userData;
	uint8 *p=(uint8*)buffer;
	uint8 *src=vn->var.sndbuffer_posCb;
	uint8 *srcend=vn->var.sndbuffer_end;
	int i=frameCount<<(vn->var.SoundStereo+vn->var.Sound16bits);
	
	if ((src+i)<=srcend)
	{
		memcpy(p,src,i);
		src+=i;
	}
	else
	{
		int j=srcend-src;
		if (j) memcpy(p,src,j);
		src=vn->var.sndbuffer;
		memcpy(p+j,src,i-j);
		src+=j;
	}		
    vn->var.sndbuffer_posCb=src;    */
    __asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}
#endif

void emu_resettimer(void) {
	lastTick=GetTickCount()+Vnes.var.frame_time*100/lj_speedpct;
}

void NES_togglesound(void) {
	char tmp[64];
	int i;
	
	ljZ_PauseAudio(1);
	
	Vnes.var.enablesound++;
	if (Vnes.var.enablesound>2) Vnes.var.enablesound=0;
	
	if (Vnes.var.enablesound==0) strcpy(tmp,"Sound : OFF");
	else if (Vnes.var.enablesound==1) strcpy(tmp,"Sound : SIM");
	else if (Vnes.var.enablesound==2) strcpy(tmp,"Sound : ON");

	menu_message(tmp);
	
	LJP_WAIT(300);
	emu_resettimer();
	
	ljZ_PauseAudio(0);
}

char NES_reset(void) {
	ljZ_PauseAudio(1);
	
	if (menu_confirm("Reset NES ?")) {nes_reset(); /*return 1;*/}
  	
  	emu_resettimer();
  	
  	ljZ_PauseAudio(0);
  	
  	return 0;
}

void NES_quicksave(void) {
	ljZ_PauseAudio(1);
	
	if (CONFIRM_SAVE) SaveStateSnss(0);;
	emu_resettimer();
	ClearScreen();
	
	ljZ_PauseAudio(0);
}

void NES_quickload(void) {
	ljZ_PauseAudio(1);

	if (LoadStateSnss(0,1))
	{
		if (CONFIRM_LOAD) LoadStateSnss(0,0);
		emu_resettimer();
		ClearScreen();
	}
	
	ljZ_PauseAudio(0);
}

void ljZ_PauseAudio(Uint8 pause)
{    
  if (pause==1)
  {
    if (snd_stream) stub_SndStreamGetVolume(snd_stream,&snd_stream_vol);  
    if (Vnes.var.enablesound==2) 
    {    
		stub_SndStreamStop(snd_stream);
		stub_SndStreamDelete(snd_stream);
		snd_stream=NULL;
    }
    ljz_AudioPaused=1;
  }
  else
  {
      ljz_AudioPaused=0;      
      if (Vnes.var.enablesound==2)
      {				
	      stub_SndStreamCreate(&snd_stream,sndOutput,Vnes.var.snd_frequency,sndInt16Little,sndMono,lj_sndCallBack,&reg_sys,1024/*Vnes.var.buffsize*/,1);
 	      stub_SndStreamStart(snd_stream);
		  stub_SndStreamSetVolume(snd_stream,snd_stream_vol);
      }     
  }
}




void GP_SetPalette()
{
  int i;
  uint32 rgamma[256],ggamma[256],bgamma[256];
  for (i=0;i<256;i++)
  {
  	rgamma[i]=gammatab[gamma][i];
  	ggamma[i]=gammatab[gamma][i];
  	bgamma[i]=gammatab[gamma][i];  	
  }

	for(i = 0 ; i < 255 ; i++) 
    {
      scalePal[i] = ((rgamma[normcolors[i].r]/8)<<11) | ((ggamma[normcolors[i].g]/4)<<5) | ((bgamma[normcolors[i].b]/8)) ;	//if LSB is cleared, the color is more clear      
    }

}

void Message (int org_x,int org_y,const char *message,uint16 *buff,int col)
{
  int l;
  int k;
  int msg_x,msg_y;

  
  if (message)
  {
      l=strlen(message);
      msg_x=org_x;
      msg_y=org_y;
      k=0;   
      while (k<l)
	{
	  if (message[k]!='\n') 
	    {
	      Yo_Printc(msg_x,msg_y,message[k],(uint16*)buff,col);
	      msg_x+=6;
	    }
	  else 
	    {
	      msg_y+=8;
	      msg_x=org_x;
	    }
	  if (msg_x>=(256-8))
	    {
	      msg_y+=8;
	      msg_x=0;
	    }
	  if (msg_y>=(240-6))
	    {
	      msg_x=0;
	      msg_y=0;	      
	    }
	  k++;
	}
    }
  
}

char Init_NES(char *RomName)
{
  int i,j,k;
  int err_code;
  long l;
  byte b;
  char sramfile[256];
  char strresult[256];
  ulong bread;
  
  FILE *f;

  memset(Vnes.PPU_patterntables,0,0x8000);
  memset(Vnes.PPU_nametables,0,0x1000);
  memset(Vnes.PPU_palette,0,0x100);
  
  memset(Vnes.CPUMemory,0,65536);  
  
  memset(Vnes.NESSRAM,0,0x10000);
  memset(Vnes.mapper_extram,0,0x10000);
  
  Vnes.sramsize=0x2000;
  Vnes.vramsize=0x2000;
  
    
  //and the mirror, according to the method choosen, 4screen not implemented yet!!!!
  if (Vnes.ROM_Header.rom_ctrl1&1)
    {
      //Vertical Vnes.var.mirroring : name table 0,1 are orginals, 2,3 are mirrors
      Vnes.var.mirroring=1;      
    }
  else
    {
      //Horizontal Vnes.var.mirroring : name table 0,2 are orginals, 1,3 are mirrors
      Vnes.var.mirroring=2;
    }
  if (Vnes.ROM_Header.rom_ctrl1&8) Vnes.var.mirroring=5;    
   
  
  

  //set vram 
  Vnes.var.vrom=0;
  
  //set low cpu page
  Vnes.CPUPageIndex[0]=Vnes.CPUMemory;
  Vnes.CPUPageIndex[1]=Vnes.CPUMemory+8192;
  Vnes.CPUPageIndex[2]=Vnes.CPUMemory+16384;  
  Vnes.CPUPageIndex[3]=Vnes.NESSRAM; //Vnes.CPUMemory+16384+8192;
  
  if (Vnes.trainer) memcpy((uint8*)(&Vnes.CPUPageIndex[3][0x1000]),(uint8*)(Vnes.rom+16),512);

    
  //  printf("  * MMC Init...");


  //if (InitMapper()) return 1;  
  mapper=(mmc_t *)mmc_create();
  if (!mapper) 
  {
	sprintf(chaine,"Mapper %d not supported\nPress a button",Vnes.Mapper_used);
  	DEBUGS(chaine);
  	
  	return 1;  
  }

  ppu_init();        

  Init_Sound();
  //  printf("ok\n");
  // Init the CPU
  
  

  #ifndef __asmcpu__        
  nes6502_getcontext(&_NEScontext);
  _NEScontext.mem_page[0]=(uint8 *)Vnes.CPUPageIndex[0];
  /*_NEScontext.mem_page[1]=(uint8 *)Vnes.CPUPageIndex[1];
  _NEScontext.mem_page[2]=(uint8 *)Vnes.CPUPageIndex[2];
  _NEScontext.mem_page[3]=(uint8 *)Vnes.CPUPageIndex[3];
  _NEScontext.mem_page[4]=(uint8 *)Vnes.CPUPageIndex[4];
  _NEScontext.mem_page[5]=(uint8 *)Vnes.CPUPageIndex[5];
  _NEScontext.mem_page[6]=(uint8 *)Vnes.CPUPageIndex[6];
  _NEScontext.mem_page[7]=(uint8 *)Vnes.CPUPageIndex[7];*/
  _NEScontext.read_handler=_NESread;
  _NEScontext.write_handler=_NESwrite;        
  nes6502_setcontext(&_NEScontext);    
  #endif   
    
  Vnes.var.DrawCframe=1;
  frameskipped=0;
	  	  
  Vnes.var.JoyPad1_BitIndex=0;
  Vnes.var.JoyPad2_BitIndex=0;	  
	
  Vnes.var.SaveRAM=Vnes.ROM_Header.rom_ctrl1&2;  
  fastforward=0;        
  //  printf("ok\n");

  //	if (Vnes.ROM_Header.rom_ctrl1&2)
  {
    //load the sram
    i=0;
    j=255;
    k=-1;
    while (RomName[i]!=0) 
      {
	if (RomName[i]=='.') j=i;
	if (RomName[i]=='/') k=i;
	if (RomName[i]=='\\') k=i;
	i++;
      }
    if (j==255) j=i;  //pas d'extension	  
    memcpy(sramfile,RomName+k+1,j+1-k-1);    
    sramfile[j+1-k-1]=0;
    strcat(sramfile,"srm");        
    
    sprintf(strresult,"%s%s",LJ_SAVESDIR,sramfile);    
    strresult[0]=lj_curVolume+'0';
    
#ifdef __PALM__	
//	DrawMessage(strresult,1);

	f = fopen(strresult, "rb");
    if (f)	
    {
		fread(Vnes.NESSRAM,0x2000,1,f);
	    Vnes.var.SaveRAM=1;
		fclose(f);
    }
    else
    {
		//DrawMessage("No sram data",0);    
    }
#endif
  } 

  return 0;
}

char Load_ROM(char *RomName)
{
  FILE *f;
  char bufc;

  unsigned long filesize;
  int i,j,k;
  ulong readsize;
  char ext[5];
  int	err_code;
  unzFile zip_file = 0;    
  char *p;
  unz_file_info unzinfo;
  char *pext; 	 	   
  char strload[256];
   
//   strcpy(strload,"Loading : ");
//   strcat(strload,shortrom_filename);
   menu_message(shortrom_filename/*strload*/);
   /*menu_waitPen(NULL,NULL,1);*/
//	unsigned long freeM,maxM;	
//	MemHeapFreeBytes(0,&freeM,&maxM);
//	StrPrintF(strload,"mem : %d %d",freeM,maxM);
//	menu_message(strload);
//	menu_waitPen(NULL,NULL,1);


  pext = (char*)yo_strrchr(RomName, '.');
  if (pext) strncpy(ext, pext, sizeof(ext));
  yo_strlwr(ext);
  if (compare(ext, ".zip") == 0)  
  {

//    DrawMessage("Loading zip",1);
  		zip_file = unzOpen(RomName);			                              
        if (!zip_file) return 1;
        
                                
        unzGoToFirstFile (zip_file);
        
            
        for (;;) 
        {
        	if (unzGetCurrentFileInfo(zip_file, &unzinfo, strload, sizeof(strload), NULL, NULL, NULL, NULL) != UNZ_OK) return 1;

         	    yo_strlwr(strload); 

                p = (char *)yo_strrchr(strload, '.');
                                
                if (compare(p, ".nes") == 0) break;
                if (compare(p, ".nsf") == 0) break;
                if (unzGoToNextFile(zip_file) != UNZ_OK) 
                {
			         unzClose (zip_file);       	
                	return 1;
                }
         }         
         unzOpenCurrentFile (zip_file);
		 romsize = unzinfo.uncompressed_size;	 	 	 
		 

  	 	 FtrPtrNew(CREATORID, FTR_ROM_ID, romsize , (void **)&Vnes.rom);
//  	 	 Vnes.rom=(uint8 *)ljz_malloc(romsize);
  	 	 
	     //unzReadCurrentFile(zip_file, Vnes.rom, romsize);
	     if (Vnes.rom)
		 {
			uint8 *ptmp;
			ptmp=(uint8*)ljz_malloc(32768);
			uint32 l=romsize;
			uint32 o=0;
			Err err;
			while (l)
			{
				if (l>=32768) 
			 	{
			 		unzReadCurrentFile(zip_file,(void*)(ptmp), 32768);			 		
			 		DmWrite(Vnes.rom,o,ptmp,32768);			 		
//			 		memcpy(Vnes.rom+o,ptmp,32768);
			 		l-=32768;
			 		o+=32768;
			 	}
			 	else if(l)	 	
			 	{
		 			unzReadCurrentFile(zip_file,(void*)(ptmp), l);		 			
		 			DmWrite(Vnes.rom,o,ptmp,l);		 			
//		 			memcpy(Vnes.rom+o,ptmp,l);
			 		l=0;		 		
			 	}
			 }	
			 ljz_free(ptmp);
		}						
				  	 	 		  	 	 
        //if(unzReadCurrentFile(zip_file, Vnes.rom, romsize) != romsize) return 1;
         unzCloseCurrentFile (zip_file);
         unzClose (zip_file);
                
  }
  else
  {

	f=fopen(RomName,"rb");		
	if (!f) {  	

  		DEBUGS("error at opening");
  		return 1;
  	}  	
	fseek(f,0,SEEK_END); //bug in palmos until now...
  	romsize=ftell(f);
  	fseek(f,0,SEEK_SET);
		  	
  	FtrPtrNew(CREATORID, FTR_ROM_ID, romsize , (void **)&Vnes.rom);
  	if (!Vnes.rom) DEBUGS("error");
  	  	  	
//  	Vnes.rom=(uint8 *)ljz_malloc(romsize);
  	if (!Vnes.rom)
  	{  		  		
		fclose(f);
  		return(2);
  	}
  	
	  	/* Read file data */
   	    uint8 *ptmp;
		ptmp=(uint8*)ljz_malloc(32768);
		int32 l=romsize;
		int32 FileSize=0;
				
		while (l)
		{
		 	fread (ptmp, 32768, 1, f);
		 	if (l>=32768)
		 	{
		  		DmWrite(Vnes.rom,FileSize,ptmp,32768);
//			 	memcpy(Vnes.rom+FileSize,ptmp,32768);
			 	
			 	FileSize+=32768;
			 	l-=32768;
			}			
			else if (l)
			{
				DmWrite(Vnes.rom,FileSize,ptmp,l);
//			 	memcpy(Vnes.rom+FileSize,ptmp,l);
			 	l=0;
			} 	
		}
		ljz_free(ptmp);		
		

	fclose(f);				
  }

  
  return 0;
}

char Open_ROM()
{
  int i,j,x,y;
  word addr;
  

  
  Vnes.romsize=romsize;      
  
  if ((Vnes.rom[0]!='N')||(Vnes.rom[1]!='E')||(Vnes.rom[2]!='S'))
    {      
      return(4);
    }    


  if (Vnes.rom[3]=='M')
    {//test for a .nsf file    	      
      Vnes.var.nsfmode=1;
      return 1;
    }     
  else Vnes.var.nsfmode=0;
  

  
  strcpy(gamename,shortrom_filename/*CurrentROMFile*/);
/*  if (Vnes.var.nsfmode) {  	          	  
  	
  }   */
  memcpy(&Vnes.ROM_Header,Vnes.rom,16);  	      
  Vnes.trainer = (Vnes.ROM_Header.rom_ctrl1&0x4?1:0);        
  /*compute crc*/
  Vnes.var.crc = 0;
  Vnes.var.crc_all = 0;  
  Vnes.var.country[0]='?';
  Vnes.var.country[1]=0;
  Vnes.var.publisher[0]='?';
  Vnes.var.publisher[1]=0;
  Vnes.var.date[0]='?';
  Vnes.var.date[1]=0;  
  if (!Vnes.var.nsfmode)
  {
  
    Vnes.var.chr_beg=Vnes.rom+16+Vnes.trainer*512+Vnes.ROM_Header.prg_rom_pages_nb*16384;
  	Vnes.var.prg_beg=Vnes.rom+16+Vnes.trainer*512;
  	Vnes.var.cart_size=(romsize-16-Vnes.trainer*512)/1024;



	
  	Vnes.var.crc = CrcCalc(Vnes.rom+16, Vnes.trainer*512+Vnes.ROM_Header.prg_rom_pages_nb * 0x4000);//, Vnes.var.crc);
  	Vnes.var.crc_all = CrcCalca(Vnes.var.chr_beg, Vnes.ROM_Header.chr_rom_pages_nb * 0x2000, Vnes.var.crc);     


	if (!nestoy_getinfo(Vnes.var.crc,Vnes.var.crc_all,&tinfo))
  	{
	  	strcpy(gamename,tinfo.name);
	  	strcpy(Vnes.var.country,tinfo.country);
	  	strcpy(Vnes.var.publisher,tinfo.editor);
//	  	strcpy(Vnes.var.date,ninfo.date);  
  		if ((Vnes.var.country[0]=='E')||(Vnes.var.country[0]=='S'))
 		{
	  		Vnes.var.fps=50;
	  		Vnes.var.frame_time=1000/Vnes.var.fps;
	  	}
	  	Vnes.ROM_Header.rom_ctrl1=tinfo.header1;
	  	Vnes.ROM_Header.rom_ctrl2=tinfo.header2;
  	}  	
	//DrawMessage("CRC Correct Settings",1);	
	

  	Crc_CorrectRomSettings();
  	
  	if (Vnes.rom[12]==0)  			
    	  Vnes.Mapper_used=(Vnes.ROM_Header.rom_ctrl1>>4)+(Vnes.ROM_Header.rom_ctrl2&0xf0);
  	else
    	  Vnes.Mapper_used=(Vnes.ROM_Header.rom_ctrl1>>4);     	
  }
  

//  DrawMessage("Allocating mem",1);	
  
  Vnes.CPUMemory=(uint8 *)ljz_malloc(65536);
  Vnes.PPU_patterntables=(uint8 *)ljz_malloc(0x8000);
  Vnes.PPU_nametables=(uint8 *)ljz_malloc(0x1000);
  Vnes.PPU_palette=(uint8*)ljz_malloc(0x100);
  
  Vnes.mapper_extram=(uint8 *)ljz_malloc(0x10000);  
  Vnes.mapper_extramsize=0;
  Vnes.NESSRAM=(uint8*)ljz_malloc(0x10000);
  


  if ( (!Vnes.CPUMemory)||(!Vnes.PPU_patterntables)||(!Vnes.PPU_nametables)||(!Vnes.PPU_palette)||
  	(!Vnes.mapper_extram)||(!Vnes.NESSRAM))
    {      
    
      return(5);
    }

  // PPU init
  
  //DrawMessage("ok",1);	
  
  return(0);
}

void SaveSRAM(void)
{
#ifdef __PALM__
  FILE *f;  
  int i,j,k;
  int err_code;
  char sramfile[256],result[256];
 
  if (Vnes.var.SaveRAM)
	{
	  //save the sram
	  i=0;
	  j=255;
	  k=-1;
	  while (CurrentROMFile[i]!=0) 
	    {
	      if (CurrentROMFile[i]=='.') j=i;
	      if (CurrentROMFile[i]=='/') k=i;
	      if (CurrentROMFile[i]=='\\') k=i;
	      i++;
	    }
	  if (j==255) j=i;  //pas d'extension
	  memcpy(sramfile,CurrentROMFile+k+1,j+1-k-1);
	  sramfile[j+1-k-1]=0;
	  strcat(sramfile,"srm");
	  	  
	  sprintf(result,"%s%s",LJ_SAVESDIR,sramfile);
	  result[0]=lj_curVolume+'0';
	  
//	  	DrawMessage(result,1);
	  
	  f = fopen(result,"wb");
	  if (!f)
	  {
	  	//gpprintf(0,48,"Error during creation",5);
	  	DEBUGS("Error during creation of SRAM file");
	  	
	  }
	  else
	  {
	  	fwrite(Vnes.NESSRAM ,0x2000,1,f);
    	fclose(f);

	  }
	}    
#endif
}

char Close_ROM(int b)
{
  //  FILE *f;
  if (b) SaveSRAM();

  mmc_destroy(&mapper);

//  if (Vnes.rom) ljz_free(Vnes.rom);
  FtrPtrFree(CREATORID, FTR_ROM_ID);


  if (Vnes.CPUMemory) ljz_free(Vnes.CPUMemory);
  if (Vnes.PPU_patterntables) ljz_free(Vnes.PPU_patterntables);
  if (Vnes.PPU_nametables) ljz_free(Vnes.PPU_nametables);
  if (Vnes.PPU_palette) ljz_free(Vnes.PPU_palette);
  if (Vnes.mapper_extram) ljz_free(Vnes.mapper_extram);
  if (Vnes.NESSRAM) ljz_free(Vnes.NESSRAM);    
  if (Vnes.var.Vbuffer) ljz_free(Vnes.var.Vbuffer);
  
  return(0);
}

void nes_reset()
{  
  Vnes.var.sramEnabled=Vnes.var.SaveRAM;	


  ppu_reset(true);    

  apu_reset();  

  mmc_reset();

  if (ppu_noLatchFunc()) Vnes.var.lazy_mode_avail=1;
  else Vnes.var.lazy_mode_avail=0;
  
  if (Vnes.var.lazy_mode_avail) Vnes.var.lazy_mode=1;
  else Vnes.var.lazy_mode=0;
  
  Vnes.var.frame_irq_enabled = 0xFF;
  Vnes.var.frame_irq_disenabled = 0;

  #ifdef __asmcpu__  

  reset_asmcpu();

  #else
  nes6502_reset();  
  #endif  

  beginTime=GetTickCount();  
  framecount=0;
  framecounter=0;  
  key_pressed_delay=0;
  
  Vnes.var.curdeccycle=0;
  Vnes.var.currentcpucycle=0;
}

extern uint32 test_yo1(void);
extern void test_yo2(uint32 val);
extern uint32 test_yo;
void LaunchEmu()
{
  long l;
  int i,j,fx;
  char chaine[512],tmp[16];
      
  /*strcpy(Vnes.var.publisher,"Unknown");
  strcpy(Vnes.var.country,"xxx");*/
  

  
  /*sprintf(chaine,"[LJZ 0.1]\nBrought to you by Yoyo\n\n%s\nSize : %dKo P-%dKo V-%dKo\nMapper : %d\n\n[ENJOY! ^=^]\nPublisher = %s Country = %s\n\n",
    gamename,Vnes.var.cart_size,Vnes.ROM_Header.prg_rom_pages_nb*16,Vnes.ROM_Header.chr_rom_pages_nb*8,Vnes.Mapper_used,
    Vnes.var.publisher,Vnes.var.country);*/
    //sprintf(chaine,"Size:%dKoP-%dKoV-%dKo Mapper:%d",
//    Vnes.var.cart_size,Vnes.ROM_Header.prg_rom_pages_nb*16,Vnes.ROM_Header.chr_rom_pages_nb*8,Vnes.Mapper_used);
//sprintf(chaine,"Size:%dKoP-%dKoV-%dKo Mapper:%d",
//    Vnes.var.cart_size,Vnes.ROM_Header.prg_rom_pages_nb*16,Vnes.ROM_Header.chr_rom_pages_nb*8,Vnes.Mapper_used);
//DEBUGS(chaine);    

//  menu_message(chaine);  
  
//  gpwait(1000);
//  DrawMessage(chaine, 0);  
//  gpwait(0);
  
        
//  lastTick=GetTickCount();
//  while (GetTickCount()-lastTick<1000);


  
  framecount=0;
  framecounter=0;    
  
  frame=0;
  l=16;  
//DEBUGS("nes reset");      
  nes_reset();          
//DEBUGS("nes reset ok");

//  Cls(0,0);

  ljZ_PauseAudio(0);  

  lastTick=GetTickCount()+Vnes.var.frame_time*100/lj_speedpct;

}

int lj_MainLoop()
{
	if (Vnes.var.fps==60) return emulate_one_frameNTSC();          	
    else return emulate_one_framePAL();
}

long JoyPad1_State()
{
  long state; 
  int ExKey;  
  state=0;

  if ((Vnes.var.padmode==0)||(Vnes.var.padmode==2)) 
  {
  	ExKey=lj_getvpad();
  	if (Vnes.var.padmode==0)
  	{
  		if(ExKey & KEY_LEFT) state|=0x40;
  		if(ExKey & KEY_UP) state|=0x10;
  		if(ExKey & KEY_RIGHT) state|=0x80;
  		if(ExKey & KEY_DOWN) state|=0x20;
  		if(ExKey & KEY_B)  
  		{  	  		
  			switch (Vnes.var.autofireB)
  			{
  				case 0:state|=2; break;
  				case 1:
  		   		if ((framecount&31)>15) state|=2;
  		   		break;
  				case 2:
  		   		if ((framecount&15)>7) state|=2;
  		   		break;
  				case 3:
  		   		if ((framecount&7)>3) state|=2;
  		   		break;  		   
			}  		
  		}
  		if(ExKey & KEY_A)  
  		{  	  		
  			switch (Vnes.var.autofireA)
  			{
  				case 0:state|=1; break;
  				case 1:
  		   		if ((framecount&31)>15) state|=1;
  		   		break;
  				case 2:	
  		   		if ((framecount&15)>7) state|=1;
  		   		break;
  				case 3:
  		   		if ((framecount&7)>3) state|=1;
  		   		break;  		   
			}  		
  		}
  	}
  	if(ExKey & KEY_START) state|=8;
  	if(ExKey & KEY_SELECT) state|=4;
  }  	

  state|=0x10000;			//1player signature  	  
  return(state);
}

long JoyPad2_State()
{
  long state; 
  int ExKey;  
  if (Vnes.var.padmode!=1) return 0x20000;
  state=0;
  state|=0x20000;			//1player signature  
  return(state);
}

void GetStateFileName(int num,char *str)
{
  char result[256];
  byte i=0,j=255,k=255,l=255;
  char chaine[256];
#ifdef __asmcpu__
  uint32 nesregs[6];
#endif

  i=0;
  j=255;
  k=-1;
  while (CurrentROMFile[i]!=0) 
  {
	if (CurrentROMFile[i]=='.') j=i;
	if (CurrentROMFile[i]=='/') k=i;
	if (CurrentROMFile[i]=='\\') k=i;
	i++;
  }
  if (j==255) j=i;  //pas d'extension	  
  memcpy(result,CurrentROMFile+k+1,j+1-k-1);    
  result[j+1-k-1]=0;
  strcat(result,"ss");
  sprintf(str,"%s%s%d",LJ_SAVESDIR,result,num);    
  str[0]=lj_curVolume+'0';
}

int SaveStateSnss(byte b)
{	
  SNSS_FILE *f;
  int err_code;
  char savename[255];
  int i;
  char chaine[256];
#ifdef __asmcpu__
  uint32 nesregs[6];
#endif

  SNSS_RETURN_CODE code;
       
  GetStateFileName(b,savename);
    
  sprintf(chaine,"Saving state to file : %s\n",savename);   
    
  code = SNSS_OpenFile (&f,savename,SNSS_OPEN_WRITE);
  if (code != SNSS_OK)
  {
	return 1;
  }
  
  menu_message("Saving");
  
//  DrawMessage("writeheader",0);              
#ifndef __asmcpu__  
  nes6502_getcontext(&_NEScontext);  
  f->baseBlock.regA=_NEScontext.a_reg;
  f->baseBlock.regX=_NEScontext.x_reg;
  f->baseBlock.regY=_NEScontext.y_reg;
  f->baseBlock.regFlags=_NEScontext.p_reg;
  f->baseBlock.regStack=_NEScontext.s_reg;
  f->baseBlock.regPc=_NEScontext.pc_reg;  
#else
  get_context(nesregs);
  f->baseBlock.regA=nesregs[0];
  f->baseBlock.regX=nesregs[1];
  f->baseBlock.regY=nesregs[2];
  f->baseBlock.regFlags=nesregs[3];
  f->baseBlock.regStack=nesregs[5];
  f->baseBlock.regPc=nesregs[4]; 
#endif
//  DrawMessage("got context",0);
  memcpy(f->baseBlock.cpuRam,Vnes.CPUPageIndex[0],0x800);  
  ppu_savestate(&(f->baseBlock));    
//  DrawMessage("got ppu",0);
  memcpy(f->baseBlock.ppuRam,Vnes.PPU_nametables,0x1000);
  memcpy(f->baseBlock.palette,Vnes.PPU_palette,0x20);
  for (i=0;i<0x20;i++)
    {
      f->baseBlock.palette[i]&=0x3f;
    }	
  f->baseBlock.mirrorState[0]=Vnes.var.ppu_mirror0;
  f->baseBlock.mirrorState[1]=Vnes.var.ppu_mirror1;
  f->baseBlock.mirrorState[2]=Vnes.var.ppu_mirror2;
  f->baseBlock.mirrorState[3]=Vnes.var.ppu_mirror3;      
//  DrawMessage("writing base block",0);    
  if ((code = SNSS_WriteBlock(f,SNSS_BASR)) != SNSS_OK)
    {
      //      printf ("Error: %s\n", getSnssErrorString (code));
      return 1;
    }
    
    
  f->vramBlock.vramSize=Vnes.vramsize;
  memcpy(f->vramBlock.vram,Vnes.PPU_patterntables,f->vramBlock.vramSize); 
//   DrawMessage("write vram block",0);
  if ((code = SNSS_WriteBlock(f,SNSS_VRAM)) != SNSS_OK)
    {  
      return 1;
    }
    
    
//   DrawMessage("write sram block",0);  
  f->sramBlock.sramSize=Vnes.sramsize;
  f->sramBlock.sramEnabled=Vnes.var.sramEnabled;
  memcpy(f->sramBlock.sram,Vnes.NESSRAM ,f->sramBlock.sramSize);
  //  printf ("writing SRAM block\n");  
  if ((code = SNSS_WriteBlock(f,SNSS_SRAM)) != SNSS_OK)
    {
      //      printf ("Error: %s\n", getSnssErrorString (code));
      return 1;
    }
    
  for (i = 0; i < 4; i ++)
    {
      f->mapperBlock.prgPages[i]=(Vnes.CPUPageIndex[i+4]-Vnes.var.prg_beg) >> 13;
    }

  for (i = 0; i < 8; i ++)
    {
      if (Vnes.PPUPageIndexProtect[i])
        f->mapperBlock.chrPages[i]=(Vnes.PPUPageIndex[i]-Vnes.var.chr_beg) >> 10;
      else
        f->mapperBlock.chrPages[i]=((Vnes.PPUPageIndex[i]-Vnes.PPU_patterntables) >> 10) | 0x8000;
    }
  
  if (mapper->intf->get_state) mapper->intf->get_state(&(f->mapperBlock));
//  DrawMessage("writing mapper block",0);  

  if ((code = SNSS_WriteBlock(f,SNSS_MPRD)) != SNSS_OK)
    {
      //      printf ("Error: %s\n", getSnssErrorString (code));
      return 1;
    }
  memcpy(f->soundBlock.soundRegisters,&Vnes.CPUMemory[0x4000],0x16);
  SNSSSaveStateSound(&(f->soundBlock));  
  
//   DrawMessage("write sound block",0);  
  if ((code = SNSS_WriteBlock(f,SNSS_SOUN)) != SNSS_OK)
	{
	  //	  printf ("Error: %s\n", getSnssErrorString (code));
	  return 1;
	}
//  DrawMessage("closing file",0);
  /* close the files */
  if ((code=SNSS_CloseFile(&f)) != SNSS_OK)
    {
      //      printf ("Error: %s\n", getSnssErrorString (code));
      return 1;
    }
    

  return 0;
}

int LoadStateSnss(byte b,int only_test)
{
  apu_t *apu;
  SNSS_FILE *f;
  char savename[255];
  int i,j,x,y,jj;
  char chaine[256];
#ifdef __asmcpu__
  uint32 nesregs[6];
#endif  

  SNSS_RETURN_CODE code;
  SNSS_BLOCK_TYPE blockType;
    
  GetStateFileName(b,savename);  
  if (only_test)
  {
  	FILE *ftest;
  	ftest=fopen(savename,"rb");
  	if (ftest)
  	{
  		fclose(ftest);
  		return 1;
  	}
  	return 0;
  }
  

  code = SNSS_OpenFile (&f,savename,SNSS_OPEN_READ);

  if (code!=SNSS_OK)
  {  
      return 1;
  }

  menu_message("Loading");

  /* iterate through each block in the file */
  if (f->headerBlock.numberOfBlocks>255) 
    {
      //printf("Load overflow\n"); 
      return 1;
    }    

   // now we are too far to not reset the nes if there is a pb   
  nes_reset();

  for (j = 0; j < f->headerBlock.numberOfBlocks; j++)
    {

      if ((code = SNSS_GetNextBlockType(&blockType,f)) != SNSS_OK)
        {
	  //          printf ("Error: %s\n", getSnssErrorString (code));
          return 1;
        }

      if ((code = SNSS_ReadBlock(f,blockType)) != SNSS_OK)
        {
	  //          printf ("Error: %s\n", getSnssErrorString (code));
          return 1;
        }

      switch (blockType)
        {
        case SNSS_BASR:
      
         // sprintf(chaine,"reading base registers block\n");	            
#ifndef __asmcpu__
          nes6502_getcontext(&_NEScontext);
	  _NEScontext.a_reg=f->baseBlock.regA;
	  _NEScontext.x_reg=f->baseBlock.regX;
	  _NEScontext.y_reg=f->baseBlock.regY;
	  _NEScontext.p_reg=f->baseBlock.regFlags;
	  _NEScontext.s_reg=f->baseBlock.regStack;
	  _NEScontext.pc_reg=f->baseBlock.regPc;	  
	  _NEScontext.int_pending = 0;
	  nes6502_setcontext(&_NEScontext);	  
#else	  	  	  
  	  nesregs[0]=f->baseBlock.regA;
  	  nesregs[1]=f->baseBlock.regX;
  	  nesregs[2]=f->baseBlock.regY;
  	  nesregs[3]=f->baseBlock.regFlags;  	  
  	  nesregs[4]=f->baseBlock.regPc;
  	  nesregs[5]=f->baseBlock.regStack;
  	  set_context(nesregs);  	  
#endif
	  memcpy(Vnes.CPUPageIndex[0],f->baseBlock.cpuRam,0x800);	  
	  ppu_loadstate(&(f->baseBlock));
	  memcpy(Vnes.PPU_nametables,f->baseBlock.ppuRam,0x1000);
	  memcpy(Vnes.PPU_palette,f->baseBlock.palette,0x20);

	  for (i=0;i<0x10;i++)
	    {
	      Vnes.PPU_palette[i]&=0x3f;
	      Vnes.PPU_palette[i+0x10]&=0x3f;
	    }

	  Vnes.var.ppu_mirror0=f->baseBlock.mirrorState[0]&0x03;
	  Vnes.var.ppu_mirror1=f->baseBlock.mirrorState[1]&0x03;
	  Vnes.var.ppu_mirror2=f->baseBlock.mirrorState[2]&0x03;
	  Vnes.var.ppu_mirror3=f->baseBlock.mirrorState[3]&0x03;
	  ppu_mirror(Vnes.var.ppu_mirror0,Vnes.var.ppu_mirror1,Vnes.var.ppu_mirror2,Vnes.var.ppu_mirror3);
          break;

        case SNSS_VRAM:
          //sprintf(chaine,"reading VRAM block, %d\n",f->vramBlock.vramSize);
	  //gpprintf (0,64,chaine,-1,-1,13);          
	  memcpy(Vnes.PPU_patterntables,(f->vramBlock.vram),f->vramBlock.vramSize);
          break;

        case SNSS_SRAM:
	  //gpprintf (0,16*5,"reading SRAM block\n",-1,-1,13);          
	  sprintf(chaine,"reading SRAM block, %d\n",f->sramBlock.sramSize);
	  //gpprintf (0,16*5,chaine,-1,-1,13);          
	  memcpy(Vnes.NESSRAM/*Vnes.CPUMemory+0x6000*/,(f->sramBlock.sram),f->sramBlock.sramSize);
	  Vnes.var.sramEnabled=f->sramBlock.sramEnabled;
          break;

        case SNSS_MPRD:
	  //gpprintf (0,16*6,"reading mapper data block\n",-1,-1,13);          	  	  
	  
      for (i = 0; i < 4; i ++)
      {
	      Vnes.CPUPageIndex[i+4]=Vnes.var.prg_beg+((uint32)f->mapperBlock.prgPages[i]<<13);
      }          
	  // set CHR pages
	  for(i = 0; i < 8; i++)
	  {
		if(f->mapperBlock.chrPages[i] & 0x8000)
		{
			// VRAM
			Vnes.PPUPageIndex[i] = Vnes.PPU_patterntables + ((uint32)(f->mapperBlock.chrPages[i] & 0x7fff) << 10);
			Vnes.PPUPageIndexProtect[i]=0;
		}
		else
		{
			// VROM
			Vnes.PPUPageIndex[i] = Vnes.var.chr_beg + ((uint32)(f->mapperBlock.chrPages[i]) << 10);
			Vnes.PPUPageIndexProtect[i]=1;			
		}
	  }	  	  	  	  
          if (mapper->intf->set_state) mapper->intf->set_state(&(f->mapperBlock));                              
                              
          #ifdef __asmcpu__
          set_cpu_bank_full(Vnes.CPUPageIndex[4],Vnes.CPUPageIndex[5],Vnes.CPUPageIndex[6],Vnes.CPUPageIndex[7]);
          #else
          nes6502_getcontext(&_NEScontext);
          nes6502_setcontext(&_NEScontext);    
          #endif                   
                             
          break;
        case SNSS_CNTR:
	  //gpprintf (0,16*7,"reading controllers block\n",-1,-1,13);          
          break;

        case SNSS_SOUN:
	  //gpprintf (0,16*8,"reading sound block\n",-1,-1,13);          
            //ResetSoundState();
            apu=apu_getcontext();
          for (i = 0; i < 0x16; i ++)
            {
	      if(i == 0x14) continue;
	      Vnes.CPUMemory[0x4000+i]=f->soundBlock.soundRegisters[i];
    		// write the DMC regs directly
    		if((i >= 0x10) && (i <= 0x13))
    		{
      			apu->apus.dmc.regs[i - 0x10] = f->soundBlock.soundRegisters[i];
    		}
    		else
    		{
      			apu_write(0x4000 + i, f->soundBlock.soundRegisters[i]);
      			apu_write_cur(0x4000 + i, f->soundBlock.soundRegisters[i]);
    		}
            }                        	  	  
                        
          break;

        default:
	  //          printf ("invalid block type\n");
          break;
        }
    }

  /* close the files */
  if ((code = SNSS_CloseFile (&f)) != SNSS_OK)
    {
      //      printf ("Error: %s\n", getSnssErrorString (code));
      return 1;
    }
//  gpprintf (0,16*10,"[Load completed]\n",2,-1,13);    
  
  return 0;
}

void Reset()
{
  Init_NES(CurrentROMFile);
}



Uint8 ProcessKey()
{
  int x,y;
  byte bouton;
  int ExKey;
  unsigned int pp,pw;
  int i;

  ExKey=lj_getvpad();
  if (ExKey & KEY_TURBO)
  {  	
  	fastforward=1;
  	//ljZ_PauseAudio(1);
  }
  else 
  {
  	if (fastforward)
  	{
  	   fastforward=0;  	   
	   framecount=0;
  	   framecounter=0;  
  	   beginTime=GetTickCount();
  	   lastTick=GetTickCount()+Vnes.var.frame_time*100/lj_speedpct;
  	}
   }
  if (ExKey & KEY_QUICKLOAD)
  {  	 
	 NES_quickload();
  }
  
  if (ExKey & KEY_QUICKSAVE)
  {
	 NES_quicksave();
  }

  return 0;
}

/*inline */byte FrameCompleted()
{
   int i,waitforframe;   
   int x,y;
   unsigned int pp,pw,dist;  
   	
   
   framecount++;
   
   if (ProcessKey()) 
   {    
	   return 1;   
   }

   if (Vnes.var.DrawCframe)
   {

	if (Vnes.var.fps==60) XlatNESBufferNTSC(NULL,NULL,NULL);
	else XlatNESBufferPAL(NULL,NULL,NULL);


	frameRendered++;	
   	if (Vnes.var.padmode==2)
   	{
   		//Draw zapper 
   		int32 x,y,xx,yy;   		   		   		
   	#ifdef __GP32__   
   		for (x=Vnes.var.zapperX-4+32;x<(Vnes.var.zapperX-1+32);x++)
   		  if (x>=32) (&gpDraw[nflip])->ptbuffer[239-Vnes.var.zapperY+x*240]=32; //white
   		for (x=Vnes.var.zapperX+2+32;x<=(Vnes.var.zapperX+4+32);x++)
   		  if( x<256+32) (&gpDraw[nflip])->ptbuffer[239-Vnes.var.zapperY+x*240]=32; //white
   		  
   		for (y=Vnes.var.zapperY-4;y<Vnes.var.zapperY-1;y++)
   		  if (y>=0) (&gpDraw[nflip])->ptbuffer[239-y+(Vnes.var.zapperX+32)*240]=32; //white
   		for (y=Vnes.var.zapperY+2;y<=Vnes.var.zapperY+4;y++)
   		  if( y<240) (&gpDraw[nflip])->ptbuffer[239-y+(Vnes.var.zapperX+32)*240]=32; //white   		   	
   	#endif
   	}   	   	   	   	
   }      

   
   /*Draw some stats*/   
   if (frame==Vnes.var.fps) //(GpTickCountGet()-beginTime>=1000)
   {
   	if (showFPS&&(!Vnes.var.scaleMode))
   	{
        i=100*1000/(GetTickCount()-beginTime+1);
		sprintf(chaine,"%2d\n%3d",frameRendered,i);

   	}
   	beginTime=GetTickCount();
   	frame=0;
   	frameRendered=0;
   }
  
   waitforframe=0;
   if (Vnes.var.enablesound)
   {			  
      if (/*(Vnes.var.DrawCframe)&&*/(Vnes.var.enablesound==2))
      {
/*    	apu_process(Vnes.var.sndbuffer_pos,Vnes.var.buffsize);    	
    	sync_apu_register();
    	Vnes.var.sndbuffer_pos+=Vnes.var.buffsize<<(Vnes.var.Sound16bits+Vnes.var.SoundStereo);
	   	if (Vnes.var.sndbuffer_pos>=Vnes.var.sndbuffer_end) Vnes.var.sndbuffer_pos-=(Vnes.var.buffsize*NBBUFFERS<<(Vnes.var.Sound16bits+Vnes.var.SoundStereo));
             
		pp=((unsigned int)Vnes.var.sndbuffer_posCb);
		pw=((unsigned int)Vnes.var.sndbuffer_pos);
		if (pw>pp) dist=(pw-pp);
		else dist=((pw+sz)-pp);	  
		dist=dist>>(Vnes.var.Sound16bits+Vnes.var.SoundStereo);	    	  

		if ( dist< Vnes.var.buffsize*NBBUFFERS/4) 
		{		  		  		
			apu_process(Vnes.var.sndbuffer_pos,Vnes.var.buffsize);    		
			sync_apu_register();
    		Vnes.var.sndbuffer_pos+=Vnes.var.buffsize<<(Vnes.var.Sound16bits+Vnes.var.SoundStereo);
	   		if (Vnes.var.sndbuffer_pos>=Vnes.var.sndbuffer_end) Vnes.var.sndbuffer_pos-=(Vnes.var.buffsize*NBBUFFERS<<(Vnes.var.Sound16bits+Vnes.var.SoundStereo));
	   		
	   		pp=((unsigned int)Vnes.var.sndbuffer_posCb);
			pw=((unsigned int)Vnes.var.sndbuffer_pos);
			if (pw>pp) dist=(pw-pp);
			else dist=((pw+sz)-pp);	  
			dist=dist>>(Vnes.var.Sound16bits+Vnes.var.SoundStereo);	    	  
		}								*/
      }   
   }

   /*on passe a la frame suivante*/
   framecounter++;
   
    
   lastTick+=Vnes.var.frame_time*100/lj_speedpct;
   
   //temp patch for fixing pause -for ex when changing volume-
   if ((int32)(lastTick-GetTickCount())>(int32)(Vnes.var.frame_time*10))
   	lastTick=GetTickCount()+Vnes.var.frame_time;
                     
   // max frames lost
   if (((int)(framecount-framecounter))>MAX_LOST_FRAME) framecount=framecounter+1; 
	 

   if (fastforward) i=UNES_TURBOFSKIP;
   else i=fskiprate;
   
   if (i==AUTO_FSKIP)
   {
   
    while ((!fastforward)&&(GetTickCount()<=lastTick)) waitforframe=2;
//    int j=lastTick-GetTickCount()+1;
//    if (j>0) {waitforframe=2; SysTaskDelay(j);}
   
   	if ((waitforframe==2)||(frameskipped>=MAX_FRAME_SKIPPED)) 
   	{   		
   		Vnes.var.DrawCframe=1;
   		frameskipped=0;   		
   	}
   	else 
   	{
   		Vnes.var.DrawCframe=0;
   		frameskipped++;
   	}   	
   }
   else
   {
   	// to avoid pb with game changing data periodically (for ex. : every 1frame/2).
   	fskiprate_adj+=fskiprate_adj_ratio;
   	if (fskiprate_adj>=100)
   	{
	   	frameskipped++;
	   	fskiprate_adj-=100;
   	}
   	
   	if (i==SKEEZIX_FSKIP) frameskipped=SKEEZIX_FSKIP;
   	
   	if ((++frameskipped)>i) 
   	{
      		Vnes.var.DrawCframe=1;
      		frameskipped-=i+1;
      		
    		while ((!fastforward)&&(GetTickCount()<=lastTick)) waitforframe=2;      		
//      		int j=lastTick-GetTickCount()+1;      		
//		    if (!fastforward&&(j>0)) {waitforframe=2; SysTaskDelay(j);}
   	}
   	else 
   	{
   		Vnes.var.DrawCframe=0;
   		if ((Vnes.var.enablesound==2)&&!fastforward)
   		{
//	   		int j=lastTick-GetTickCount()+1;
//    		if (j>0) {waitforframe=2; SysTaskDelay(j);}
	   		while ((!fastforward)&&(GetTickCount()<=lastTick)) waitforframe=2;
	   	}
	}
   }
   frame++;

   return 0;
}

inline uint8 emulate_one_frameNTSC(void)
{      

  framecompleted=false;
  //vblank=true;

  while (!framecompleted)
  {    

     curscanline=ppu_currentscanline(); 

     
  	
     Vnes.var.currentcpucycle+=Vnes.var.cpucycle;   
     Vnes.var.curdeccycle+=Vnes.var.deccycle;
     if (Vnes.var.curdeccycle>=65536)
     {
   	Vnes.var.currentcpucycle++;
   	Vnes.var.curdeccycle-=65536;
     }   
     if (Vnes.var.currentcpucycle>0) 
     {   	
   	synccycles=Vnes.var.currentcpucycle;
   	if (curscanline==241) synccycles+=CYCLES_BEFORE_NMI;
   	#ifndef __asmcpu__   	   	
   	Vnes.var.currentcpucycle-=nes6502_execute(Vnes.var.currentcpucycle);
   	if (Vnes.var.enablesound)
   	  if (sync_dmc_register(synccycles)) nes6502_pending_irq();
   	#else   

   	Vnes.var.currentcpucycle-=cpu_exec(Vnes.var.currentcpucycle);

   	if (Vnes.var.enablesound)
     	  if (sync_dmc_register(synccycles)) cpu_pending_irq();

   	#endif      
      	synccycles=0;
     }   
     

     if (mapper->intf->HSync) mapper->intf->HSync(curscanline);     
    if (Vnes.var.lazy_mode) ppu_lazy_scanlineNTSC();
	else
	  ppu_scanlineNTSC();

     

     switch (curscanline)
     {
	case 240:
		//framecompleted=true;
		if(!(Vnes.var.frame_irq_enabled & 0xC0))
		{
			#ifndef __asmcpu__			
			nes6502_pending_irq();
			#else		
			cpu_pending_irq();
			#endif
		}		
		break;
	case 241:
		//cpu vbl	
		if (mapper->intf->VSync) mapper->intf->VSync();
							
		#ifndef __asmcpu__
		Vnes.var.currentcpucycle-=nes6502_execute(CYCLES_BEFORE_NMI); //7);		
		if (ppu_vbl()) nes6502_nmi();		
		#else		
		Vnes.var.currentcpucycle-=cpu_exec(CYCLES_BEFORE_NMI); //7);
		if (ppu_vbl()) cpu_nmi();		
		#endif      		      		      		
		break;
	case 261:
		//vblank=false;
		framecompleted=true;
		break;

	}        
    
    
  }

  return FrameCompleted();            
}


inline uint8 emulate_one_framePAL(void)
{      
  framecompleted=false;
  //vblank=true;  
  while (!framecompleted)
  {  
     curscanline=ppu_currentscanline(); 
  	
     Vnes.var.currentcpucycle+=Vnes.var.cpucycle;   
     Vnes.var.curdeccycle+=Vnes.var.deccycle;
     if (Vnes.var.curdeccycle>=65536)
     {
   	Vnes.var.currentcpucycle++;
   	Vnes.var.curdeccycle-=65536;
     }   
     if (Vnes.var.currentcpucycle>0) 
     {   	
   	synccycles=Vnes.var.currentcpucycle;
   	if (curscanline==241) synccycles+=CYCLES_BEFORE_NMI;
   	#ifndef __asmcpu__   	   	
   	Vnes.var.currentcpucycle-=nes6502_execute(Vnes.var.currentcpucycle);
   	if (Vnes.var.enablesound)
   	  if (sync_dmc_register(synccycles)/*&&DPCM_IRQ*/) nes6502_pending_irq();
   	#else   
   	Vnes.var.currentcpucycle-=cpu_exec(Vnes.var.currentcpucycle);
   	if (Vnes.var.enablesound)
      	  if (sync_dmc_register(synccycles)/*&&DPCM_IRQ*/) cpu_pending_irq();
      	#endif      
      	synccycles=0;
     }   
     
     if (mapper->intf->HSync) mapper->intf->HSync(curscanline);	                 
     if (Vnes.var.lazy_mode) ppu_lazy_scanlinePAL();
	 else ppu_scanlinePAL();
     switch (curscanline)
     {
	case 240:
		//framecompleted=true;
		if(!(Vnes.var.frame_irq_enabled & 0xC0))
		{
			#ifndef __asmcpu__			
			nes6502_pending_irq();
			#else		
			cpu_pending_irq();
			#endif
		}		
		break;
	case 241:
		//cpu vbl	
		if (mapper->intf->VSync) mapper->intf->VSync();
							
		#ifndef __asmcpu__
		Vnes.var.currentcpucycle-=nes6502_execute(CYCLES_BEFORE_NMI); //7);		
		if (ppu_vbl()) nes6502_nmi();		
		#else		
		Vnes.var.currentcpucycle-=cpu_exec(CYCLES_BEFORE_NMI); //7);
		if (ppu_vbl()) cpu_nmi();		
		#endif      		      		      		
		break;
	case 311:
		//vblank=false;
		framecompleted=true;
		break;
	/*default:
		break;*/
	}
        
    
    
  }
    	        	  
  return FrameCompleted();            
}


void ShowSplash()
{
}

void InitDisplay()
{
  int i,j;  
  //8bit mode setting
  
  //makes the palette	
  for (i=0;i<64;i++)
    {
      normcolors[i].r=(palette[i].r);
      normcolors[i].g=(palette[i].g);
      normcolors[i].b=(palette[i].b);
      normcolors[i+64].r=(palette[i].r)|255;
      normcolors[i+64].g=(palette[i].g);
      normcolors[i+64].b=(palette[i].b);
      normcolors[i+128].r=(palette[i].r);
      normcolors[i+128].g=(palette[i].g)|255;
      normcolors[i+128].b=(palette[i].b);
      normcolors[i+64+128].r=(palette[i].r);
      normcolors[i+64+128].g=(palette[i].g);
      normcolors[i+64+128].b=(palette[i].b)|255;      
    }
    
  
  for (i=0;i<16;i++)
  {
  	menucolors[i].r=0;
  	menucolors[i].g=i<<4;
  	menucolors[i].b=0;  
  }
  menucolors[32].r=200;
  menucolors[32].g=200;
  menucolors[32].b=255;  
  menucolors[33].r=255;
  menucolors[33].g=255;
  menucolors[33].b=255;  
  
  menucolors[42].r=100;
  menucolors[42].g=100;
  menucolors[42].b=128;  
  menucolors[43].r=128;
  menucolors[43].g=128;
  menucolors[43].b=128;  
  menucolors[44].r=96;
  menucolors[44].g=96;
  menucolors[44].b=96;  
  
  menucolors[34].r=128;
  menucolors[34].g=100;
  menucolors[34].b=30;  
  menucolors[35].r=255;
  menucolors[35].g=210;
  menucolors[35].b=210;  
  
  menucolors[36].r=230;
  menucolors[36].g=210;
  menucolors[36].b=255;  
  
  menucolors[37].r=150;
  menucolors[37].g=100;
  menucolors[37].b=200;  
  
  menucolors[38].r=255;
  menucolors[38].g=210;
  menucolors[38].b=220;  
  
  menucolors[39].r=menucolors[38].r/2;
  menucolors[39].g=menucolors[38].g/2;
  menucolors[39].b=menucolors[38].b/2;  
  
  for (i=0;i<16;i++) 
  {
  	menucolors[64+i].r=i*16;
  	menucolors[64+i].g=i*16;
  	menucolors[64+i].b=i*16;
  	menucolors[64+i+16].r=255-i*16;
  	menucolors[64+i+16].g=255-i*16;
  	menucolors[64+i+16].b=255-i*16;
  }
  

  GP_SetPalette();
  Vnes.var.Vbuffer=(uint8 *)ljz_malloc((256+16)*240);    
    
  memset(Vnes.var.Vbuffer,0,(256+16)*240);
  
}


void nes_init()
{  
  int val;
  
  memset((char*)&Vnes,0,sizeof(Vnes));
  
  Vnes.var.cpucycle=113;
  Vnes.var.deccycle=65536*200/3;
  CYCLES_BEFORE_NMI = 1;
  Vnes.var.curdeccycle=0;
  Vnes.var.currentcpucycle=0;
  Vnes.var.debugmode=0; 
  
  lj_speedpct=100;
  
  Vnes.var.morethan8spr=0;
  Vnes.var.DrawAllLines=0;
  Vnes.var.scaleMode=0;
  Vnes.var.autofireA=0;
  Vnes.var.autofireB=0;
  Vnes.var.padmode=0;
  Vnes.var.zapperX=128;
  Vnes.var.zapperY=120;
  
  FtrGet(CREATORID,FTR_OPT_FSKIP_ID,(unsigned long*)&val); 
  fskiprate=val;//AUTO_FSKIP;  //0;
  fskiprate_adj_ratio=0;
  fskiprate_adj=0;
  Vnes.var.InterPolateSnd=0;
  Vnes.var.emupause=0;  
  Vnes.var.fps=60; //ntsc
  Vnes.var.frame_time=1000/Vnes.var.fps;
  

  FtrGet(CREATORID,FTR_OPT_SOUND_ID,(unsigned long*)&val);  
  Vnes.var.enablesound=val;
  
  
  Vnes.var.MasterVolume=127;
  
  FtrGet(CREATORID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);  
  Vnes.var.sndfreq=val;
  Vnes.var.sndfilter=2;
  
  FtrGet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,(unsigned long*)&val); 
  snd_stream_vol=val;
  if (snd_stream_vol<0) snd_stream_vol=0;
  if (snd_stream_vol>128) snd_stream_vol=128;
  snd_stream_vol*=16;  

  
  __asm 
	{
	  	ldr  r0, = reg_sys
	 	add	 r0,r0,r10
	  	str	 r9,[r0]
	  	str	 r10,[r0,#4]
	}  
  
  showFPS=0;
  gamma=0;
}

void CloseAll()
{      

      /*clear screen*/
      Cls(0,0);
      Cls(0,1);  		
      /*stop timer*/


//	if (!FrmAlert(FrmAlertSaveState)) SaveStateSnss(0);
		
      /*close soundsys*/     
      Close_SoundSys();
            	        
      /**/     
      ppu_deinit();
      
      /**/
      /*close rom*/      
      Close_ROM(1);      
}

int nes_main (void) //(int argc,char *argv[])
{
  char i;
  int j,k;
  char *ftrptr;  
  CurrentROMFile[0]=0;          
  stepbystep=0;
  debugison=0;  
  
  
  
  nes_init();        
  InitDisplay();        

  strcpy(CurrentROMFile,LJ_ROMSDIR);    
  
  {//handle categories
    	char cat[32];
	  	FtrGet(CREATORID,FTR_OPT_CATEGORY_ID ,(unsigned long*)&ftrptr);
	  	strcpy(cat,ftrptr);
  		if ( StrCaselessCompare(cat,"uNaRcHiVeD") != 0) {
  			strcat(CurrentROMFile,cat);
	  		strcat(CurrentROMFile,"/");
	  	}
	  	//FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
  	}
  
  
  FtrGet(CREATORID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);    
  
  lj_curVolume=ftrptr[0];    
  CurrentROMFile[0]=lj_curVolume+'0';
  ftrptr+=3;  
  
  strcpy(shortrom_filename,ftrptr);  
  strcat(CurrentROMFile,ftrptr);
  
//  FtrPtrFree(CREATORID, FTR_ROM_FILENAME_ID);
  

  Cls(0,0);
  Cls(0,1);
  if ((!Load_ROM(CurrentROMFile))&&(!Open_ROM())&&(!Init_NES(CurrentROMFile)))
    {                                       

      Open_SoundSys(Vnes.var.sndfreq,Vnes.var.sndfilter);
      ljz_AudioPaused=1;
      /*timer*/
      LaunchEmu();
//      CloseAll();            
      /*exit*/
      return(0);
    }
  else 
    {
    
      Close_ROM(0);
      return(1);
    }
}

void panic(void)
{
}

void asm_panic(uint32 opcode,uint32 PC,uint8 *nesstack,uint8 *pcmem)
{
	int i;
	sprintf(chaine,"PANIC : op %02X PC=%02X\nStack mem : %02X %02X %02X %02X\nPC mem : %02X %02X %02X %02X %02X %02X\n%02X %02X %02X %02X %02X %02X",
	opcode,PC,nesstack[0],nesstack[1],nesstack[2],nesstack[3],
	pcmem[-6],pcmem[-5],pcmem[-4],pcmem[-3],pcmem[-2],pcmem[-1],
	pcmem[0],pcmem[1],pcmem[2],pcmem[3],pcmem[4],pcmem[5]);


	exit(1);

}


//extern long __CodeRelocStart__[];

void reset_asmcpu(void)
{			
#ifdef __asmcpu__
	char strtmp[256];
	Vnes.NESRAM=NULL;

	init_cpu((uint8*)(&Vnes.NESRAM));		
	Vnes.CPUPageIndex[0]=Vnes.NESRAM;
	init_sram(Vnes.CPUPageIndex[3]);	
	//gm_memset(Vnes.NESSRAM,0,0x10000);
	memset(Vnes.NESRAM,0,0x7ff);	

	reset_cpu();			
#endif
}


void Cdebug_opcode(uint32 *nesreg)
{
	char tmp[16];
#ifdef __asmcpu__
	
	strcpy(chaineDEB,"A=");StrIToH(tmp,nesreg[0]>>24);StrCat(chaineDEB,tmp);
	strcat(chaineDEB," X=");StrIToH(tmp,nesreg[1]);StrCat(chaineDEB,tmp);
	strcat(chaineDEB," Y=");StrIToH(tmp,nesreg[2]);StrCat(chaineDEB,tmp);
	strcat(chaineDEB," S=");StrIToH(tmp,nesreg[4]>>24);StrCat(chaineDEB,tmp);
	strcat(chaineDEB," P=");StrIToH(tmp,nesreg[5]);StrCat(chaineDEB,tmp);
	strcat(chaineDEB," PC=");StrIToH(tmp,nesreg[3]);StrCat(chaineDEB,tmp);
	strcat(chaineDEB," r0=");StrIToH(tmp,nesreg[11]);StrCat(chaineDEB,tmp);
	strcat(chaineDEB," ADDR=");StrIToH(tmp,nesreg[7]);StrCat(chaineDEB,tmp);
#endif	

	DEBUGS(chaineDEB);
//	gpprintf(16,16,chaineDEB,0,0,0xe0);
}

void debug_info()
{  

}


/****************************************************/
/****************************************************************************/

extern uint32 lj_renderingmode;
extern uint32 lj_smoothmode;
int lj_ShowMenuGFXConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,hwsmooth,fskipval;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(19*sizeof(RectangleType));
  char tmp[16];
  

	
  scrmode=lj_renderingmode;
  smoothing=lj_smoothmode&_SMOOTH_MASK_;
  hwsmooth=lj_smoothmode&_ZOD_SMOOTHING_;

	
  fskipval=fskiprate;
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)		
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	  
	  	menu_button(10,80,(char*)"FRAMESKIP",0,&item_rect[1],2);	  
	  	menu_bar(150,80,fskipval,11,&item_rect[2]);
	  	if (fskipval==AUTO_FSKIP) strcpy(tmp,"AUTO");
	  	else if (fskipval==SKEEZIX_FSKIP) strcpy(tmp,"SKZX");
	  	else StrIToA(tmp,fskipval);
	  	menu_messageRaw(260,80,tmp);
	  
	  	menu_button(10,130,(char*)"ZOOM",0,&item_rect[3],2);
	  	menu_button(150,130,(char*)"1",((scrmode==0)||(scrmode==2)?2:1),&item_rect[4],0);
	  	menu_button(200,130,(char*)"1.25",((scrmode==1)||(scrmode==3)?2:1),&item_rect[5],0);
	  	menu_button(250,130,(char*)"WIDE",(scrmode==4?2:1),&item_rect[6],0);
	  	
	  	menu_button(10,180,(char*)"FULLSCREEN",0,&item_rect[7],2);
	  	menu_button(150,180,(char*)"OFF",(scrmode>=2?1:2),&item_rect[8],0);
	  	menu_button(200,180,(char*)"ON",(scrmode>=2?2:1),&item_rect[9],0);
	 
	  	menu_button(10,230,(char*)"SMOOTHING",0,&item_rect[10],2);
	  	menu_button(150,230,(char*)"-",((smoothing==0)&&(!hwsmooth)?2:1),&item_rect[11],4);
	  	menu_button(180,230,(char*)"1",(smoothing==1?2:1),&item_rect[12],4);
	  	menu_button(210,230,(char*)"2",(smoothing==2?2:1),&item_rect[13],4);
	  	menu_button(240,230,(char*)"3",(smoothing==3?2:1),&item_rect[14],4);
	  	menu_button(280,230,(char*)"HW",(hwsmooth?2:1),&item_rect[15],3);
	  	
	  	menu_button(10,280,(char*)"FLIPPING",0,&item_rect[16],2);
	  	menu_button(150,280,(char*)"OFF",(lj_flipping?1:2),&item_rect[17],0);
	  	menu_button(200,280,(char*)"ON",(lj_flipping?2:1),&item_rect[18],0);
	  		  	
	  	
	  	if (scr) ljp_WinScreenUnlock();
	
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[2])) {
	  	fskipval=(x-10-item_rect[2].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[4])) {
		  scrmode&=~4;
	  	  scrmode&=~1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {
		  scrmode&=~4;
	  	  scrmode|=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {
	  	  scrmode=4;
	  	  redraw=1;
	  }
	  //SCREEN MODES FULL/WIN
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {
	  	  scrmode&=~(2|4);
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) {
	  	  if (scrmode<2) scrmode|=2;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[11])&&scrmode) {
		  if (smoothing==2){DeInitStretchTables();}
	  	  smoothing=0;
	  	  hwsmooth=0;	  	  
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[12])&&scrmode) {
		  if (smoothing==2){DeInitStretchTables();}
	  	  smoothing=1;
	  	  hwsmooth=0;
	  	  redraw=1;	  	  
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[13])&&scrmode) {
	  	  if (smoothing!=2){	 
			if (InitStretchTables()){
				menu_message("Err:InitStretchTables");
			}else{
		  	  smoothing=2;
		  	  hwsmooth=0;
		  	}		
	  	  }
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[14])&&scrmode) {
		  if (smoothing==2){DeInitStretchTables();}
	  	  smoothing=3;
	  	  hwsmooth=0;
	  	  redraw=1;	  	  
	  }
	  //HW SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[15])&&scrmode) {
	  	  hwsmooth=_ZOD_SMOOTHING_;
	  	  if (smoothing==2){DeInitStretchTables();}
	  	  smoothing=0;
	  	  redraw=1;	  	  
	  }
	  
	  //FLIPPING
	  if (TEST_PEN_MENU(x,y,item_rect[17])) {
	  	  lj_flipping=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[18])) {
	  	  lj_flipping=1;
	  	  redraw=1;
	  }
	  	  
	  if (mStopEmulation) break;
  }  
  
  fskiprate=fskipval;

  lj_renderingmode=scrmode;
  lj_smoothmode=smoothing|hwsmooth;
	
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int lj_ShowMenuSNDConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=snd_stream_vol/16;
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
	  menu_button(150,80,(char*)"OFF",(Vnes.var.enablesound==0?2:1),&item_rect[2],0);
	  menu_button(200,80,(char*)"SIM",(Vnes.var.enablesound==1?2:1),&item_rect[3],0);	  
	  menu_button(250,80,(char*)"ON",(Vnes.var.enablesound==2?2:1),&item_rect[4],0);	 
	  
	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
	  menu_bar(150,120,vol,128,&item_rect[6]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(270,120,tmp);
	  
	  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  Vnes.var.enablesound=0;		  
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  Vnes.var.enablesound=1;	  	  
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  Vnes.var.enablesound=2;
		  redraw=1;
	  }	  
	  //VOLUME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x-10)*128/100;
	  	if (vol<0) vol=0;
	  	if (vol>128) vol=128;
	  	redraw=1;
	  }
	  
	  if (mStopEmulation) break;

  }  

	snd_stream_vol=vol*16;
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int lj_ShowMenuOTHERConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)  	
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"AUTO A",0,&item_rect[1],4);
	  menu_button(100,80,(char*)"OFF",(Vnes.var.autofireA==0?2:1),&item_rect[2],0);
	  menu_button(150,80,(char*)"SLW",(Vnes.var.autofireA==1?2:1),&item_rect[3],0);
	  menu_button(200,80,(char*)"MED",(Vnes.var.autofireA==2?2:1),&item_rect[4],0);
	  menu_button(250,80,(char*)"FST",(Vnes.var.autofireA==3?2:1),&item_rect[5],0);
	  
	  menu_button(10,120,(char*)"AUTO B",0,&item_rect[6],4);
	  menu_button(100,120,(char*)"OFF",(Vnes.var.autofireB==0?2:1),&item_rect[7],0);
	  menu_button(150,120,(char*)"SLW",(Vnes.var.autofireB==1?2:1),&item_rect[8],0);
	  menu_button(200,120,(char*)"MED",(Vnes.var.autofireB==2?2:1),&item_rect[9],0);
	  menu_button(250,120,(char*)"FST",(Vnes.var.autofireB==3?2:1),&item_rect[10],0);
	  
	  menu_button(10,160,(char*)"EMU SPEED",0,&item_rect[11],4);
	  menu_bar(130,160,lj_speedpct,100,&item_rect[12]);
	  StrIToA(tmp,lj_speedpct);strcat(tmp,"%");
    	menu_messageRaw(240,160,tmp);
	  
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  Vnes.var.autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  Vnes.var.autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  Vnes.var.autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  Vnes.var.autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  Vnes.var.autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  Vnes.var.autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  Vnes.var.autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  Vnes.var.autofireB=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
	  	lj_speedpct=(x-item_rect[12].topLeft.x);
	  	if (lj_speedpct>100) lj_speedpct=100;
	  	if (lj_speedpct<10) lj_speedpct=10;
	  	redraw=1;
	  }
	  
	  if (mStopEmulation) break;
  }  
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}




int lj_ShowMenuConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)  	
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(92,100,(char*)"GFX",0,&item_rect[1],2);
	  menu_button(92,150,(char*)"SOUND",0,&item_rect[2],2);
	  menu_button(92,200,(char*)"OTHER",0,&item_rect[3],2);	  
	  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	lj_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	lj_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  lj_ShowMenuOTHERConfig(savescr);
		  redraw=1;		  
	  }
	  
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}



int lj_ShowMenuSave(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
  FILE *savefile;
  	  int slot[4];
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)  	  		  	  	  	  	  	  	
	  
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  for (int i=0;i<4;i++) 
  	  	if (LoadStateSnss(i,1)) 
  	  	{
			char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			GetStateFileName(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);			
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
	  	 }	
  	  	  	  	  	  	
		 menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		 menu_button(10,50,(char*)"SAVE",0,&item_rect[1],2);
		 menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:1),&item_rect[2],1);
		 menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:1),&item_rect[3],1);
		 menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:1),&item_rect[4],1);
		 menu_button(50,200,(char*)"QUICK",(slot[0]?2:1),&item_rect[5],1);
		 if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		 if (!slot[1]||(SHOW_OVERWRITE))
	  	  {SaveStateSnss(1);result=1;  break;}
	  	  else redraw=1;
		
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (!slot[2]||(SHOW_OVERWRITE))
	  	  {SaveStateSnss(2);result=1; break;}
	  	  else redraw=1;
		 
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		 if (!slot[3]||(SHOW_OVERWRITE))
	  	  {SaveStateSnss(3);result=1;break;}
	  	  else redraw=1;
	  	 
		  
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	 if (!slot[0]||(SHOW_OVERWRITE))
	  	  {SaveStateSnss(0);result=1;break;}
	  	  else redraw=1;
		  
	  }
	  
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}



int lj_ShowMenuLoad(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
   int slot[4];
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
     
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)  	
		
  	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
      for (int i=0;i<4;i++)      
      	if (LoadStateSnss(i,1)) 
      	{      		
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			GetStateFileName(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
	  	}	
      
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"LOAD",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;

  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (slot[1])
		if (!LoadStateSnss(1,0)) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (slot[2])
		if (!LoadStateSnss(2,0)) {result=1;break;}
	  }
	  //LOAD 2
	  
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
	  	if (slot[3])
		if (!LoadStateSnss(3,0)) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
		  if (slot[0])
    	if (!LoadStateSnss(0,0)) {result=1;break;}
	  }
	  
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}

int lj_ShowSysInfos(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;								
		VFSVolumeSize(lj_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(lj_curVolume,strb,16);strb[16]=0;
		MemHeapFreeBytes(0,&freeP,&maxP);		
		
		GUI_REDRAW_BG(0)				
		
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d]",strb,lj_curVolume);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,63,str);				
		sprintf(str,"Used:%dM/%dM",usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,81,str);				
											
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM %ldK/%ldK",freeP/1024,maxP/1024);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
//		TwGfxInfoType gfxinfo;
//		gfxinfo.size=sizeof(gfxinfo);
//		TwGfxGetInfo(lj_mGfxLib,&gfxinfo);		
		//menu_button(10,130,"VRAM",6,&my_rect,4);		
		//sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		//menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);
						
    		
		menu_button(10,130,"ROM",4,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,gamename);		
		
		sprintf(str,"%dK P-%dK V-%dK",Vnes.var.cart_size,Vnes.ROM_Header.prg_rom_pages_nb*16,Vnes.ROM_Header.chr_rom_pages_nb*8);
		menu_button(10,160,"Size",4,&my_rect,4);
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,str);
	    
	    sprintf(str,"%s[%d]",mapper->intf->name,mapper->intf->number);
		menu_button(10,190,"Mapper",4,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
		menu_button(10,220,"TV",7,&my_rect,4);		
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,(Vnes.var.fps==60)?"NTSC":"PAL");
		
		menu_button(160,220,"CRC",7,&my_rect,4);
		sprintf(str,"%08X",Vnes.var.crc,Vnes.var.crc_all);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,213,str);
		sprintf(str,"%08X",Vnes.var.crc_all);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,231,str);
		
								
		menu_button(10,250,"Publisher",7,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,Vnes.var.publisher);
		menu_button(10,280,"Country",7,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,280,Vnes.var.country);
				
		
  	
	  	menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
		if (mStopEmulation) break;	  
  }  
  ljz_free(item_rect);
  return result;
}



int lj_ShowMenu()
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr,*tmpscr,*tmpdst;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;
  
  ljZ_PauseAudio(1);  
        
  scr=/*(uint8*)(g_pnobridge -> vram);*/ljp_WinScreenLock(winLockCopy);  
  savescr=(uint8*)ljz_malloc(display_height*display_width*2);  
  if (scr&&savescr)
  {
	  tmpscr=scr;
  	for (int yy=0;yy<display_height-(lj_renderingmode<2?BELTBAR_SIZE:0);yy++)
  	{
	  for (x=0;x<display_width;x++)
	  {
  		y=((uint16*)tmpscr)[x];
	  	((uint16*)tmpscr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  tmpscr+=display_pitch*2;
	}

	tmpscr=scr;
	tmpdst=savescr;
	for (int yy=0;yy<display_height;yy++)
  	{
	    memcpy(tmpdst,tmpscr,display_width*2);
	    tmpdst+=display_width*2;
	    tmpscr+=display_pitch*2;
	}
  }
  if (scr) ljp_WinScreenUnlock();
              
  for (;;)
  {  
  	if (redraw)
  	{
	  	slot0=LoadStateSnss(0,1);    
		GUI_REDRAW_BG(1)
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(10,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(180,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(10,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(180,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(10,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(180,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		menu_button(180,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		menu_button(10,250,(char*)"RESET NES",9,&item_rect[7],2);
		if (scr) ljp_WinScreenUnlock();
  	}
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  //LAUNCHER
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {lj_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (lj_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (lj_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  SaveStateSnss(0);
		  result=0;
		  break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
	  	if (slot0)
	    if (!LoadStateSnss(0,0)) {result=0;break;}
	  }
	  //RESET NES
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {if (menu_confirm("Reset NES ?")) {nes_reset(); result=0;break;}redraw=1;}
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {lj_ShowSysInfos(savescr); redraw=1;}
	  
	  if (mStopEmulation) break;
	}
  ljz_free(item_rect);
  
  if (savescr) ljz_free(savescr);
            
  ljZ_PauseAudio(0);  
  lastTick=GetTickCount()+Vnes.var.frame_time*100/lj_speedpct;
  
  return result;
}  

