//---------------------------------------------------------------------------
// NEOPOP : Emulator as in Dreamland
//
// Copyright (c) 2001-2002 by neopop_uk
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version. See also the license.txt file for
//	additional informations.
//---------------------------------------------------------------------------

/*
//---------------------------------------------------------------------------
//=========================================================================

	system_comms.c

//=========================================================================
//---------------------------------------------------------------------------

  History of changes:
  ===================

28 AUG 2002 - neopop_uk
=======================================
- Created this file to handle inter-NeoPop link-up communications.
- Added dialog box handler.
- Connect and listen operations.

30 AUG 2002 - neopop_uk
=======================================
- Tidied up the "error disconnect" messages.

04 SEP 2002 - neopop_uk
=======================================
- Will now use the dialog translation when it's full supported.

08 SEP 2002 - neopop_uk
=======================================
- Added partial support for translations.

//---------------------------------------------------------------------------
*/

#include "neopop.h"

#include "system_main.h"
#include "system_comms.h"
//#include "system_language.h"
//#include "system_config.h"

//=============================================================================

typedef struct
{
	_u8 control;
	_u8 data;
}
COMMSDATA;

/*

	The packet structure is incredibly simple, the control byte
	determines what the data byte means. It should be quite
	possible for different ports to be link-up compatible!

Control
=======
	0	= "Data" - Emulated data, return this to the emulation core.
	
	1	= "Pause" 
	
	 Data:	1	- The other system is not able to emulate right
					now, please pause, but keep checking for "UnPause" message.

			0	- The other system is ready again, un-pause!

*/

//=============================================================================


//=============================================================================

static void __cdecl comms_message(char* vaMessage,...)
{
}

static void getPort(void)
{
}

static BOOL valid_ip(char* address_str)
{
	return TRUE;
}

static void getRemoteAddress(void)
{
}

//=============================================================================

static void comms_init(void)
{
}

//=============================================================================

//-----------------------------------------------------------------------------
// comms_connect()
//-----------------------------------------------------------------------------
static void comms_connect(void)
{
}

//-----------------------------------------------------------------------------
// comms_listen()
//-----------------------------------------------------------------------------
static void comms_listen(void)
{
}

//-----------------------------------------------------------------------------
// comms_disconnect()
//-----------------------------------------------------------------------------
static void comms_disconnect(void)
{
}

//=============================================================================

void system_comms_shutdown(void)
{
}

//-----------------------------------------------------------------------------
// system_comms_pause()
//-----------------------------------------------------------------------------
void system_comms_pause(BOOL remote_enable)
{
}

//-----------------------------------------------------------------------------
// system_comms_pause_check()
//-----------------------------------------------------------------------------
void system_comms_pause_check(void)
{
}

//-----------------------------------------------------------------------------
// system_comms_read()
//-----------------------------------------------------------------------------
BOOL system_comms_read(_u8* buffer)
{
}

//-----------------------------------------------------------------------------
// system_comms_poll()
//-----------------------------------------------------------------------------
BOOL system_comms_poll(_u8* buffer)
{
		return FALSE;

}

//-----------------------------------------------------------------------------
// system_comms_write()
//-----------------------------------------------------------------------------
void system_comms_write(_u8 data)
{
}

//=============================================================================

//-----------------------------------------------------------------------------
// system_comms_connect_dialog()
//-----------------------------------------------------------------------------
void system_comms_connect_dialog(void)
{
}

//=============================================================================
