#include "neopop.h"

#ifdef __GFXRENDER_1__

#include "neopop.h"
#include "mem.h"
#include "gfx.h"

//=============================================================================

_u16 cfbb[17*256];
_u16 cfb[256*256];
_u16 cfba[17*256];

_u8 zbuffer[256];

_u16* cfb_scanline;	//set = scanline * SCREEN_WIDTH
_u8 scanline;

_u8 winx = 0, winw = SCREEN_WIDTH;
_u8 winy = 0, winh = SCREEN_HEIGHT;
_u8 scroll1x = 0, scroll1y = 0;
_u8 scroll2x = 0, scroll2y = 0;
_u8 scrollsprx = 0, scrollspry = 0;
_u8 planeSwap = 0;
_u8 bgc = 0, oowc = 0;

_u16 r,g,b;

_u8 negative;	//Negative / Positive switched?

//=============================================================================

void gfx_delayed_settings(void)
{
	//Window dimensions
	winx = ram[0x8002];
	winy = ram[0x8003];
	winw = ram[0x8004];
	winh = ram[0x8005];

	//Scroll Planes (Confirmed delayed)
	scroll1x = ram[0x8032];
	scroll1y = ram[0x8033];
	scroll2x = ram[0x8034];
	scroll2y = ram[0x8035];

	//Sprite offset (Confirmed delayed)
	scrollsprx = ram[0x8020];
	scrollspry = ram[0x8021];

	//Plane Priority (Confirmed delayed)
	planeSwap = ram[0x8030] & 0x80;

	//Background colour register (Confirmed delayed)
	bgc = ram[0x8118];

	//2D Control register (Confirmed delayed)
	oowc = ram[0x8012] & 7;
	negative = ram[0x8012] & 0x80;
}


_u16	rbg2rgbi[4096];

// On verra la correction gamma plus tard
void gfx_table_init(void)
{
	int i;
	for ( i=0;i<4096;i++ )
	{
		int	r = (i&0xF)<<12;
		int	b = (i&0xF00)>>6;
		int	g = (i&0xF0)<<3;
		rbg2rgbi[i] = (r|g|b)|0x843;
	}
}

extern void n2gold(unsigned short *map,unsigned int *cfb );
extern void n2gt(unsigned short *map,unsigned int *cfb,unsigned short* colormap );

static int gammacoor = 0;

void n2g(unsigned short *map,unsigned int *cfb)
{
	//n2gold(map,cfb);
	
	if ( gammacoor==0 )
	{
		gfx_table_init();
		gammacoor = 1;
	}
	n2gt( map, cfb, rbg2rgbi );
	
}
//=============================================================================
#endif
