  AREA mem, CODE, READONLY

  CODE32
  IMPORT adr_trans_tab
  ;IMPORT _pc

  ; +++-----------------------------------------------------------------+++
  ; +     loadB                                                           +
  ; +                                                                     +
  ; +   IN  : r0 = adress                                                 +
  ; +   OUT : r0 = Byte data                                              +
  ; +++-----------------------------------------------------------------+++
  EXPORT loadB

loadB
  ; Save the registers ro to r3.
  ;//poke :stmfd sp!, {lr}

  ; Load the adress of adr_trans_tab global variable
  ldr r1, =adr_trans_tab

  and r2, r0, #0xf00000	;//R2=page d'adresse
  mov r0, r0, lsl #12	;//R0 = adresse en haut

  ; base addr
  ldr r3, [r1, r2, lsr #18]	;//Dans R3 la base mmoire du bitard
  cmn r2, #0
  cmpeq r0, #0xc000000
  movhs r3, #0

  cmp r2, #0xf00000
  bne loadB_1
  cmp r0, #0xf0000000
  movlo r3, #0
  bic r0, r0, #0xf0000000

loadB_1
  movs r1, r3
  ldrneb r1, [r3, r0, lsr #12]

  ; to cast to 8 bits
  and r0, r1, #0xff

  ;//poke :ldmfd sp!, {pc}
  mov pc,lr


  ; +++-----------------------------------------------------------------+++
  ; +     loadW                                                           +
  ; +                                                                     +
  ; +   IN  : r0 = adress                                                 +
  ; +   OUT : r0 = Word data                                              +
  ; +++-----------------------------------------------------------------+++
  EXPORT loadW

loadW
  ; Save the registers r0 to r4.
  ;//poke :stmfd sp!, {r4, lr}

  ; Load the adress of adr_trans_tab global variable
  ldr r1, =adr_trans_tab

  and r2, r0, #0xf00000
  mov r0, r0, lsl #12

  ; base addr
  ldr r3, [r1, r2, lsr #18]
  cmn r2, #0
  cmpeq r0, #0xc000000
  movhs r3, #0

  cmp r2, #0xf00000
  bne loadW_1

  cmp r0, #0xf0000000
  movlo r3, #0
  bic r0, r0, #0xf0000000

loadW_1
  movs r1, r3
  beq loadW_2

  add r3, r3, r0, lsr #12
  tst r3, #1
  ldreqh r1, [r3]
  ldrneb r1, [r3], #1
  ldrneb r3, [r3]
  orrne r1, r1, r3, lsl #8

loadW_2
  ; to cast to 16 bits
  mov r0, r1, lsl #16
  mov r0, r0, lsr #16

;  //poke :ldmfd sp!, {r4, pc}
  mov pc,lr

  ; +++-----------------------------------------------------------------+++
  ; +     loadL                                                           +
  ; +                                                                     +
  ; +   IN  : r0 = adress                                                 +
  ; +   OUT : r0 = DWord data                                             +
  ; +++-----------------------------------------------------------------+++
  EXPORT loadL

loadL
  ; Save the registers r0 to r4.
  ;//poke :stmfd sp!, {r4, lr}

  and r2, r0, #0xf00000
  mov r1, r0, lsl #12
    
  ; Load the adress of adr_trans_tab global variable
  ldr r0, =adr_trans_tab
  cmn r2, #0

  ldr r3, [r0, r2, lsr #18 ]
  cmpeq r1, #0xc000000
  
  movhs r3, #0
  cmp r2, #0xf00000
  bne loadL_1
  
  cmp r1, #0xf0000000
  movlo r3, #0
  
  bic r1, r1, #0xf0000000  
  
loadL_1
  movs r0, r3
  beq loadL_2

  tst r1, #0x3000
  ldreq r0, [r3, r1, lsr #12]
  beq loadL_2
  
  ldrb r1, [r3, r1, lsr #12]!
  ldrb r0, [r3, #1]!
  orr r1, r1, r0, lsl #8
  ldrb r0, [r3, #1]!
  orr r0, r1, r0, lsl #16
  ldrb r1, [r3, #1]
  orr r0, r0, r1, lsl #24

loadL_2
  ;//poke :ldmfd sp!, {r4, pc}
  mov pc,lr

  END
