#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "ljPRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif
#include "PNOMain.h"
#include "App_Cst.h"


/**********************************************/
// To be defined in emulation module sources
// look other modules for examples 
/**********************************************/
#include "smsgg_main.h"
extern UInt32 smsgg_renderingmode;
extern UInt16 *smsgg_zodvram;
extern UInt32 smsgg_enabledSound,smsgg_sndfreq;
int smsgg_ShowMenu(void);
void smsgg_pause(int pause);
void smsgg_end(void);
int smsgg_loadrom(void);
void smsgg_MainLoop(void);
void smsgg_updatevpad(int key);
void smsgg_changefskip(void);
void smsgg_changerendering(void);
/**********************************************/
/**********************************************/

// BUTTONS translation stuff
unsigned int g_translateBtn[20]=
{KEY_A,KEY_B,KEY_START,
KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,
KEY_QUICKLOAD,KEY_QUICKSAVE,KEY_FRAMESKIP,
KEY_SCREENMODE,KEY_TURBO,0,0,0,0,0,0,0,0};
unsigned int g_confinput[20];

void ClearScreen(void);

UInt32 mStopEmulation=0;
extern UInt32 ljp_showFPS,ljp_showBeltbar,ljp_showBattMode,ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;
extern UInt32 device_type;



unsigned long Run()
{
	Int32 lastTick;
	UInt32 pollcpt=0;
	UInt32 keys,keyval;
    Int16 penX,penY;
    Boolean penDown;    
	//Read the key config
	UInt32 *ftrptr;
	int val;
    char text[16];
    Int32 framerate = 0;
    Int32 timecpt,framecpt = 0;
    
//    DEBUGS("SMS/GG emulator started succesfully!");
//	menu_message("SMS/GG started succesfully!");
//	menu_waitPen(NULL,NULL,1);
	//return;
	
 	FtrGet(CREATORID,FTR_OPT_INPUTCONF_ID ,(unsigned long*)&ftrptr);
	for (int i=0;i<20;i++) g_confinput[i]=ByteSwap32(ftrptr[i]);
	
	FtrGet(CREATORID,FTR_OPT_SHOWFRAMERATE_ID ,(unsigned long*)&ljp_showFPS);
	FtrGet(CREATORID,FTR_OPT_SHOWBELTBAR_ID ,(unsigned long*)&ljp_showBeltbar);
	FtrGet(CREATORID,FTR_OPT_SHOWBATTMODE_ID ,(unsigned long*)&ljp_showBattMode);
	FtrGet(CREATORID,FTR_OPT_ISLOWRES_ID ,(unsigned long*)&ljp_isLowRes);
	FtrGet(CREATORID,FTR_OPT_CONFIRMOW_ID ,(unsigned long*)&ljp_confirmOW);
	FtrGet(CREATORID,FTR_OPT_CONFIRMSL_ID ,(unsigned long*)&ljp_confirmSL);
	
	//menu_message(ljp_showBattMode+'0');menu_waitPen(1,1,NULL);
	
	FtrGet(CREATORID,FTR_OPT_SOUND_ID ,(unsigned long*)&val);
	smsgg_enabledSound=(UInt32)val;
	if (smsgg_enabledSound) {
		FtrGet(CREATORID,FTR_OPT_SOUNDFREQ_ID ,(unsigned long*)&val);
		if (val==1) smsgg_sndfreq=22050;
		else if (val==2) smsgg_sndfreq=11025;
		else smsgg_sndfreq=44100;	
	}
	//
	//Load the Rom
	mStopEmulation=smsgg_loadrom();
		
	if (smsgg_enabledSound) {
		//char tmp[32];		
		//sprintf(tmp,"%d",smsgg_sndfreq);menu_message(tmp);menu_waitPen(NULL,NULL,1);
		
    	system_init(smsgg_sndfreq);
		
//		menu_message("Started with sound ON");menu_waitPen(NULL,NULL,1);
	} else {
//		snd.enabled = false;
		system_init(0);
		
//		menu_message("Started with sound OFF");menu_waitPen(NULL,NULL,1);
	}
	
	//system_init();
	
	if (device_type & BF_ZODIAC) {
		smsgg_zodvram=(UInt16*) stubzodiacblit ( 0,0,0,0 );
		if (!smsgg_zodvram) menu_info("Zodiac VRAM NULL ptr!!");
	}

	ClearScreen();
	//
	//Main Loop
	
	//autoload?
	if (g_pnobridge->game_rom){
		state_load(g_pnobridge->game_rom-1,0);
	}
	
	
	timecpt=GetTickCount();
	emu_resettimer();
	while (!mStopEmulation)
	{
	
   	    //Read key state
	    keys = KeyCurrentState();
	    
		keyval=0;

		//check pen
		if (!(pollcpt&3)) LJP_CHECK_MENU_ACCESS(smsgg_ShowMenu,smsgg_renderingmode>=2)
		
		//handle sys event
		if (!(pollcpt&31)) LJP_HANDLE_EVENT(smsgg_pause)
		
		//avoid autoff
		//every 1024 frame => 
		if (!(pollcpt&1023)) EvtResetAutoOffTimer(); 
		
		LJP_UPDATE_KEYS
		
		smsgg_updatevpad(keyval);
		
		if (keyval&KEY_FRAMESKIP) 
		{
			smsgg_changefskip();
			ClearScreen();
		}
		if (keyval&KEY_SCREENMODE) 
		{
			smsgg_changerendering();
			stub_DrawBeltBar();
			ClearScreen();
		}
		
		pollcpt++;
		
	
		//Emulate of 1 frame
		
		smsgg_MainLoop();
		
		framecpt++;
		if ((smsgg_renderingmode<2) &&  ( (ljp_showFPS) || (ljp_showBeltbar) ))
		if (framecpt>=30) {
		  //FPS
		    UInt8 *vr;
			vr=(UInt8*)(g_pnobridge -> vram)/*+(g_pnobridge -> display_pitch)*2*/;		
			framecpt=0;
			framerate=30*1000/(GetTickCount()-timecpt+1);
			timecpt=GetTickCount();

			if (ljp_showBeltbar) {
				beltbar_draw(0,g_pnobridge -> display_height-BELTBAR_SIZE,g_pnobridge -> display_pitch,framerate,0,vr);
			} else if (ljp_showFPS) {
				for (int y=0;y<20;y++)
				{	
					memset(vr,0,80*2);
					vr+=(g_pnobridge -> display_pitch)*2;
				}
				
				text[0]=((framerate/100)%10)+48;
				text[1]=((framerate/10)%10)+48;
				text[2]=((framerate)%10)+48;
				text[3]=0;
				
				menu_messageRaw(5,0,text);
			}
		}
	}

	smsgg_end();
	
	if (device_type & BF_ZODIAC) {
		stubzodiacblit ( 1,0,0,0 );
	}


	return 0;
}



/************************************/


void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height-(smsgg_renderingmode<2?BELTBAR_SIZE:0);y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}
