/*
    loadrom.c --
    File loading and management.
*/

#include "palmdep.h"
#include "pnobridge.h"
#include "App_Cst.h"

#define stricmp StrCaselessCompare

#include "./sms_shared.h"

extern char game_type;

//extern t_cart cart;

char game_name[1024];

typedef uint8 byte;

int load_rom(char *romfile) {
	int *d; 
	long romsize;
	char str[256];
	FILE *f;
	char gb_file[256];
	  char ext[5];
	  int	err_code;
	  unzFile zip_file = 0;    
	  unz_file_info unzinfo;
	  char *pext;
	 char *p,*pp;	
	 
	 char game_typ; //1=GG 2=SMS
	 
	pext = (char*)strchr(romfile, '.');
	while (p = (char *)strchr(pext+1, '.'))
	{
       	pext=p;
    }
	
  	if (pext) strncpy(ext, pext, sizeof(ext));
  	strlwr(ext);
  	

  	if (StrCompare(ext, ".zip") == 0)  
  	{  	  	
	  	zip_file = unzOpen(romfile);			                              
        if (!zip_file) {
        	menu_message("error at opening ZIP");menu_waitPen(NULL,NULL,1);
  			return NULL;
  		}
        unzGoToFirstFile (zip_file);                    
        for (;;) 
        {
        	if (unzGetCurrentFileInfo(zip_file, &unzinfo, gb_file, sizeof(gb_file), NULL, NULL, NULL, NULL) != UNZ_OK) return NULL;

         	    strlwr(gb_file); 
                p = (char *)strchr(gb_file, '.');
                while (pp = (char *)strchr(p+1, '.'))
                {
                	p=pp;
                }
                if (strcmp(p, ".gg") == 0) {
                	game_typ=1;
                	break;
                }
                if (strcmp(p, ".sms") == 0) {
                	game_typ=2;
                	break;
                }
                if (unzGoToNextFile(zip_file) != UNZ_OK) return NULL;
         }         
         unzOpenCurrentFile (zip_file);

	 	romsize = unzinfo.uncompressed_size;	 	 	 
		/*d=(uint8 *)ljz_malloc(romsize);*/
		FtrPtrNew(CREATORID, FTR_ROM_ID, romsize , (void **)&d);
		
		strcpy(game_name, gb_file);
		
		/*unzReadCurrentFile(zip_file, d, romsize);         */				
		if (d)
		{
			uint8 *ptmp;
			ptmp=(uint8*)ljz_malloc(65536);
			uint32 l=romsize;
			uint32 o=0;
			while (l)
			{
				if (l>65536) 
			 	{
			 		unzReadCurrentFile(zip_file,(void*)(ptmp), 65536);
			 		DmWrite(d,o,ptmp,65536);
			 		l-=65536;
			 		o+=65536;
			 	}
			 	else		 	
			 	{
		 			unzReadCurrentFile(zip_file,(void*)(ptmp), l);
		 			DmWrite(d,o,ptmp,l);
			 		l=0;		 		
			 	}
			 }
			 ljz_free(ptmp);
		}						
	    unzCloseCurrentFile (zip_file);
	    unzClose (zip_file);  	
	}
	else
	{
		if (strcmp(ext, ".gg") == 0) {
        	game_typ=1;
        }
        if (strcmp(ext, ".sms") == 0) {
        	game_typ=2;
        }
		
		
	    f=fopen(romfile,"rb");		
  		if (!f) {  	
	  		//GpTextOut(NULL,&gpDraw[nflip],160,10,(char*)"File access error",0xe0);
	  		//	DrawMessage("error at opening",1);
	  		menu_message("error at opening");menu_waitPen(NULL,NULL,1);
  			return NULL;
		}  	
		fseek(f,0,SEEK_END); //bug in palmos until now...
	  	romsize=ftell(f);
	  	fseek(f,0,SEEK_SET);		
  	
	  	//d=(byte *)ljz_malloc(romsize);
	  	FtrPtrNew(CREATORID, FTR_ROM_ID, romsize , (void **)&d);
	  	if (d)
	  	{
		  	/* Read file data */
    	    uint8 *ptmp;
			ptmp=(uint8*)ljz_malloc(65536);
			int32 l,FileSize=0;
			while (1)
			{
			 	l=fread (ptmp, 1, 65536, f);
			 	if (l>=0)
			 	{		 		
				 	DmWrite(d,FileSize,ptmp,l);
				 	FileSize+=l;
				}			 	
			 	if (l<65536) break;
			}
			ljz_free(ptmp);	
		}	  		  	
  		else
	  	{  		  		
			fclose(f);
			menu_message("error: NULL pointer");menu_waitPen(NULL,NULL,1);
  			return NULL;
	  	}		
		fclose(f);			
		
	}
	//*len=romsize;		
	//return (int)d;
	
	/* Don't load games smaller than 32k */
    if(romsize < 0x8000) {
    	if (d) FtrPtrFree(CREATORID, FTR_ROM_ID);
    	return 0;
    }

    /* Take care of image header, if present */
    if((romsize / 512) & 1)
    {
        romsize -= 512;
        //fseek(f, 512, SEEK_SET);
        d += 512;
    }

    cart.pages = (romsize / 0x4000);
    cart.rom=d;
    //cart.rom = MemGluePtrNewL ( romsize );
    if(!cart.rom) return 0;
    //fread(cart.rom, size, 1, f);
//    memcpy(cart.rom,d,romsize);
	
	
	//if ( ( StrStr(/*strrchr(*/game_name/*, '.')*/, ".gg") == 0 ) ||
	// ( StrStr ( game_name, ".GG" ) == 0 ) )
	if (game_typ == 1)
    {
      cart.type = TYPE_GG;
      game_type = TYPE_GG;
//      menu_message ( "Game is GG" ); menu_waitPen(NULL, NULL, 1);
    } else {
      cart.type = TYPE_SMS;
      game_type = TYPE_SMS;
//      menu_message ( "Game is SMS" ); menu_waitPen(NULL, NULL, 1);
    }
	
	return 1;
}

int load_rom_original(char *filename)
{
    int size;

#if 0
    if(stricmp(strrchr(filename, '.'), ".zip") == 0)
    {
        char name[0x100];

        cart.rom = loadzip(filename, name, &size);
        if(!cart.rom) return 0;
        strcpy(game_name, name);

        /* Take care of image header, if present */
        if((size / 512) & 1)
        {
            size -= 512;
            memmove(cart.rom, cart.rom + 512, size);
        }

        cart.pages = (size / 0x4000);
    }
    else
    {
        FILE *fd = NULL;

        fd = fopen(filename, "rb");
        if(!fd) return 0;

        /* Seek to end of file, and get size */
        fseek(fd, 0, SEEK_END);
        size = ftell(fd);
        fseek(fd, 0, SEEK_SET);

        /* Don't load games smaller than 32k */
        if(size < 0x8000) return 0;

        /* Take care of image header, if present */
        if((size / 512) & 1)
        {
            size -= 512;
            fseek(fd, 512, SEEK_SET);
        }

        cart.pages = (size / 0x4000);
        cart.rom = malloc(size);
        if(!cart.rom) return 0;
        fread(cart.rom, size, 1, fd);

        fclose(fd);
    }
#endif

#if 1
 {
	FILE *f = fopen ( filename, "rb" );

	if ( ! f ) {
	  return ( NULL );
	}

	fseek ( f, 0, SEEK_END );
	size = ftell ( f );
	fseek ( f, 0, SEEK_SET );

        /* Don't load games smaller than 32k */
        if(size < 0x8000) return 0;

        /* Take care of image header, if present */
        if((size / 512) & 1)
        {
            size -= 512;
            fseek(f, 512, SEEK_SET);
        }

        cart.pages = (size / 0x4000);
        cart.rom = MemGluePtrNewL ( size );
        if(!cart.rom) return 0;
        fread(cart.rom, size, 1, f);

	fclose ( f );

        /* Update file size and return pointer to file data */
        //*file_size = size;
        //return (buf);
 }
    strcpy ( game_name, filename );
#endif

    /* Figure out game image type */
    
    /*if ( ( StrStr(strrchr(game_name, '.'), ".gg") == 0 ) ||
	 ( StrStr ( game_name, ".GG" ) == 0 ) )
    {
      cart.type = TYPE_GG;
      game_type = TYPE_GG;
      menu_message ( "Game is GG" ); menu_waitPen(NULL, NULL, 1);
    } else*/ {
      cart.type = TYPE_SMS;
      game_type = TYPE_SMS;
//      menu_message ( "Game is SMS" ); menu_waitPen(NULL, NULL, 1);
    }

    return 1;
}

#if 0
unsigned char *loadzip(char *archive, char *filename, int *filesize)
{
    char name[0x100];
    unsigned char *buffer;

    int zerror = UNZ_OK;
    unzFile zhandle;
    unz_file_info zinfo;

    zhandle = unzOpen(archive);
    if(!zhandle) return (NULL);

    /* Seek to first file in archive */
    zerror = unzGoToFirstFile(zhandle);
    if(zerror != UNZ_OK)
    {
        unzClose(zhandle);
        return (NULL);
    }

    /* Get information about the file */
    unzGetCurrentFileInfo(zhandle, &zinfo, &name[0], 0xff, NULL, 0, NULL, 0);
    *filesize = zinfo.uncompressed_size;

    /* Error: file size is zero */
    if(*filesize <= 0)
    {
        unzClose(zhandle);
        return (NULL);
    }

    /* Open current file */
    zerror = unzOpenCurrentFile(zhandle);
    if(zerror != UNZ_OK)
    {
        unzClose(zhandle);
        return (NULL);
    }

    /* Allocate buffer and read in file */
    buffer = malloc(*filesize);
    if(!buffer) return (NULL);
    zerror = unzReadCurrentFile(zhandle, buffer, *filesize);

    /* Internal error: free buffer and close file */
    if(zerror < 0 || zerror != *filesize)
    {
        free(buffer);
        buffer = NULL;
        unzCloseCurrentFile(zhandle);
        unzClose(zhandle);
        return (NULL);
    }

    /* Close current file and archive file */
    unzCloseCurrentFile(zhandle);
    unzClose(zhandle);

    memcpy(filename, name, 0x100);
    return (buffer);
}

#endif
