#include "palmdep.h"
#include "ljPRsc.h"
#include "App_Cst.h"

#include "zlib.h"
#include "unzip.h"
/*************
/*tinus*/
#include "filters.h"
/*********/

#include "PNOMain.h"
/*****************/
#include "LJZmenu.h"
/**************************/
#include "smsgg_main.h"

#include "sms_shared.h"

extern UInt32 mStopEmulation;
extern UInt32 device_type;
extern int sms_sndbuffsize;

extern pnobridge_t *g_pnobridge;

int frames_displayed;
char renderit;

UInt16 *smsgg_zodvram;

uint16 *smsgg_curRenderingScreenPtr;
uint32 smsgg_curRenderingScreenIndex;
uint32 smsgg_enabledSound,smsgg_sndfreq;
uint32 smsgg_renderingmode,smsgg_smoothmode;
uint32 smsgg_padState;

int32 smsgg_frameskipped,smsgg_frameskip,smsgg_fastforward;
int32 smsgg_frameBeginTime;
int32 smsgg_speedpct;

int32 smsgg_autofireA,smsgg_autofireB;
int32 smsgg_flipping;
int32 smsgg_framecount;

extern UInt32 ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;

//int mysndbuffersize;
//signed short *mysndbuffer;

char game_type = 3;

char CurrentROMFile[256];
char smsgg_curVolume;
char shortrom_filename[256];

char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};

void GetStateFileName(int n,char *str);

/*************************/
/* sound stuff */
/*************************/
#include "SoundMgr.h"
static SndStreamRef snd_stream=NULL;
Int32 snd_stream_vol;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
/*************************/

void smsgg_pause(int pause);

void emu_resettimer(void) {
	smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
}

/* load/save state*/
int state_load(int n,int only_check){	
	char savename[255];
 	FILE *f;
 	char chaine[256];  
 	
	GetStateFileName(n,savename);
	
	f=fopen(savename,"rb");
  if (f) 
  {
  	if (only_check){
  		fclose(f);
		return 1;
	} else {
		menu_message("Loading");
	
	 	system_load_state(f);
		fclose(f);
		
		return 1;
	}
  }
  else 
  {
  	if (only_check) return 0;
  	
    strcpy(chaine,"Cannot open ");
    strcat(chaine,savename);
    strcat(chaine," for loading\n");
//	DrawMessage(chaine,1);
	menu_message(chaine);menu_waitPen(NULL,NULL,1);
  }
	
	return 0;
}
void state_save(int n){
	
	char savename[255];
  FILE *f;
 char chaine[256];  
  GetStateFileName(n,savename);
	//DEBUGS("saving state to");
	//DEBUGS(savename);
	
	menu_message("Saving");
	
  f=fopen(savename,"w+b");
  if (f) 
  {
 	system_save_state(f);
	fclose(f);
  }
  else 
  {
    strcpy(chaine,"Cannot open ");
    strcat(chaine,savename);
    strcat(chaine," for saving\n");
//	DrawMessage(chaine,1);
	menu_message(chaine);menu_waitPen(NULL,NULL,1);
  }
}

/* get save filename based on slot number*/
void GetStateFileName(int n,char *str){
	//sprintf(str,"toto.ss%d",slot);
	
  char result[256];
  unsigned char i=0,j=255,k=255,l=255;

  i=0;
  j=255;
  k=-1;
  while (CurrentROMFile[i]!=0) 
  {
	if (CurrentROMFile[i]=='.') j=i;
	if (CurrentROMFile[i]=='/') k=i;
	if (CurrentROMFile[i]=='\\') k=i;
	i++;
  }
  if (j==255) j=i;  //pas d'extension	  
  //j=0;
  memcpy(result,CurrentROMFile+k+1,j+1-k-1);    
  result[j+1-k-1]=0;
  if (n>=0)
  {  
	  if (IS_GG) strcat(result,"gs"); else strcat(result,"ss"); //menu_message(result); menu_waitPen(NULL,NULL,1);
//	  sprintf(str,"%s%s%d",FGBZ_SAVESDIR,result,n);
		if (IS_GG) {
  			strcpy(str,SMSGG_GGSAVESDIR);
  		} else {
  			strcpy(str,SMSGG_SMSSAVESDIR);
  		}
		strcat(str,result);
		int lstr=strlen(str);
		str[lstr++]=n+48;
		str[lstr]=0;
  } 
  else 
  {
  	strcat(result,"srm");
  	//sprintf(str,"%s%s",FGBZ_SAVESDIR,result);
  	if (IS_GG) {
  		strcpy(str,SMSGG_GGSAVESDIR);
  	} else {
  		strcpy(str,SMSGG_SMSSAVESDIR);
  	}
	strcat(str,result);
  }
  str[0]=smsgg_curVolume+'0';
}

void system_load_sram(void){
	char savename[255];
 	FILE *f;
 	char chaine[256];  
 	
	GetStateFileName(-1,savename);
	
	f=fopen(savename,"rb");
	if (f) 
	{
 		fread(sms.sram,0x8000,1,f);
 		
		fclose(f);
		
		return;
	}
 	else 
	{  	
    	/*strcpy(chaine,"Cannot open ");
	    strcat(chaine,savename);
    	strcat(chaine," for loading SRAM\n");
		menu_message(chaine);menu_waitPen(NULL,NULL,1);*/
	}	
	return;
}

void system_save_sram(void){
	char savename[255];
	FILE *f;
	char chaine[256];  
	GetStateFileName(-1,savename);
	
	f=fopen(savename,"w+b");
	if (f) 
	{
		fwrite(sms.sram,0x8000,1,f);
		
		fclose(f);
	}
	else 
	{
  		strcpy(chaine,"Cannot open ");
	    strcat(chaine,savename);
  		strcat(chaine," for saving SRAM\n");
		menu_message(chaine);menu_waitPen(NULL,NULL,1);
	}
}

void smsgg_togglesound(void) {
	char tmp[64];
	int i;
	
	smsgg_pause(1);
	
	smsgg_enabledSound++;
	if (smsgg_enabledSound>2) smsgg_enabledSound=0;
	
	if (smsgg_enabledSound==0) strcpy(tmp,"Sound : OFF");
	else if (smsgg_enabledSound==1) strcpy(tmp,"Sound : SIM");
	else if (smsgg_enabledSound==2) strcpy(tmp,"Sound : ON");

	menu_message(tmp);
	
	LJP_WAIT(300);
	emu_resettimer();
	
	snd.enabled = smsgg_enabledSound;
	if (smsgg_enabledSound) {
		audio_init(smsgg_sndfreq);
	} else {
		audio_init(0);
	}
	
	smsgg_pause(0);
}

char smsgg_reset(void) {
	smsgg_pause(1);
	
	if (IS_GG) {
  		if (menu_confirm("Reset GG ?")) {sms_reset(); /*return 1;*/}
    } else {
  	    if (menu_confirm("Reset SMS ?")) {sms_reset(); /*return 1;*/}
  	}
  	
  	emu_resettimer();
  	
  	smsgg_pause(0);
  	
  	return 0;
}

void smsgg_quicksave(void) {
	smsgg_pause(1);
	
	if (CONFIRM_SAVE) state_save(0);
	smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
	ClearScreen();
	
	smsgg_pause(0);
}

void smsgg_quickload(void) {
	smsgg_pause(1);
	
	if (state_load(0,1))
	{
		if (CONFIRM_LOAD) state_load(0,0);
		smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
		ClearScreen();
	}
	
	smsgg_pause(0);
}

static Err smsgg_sndCallBack (void *userData,SndStreamRef stream, void *buffer,UInt32 framecountZ)
{
/*	//UInt32 size = *bufsize;
  Int16 *bufptr = buffer;
  UInt8 *sndbuf = (void*) ByteSwap32 ( ((UInt32)userData) );

//#ifdef AUDIO_ARM
  // local audio stuff
  UInt16 max;
  UInt8 scale;
  UInt16 frames = *bufsize / 2 / 2;

  //t_snd *snd = (t_snd*) sndbuf;

  if ( snd.bufsize < frames ) {
    max = snd.bufsize;
    scale = *bufsize / 2 / 2; //frames / //snd.bufsize;
  } else {
    max = frames;
    scale = 1;
  }

  { // gen
    UInt16 i = 0, f = 0, j = 0;
    UInt8 si;

    while ( f < frames ) {
      for ( si = 0; si < scale; si++ ) {
	bufptr [ i++ ] = snd.buffer [ 0 ] [ j ];
	bufptr [ i++ ] = snd.buffer [ 1 ] [ j ];
      }
      f++;
      j++;
      if ( j == max ) {
	j = 0;
      }
    } // while

  } // gen*/
//#endif
	
	//scary asm stuff
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}	
	
	
	//*bufsize = snd.bufsize;
	//memcpy(buffer,(void*)snd.buffer,framecountZ);
	//buffer = (void*)snd.buffer[0];
	
	//memset(buffer,framecountZ *2,0);
	
	/*Int16 *p
	p=(Int16*)buffer;
	for(int x=0; x<framecountZ
	*p++ = 2345;
	*p++ = 2347;
	*p++ = 2398;
	*p++ = 2456;
	*p++ = 2602;*/
	
	
	//memset(mybuf,framecountZ,0);
	sound_mix((int16*)buffer, framecountZ); //stereo so /2
	

	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}

void smsgg_pause(int pause){
	if (pause)
	{
		if (snd_stream) stub_SndStreamGetVolume(snd_stream,&snd_stream_vol);  
		if (smsgg_enabledSound==2) 
		{
			stub_SndStreamStop(snd_stream);
			stub_SndStreamDelete(snd_stream);
			snd_stream=NULL;
		}
	}
	else
	{
		smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
		if (smsgg_enabledSound==2) 
		{
			stub_SndStreamCreate(&snd_stream,sndOutput,smsgg_sndfreq,sndInt16Little,sndStereo,smsgg_sndCallBack,&reg_sys,sms_sndbuffsize,1);
			stub_SndStreamStart(snd_stream);		
			stub_SndStreamSetVolume(snd_stream,snd_stream_vol);
		}
	}
}

void smsgg_end(void){
	int val;
	ljz_free(smsgg_curRenderingScreenPtr);    
	
	//SRAM
	if (sms.save)
	{
		system_save_sram();
	}
	
	system_shutdown();

	if (snd_stream) stub_SndStreamGetVolume(snd_stream,&snd_stream_vol);  
		if (smsgg_enabledSound==2) 
		{
			stub_SndStreamStop(snd_stream);
			stub_SndStreamDelete(snd_stream);
			snd_stream=NULL;
		}

	if (cart.rom) FtrPtrFree(CREATORID, FTR_ROM_ID);

	FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID,smsgg_smoothmode);	
	FtrSet(CREATORID, FTR_OPT_SOUND_ID,smsgg_enabledSound);
	switch (smsgg_sndfreq)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,val);
	
	FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,smsgg_renderingmode);
	
	FtrSet(CREATORID, FTR_OPT_FSKIP_ID,smsgg_frameskip);	
	
	FtrSet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,snd_stream_vol/16); 
	
	ljz_std_showstat();
}

int init_video()
{
	//Init vid, here hardcoded to 256x240
	signed long val1,val2,val;		
	/*if (cart.type == TYPE_GG) {
		smsgg_curRenderingScreenPtr=(uint16*)ljz_malloc(160*144*2);
		memset(smsgg_curRenderingScreenPtr,0,160*144*2);
	} else*/ {
		smsgg_curRenderingScreenPtr=(uint16*)ljz_malloc(256*192*2);
		memset(smsgg_curRenderingScreenPtr,0,256*192*2);
	}
	FtrGet(CREATORID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(CREATORID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
	smsgg_renderingmode=val1;
	smsgg_smoothmode=val2;
	
	smsgg_fastforward=0;
	
	smsgg_frameskipped=0;
	
    FtrGet(CREATORID,FTR_OPT_FSKIP_ID,(unsigned long*)&val);     
	smsgg_frameskip=val;
	
	FtrGet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,(unsigned long*)&val); 
	snd_stream_vol=val;
	if (snd_stream_vol<0) snd_stream_vol=0;
	if (snd_stream_vol>128) snd_stream_vol=128;
	snd_stream_vol*=16;  

	memset ( &bitmap, sizeof(t_bitmap), 0 );
 	/*if (cart.type == TYPE_GG) {
 		bitmap.width  = 160;
	  	bitmap.height = 144;
 	} else*/ {
 		bitmap.width  = 256;
	  	bitmap.height = 192;
	}
  	bitmap.depth  = 16;
  	//yeah, seems weird but whatever --Tinnus
  	if (IS_GG) {
  		bitmap.pitch = 160*2;
  	} else {
  		bitmap.pitch = 256*2;
  	}
  	bitmap.granularity = 2; // Bytes per pixel
  	bitmap.data = (unsigned char *)smsgg_curRenderingScreenPtr;
//  	bitmap.data = (unsigned char *)g_pnobridge->vram;
  	bitmap.viewport.w = 256; // Initial size of display on power-up (do not change)
	bitmap.viewport.h = 192;
	bitmap.viewport.x = 0;//x20; // Offset used for rendering (do not change)
	bitmap.viewport.y = 0;//x00;*/
//	bitmap.remap = 1;

//tinnus
	filters_init();
//	if (IS_SMS) InitStretchTables();       
	return 0;
}


int smsgg_loadrom(){
	char tmp[16];
	char cat[32];

	//load rom & init stuff
	int val;
	FtrGet(CREATORID,FTR_OPT_SOUND_ID,(unsigned long*)&val);  
	smsgg_enabledSound=val;
	
	FtrGet(CREATORID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);  
	if (val==1) smsgg_sndfreq=22050;
	else if (val==2) smsgg_sndfreq=11025;
	else smsgg_sndfreq=44100;		
	
	smsgg_speedpct=100;
	smsgg_autofireA=0;
	smsgg_autofireB=0;
	
	smsgg_framecount=0;
	
	
	
	char *ftrptr;
	
	FtrGet(CREATORID,FTR_OPT_SMSGG_SYS_ID,(unsigned long*)&val); //is it SMS or GG?
    if (val==1) {
    	strcpy(CurrentROMFile,SMSGG_SMSROMSDIR);    
    } else {
    	strcpy(CurrentROMFile,SMSGG_GGROMSDIR);    
    }
    
    if (val==1) game_type=SYS_SMS; else game_type=SYS_GG;

//	sprintf(tmp,"%d",val);menu_message(tmp);menu_waitPen(NULL,NULL,1);

    
    //handle categories
  	FtrGet(CREATORID,FTR_OPT_CATEGORY_ID ,(unsigned long*)&ftrptr);
  	strcpy(cat,ftrptr);
  	if ( StrCaselessCompare(cat,"uNaRcHiVeD") != 0) {
  		strcat(CurrentROMFile,cat);
  		strcat(CurrentROMFile,"/");
  	}
//  	FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
    
    FtrGet(CREATORID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
    
    smsgg_curVolume=ftrptr[0];
    CurrentROMFile[0]=smsgg_curVolume+'0';
    
    ftrptr+=3;
	strcpy(shortrom_filename,ftrptr);  
    strcat(CurrentROMFile,ftrptr);
//    FtrPtrFree(CREATORID, FTR_ROM_FILENAME_ID);
        
//    char strload[128];
//    strcpy(strload,"Loading : ");
//    strcat(strload,shortrom_filename);  
    menu_message(shortrom_filename/*strload*/);
    
    //load rom
    load_rom(CurrentROMFile);
    
    { //SRAM
    	char filename[255];
    	FILE* f;
    	
    	GetStateFileName(-1,filename);
    	
    	f=fopen(filename,"rb");
		if (f) 
		{
			fclose(f);
			
			system_load_sram();
			sms.save=1;
		}
    }
    
//    menu_message("rom loaded");menu_waitPen(NULL,NULL,1);
    
    init_video();
    
//    menu_message("init_video ok");menu_waitPen(NULL,NULL,1);
    
//	loader_init(CurrentROMFile);	
//    emu_running=1;
//	emu_reset();
//    frames_rendered=frames_displayed=0;
//    framelimit_delay=0;
	smsgg_frameBeginTime=GetTickCount();    
//	emu_run();		

	__asm 
    {
  		ldr  r0, = reg_sys
	  	add	 r0,r0,r10
  		str	 r9,[r0]
	  	str	 r10,[r0,#4]
    } 

	smsgg_pause(0);	
	
//	menu_message("ok");menu_waitPen(NULL,NULL,1);
    return 0; 
}

void smsgg_asmfastrender(uint8 *screen,uint8 *source,UInt32 offset_pitch)
{
	__asm{
		stmfd r13!,{r3-r12}
	
		mov	  r3,#144
		bic	  r0,r0,#3
		bic	  r1,r1,#3

	 loopY:	
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r5-r12}
		stmia r0!,{r5-r12}
		
		add	  r0,r0,r2 //(256-160) * 2
		
		subs  r3,r3,#1
		bne   loopY
		
		ldmfd r13!,{r3-r12}	
		}	
}

void smsgg_asmfastrenderx2(uint8 *screen,uint8 *source,UInt32 offset_pitch)
{
	__asm{
	
#define asm_mac() \
		mov	  r5,r4,lsr #16;\
		mov	  r4,r4,lsl #16;\
		orr	  r5,r5,r5,lsl #16;\
		orr	  r4,r4,r4,lsr #16;\
		mov	  r7,r6,lsr #16;\
		mov	  r6,r6,lsl #16;\
		orr	  r7,r7,r7,lsl #16;\
		orr	  r6,r6,r6,lsr #16;\
		mov	  r9,r8,lsr #16;\
		mov	  r8,r8,lsl #16;\
		orr	  r9,r9,r9,lsl #16;\
		orr	  r8,r8,r8,lsr #16;\
		mov	  r11,r10,lsr #16;\
		mov	  r10,r10,lsl #16;\
		orr	  r11,r11,r11,lsl #16;\
		orr	  r10,r10,r10,lsr #16;	
	
		stmfd r13!,{r3-r12}
	
		mov	  r3,#144
		bic	  r0,r0,#3
		bic	  r1,r1,#3
		add	  r12,r0,r2
		mov	  r2,r2,lsl #1
		sub	  r2,r2,#640
	 loopY:	
		ldmia r1!,{r4,r6,r8,r10}  //read 4*4/2=8pixels				
		asm_mac()		
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		ldmia r1!,{r4,r6,r8,r10}  
		asm_mac()
		stmia r0!,{r4-r11}
		stmia r12!,{r4-r11}
		
#undef asm_mac		
		
		add	  r0,r0,r2 //(256-160) * 2
		add	  r12,r12,r2 //(256-160) * 2
		
		subs  r3,r3,#1
		bne   loopY
		
		ldmfd r13!,{r3-r12}	
		}	
}

void smsgg_MainLoop(void){
	
	/*** timing start ***/
	
	frames_displayed++;	
	smsgg_frameBeginTime+=17*100/smsgg_speedpct;	//60Hz				
	
	if ((smsgg_frameskip==AUTO_FSKIP)&&(!smsgg_fastforward))
	{
		int i,haswaited=0;
		
		//do avoid issue when Tick is looping
		if ((int32)(smsgg_frameBeginTime-GetTickCount())>=(int32)(10*17))		
			smsgg_frameBeginTime=GetTickCount()+17;				
		while (GetTickCount()<=smsgg_frameBeginTime)  haswaited=1;
//		i=smsgg_frameBeginTime-GetTickCount()+1;
//        if (i>0) {haswaited=1; SysTaskDelay(i);}
		
		if (haswaited||(smsgg_frameskipped>=MAX_FRAME_SKIPPED)) 
		{
			renderit=true;
			smsgg_frameskipped=0;
		}
		else 
		{
			renderit=false;
			smsgg_frameskipped++;
		}
	}
	else
	{	
		if (smsgg_frameskip==SKEEZIX_FSKIP) smsgg_frameskipped=SKEEZIX_FSKIP;	
		smsgg_frameskipped++;
		
		if (smsgg_fastforward)
		{
			if (smsgg_frameskipped>SMSGG_TURBOFSKIP)
			{
				smsgg_frameskipped=0;
				renderit=true;
			}
			else renderit=false;
		}
		else
		{					
			if (smsgg_frameskipped>smsgg_frameskip)
			{
				smsgg_frameskipped=0;
				renderit=true;
				int i,haswaited;					
				
				//do avoid issue when Tick is looping				
				if ((int32)(smsgg_frameBeginTime-GetTickCount())>=(int32)(10*17))				
					smsgg_frameBeginTime=GetTickCount()+17;
				while (GetTickCount()<=smsgg_frameBeginTime) haswaited=1;
//				i=smsgg_frameBeginTime-GetTickCount()+1;
//		        if (i>0) {SysTaskDelay(i);}
	 		   			   										
			}
			else 
			{
				int i;
				renderit=false;				
				if ((int32)(smsgg_frameBeginTime-GetTickCount())>=(int32)(10*17))				
					smsgg_frameBeginTime=GetTickCount()+17;
				if (smsgg_enabledSound==2)
				{
					while (GetTickCount()<=smsgg_frameBeginTime) ;
//					i=smsgg_frameBeginTime-GetTickCount()+1;
//			        if (i>0) {SysTaskDelay(i);}
				}
			}
		}
	}
	
	/*** timing end ***/
	
	
  /*** video start ***/

	
	if (!renderit) {
		system_frame(1);
	} else {	
		system_frame(0);

		UInt16 *fline, *tline;

	  if (IS_GG) {
		fline = ((UInt16*)bitmap.data) + (15 * 256) + 48;
	   if (!ljp_isLowRes) {
		switch (smsgg_renderingmode)
	  	{
	  		case 3:
	  		case 1:
	  			tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-288-(smsgg_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-320)>>1);
	  			switch (smsgg_smoothmode&_SMOOTH_MASK_){	  			
		  			case 7:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,SCALE_2XSAI,160,144,320,288);
		  			break;
		  			case 6:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,SUPER_EAGLE,160,144,320,288);	  			
		  			break;
			  		case 5:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,SUPER_2XSAI,160,144,320,288);
		  			break;
				  	case 4:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,_2XSAI,160,144,320,288);	  			
	  				break;
				  	case 3:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,HQ2X,160,144,320,288);
		  			break;	
		  			case 2:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,LQ2X,160,144,320,288);
		  			break;
			  		case 1:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,ADVMAME2X,160,144,320,288);
		  			break;
			  		case 0:
			  		
			  			if (device_type&BF_ZODIAC){	
				  			if (smsgg_smoothmode&_ZOD_SMOOTHING_) {
							tline = ((UInt16*) smsgg_zodvram);				
							smsgg_asmfastrender((uint8*)tline,(uint8*)fline,(480-160)<<1);
							stubzodiacblit(3,160,144,6);
							break;
						}
						else if (!smsgg_smoothmode) {
							tline = ((UInt16*) smsgg_zodvram);				
							smsgg_asmfastrender((uint8*)tline,(uint8*)fline,(480-160)<<1);
							stubzodiacblit(3,160,144,2);
							break;
						}
			  		}
			  		else smsgg_asmfastrenderx2((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1));
					break;
				}
				break;
			case 2:
	  		case 0:
				tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-144-(smsgg_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-160)>>1);
			    smsgg_asmfastrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch-160)<<1));
			    break;
			case 4:			
				if (device_type&BF_ZODIAC){					
					if (smsgg_smoothmode&_ZOD_SMOOTHING_) {
						tline = ((UInt16*) smsgg_zodvram);
						smsgg_asmfastrender((uint8*)tline,(uint8*)fline,(480-160)<<1);
						stubzodiacblit(3,160,144,5);
						break;
					}
					else if (!smsgg_smoothmode) {
						tline = ((UInt16*) smsgg_zodvram);
						smsgg_asmfastrender((uint8*)tline,(uint8*)fline,(480-160)<<1);
						stubzodiacblit(3,160,144,1);
						break;
					}
						
				}
				if (device_type&BF_HIRESPLUS){
					tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-320/*-BELTBAR_SIZE*/)>>1) * display_pitch ) + ((display_width-480)>>1);
					if (smsgg_smoothmode) fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,SCALE_2XSAI,160,144,480,320/*-BELTBAR_SIZE*/);
				}
				break;
		}
	  } else {
	  	tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-144-BELTBAR_SIZE)>>1) * display_pitch ) + ((display_width-160)>>1);
		smsgg_asmfastrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch-160)<<1));
	  }
	} else { //SMS
		fline = ((UInt16*)bitmap.data);
	  if (!ljp_isLowRes) {	
		switch (smsgg_renderingmode)
			{
				case 0:
				case 2:	
					tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-192-(smsgg_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-256)>>1);			
					ljp_asmfastrender((uint8*)tline,(uint8*)fline,192,(display_pitch-256)<<1);		
					break;		
				case 1:
				case 3:							
					if (device_type&BF_ZODIAC){				
						if (smsgg_smoothmode&_ZOD_SMOOTHING_) {
							tline = ((UInt16*) smsgg_zodvram);				
							ljp_asmfastrender((uint8*)tline,(uint8*)fline,192,(480-256)<<1);
							stubzodiacblit(3,256,192,4);
							break;
						}else if (!smsgg_smoothmode) {
							tline = ((UInt16*) smsgg_zodvram);				
							ljp_asmfastrender((uint8*)tline,(uint8*)fline,192,(480-256)<<1);
							stubzodiacblit(3,256,192,0);
							break;
						}
					}
					tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-192*5/4-(smsgg_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-320)>>1);
					if (smsgg_smoothmode==0) ljp_asmfastrenderX15((uint8*)tline,(uint8*)fline,192,(display_pitch-320)<<1);
					else if (smsgg_smoothmode==1) ljp_asmfastrenderX15sm((uint8*)tline,(uint8*)fline,192,(display_pitch-320)<<1);
					else if (smsgg_smoothmode==2) StretchNesterTrue(fline,tline,256,display_pitch,192);
					else if (smsgg_smoothmode==3) fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,256*2,SCALE_2XSAI,256,192,320,192*5/4);
					break;		
				case 4:
					if (device_type&BF_ZODIAC){						
					if (smsgg_smoothmode&_ZOD_SMOOTHING_) {
						tline = ((uint16*) smsgg_zodvram);
						ljp_asmfastrender((uint8*)tline,(uint8*)fline,192,(480-256)<<1);
						stubzodiacblit(3,256,192,5);
						break;
					} else if (!smsgg_smoothmode) {
						tline = ((uint16*) smsgg_zodvram);
						ljp_asmfastrender((uint8*)tline,(uint8*)fline,192,(480-256)<<1);
						stubzodiacblit(3,256,192,1);
						break;
					}
					}
					if (device_type&BF_HIRESPLUS){
						tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-320/*-BELTBAR_SIZE*/)>>1) * display_pitch ) + ((display_width-480)>>1);
						if (smsgg_smoothmode) fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,256*2,SCALE_2XSAI,256,(UInt32)192,480,320/*-BELTBAR_SIZE*/);
					}
					break;
			}
		  } else {
	  		tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-120-BELTBAR_SIZE)>>1) * display_pitch ) + ((display_width-160)>>1);
			fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,256*2,SCALE_2XSAI,256,192,160,120);
	 	  }
	    }
	
    }
	
  /*** video end ***/
}

void smsgg_updatevpad(int k_key) {
	input.pad[0]=0;
	input.pad[1]=0;
	input.system=0;

	if (k_key & KEY_A) {
		switch (smsgg_autofireA)
	 	{
  			case 0:input.pad[0] |= INPUT_BUTTON1;; break;
  			case 1:
  	  			if ((smsgg_framecount&31)>15)input.pad[0] |= INPUT_BUTTON1;
  	  			break;
  			case 2:
  	  			if ((smsgg_framecount&15)>7) input.pad[0] |= INPUT_BUTTON1;
  	  			break;
  			case 3:
  	  			if ((smsgg_framecount&7)>3) input.pad[0] |= INPUT_BUTTON1;
  	  			break;  		   
  	 	}
	}
	if (k_key & KEY_B) {
		switch (smsgg_autofireB)
	 	{
  			case 0:input.pad[0] |= INPUT_BUTTON2;; break;
  			case 1:
  	  			if ((smsgg_framecount&31)>15)input.pad[0] |= INPUT_BUTTON2;
  	  			break;
  			case 2:
  	  			if ((smsgg_framecount&15)>7) input.pad[0] |= INPUT_BUTTON2;
  	  			break;
  			case 3:
  	  			if ((smsgg_framecount&7)>3) input.pad[0] |= INPUT_BUTTON2;
  	  			break;  		   
  	 	}
	}
	if (k_key & KEY_UP) input.pad[0] |= INPUT_UP;
	if (k_key & KEY_DOWN) input.pad[0] |= INPUT_DOWN;
	if (k_key & KEY_LEFT) input.pad[0] |= INPUT_LEFT;
	if (k_key & KEY_RIGHT) input.pad[0] |= INPUT_RIGHT;
	
	if (k_key & KEY_START) {
		if (IS_GG) {
			input.system |= INPUT_START;
		} else {
			input.system |= INPUT_PAUSE;
		}
	}
	
	//process key
	int key=k_key;
	if (key&KEY_QUICKLOAD)
	{
		if (state_load(0,1))
		{
			if (CONFIRM_LOAD) {smsgg_pause(1);state_load(0,0);smsgg_pause(0);}
			smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
			 ClearScreen();
		}
	}
	if (key&KEY_QUICKSAVE)
	{
		if (CONFIRM_SAVE) {smsgg_pause(1);state_save(0);smsgg_pause(0);}
		smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
		 ClearScreen();
	}
	if (key&KEY_TURBO)
	{		
		smsgg_fastforward=1;		
	}
	else 
	if (smsgg_fastforward)
	{
		smsgg_fastforward=0;
		smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
	}
}

void smsgg_changefskip(void){
	char tmp[64];
	int i;
	
	smsgg_pause(1);
	
	smsgg_frameskip++;
	if (smsgg_frameskip>SKEEZIX_FSKIP) smsgg_frameskip=0;
	
	
	if (smsgg_frameskip==AUTO_FSKIP) strcpy(tmp,"Frameskip : AUTO");
	else if (smsgg_frameskip==SKEEZIX_FSKIP) strcpy(tmp,"Frameskip : Skeezix");
	else 
	{
		char tmp2[16];
		strcpy(tmp,"Frameskip : ");
		StrIToA(tmp2,smsgg_frameskip);
		strcat(tmp,tmp2);
	}

	menu_message(tmp);
	
	i=GetTickCount();
	while ((GetTickCount()-i)<300)
	{
	}
	smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
	
	smsgg_pause(0);
}
void smsgg_changerendering(void){
	smsgg_renderingmode++;
	
	if (smsgg_renderingmode>3) smsgg_renderingmode=0;
	if (smsgg_renderingmode==2) {
		stub_fullscreen(1);
		LJP_HANDLE_EVENT(smsgg_pause)	
	}
	if (smsgg_renderingmode==0) {
		stub_fullscreen(0);
		LJP_HANDLE_EVENT(smsgg_pause)
	}
	menu_message("Changing screen mode");
	smsgg_frameBeginTime=GetTickCount();
	while ((GetTickCount()-smsgg_frameBeginTime)<300){
	}
	ClearScreen();
	smsgg_frameBeginTime=GetTickCount()+17*100/smsgg_speedpct;
}

int smsgg_ShowMenuGFXConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval,hwsmooth;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(23*sizeof(RectangleType));
  char tmp[16];

	
  scrmode=smsgg_renderingmode;
  smoothing=smsgg_smoothmode&_SMOOTH_MASK_;
  hwsmooth=smsgg_smoothmode&_ZOD_SMOOTHING_;
	
  fskipval=smsgg_frameskip;

	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {  	  	
		GUI_REDRAW_BG(1);
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	  
	  	menu_button(10,80,(char*)"FRAMESKIP",0,&item_rect[1],2);	  
	  	menu_bar(150,80,fskipval,11,&item_rect[2]);
	  	if (fskipval==AUTO_FSKIP) strcpy(tmp,"AUTO");
	  	else if (fskipval==SKEEZIX_FSKIP) strcpy(tmp,"SKZX");
	  	else StrIToA(tmp,fskipval);
	  	menu_messageRaw(260,80,tmp);
	  
	  	menu_button(10,120,(char*)"ZOOM",0,&item_rect[3],2);	  	
	  	menu_button(150,120,(char*)"1",((scrmode==0)||(scrmode==2)?2:1),&item_rect[4],0);
	  	if (IS_GG) {
		  	menu_button(200,120,(char*)"2",((scrmode==1)||(scrmode==3)?2:1),&item_rect[5],0);
		} else {
			menu_button(200,120,(char*)"1.25",((scrmode==1)||(scrmode==3)?2:1),&item_rect[5],0);
		}
	  	menu_button(250,120,(char*)"WIDE",(scrmode==4?2:1),&item_rect[6],0);
	  	
	  	menu_button(10,155,(char*)"FULLSCREEN",0,&item_rect[7],2);
	  	menu_button(150,155,(char*)"OFF",(scrmode&2?1:2),&item_rect[8],0);
	  	menu_button(200,155,(char*)"ON",(scrmode&2?2:1),&item_rect[9],0);	  	  	  
	  
	  	if (IS_GG) {
		  	menu_button(10,190,(char*)"SMOOTHING",0,&item_rect[10],2);
		  	menu_button(150,190,(char*)"OFF",((smoothing==0)&&(!hwsmooth)?2:1),&item_rect[11],0);	  		  	
	  		menu_button(200,190,(char*)"AdvMAME2x",(smoothing==1?2:1),&item_rect[12],4);
		  	menu_button(2,218,(char*)"LQ2X",(smoothing==2?2:1),&item_rect[13],4);	  	  	  
		  	menu_button(68,218,(char*)"HQ2X",(smoothing==3?2:1),&item_rect[14],4);
	  		menu_button(136,218,(char*)"2xSaI",(smoothing==4?2:1),&item_rect[15],4);
		  	menu_button(202,218,(char*)"Super 2xSaI",(smoothing==5?2:1),&item_rect[16],4);
		  	menu_button(10,246,(char*)"Super Eagle",(smoothing==6?2:1),&item_rect[17],4);
		  	menu_button(130,246,(char*)"Scale 2xSaI",(smoothing==7?2:1),&item_rect[18],4);
	  		menu_button(260,246,(char*)"HW",(hwsmooth?2:1),&item_rect[22],4);
	  	} else {
	  		menu_button(10,230,(char*)"SMOOTHING",0,&item_rect[10],2);
	  		menu_button(150,230,(char*)"-",((smoothing==0)&&(!hwsmooth)?2:1),&item_rect[11],4);
		  	menu_button(180,230,(char*)"1",(smoothing==1?2:1),&item_rect[12],4);
		  	menu_button(210,230,(char*)"2",(smoothing==2?2:1),&item_rect[13],4);
	  		menu_button(240,230,(char*)"3",(smoothing==3?2:1),&item_rect[14],4);
		  	menu_button(280,230,(char*)"HW",(hwsmooth?2:1),&item_rect[15],3);
	  	}
	  	
	  	menu_button(10,280,(char*)"FLIPPING",0,&item_rect[19],2);
		menu_button(150,280,(char*)"OFF",(smsgg_flipping?1:2),&item_rect[20],0);
	  	menu_button(200,280,(char*)"ON",(smsgg_flipping?2:1),&item_rect[21],0);
	  	
	  	if (scr) ljp_WinScreenUnlock();
	
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[2])) {
	  	fskipval=(x-10-item_rect[2].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }

	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[4])) {
		  scrmode&=~4;
	  	  scrmode&=~1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {
		  scrmode&=~4;
	  	  scrmode|=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {
	  	  scrmode=4;
	  	  redraw=1;
	  }
	  //SCREEN MODES WIN/FULL
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {
	  	  scrmode&=~(2|4);
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) {
	  	  if (scrmode<2) scrmode|=2;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (IS_GG) {
		  if (TEST_PEN_MENU(x,y,item_rect[11])) {
		  	  smoothing=0;hwsmooth=0;
	  		  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[12])) {
	  		  smoothing=1;hwsmooth=0;
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[13])) {
		  	  smoothing=2;hwsmooth=0;
	  		  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[14])) {
	  		  smoothing=3;hwsmooth=0;
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[15])) {
		  	  smoothing=4;hwsmooth=0;
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[16])) {
		  	  smoothing=5;
		  	  hwsmooth=0;
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[17])) {
		  	  smoothing=6;
		  	  hwsmooth=0;
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[18])) {
		  	  smoothing=7;
		  	  hwsmooth=0;
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[22])) {
		  	  smoothing=0;
		  	  hwsmooth=_ZOD_SMOOTHING_;
		  	  redraw=1;
		  }
	  } else { //sms
	  	  if (TEST_PEN_MENU(x,y,item_rect[11])&&scrmode) {
			  if (smoothing==2){DeInitStretchTables();}
		  	  smoothing=0;
	  		  hwsmooth=0;	  	  
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[12])&&scrmode) {
			  if (smoothing==2){DeInitStretchTables();}
		  	  smoothing=1;
		  	  hwsmooth=0;
	  		  redraw=1;	  	  
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[13])&&scrmode) {
	  		  if (smoothing!=2){	 
				if (InitStretchTables()){
					menu_message("Err:InitStretchTables");
				}else{
			  	  smoothing=2;
		  		  hwsmooth=0;
			  	}
		  	  }
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[14])&&scrmode) {
			  if (smoothing==2){DeInitStretchTables();}
		  	  smoothing=3;
		  	  hwsmooth=0;
		  	  redraw=1;	  	  
		  }
		  //HW SMOOTHING
		  if (TEST_PEN_MENU(x,y,item_rect[15])&&scrmode) {
		  	  hwsmooth=_ZOD_SMOOTHING_;
		  	  if (smoothing==2){DeInitStretchTables();}
		  	  smoothing=0;
		  	  redraw=1;	  	  
		  }
	  }
	  //FLIPPING
	  if (TEST_PEN_MENU(x,y,item_rect[20])) {
	  	  smsgg_flipping=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[21])) {
	  	  smsgg_flipping=1;
	  	  redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  smsgg_frameskip=fskipval;

  smsgg_renderingmode=scrmode;
  smsgg_smoothmode=smoothing|hwsmooth;
	
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}



int smsgg_ShowMenuSNDConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=snd_stream_vol/16;	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(1)
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
	  menu_button(150,80,(char*)"OFF",(smsgg_enabledSound==0?2:1),&item_rect[2],0);
	  menu_button(200,80,(char*)"SIM",(smsgg_enabledSound==1?2:1),&item_rect[3],0);	  
	  menu_button(250,80,(char*)"ON",(smsgg_enabledSound==2?2:1),&item_rect[4],0);	 
	  
	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
	  menu_bar(150,120,vol,128,&item_rect[6]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(270,120,tmp);
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  smsgg_enabledSound=0;		  
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  smsgg_enabledSound=1;	  	  
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  smsgg_enabledSound=2;
		  redraw=1;
	  }
	  
	  //VOLUME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x-10)*128/100;
	  	if (vol<0) vol=0;
	  	if (vol>128) vol=128;
	  	redraw=1;
	  }
	  if (mStopEmulation) break;
  }  

	snd_stream_vol=vol*16;
	
	audio_deinit();
	snd.enabled = smsgg_enabledSound;
	if (!smsgg_enabledSound) audio_init(smsgg_sndfreq);
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int smsgg_ShowMenuOTHERConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG  	(1)
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"AUTO A",0,&item_rect[1],4);
	  menu_button(100,80,(char*)"OFF",(smsgg_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(150,80,(char*)"SLW",(smsgg_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(200,80,(char*)"MED",(smsgg_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(250,80,(char*)"FST",(smsgg_autofireA==3?2:1),&item_rect[5],0);
	  
	  menu_button(10,120,(char*)"AUTO B",0,&item_rect[6],4);
	  menu_button(100,120,(char*)"OFF",(smsgg_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(150,120,(char*)"SLW",(smsgg_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(200,120,(char*)"MED",(smsgg_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(250,120,(char*)"FST",(smsgg_autofireB==3?2:1),&item_rect[10],0);
	  
	  menu_button(10,160,(char*)"EMU SPEED",0,&item_rect[11],4);
	  menu_bar(130,160,smsgg_speedpct,100,&item_rect[12]);
	  StrIToA(tmp,smsgg_speedpct);
	  strcat(tmp,"%");
    	menu_messageRaw(240,160,tmp);
	  
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  smsgg_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  smsgg_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  smsgg_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  smsgg_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  smsgg_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  smsgg_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  smsgg_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  smsgg_autofireB=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
	  	smsgg_speedpct=(x-item_rect[12].topLeft.x);
	  	if (smsgg_speedpct>100) smsgg_speedpct=100;
	  	if (smsgg_speedpct<10) smsgg_speedpct=10;
	  	redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}




int smsgg_ShowMenuSave(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  FILE *savefile;
  	  int slot[4];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG  (1)	
  		
  	  	  	  	  	  	
	  
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  for (int i=0;i<4;i++) 
  	  	if (state_load(i,1))   	  	
  	  	{
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			GetStateFileName(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
	  	}	  	  	
  	  	  	  	  	  	
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"SAVE",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (!slot[1]||(SHOW_OVERWRITE))
		  {state_save(1);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (!slot[2]||(SHOW_OVERWRITE))
		  {state_save(2);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (!slot[3]||(SHOW_OVERWRITE))
		  {state_save(3);result=1; break;}
		  else redraw=1;
		 
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
		  if (!slot[0]||(SHOW_OVERWRITE))
		  {state_save(0);result=1; break;}
		  else redraw=1;
		 
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}



int smsgg_ShowMenuLoad(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
   int slot[4];
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG  	(1)
		
  	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
      for (int i=0;i<4;i++) 
      	if (state_load(i,1)) 
      	{
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			GetStateFileName(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
		}	
      
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"LOAD",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;

  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (slot[1])
		if (state_load(1,0)) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (slot[2])
		if (state_load(2,0)) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot[3])
		if (state_load(3,0)) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	if (slot[0])
    	if (state_load(0,0)) {result=1;break;}
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}


int smsgg_ShowMenuConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG  	(1)
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(92,100,(char*)"GFX",0,&item_rect[1],2);
	  menu_button(92,150,(char*)"SOUND",0,&item_rect[2],2);
	  menu_button(92,200,(char*)"OTHER",0,&item_rect[3],2);
	  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	smsgg_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	smsgg_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  smsgg_ShowMenuOTHERConfig(savescr);
		  redraw=1;		  
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}

int smsgg_ShowSysInfos(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG	(1)			
		
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(smsgg_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(smsgg_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d]",strb,smsgg_curVolume);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,63,str);				
		sprintf(str,"Used:%dM/%dM",usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,81,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM %ldK/%ldK",freeP/1024,maxP/1024);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
		/*TwGfxInfoType gfxinfo;
		gfxinfo.size=sizeof(gfxinfo);
		TwGfxGetInfo(smsgg_mGfxLib,&gfxinfo);		
		menu_button(10,130,"VRAM",6,&my_rect,4);		
		sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);*/
						
    		
/*		menu_button(10,160,"ROM",4,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,rom.name);
		
		sprintf(str,"%dKo RAM-%dKo",mbc.romsize,mbc.ramsize);
		menu_button(10,190,"Size",4,&my_rect,4);
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
		menu_button(10,220,"Type",7,&my_rect,4);		
		sprintf(str,"%d Bt:%d Rtc:%d CGB:%d",mbc.type,mbc.batt,rtc.batt,hw.cgb);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);
		
		menu_button(10,250,"CRC",7,&my_rect,4);		
		sprintf(str,"%08X",smsgg_romCrc);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,str);
		
		menu_button(10,280,"GoodGB",7,&my_rect,4);		
		int i=DAT_LookFor(smsgg_romCrc);
		if (i<0) sprintf(str,"not found");
		else sprintf(str,"%s",MyDat[i].name);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,280,str);
*/		
						  	
	  	menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}


int smsgg_ShowMenu(void)
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr,*tmpscr,*tmpdst;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;

  
  smsgg_pause(1);
    
       
  scr=/*(uint8*)(g_pnobridge -> vram);*/ljp_WinScreenLock(winLockCopy);  
  savescr=(uint8*)ljz_malloc(display_width*display_height*2);    
  if (scr&&savescr)
  {
	  tmpscr=scr;
  	for (int yy=0;yy<display_height-(smsgg_renderingmode<2?BELTBAR_SIZE:0);yy++)
  	{
	  for (x=0;x<display_width;x++)
	  {
  		y=((uint16*)tmpscr)[x];
	  	((uint16*)tmpscr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  tmpscr+=display_pitch*2;
	}
	tmpscr=scr;
	tmpdst=savescr;
	for (int yy=0;yy<display_height;yy++)
  	{
	    memcpy(tmpdst,tmpscr,display_width*2);
	    tmpdst+=display_width*2;
	    tmpscr+=display_pitch*2;
	}
  }
  if (scr) ljp_WinScreenUnlock();
            
              
  for (;;)
  {  
  	if (redraw)
  	{  	
	  	slot0=state_load(0,1);    
  		
  		
		GUI_REDRAW_BG  	(0)	
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(10,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(180,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(10,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(180,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(10,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(180,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(180,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		if (IS_GG) {
			menu_button(10,250,(char*)"RESET GG",9,&item_rect[7],2);				
		} else {
			menu_button(10,250,(char*)"RESET SMS",9,&item_rect[7],2);				
		}
		if (scr) ljp_WinScreenUnlock();				
		
  	}
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {smsgg_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (smsgg_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (smsgg_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  state_save(0);
		  result=0;
		  break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot0)
	    if (state_load(0,0)) {result=0;break;}
	  }
	  //RESET SMS/GG
	  if (IS_GG) {
	  	if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("Reset GG ?")) {sms_reset(); result=0;break;}redraw=1;}
	  } else {
	  	if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("Reset SMS ?")) {sms_reset(); result=0;break;}redraw=1;}
	  }
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {smsgg_ShowSysInfos(savescr);redraw=1;}

		if (mStopEmulation) break;
	}
  ljz_free(item_rect);
  
  if (savescr) ljz_free(savescr);
            
  smsgg_pause(0);
  return result;
}  



