#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "ljPRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif



#include "App_Cst.h"

#include "os9xpalm.h"
#include "PNOMain.h"
#include "port.h"

#include "LJZMenu.h"

unsigned int g_translateBtn[20]=
{KEY_A,KEY_B,KEY_X,KEY_Y,
KEY_L,KEY_R,KEY_START,KEY_SELECT,
KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,
KEY_QUICKLOAD,KEY_QUICKSAVE,KEY_FRAMESKIP,
KEY_SCREENMODE,KEY_RENDER,KEY_TURBO,0,0};
unsigned int g_confinput[20];


extern UInt32 ljp_showFPS,ljp_showBeltbar,ljp_showBattMode,ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;
extern uint32 os9x_renderingmode;
extern UInt32 device_type;
extern UInt16 *os9x_zodvram;
extern int os9x_spcmode;

//extern int os9x_hack;

void os9x_pause(int pause);
void ClearScreen(void);

int load_state(int num);

UInt32 mStopEmulation=0;

unsigned long Run()
{
	UInt8 hostcount = 0;
	UInt32 pollcpt = 0;
	UInt32 keys,keyval;
    Int16 penX,penY;
    Boolean penDown;
    UInt32 *ftrptr;
    Int32 lastTick;
    char text[16];
    Int32 framerate = 0;
    Int32 timecpt,framecpt = 0;
    
//    SHOW_3D_INTRO(GetTickCount)

	//Read the key config
	
 	FtrGet(CREATORID,FTR_OPT_INPUTCONF_ID ,(unsigned long*)&ftrptr);
	for (int i=0;i<20;i++) g_confinput[i]=ByteSwap32(ftrptr[i]);
	//
	FtrGet(CREATORID,FTR_OPT_SHOWFRAMERATE_ID ,(unsigned long*)&ljp_showFPS);
	FtrGet(CREATORID,FTR_OPT_SHOWBELTBAR_ID ,(unsigned long*)&ljp_showBeltbar);
	FtrGet(CREATORID,FTR_OPT_SHOWBATTMODE_ID ,(unsigned long*)&ljp_showBattMode);
	FtrGet(CREATORID,FTR_OPT_ISLOWRES_ID ,(unsigned long*)&ljp_isLowRes);
	FtrGet(CREATORID,FTR_OPT_CONFIRMOW_ID ,(unsigned long*)&ljp_confirmOW);
	FtrGet(CREATORID,FTR_OPT_CONFIRMSL_ID ,(unsigned long*)&ljp_confirmSL);
	
	FtrGet(CREATORID,FTR_OPT_SNESHACKS_ID ,(unsigned long*)&os9x_hack);
	
	
	
	//Load the Rom

	mStopEmulation=os9x_loadrom();
	
	if (device_type & BF_ZODIAC) {
		os9x_zodvram=(UInt16*) stubzodiacblit ( 0,0,0,0 );
		if (!os9x_zodvram) menu_info("Zodiac VRAM NULL ptr!!");
	}

	ClearScreen();
	//
	//Main Loop
	if (g_pnobridge->game_rom){
		load_state(g_pnobridge->game_rom-1);
	}
	
	timecpt=GetTickCount();
	while (!mStopEmulation)
	{
	
   	    //Read key state
	    keys = KeyCurrentState();
	    
		keyval=0;

		//check pen
		if (!(pollcpt&3)) LJP_CHECK_MENU_ACCESS(os9x_ShowMenu,os9x_renderingmode>=2)
		
		//handle sys event
		if (!(pollcpt&31)) LJP_HANDLE_EVENT(os9x_pause)
				
		//avoid autoff
		//every 1024 frame => 
		if (!(pollcpt&1023)) EvtResetAutoOffTimer(); 
		
		LJP_UPDATE_KEYS
		
		os9x_updatevpad(keyval);
		
		if (keyval&KEY_FRAMESKIP) 
		{
			os9x_changefskip();
			ClearScreen();
		}
		if (keyval&KEY_SCREENMODE) 
		{
			os9x_changerendering();
			stub_DrawBeltBar();
			ClearScreen();
		}
		
		pollcpt++;	
		//Emulate SNES		
		
		S9xMainLoop();

		
		framecpt++;
		if ((os9x_renderingmode<2) && (( (ljp_showFPS) || (ljp_showBeltbar) )))
		if (framecpt>=30) {
		  //FPS
		    UInt8 *vr;
			vr=(UInt8*)(g_pnobridge -> vram)/*+(g_pnobridge -> display_pitch)*2*/;		
			framecpt=0;
			framerate=30*1000/(GetTickCount()-timecpt+1);
			timecpt=GetTickCount();

			if (ljp_showBeltbar) {
				beltbar_draw(0,g_pnobridge -> display_height-BELTBAR_SIZE,g_pnobridge -> display_pitch,framerate,0,vr);
			} else if (ljp_showFPS) {
				for (int y=0;y<20;y++)
				{	
					memset(vr,0,80*2);
					vr+=(g_pnobridge -> display_pitch)*2;
				}
				
				text[0]=((framerate/100)%10)+48;
				text[1]=((framerate/10)%10)+48;
				text[2]=((framerate)%10)+48;
				text[3]=0;
				
				menu_messageRaw(5,0,text);
			}
		}
	}

	if (!os9x_spcmode) os9x_end();

	if (device_type & BF_ZODIAC) {
		stubzodiacblit ( 1,0,0,0 );
	}

	return 0;
}



/************************************/


void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height-(os9x_renderingmode<2?BELTBAR_SIZE:0);y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}

int gui_redraw_bg_func(int *red,uint8 **scrP,uint8 *savescr,uint8 batt){
	int redraw;
	int result;
	uint8 *scr;
	redraw=*red;
	scr=*scrP;
	GUI_REDRAW_BG(batt)
	*red=redraw;
	*scrP=scr;
	return result;
}
