/*
 * Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 *
 * (c) Copyright 1996 - 2000 Gary Henderson (gary@daniver.demon.co.uk) and
 *                           Jerremy Koot (jkoot@snes9x.com)
 *
 * Super FX C emulator code 
 * (c) Copyright 1997 - 1999 Ivar (Ivar@snes9x.com) and
 *                           Gary Henderson.
 * Super FX assembler emulator code (c) Copyright 1998 zsKnight and _Demo_.
 *
 * DSP1 emulator code (c) Copyright 1998 Ivar, _Demo_ and Gary Henderson.
 * DOS port code contains the works of other authors. See headers in
 * individual files.
 *
 * Snes9x homepage: www.snes9x.com
 *
 * Permission to use, copy, modify and distribute Snes9x in both binary and
 * source form, for non-commercial purposes, is hereby granted without fee,
 * providing that this license information and copyright notice appear with
 * all copies and any derived work.
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event shall the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Snes9x is freeware for PERSONAL USE only. Commercial users should
 * seek permission of the copyright holders first. Commercial use includes
 * charging money for Snes9x or software derived from Snes9x.
 *
 * The copyright holders request that bug fixes and improvements to the code
 * should be forwarded to them so everyone can benefit from the modifications
 * in future versions.
 *
 * Super NES and Super Nintendo Entertainment System are trademarks of
 * Nintendo Co., Limited and its subsidiary companies.
 */
 
#define OS9X_TURBOFSKIP 15

//#include <TapWave.h>





//#define TESTING
//#define TESTING_LOADQUICKATSTART

#include "os9xpalm.h"



#define OS9X_ROMSDIR "0:/PALM/Programs/LJP/SNES/Roms/" //"gp:\\snes\\ffmq11.zip"
#define OS9X_SAVESDIR "0:/PALM/Programs/LJP/SNES/Saves/"


#define _MAX_SKIP_FRAME_ 10
#define AUTO_FSKIP 10
#define SKEEZIX_FSKIP 11

/***********************************************/
/* SNES9X headers */
#include "snes9x.h"
#include "memmap.h"
//#include "debug.h"
#include "cpuexec.h"
#include "ppu.h"
#include "snapshot.h"
#include "apu.h"
#include "display.h"
#include "snes9x/gfx.h" //same name as NGP header
#include "soundux.h"
#include "cheats.h"

#include "gammatab.h"

extern UInt32 ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;

#include "os9xZ_openspc.h"

extern "C" UInt32 mStopEmulation;
extern "C" UInt32 device_type;


char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};

extern int os9x_statecompress(char *source,char *dest,char *img);
extern int os9x_stateuncompress(char *source,char *dest);

int os9x_load(char *ext);
int os9x_loadzsnes(char *ext);
int os9x_save(char *ext);
/*****************/
extern "C" {

#include "LJZmenu.h"
#include "App_Cst.h"
#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "ljPRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif

#include "PNOMain.h"



#include "stretch_nester.h"
#include "filters.h"

int __getdate_file(const char * name);
void ClearScreen(void);
Int8 remove ( const char *filename );
Int8 fgetdate( const char *filename,UInt32 *date);

void os9x_pause(int pause);

void os9x_changerendering(void);
}
/**************************/



#ifdef TITLE
#undef TITLE
#define TITLE "OpenSNES9XZ"
#endif

/****************/

/* timing stuff*/
uint32 os9x_frame;
volatile int os9x_timertps_running;
volatile int os9x_timersnd_running;
uint32 os9x_framerendered;
uint32 os9x_framecomputed;
int32 os9x_frameBeginTime;
/************************/
/* emu options */

int os9x_hack;

uint32 os9x_asmcpu;

uint32 os9x_gammavalue;

extern unsigned char gammatab[10][32];

int32 os9x_fastmode;
int32 os9x_fskipvalue;

int32 os9x_specialskipframe;

int32 os9x_flipping;

int os9x_showfps;
int32 os9x_ShowSub;
int32 os9x_PalBrightness;
int os9x_apuenabled;
int os9x_sampledecoder;
int os9x_syncmode;
int os9x_fastsprite;

int os9x_spcmode;

int os9x_fastforward;

int os9x_softrendering;
uint8 *vrambuffer;

int os9x_BG_Forced;
int os9x_DisableIRQ;
int os9x_DisableHDMA;
int os9x_CyclesPercentage;
/************************/
int framecpto;

int os9x_emupaused;

/* not used yet*/


/************************/
/*sound stuff*/
int os9x_soundenabled;


/*volatile uint32 os9x_sndThSample_Int,os9x_sndThSample_Dec;
volatile uint32 os9x_sndThSample_Int_Incr,os9x_sndThSample_Dec_Incr;
volatile uint32 os9x_sndRealSample;*/

uint8 *os9x_sndBuffer;
uint8 *os9x_sndBufferpos,*os9x_sndBufferend;
uint32 os9x_sndSz;
int os9x_sndFrequency;
int os9x_sndStereo;
int os9x_snd16bits;
int os9x_sndBuffsize;

/************************/
/* video */


uint16 *os9x_zodvram;
uint8 *os9x_curTileCachePtr;

int os9x_screen_h,os9x_screen_w;


//uint8 *os9x_tileCachesPtr[3];
//uint8 *os9x_curRenderingScreenPtr,*os9x_tmpRenderingScreenPtr;
//uint8 *os9x_RenderingScreenPtr[2];
//int os9x_curRenderingScreenIndex;


uint32 os9x_ColorsChanged;
uint32 os9x_renderingmode;
uint32 os9x_smoothmode;


/* inputs */
volatile char os9x_exitemu;

uint32 os9x_autofireA,os9x_autofireB,os9x_autofireX,os9x_autofireY;
uint32 os9x_autofireL,os9x_autofireR;
uint32 os9x_speedpct;

uint32 os9x_vpad;


/****************/
char rom_filename[256];
char shortrom_filename[256];
char os9x_romsdir[256];
char os9x_savesdir[256];
char sram_filename[256];
char tmp_filename[256];
char os9x_curVolume;
/****************/



#include "SoundMgr.h"
static SndStreamRef snd_stream=NULL;
Int32 snd_stream_vol;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
int in_mix=0;

void S9xGetSaveFilename (char *ex,char *filename);

START_EXTERN_C

void emu_resettimer(void) {
	os9x_frameBeginTime=GetTickCount()+Settings.FrameTime*100/os9x_speedpct;
}

void SNES_togglesound(void) {
	char tmp[64];
	int i;
	int opt;
	
	//Settings.NextAPUEnabled = Settings.APUEnabled=os9x_apuenabled=os9x_soundenabled=1;
	
	opt=os9x_soundenabled;
	
	os9x_pause(1);
	
	opt++;
	if (opt>2) opt=0;
	
	if (opt==0) strcpy(tmp,"Sound : OFF");
	else if (opt==1) strcpy(tmp,"Sound : SIM");
	else if (opt==2) strcpy(tmp,"Sound : ON");

	menu_message(tmp);
	
	LJP_WAIT(300);
	
	if (opt) {
		if (!os9x_soundenabled)
  		{
			if (menu_confirm("RESET adviced. Do it ?")) S9xReset();
	  	}
	} else {
		CPU.APU_APUExecuting=0;
	}
	
	Settings.NextAPUEnabled = Settings.APUEnabled=os9x_apuenabled=os9x_soundenabled=opt;
	
	emu_resettimer();
	
	os9x_pause(0);
}

char SNES_reset(void) {
	os9x_pause(1);
	
	if (menu_confirm("Reset SNES ?")) {S9xReset(); /*return 1;*/}
  	
  	emu_resettimer();
  	
  	os9x_pause(0);
  	
  	return 0;
}

void SNES_quicksave(void) {
	os9x_pause(1);
	
	if (CONFIRM_SAVE) os9x_save(".za0");
	emu_resettimer();
	ClearScreen();
	
	os9x_pause(0);
}

void SNES_quickload(void) {
	int slot0;
	FILE *savefile;
	
	os9x_pause(1);
	
  	S9xGetSaveFilename (".za0",sram_filename);
	savefile=fopen(sram_filename,"rb");
    if (savefile) {
  		slot0=1;
	  	fclose(savefile);	
  	} else slot0=0;

	if (slot0)
	{
		if (CONFIRM_LOAD) os9x_load(".za0");
		emu_resettimer();
		ClearScreen();
	}
	
	os9x_pause(0);
}

END_EXTERN_C

static Err os9x_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}	
//	if (frameCountZ==os9x_sndBuffsize){
		if (!in_mix){
			in_mix=1;
			S9xMixSamples((uint8*)bufferZ,(int)(frameCountZ<<(os9x_sndStereo)));
			in_mix=0;
		}
//	}
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}


int32 os9x_time()
{
	//TODO return time
	//return 0;
	int32 l;
	l=TimGetTicks();		
	return l*1000/SysTicksPerSecond();
}







void os9x_TextOut(uint8 *buffer,int X,int Y,char *A,int col,int bold);

#define MsgAll(X,Y,A,col) {\
  /*os9x_TextOut(os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex],X,Y,A,col,0);*/}

  
extern void init_logop(void);
extern void close_logop(void);  
  
  

char g_filename[512];
const char *S9xGetFilename (const char *ex);

void S9xLoadSDD1Data ()
{
	Settings.SDD1Pack=TRUE;
}


void OutOfMemory()
{
 S9xMessage(0,0,"Out of memory ...\n");  
 os9x_pause(1);  
}

/*
  Initialisation des variables systemes de la SNES
*/

const char *S9xBasename (const char *f)
{
  const char *p;
  if ((p = strrchr (f, '/')) != NULL || (p = strrchr (f, '\\')) != NULL)
    return (p + 1);
  return (f);
}

void S9xExtraUsage (){}
void S9xGraphicsMode (){}
void S9xTextMode (){}

bool8 S9xInitUpdate ()
{  
  GFX.Screen=vrambuffer;
//  os9x_curRenderingScreenPtr=os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex];    
  return(TRUE);
}



void os9x_asmfastrender(uint8 *screen,uint8 *source,int height,int pitch)
{
	__asm{	
		cmp   r2,#0
		beq	  fin
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
	 loopY:	
		ldmia r1!,{r3-r12}  //r3-r12 : 10regs -> 40bytes <=> 20pixels
		stmia r0!,{r3-r12} //20
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //40
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //60
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //80
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //100
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //120
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //140
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //160
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //180
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //200
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //220
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //240
		ldmia r1!,{r3-r10}
		stmia r0!,{r3-r10} //256						
		add	  r0,r0,r14 
		subs  r2,r2,#1
		bne   loopY
	
		
		ldmfd r13!,{r3-r12,r14}	
	fin:		
		}	
}

START_EXTERN_C
void ljp_asmfastrender(uint8 *screen,uint8 *source,int height,int pitch);
void ljp_asmfastrenderX15(uint8 *screen,uint8 *source,int height,int pitch);
void ljp_asmfastrenderX15sm(uint8 *screen,uint8 *source,int height,int pitch);
END_EXTERN_C

bool8 S9xDeinitUpdate (int Width, int Height, bool8 sixteen_bit)
{
  int i,j;  
  if (Width==256) 
	{
		if (Height<=240)
		{		 
#ifdef PROFILING	 
PROF_START(15);
#endif

					
    	  UInt16 *tline,*fline;
			
			
		  fline = (UInt16*)vrambuffer;//+((240-Height)>>1)*256;
		  if (!ljp_isLowRes) {
			switch (os9x_renderingmode)
			{
				case 0:
				case 2:	
					tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-Height-(os9x_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-256)>>1);			
					ljp_asmfastrender((uint8*)tline,(uint8*)fline,Height,(display_pitch-256)<<1);		
					break;		
				case 1:
				case 3:							
					if (device_type&BF_ZODIAC){				
						if (os9x_smoothmode&_ZOD_SMOOTHING_) {
							tline = ((UInt16*) os9x_zodvram);				
							ljp_asmfastrender((uint8*)tline,(uint8*)fline,Height,(480-256)<<1);
							stubzodiacblit(3,256,Height,4);
							break;
						}else if (!os9x_smoothmode) {
							tline = ((UInt16*) os9x_zodvram);				
							ljp_asmfastrender((uint8*)tline,(uint8*)fline,Height,(480-256)<<1);
							stubzodiacblit(3,256,Height,0);
							break;
						}
					}
					tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-Height*5/4-(os9x_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-320)>>1);
					if (os9x_smoothmode==0) ljp_asmfastrenderX15((uint8*)tline,(uint8*)fline,Height,(display_pitch-320)<<1);
					else if (os9x_smoothmode==1) ljp_asmfastrenderX15sm((uint8*)tline,(uint8*)fline,Height,(display_pitch-320)<<1);
					else if (os9x_smoothmode==2) StretchNesterTrue(fline,tline,256,display_pitch,Height);
					else if (os9x_smoothmode==3) fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,256*2,SCALE_2XSAI,256,Height,320,Height*5/4);
					break;		
				case 4:
					if (device_type&BF_ZODIAC){						
					if (os9x_smoothmode&_ZOD_SMOOTHING_) {
						tline = ((uint16*) os9x_zodvram);
						ljp_asmfastrender((uint8*)tline,(uint8*)fline,Height,(480-256)<<1);
						stubzodiacblit(3,256,Height,5);
						break;
					} else if (!os9x_smoothmode) {
						tline = ((uint16*) os9x_zodvram);
						ljp_asmfastrender((uint8*)tline,(uint8*)fline,Height,(480-256)<<1);
						stubzodiacblit(3,256,Height,1);
						break;
					}
					}
					if (device_type&BF_HIRESPLUS){
						tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-320)>>1) * display_pitch ) + ((display_width-480)>>1);
						if (os9x_smoothmode) fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,256*2,SCALE_2XSAI,256,(UInt32)Height,480,320/*-BELTBAR_SIZE*/);
					}
					break;
			}	
		  } else {
		    tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-140-BELTBAR_SIZE)>>1) * display_pitch ) + ((display_width-160)>>1);
			fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,256*2,SCALE_2XSAI,256,Height,160,140);
		  }
		  
		os9x_framerendered++;		  
#ifdef PROFILING
PROF_END(15);
#endif		  
 
 
#ifdef PROFILING
PROF_START(11);
#endif		  
		  
#ifdef PROFILING
PROF_END(11);
#endif		   
		  return(TRUE);
		}	      
	}    	
 menu_message("Video mode not handled now");
 menu_waitPen(NULL,NULL,1);
  return(TRUE);
}


bool8 S9xOpenSoundDevice(int mode, bool8 stereo, int buffer_size)
{     
  __asm 
  {
  	ldr  r0, = reg_sys
  	add	 r0,r0,r10
  	str	 r9,[r0]
  	str	 r10,[r0,#4]
  } 
  so.stereo = os9x_sndStereo;
  so.sixteen_bit = os9x_snd16bits;
  so.playback_rate = os9x_sndFrequency;
  so.buffer_size = os9x_sndBuffsize;
  if (so.sixteen_bit) so.buffer_size*=2;
  so.encoded = FALSE;
  
  return(TRUE);
}

bool8 S9xReadMousePosition (int which1_0_to_1, int &x, int &y, uint32 &buttons)
{ 
  x=0;
  y=0;
  buttons=0;
  return(FALSE);
}
bool8 S9xReadSuperScopePosition (int &x, int &y, uint32 &buttons)
{
  return(FALSE);
}


void S9xDeinitDisplay ()
{
  ljz_free(GFX.ZBuffer);
  ljz_free(GFX.SubZBuffer);
  ljz_free(GFX.SubScreen);
  S9xGraphicsDeinit();
}

void S9xInitDisplay ()
{
/*  if (os9x_softrendering) 
  {*/
  	GFX.Screen = vrambuffer;
  	GFX.SubScreen = (uint8 *)ljz_malloc(256*240*2);    
  	GFX.SubZBuffer = (uint8 *)ljz_malloc(256*240);
/*  }
  else 
  {
  	GFX.SubScreen = NULL;//(uint8 *)ljz_malloc(256*240*2);    
  	GFX.SubZBuffer = NULL;//(uint8 *)ljz_malloc(256*240);
  }*/
  
  GFX.Pitch = GFX.RealPitch = 256*2;
  
  GFX.ZBuffer = (uint8 *)ljz_malloc(256*240);  
  
  GFX.Delta = (GFX.SubScreen - GFX.Screen) >> 1;
  GFX.PPL = GFX.Pitch >> 1;
  GFX.PPLx2 = GFX.Pitch;
  GFX.ZPitch = GFX.Pitch >> 1;  
}

void S9xMessage (int type, int number, const char *message)
{	
	menu_message((char*)message);	
	menu_waitPen(NULL,NULL,1);
}



uint32 S9xReadJoypad (int which1_0_to_4)
{
  uint32 val=0x80000000;    
  if (which1_0_to_4==0)
  {	  
	  if (os9x_vpad&KEY_Y) 
	  {
	  	switch (os9x_autofireY)
  		{
  			case 0:val|=SNES_Y_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_Y_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_Y_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_Y_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_X) 
	  {
	  	switch (os9x_autofireX)
  		{
  			case 0:val|=SNES_X_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_X_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_X_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_X_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_B) 
	  {
	  	switch (os9x_autofireB)
  		{
  			case 0:val|=SNES_B_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_B_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_B_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_B_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_A) 
	  {
	  	switch (os9x_autofireA)
  		{
  			case 0:val|=SNES_A_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_A_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_A_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_A_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_X) 
	  {
	  	switch (os9x_autofireX)
  		{
  			case 0:val|=SNES_X_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_X_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_X_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_X_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_L) 
	  {
	  	switch (os9x_autofireL)
  		{
  			case 0:val|=SNES_TL_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_TL_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_TL_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_TL_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_R) 
	  {
	  	switch (os9x_autofireR)
  		{
  			case 0:val|=SNES_TR_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_TR_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_TR_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_TR_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_LEFT) val|=SNES_LEFT_MASK;
	  if (os9x_vpad&KEY_RIGHT) val|=SNES_RIGHT_MASK;
	  if (os9x_vpad&KEY_DOWN) val|=SNES_DOWN_MASK;
	  if (os9x_vpad&KEY_UP) val|=SNES_UP_MASK;
	  if (os9x_vpad&KEY_SELECT) val|=SNES_SELECT_MASK;
	  if (os9x_vpad&KEY_START) val|=SNES_START_MASK;
  }
  return(val);
}


extern unsigned char gammatab[10][32];
void S9xSetPalette ()
{

}

int Do_Nothing()
{
	int j=0;//rand();
	j+=1;
	return j;
}

void S9xSyncSpeed ()
{
   int haswait;   
      
   S9xProcessEvents(FALSE);      

         
   os9x_frame++;
   os9x_framecomputed++;	      
   if ((Settings.SkipFrames== AUTO_FRAMERATE)&&(!os9x_fastforward))
    {    
       int32 i;
       haswait=0;
       os9x_frameBeginTime+=Settings.FrameTime*100/os9x_speedpct;
       
       if ((int32)(os9x_frameBeginTime-GetTickCount())>(int32)(Settings.FrameTime*20))
          os9x_frameBeginTime=GetTickCount()+Settings.FrameTime;
       
//       i=os9x_frameBeginTime-GetTickCount()+1;
//       if (i>0) {haswait=1; SysTaskDelay(i);}
       while (GetTickCount()<=os9x_frameBeginTime)  haswait=1;
    
	   if (IPPU.SkippedFrames>_MAX_SKIP_FRAME_) 
	   {	   	
	   	haswait=1;
	   }
       if (!haswait) 
    	{
		  IPPU.RenderThisFrame=FALSE;
		  IPPU.SkippedFrames++;
		}
	      else
		{
		  IPPU.RenderThisFrame = TRUE;
		  IPPU.SkippedFrames = 0;
	    }
    }
  else
    {
	  os9x_frameBeginTime+=Settings.FrameTime*100/os9x_speedpct;
	  
	  if ((int32)(os9x_frameBeginTime-GetTickCount())>(int32)(Settings.FrameTime*20))
         os9x_frameBeginTime=GetTickCount()+Settings.FrameTime;       
	  haswait=0;
	  
	  if (os9x_fastforward)
	  {
	    if (++IPPU.FrameSkip > OS9X_TURBOFSKIP)
		{	
			IPPU.RenderThisFrame=TRUE;
			IPPU.FrameSkip=0;
		}
		else
		{
			IPPU.RenderThisFrame=FALSE;
		}
	  }
	  else
	  {
        if (++IPPU.FrameSkip > Settings.SkipFrames)
		{	
        	int32 i;
			while (GetTickCount()<=os9x_frameBeginTime) 
   	   			haswait=1;
   	   		i=os9x_frameBeginTime-GetTickCount()+1;
//	        if (i>0) {SysTaskDelay(i);}
			
			IPPU.RenderThisFrame=TRUE;
			IPPU.FrameSkip=0;
		}
		else
		{
			IPPU.RenderThisFrame=FALSE;
			
			if (os9x_soundenabled==2)
			{
				while (GetTickCount()<=os9x_frameBeginTime) haswait=1;
//				int i=os9x_frameBeginTime-GetTickCount()+1;
//		        if (i>0) {SysTaskDelay(i);}
		    }
			
   	   			
		}
	  }
    }    
}

void S9xInitInputDevices()
{
}

void S9xSetTitle(char *title)
{
}

char *GetSnapName()
{  
  return(NULL);
}



void S9xGetSaveFilename (char *ex,char *filename)
{

  strcpy (filename, os9x_savesdir);
  strcat (filename, shortrom_filename);  
  strcat (filename, ex);  

}



void Snes_Close_ROM()
{    

  
  S9xGetSaveFilename (".srm",sram_filename);   
  Memory.SaveSRAM (sram_filename);

  if (Settings.APUEnabled) S9xSetSoundMute (TRUE);  
  //S9xSaveCheatFile (S9xGetFilename (".cht"));
  S9xDeinitDisplay ();  

  S9xDeinitAPU ();

  Memory.Deinit ();

}

void S9xReinitsound()
{
/*  if (0)
  {
  	  S9xSetSoundMute(TRUE);  
	  S9xOpenSoundDevice(os9x_sndFrequency,os9x_sndStereo,os9x_sndBuffsize);
	  S9xSetSoundMute(FALSE);					
  }*/
}


int os9x_save(char *ext)
{
	menu_message("Saving");		
/*	strcpy (tmp_filename, os9x_savesdir);
	strcat (tmp_filename, "tmp.xxx");  	*/

	S9xGetSaveFilename (ext,sram_filename);			

	S9xFreezeGame(/*tmp_filename*/sram_filename);

	/*menu_message("Zipping");					
	int res=os9x_statecompress(tmp_filename,sram_filename,NULL);	
	if (res)
	{
		char str[64];
		sprintf(str,"Error %d",res);
		menu_message(str);
		menu_waitPen(NULL,NULL,1);
	}
	remove(tmp_filename);*/
	return 0;
}



int os9x_load(char *ext)
{
	int snap_exist;
	FILE *savefile;
	S9xGetSaveFilename (ext,sram_filename);
	savefile=fopen(sram_filename,"rb");
  	if (savefile) 
  	{
  		fclose(savefile);
/*		strcpy (tmp_filename, os9x_savesdir);
	  	strcat (tmp_filename, "tmp.xxx");  
	  	menu_message("Unzipping");
		os9x_stateuncompress(sram_filename,tmp_filename);*/
		menu_message("Loading");
		S9xUnfreezeGame(sram_filename/*tmp_filename*/);					
//		remove(tmp_filename);		  
		S9xInitUpdate();
		S9xReschedule ();
		return 1;
	}
	return 0;
}


int os9x_loadzsnes(char *ext)
{
	int snap_exist;
	FILE *savefile;
	S9xGetSaveFilename (ext,sram_filename);
	savefile=fopen(sram_filename,"rb");
  	if (savefile) 
  	{
  		fclose(savefile);		
		S9xUnfreezeGame(sram_filename);
		S9xInitUpdate();
		S9xReschedule ();
		return 1;
	}
	return 0;
}



void S9xProcessEvents (bool8 block)
{  
	if (os9x_vpad&KEY_QUICKLOAD)
	{
		FILE *savefile;
	  	S9xGetSaveFilename (".za0",sram_filename);
		savefile=fopen(sram_filename,"rb");
	    if (savefile) 
	    {	  		
		  	fclose(savefile);	
		  	if (CONFIRM_LOAD) os9x_load(".za0");
	  	}	  			
	}
	
	if (os9x_vpad&KEY_QUICKSAVE)
	{
		if (CONFIRM_SAVE)
		{
			os9x_save(".za0");
		}
	}
	
	if (os9x_vpad&KEY_RENDER)
	{
		os9x_softrendering++;
		if (os9x_softrendering>2) os9x_softrendering=1;
		os9x_ShowSub=0;
	  	ZeroMemory (IPPU.TileCached [TILE_2BIT], (MAX_2BIT_TILES+MAX_4BIT_TILES+MAX_8BIT_TILES)<<1);
    	S9xInitUpdate();
		S9xReschedule ();
		switch (os9x_softrendering)
		{
//			case 0:menu_message("Render : Hardware");break;
			case 1:menu_message("Render : Software - fast");break;
			case 2:menu_message("Render : Software - exact");break;
		}
		int i=GetTickCount();
		while ((GetTickCount()-i)<300)
		{
		}
		os9x_frameBeginTime=GetTickCount()+Settings.FrameTime*100/os9x_speedpct;
		ClearScreen();
	}
	
	if (os9x_vpad&KEY_TURBO)
	{			
		os9x_fastforward=1;		
	}
	else 
	if (os9x_fastforward)
	{
		os9x_fastforward=0;
		os9x_frameBeginTime=GetTickCount()+Settings.FrameTime*100/os9x_speedpct;
	}
}

void S9xGenerateSound ()
{
}

void S9xExit ()
{ 
  S9xSetSoundMute (TRUE);
  S9xDeinitDisplay ();
  S9xGetSaveFilename (".srm",sram_filename);   
  Memory.SaveSRAM (sram_filename);
  //S9xSaveCheatFile (S9xGetFilename (".cht"));
  Memory.Deinit ();
  S9xDeinitAPU ();
}

void _makepath (char *path,const char *,const char *dir,
		 const char *fname, const char *ext)
{
  if (dir && *dir)
    {
      strcpy (path, dir);
      strcat (path, SLASH_STR);
    }
  else
    *path = 0;
  strcat (path, fname);
  if (ext && *ext)
    {
      strcat (path, ".");
      strcat (path, ext);
    }
}

void _splitpath (const char *path, char *drive, char *dir, char *fname,
		 char *ext)
{
  *drive = 0;

  char *slash = (char*)strrchr (path, '/');
  if (!slash)
    slash =  (char*)strrchr (path, '\\');

  char *dot =  (char*)strrchr (path, '.');

  if (dot && slash && dot < slash)
    dot = NULL;

  if (!slash)
    {
      strcpy (dir, "");
      strcpy (fname, path);
      if (dot)
        {
	  *(fname + (dot - path)) = 0;
	  strcpy (ext, dot + 1);
        }
      else
	strcpy (ext, "");
    }
  else
    {
      strcpy (dir, path);
      *(dir + (slash - path)) = 0;
      strcpy (fname, slash + 1);
      if (dot)
	{
	  *(fname + (dot - slash) - 1) = 0;
	  strcpy (ext, dot + 1);
	}
      else
	strcpy (ext, "");
    }
}

void S9xAutoSaveSRAM ()
{
//  S9xGetSaveFilename (".srm",sram_filename);   
//  Memory.SaveSRAM (sram_filename);
}

const char *GetHomeDirectory ()
{
//  return (getenv ("HOME"));
	return NULL;
}


const char *S9xGetFilename (const char *ex)
{
  

  //_splitpath (rom_filename/*Memory.ROMFilename*/, drive, dir, fname, ext);
  strcpy (g_filename, os9x_romsdir);
  
  strcat (g_filename, shortrom_filename);
  strcat (g_filename, ex);

  return (g_filename);
}



const char *S9xGetROMDirectory ()
{
  return (os9x_romsdir);
}


const char *S9xChooseFilename (bool8 read_only,uint8 num)
{  
  return (NULL);
}

bool8 S9xOpenSnapshotFile (const char *fname, bool8 read_only, STREAM *file)
{
 /* char filename [PATH_MAX];
  char drive [_MAX_DRIVE];
  char dir [_MAX_DIR];
  char ext [_MAX_EXT];*/

 // strcpy(filename,fname);

  if (read_only)
    {
      if (*file = OPEN_STREAM(fname,"rb")) return(TRUE);
    }
  else
    {
      if (*file = OPEN_STREAM(fname,"w+b")) return(TRUE);
    }
  return (FALSE);
}

void S9xCloseSnapshotFile (STREAM file)
{
  CLOSE_STREAM (file);
}

//extern int32 dsp_opcode[256];
void Snes9X_Start()
{  

//  ClearScreen();
  //memset(dsp_opcode,0,256*4);

  os9x_frameBeginTime=GetTickCount();
  os9x_frame=0;

  os9x_framerendered=0;
  
  os9x_timertps_running=0;
  os9x_timersnd_running=0;
  os9x_emupaused=1;
  
    
  os9x_exitemu=0;
  os9x_emupaused=0;
  
#ifdef TESTING
  init_logop();
#endif  
  //called once before starting because sound issue
//
  os9x_pause(0);
}



void os9x_paramInit(void)
{  
	/*hack*/
	
	//os9x_hack=0;
	
  //default values
  /*gfx*/
  os9x_flipping=0;
  
  os9x_gammavalue=0;
  os9x_showfps=0;
  
  os9x_specialskipframe=0;
  
  os9x_syncmode=0;
  
  os9x_fastforward=0;
  
  int val;
  FtrGet(CREATORID,FTR_OPT_FSKIP_ID,(unsigned long*)&val); 
  os9x_fskipvalue=val;
  
  
  FtrGet(CREATORID,FTR_OPT_CPUCORE_ID,(unsigned long*)&val);  
  os9x_asmcpu=val;
  
  os9x_fastmode=1;
  /*input*/   
  
  os9x_autofireA=0;
  os9x_autofireB=0;
  os9x_autofireX=0;
  os9x_autofireY=0;
  os9x_autofireL=0;
  os9x_autofireR=0;
  os9x_speedpct=100;
  
  /*hack*/
  
  FtrGet(CREATORID,FTR_OPT_SNESTRANSP_ID,(unsigned long*)&val);
  if (os9x_softrendering!=1) val=0;  
  os9x_ShowSub=(val?4:0);
  
  os9x_PalBrightness=0;
  os9x_fastsprite=0;
  os9x_BG_Forced=0;
  os9x_DisableIRQ=0;
  os9x_DisableHDMA=0;
  os9x_CyclesPercentage=100;
  /*sound*/
  FtrGet(CREATORID,FTR_OPT_SOUND_ID,(unsigned long*)&val);
  os9x_soundenabled=val;
  os9x_sampledecoder=0;//0;//4;
  
  FtrGet(CREATORID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);
  if (val==1) os9x_sndFrequency=22050;
  else if (val==2) os9x_sndFrequency=11025;
  else os9x_sndFrequency=44100;
  
  FtrGet(CREATORID,FTR_OPT_FSKIP_ID,(unsigned long*)&val); 
  os9x_fskipvalue=val;
  
  os9x_sndBuffsize=1024;//1024;
  os9x_sndStereo=1;
  os9x_snd16bits=1;//1;  
  //  
  FtrGet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,(unsigned long*)&val); 
  snd_stream_vol=val;
  if (snd_stream_vol<0) snd_stream_vol=0;
  if (snd_stream_vol>128) snd_stream_vol=128;
  snd_stream_vol*=16;  
}

int os9x_Init(void)
{
  int i;
	unsigned long val;	
/*  char strtmp[64];
  unsigned long freeP,maxP;
  MemHeapFreeBytes(0,(unsigned long*)&freeP,(unsigned long*)&maxP);
  sprintf(strtmp,"free heap :\n%d\n%d",freeP,maxP);
  S9xMessage(1,0,strtmp);*/
  
  /*emu parameters ini*/
  os9x_paramInit();
	
  os9x_vpad=0;
//  os9x_curRenderingScreenIndex=0;        
//  os9x_curRenderingScreenPtr=os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex];
  os9x_sndBuffer=NULL;      

  
  FtrGet(CREATORID,FTR_OPT_FAST_SPR_ID,(unsigned long*)&val);  
  os9x_fastsprite=val;
  

	
   snd_stream=0;
 /*********************/ 
  
	unsigned long val1,val2;
	FtrGet(CREATORID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(CREATORID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
	os9x_renderingmode=val1;
	os9x_smoothmode=val2;
	filters_init();	
		
	if (os9x_smoothmode==2){
		if (InitStretchTables()){
			menu_info("Err:InitStretchTables");
			os9x_smoothmode=0;
		}
	}

  
      
  os9x_apuenabled=os9x_soundenabled;  
      
	
  ZeroMemory (&Settings, sizeof (Settings));

  // ROM Options
    memset (&Settings, 0, sizeof (Settings));

    Settings.ForceLoROM = false;
    Settings.ForceInterleaved = false;

    Settings.ForceNotInterleaved = false;
    Settings.ForceInterleaved = false;
    Settings.ForceInterleaved2 = false;

    Settings.ForcePAL = false;
    Settings.ForceNTSC = false;
    Settings.ForceHeader = false;
    Settings.ForceNoHeader = false;   

    // Sound options        
    
    Settings.SoundSync = FALSE;
    Settings.InterpolatedSound = FALSE;//TRUE;
    Settings.SoundEnvelopeHeightReading = TRUE;
    Settings.DisableSoundEcho = FALSE;
    Settings.DisableMasterVolume = FALSE;
    Settings.Mute = FALSE;
    Settings.SoundSkipMethod = 0;
    Settings.SoundPlaybackRate = os9x_sndFrequency;
    Settings.SixteenBitSound = os9x_snd16bits;
    Settings.Stereo = os9x_sndStereo;
    Settings.AltSampleDecode = os9x_sampledecoder;
    Settings.ReverseStereo = FALSE;
//    Settings.SoundDriver = 0;//WIN_SNES9X_DIRECT_SOUND_DRIVER;
    Settings.SoundBufferSize = 0;//4;
    Settings.SoundMixInterval = 0;//20;
	Settings.DisableSampleCaching=TRUE;
	
	Settings.FixFrequency = FALSE;

    // Tracing options
    Settings.TraceDMA = false;
    Settings.TraceHDMA = false;
    Settings.TraceVRAM = false;
    Settings.TraceUnknownRegisters = false;
    Settings.TraceDSP = false;

    // Joystick options
    Settings.SwapJoypads = false;
    Settings.JoystickEnabled = false;

    // ROM timing options (see also H_Max above)
    Settings.PAL = false;
    Settings.FrameTimePAL = 20;
    Settings.FrameTimeNTSC = 17;    

    // CPU options 
    Settings.CyclesPercentage = os9x_CyclesPercentage;
    Settings.Shutdown = true;
    Settings.ShutdownMaster = true;
    Settings.NextAPUEnabled = Settings.APUEnabled = os9x_apuenabled;
    Settings.DisableIRQ = os9x_DisableIRQ;
    Settings.Paused = false;
    Settings.H_Max = SNES_CYCLES_PER_SCANLINE;
    Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;
    
    os9x_specialskipframe=0;
    if (os9x_fskipvalue==AUTO_FSKIP) Settings.SkipFrames=AUTO_FRAMERATE;
    else if (os9x_fskipvalue==SKEEZIX_FSKIP) 
    {
    	Settings.SkipFrames=0;
    	os9x_specialskipframe=1;
    }
    else Settings.SkipFrames=os9x_fskipvalue;


    // ROM image and peripheral options
    Settings.ForceSuperFX = false;
    Settings.ForceNoSuperFX = false;
    Settings.MultiPlayer5 = true;
    Settings.Mouse = true;
    Settings.SuperScope = true;
    Settings.MultiPlayer5Master = true;
    Settings.SuperScopeMaster = true;
    Settings.MouseMaster = true;
    Settings.SuperFX = false;
 
    // SNES graphics options
    Settings.BGLayering = false;
    Settings.DisableGraphicWindows = false;
    Settings.ForceTransparency = false;
    Settings.ForceNoTransparency = false;
    Settings.DisableHDMA = os9x_DisableHDMA;
    Settings.Mode7Interpolate = false;
    Settings.DisplayFrameRate = false;
    
    Settings.SixteenBit = 1;
    Settings.Transparency = 1;
    Settings.SupportHiRes = false;

    Settings.AutoSaveDelay = 0;
    Settings.ApplyCheats = true;

    Settings.TurboMode = false;
    Settings.TurboSkipFrames = 15;
    Settings.AutoMaxSkipFrames = 10;

    Settings.Port = 1996;


framecpto=0;

  Settings.ForcedPause = 0;
  Settings.StopEmulation = TRUE;
  Settings.Paused = FALSE;
     
  
  Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;
  
//  S9xMessage(0,0,"Init Memory");

	
  if (!Memory.Init ())
    OutOfMemory ();
	
//  S9xMessage(0,0,"Init Display");


  S9xInitDisplay ();
  

//  S9xMessage(0,0,"Init Graphics");

	
  if (!S9xGraphicsInit ())
    OutOfMemory ();
	
//  S9xMessage(0,0,"Init APU");

  if (!S9xInitAPU())
    OutOfMemory ();
	
//  S9xMessage(0,0,"Init Sound");


  S9xInitSound (Settings.SoundPlaybackRate, Settings.Stereo,Settings.SoundBufferSize);
  if (!Settings.APUEnabled)
	
    {
//      S9xMessage(0,0,"Sound off\n");
      S9xSetSoundMute (TRUE);
    }
  uint32 saved_flags = CPU.Flags;
  
	
  if (rom_filename)
    {      
      menu_message(shortrom_filename);
      if (!Memory.LoadROM (rom_filename))
		{
	      menu_message("Could not load ROM");
	      menu_waitPen(NULL,NULL,1);
	      Snes_Close_ROM();
	      return -1;
	    }
	    
	
	  S9xGetSaveFilename (".srm",sram_filename);	  	  
	  Memory.LoadSRAM (sram_filename);	    
        //S9xLoadCheatFile (S9xGetFilename (".cht"));      
#ifdef TESTING_LOADQUICKATSTART
        os9x_load(".za0");
#endif        
    }
  else
    {
      S9xReset ();
      Settings.Paused |= 2;
    }
       
    
  CPU.Flags = saved_flags;
    
  if (Settings.APUEnabled) S9xSetSoundMute (FALSE);

  if (Settings.PAL) Settings.FrameTime=Settings.FrameTimePAL;
  else Settings.FrameTime=Settings.FrameTimeNTSC;

  int curtime=os9x_time();

  /*last init before start (needed to be done after S9xReset*/
  PPU.BG_Forced=os9x_BG_Forced;

  Snes9X_Start();

  //Snes_Close_ROM();
  return(0);
}

void S9xParseArg (char **argv, int &index, int argc)
{	
}

void os9x_setScreenWH(int w,int h)
{
	os9x_screen_h=h;
	os9x_screen_w=w;
}


START_EXTERN_C
int os9x_loadrom(void)
{   
	
  ljz_std_showstat();  
/*  char str[64];
  unsigned long maxP,freeP;
  MemHeapFreeBytes(0,&freeP,&maxP);
  sprintf(str,"RAM Free:%d Max:%d");
  menu_message(str);menu_waitPen(NULL,NULL,1);*/
  

	
  int val;
  FtrGet(CREATORID,FTR_OPT_SNESRENDER_ID,(unsigned long*)&val);
  if (val>1) val=0;
  os9x_softrendering=val+1;

  char *ftrptr;
/*#ifdef __MWERKS__
  strcat(rom_filename,"/");
#else
  strcat(rom_filename,"\\");
#endif*/

 strcpy(os9x_romsdir,OS9X_ROMSDIR);
  
  {//handle categories
    	char cat[32];
	  	FtrGet(CREATORID,FTR_OPT_CATEGORY_ID ,(unsigned long*)&ftrptr);
	  	strcpy(cat,ftrptr);
  		if ( StrCaselessCompare(cat,"uNaRcHiVeD") != 0) {
  			strcat(os9x_romsdir,cat);
	  		strcat(os9x_romsdir,"/");
	  	}
	  	//FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
  	}
  

  FtrGet(CREATORID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
  
  os9x_curVolume=ftrptr[0];
       
  os9x_romsdir[0]=os9x_curVolume+'0';  
  strcpy(os9x_savesdir,OS9X_SAVESDIR);
  os9x_savesdir[0]=os9x_curVolume+'0';
  
  strcpy(rom_filename,os9x_romsdir);      

  ftrptr+=3;
  strcpy(shortrom_filename,ftrptr);  
  char *p=StrChr(shortrom_filename,'.');
  char *q;
  q=p;
  while (p)
  {
  	q=p;
  	p=StrChr(p+1,'.');
  }
  *q=0;
                           
  
    
  strcat(rom_filename,ftrptr);
    

  
  if (StrCaselessCompare(q+1, "spc") == 0)
  {
//	  	menu_message("SPC FILE");
  	os9x_spcmode=1;
  	strcpy (g_filename, os9x_romsdir);
	strcat (g_filename, shortrom_filename);
	strcat (g_filename, ".spc");
  	OSPC_Play(g_filename);

  	return 1;
  }
  os9x_spcmode=0;
  
//  FtrPtrFree(CREATORID, FTR_ROM_FILENAME_ID);          	
  vrambuffer = (uint8*)ljz_malloc(256*(240+6)*2);
  //for scale2xsai stuff
  vrambuffer+=256*3*2;  
  	
  return os9x_Init();     
}

void os9x_updatevpad(uint32 val)
{
	os9x_vpad=val;
}

void os9x_end(void)
{		
#ifdef TESTING  
  close_logop();
#endif    
//wait for potential gfx job to finish


	os9x_pause(1);
	Snes_Close_ROM();

	vrambuffer-=256*3*2;
	ljz_free(vrambuffer);
	

	int val;
	
	FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID,os9x_smoothmode);	
	 FtrSet(CREATORID,FTR_OPT_CPUCORE_ID,  os9x_asmcpu);  


	FtrSet(CREATORID, FTR_OPT_SOUND_ID,os9x_soundenabled);
	switch (os9x_sndFrequency)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,val);
	
	FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,os9x_renderingmode);
	
	FtrSet(CREATORID, FTR_OPT_FSKIP_ID,os9x_fskipvalue);
	
	FtrSet(CREATORID, FTR_OPT_FAST_SPR_ID, os9x_fastsprite);
	FtrSet(CREATORID, FTR_OPT_SNESRENDER_ID,os9x_softrendering-1);
	FtrSet(CREATORID, FTR_OPT_SNESTRANSP_ID,(os9x_ShowSub==4));

	FtrSet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,snd_stream_vol/16);
	
	FtrSet(CREATORID, FTR_OPT_SNESHACKS_ID,os9x_hack); 

/*	char str[64];
	unsigned long maxP,freeP;
	MemHeapFreeBytes(0,&freeP,&maxP);
	sprintf(str,"RAM Free:%d Max:%d");
	menu_message(str);menu_waitPen(NULL,NULL,1);*/
	ljz_std_showstat();

}


void os9x_pause(int pause)
{
	if (pause)
	{
		if (snd_stream) stub_SndStreamGetVolume(snd_stream,&snd_stream_vol);  
		if ((os9x_soundenabled==2)&&(snd_stream))
		{
			stub_SndStreamStop(snd_stream);
			stub_SndStreamDelete(snd_stream);
			snd_stream=NULL;
		}			
		S9xSetSoundMute (TRUE);		
	}
	else
	{		
		S9xSetSoundMute (FALSE);				
		if (os9x_soundenabled==2) 
		{
			stub_SndStreamCreate(&snd_stream,sndOutput,os9x_sndFrequency,(os9x_snd16bits?sndInt16Little:sndUInt8),(os9x_sndStereo?sndStereo:sndMono),os9x_sndCallBack,&reg_sys,os9x_sndBuffsize,1);
			stub_SndStreamStart(snd_stream);
			stub_SndStreamSetVolume(snd_stream,snd_stream_vol);
		}
		os9x_frameBeginTime=GetTickCount()+Settings.FrameTime*100/os9x_speedpct;
	}
}


void os9x_changefskip(void)
{
	os9x_fskipvalue++;	
	if (os9x_fskipvalue>SKEEZIX_FSKIP) os9x_fskipvalue=0;
	
	os9x_specialskipframe=0;
	if (os9x_fskipvalue==AUTO_FSKIP) Settings.SkipFrames=AUTO_FRAMERATE;
    else if (os9x_fskipvalue==SKEEZIX_FSKIP) 
    {
    	Settings.SkipFrames=0;
    	os9x_specialskipframe=1;
    }
    else Settings.SkipFrames=os9x_fskipvalue;
	
	char tmp[64];
	if (os9x_fskipvalue==AUTO_FSKIP) sprintf(tmp,"Frameskip : AUTO");
	else if (os9x_fskipvalue==SKEEZIX_FSKIP) sprintf(tmp,"Frameskip : SKEEZIX");
	else sprintf(tmp,"Frameskip : %d",Settings.SkipFrames);	
	
	menu_message(tmp);
	int i=GetTickCount();
	while ((GetTickCount()-i)<300)
	{
	}
	
	
	os9x_frameBeginTime=GetTickCount()+Settings.FrameTime*100/os9x_speedpct;
}
END_EXTERN_C


/*********************/

char *os9x_getfilename(char *ext)
{
	return (char*)S9xGetFilename (ext);
}


/*********************/
/*********************/
/*********************/
extern "C" int gui_redraw_bg_func(int *red,uint8 **scrP,uint8 *savescr,uint8 batt);
int os9x_ShowMenuGFXConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval,hwsmooth;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(28*sizeof(RectangleType));
  char tmp[16];
  

	
  scrmode=os9x_renderingmode;
  smoothing=os9x_smoothmode&_SMOOTH_MASK_;
  hwsmooth=os9x_smoothmode&_ZOD_SMOOTHING_;
  
  fskipval=os9x_fskipvalue;	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {	  	
	    //GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	  	menu_button(10,60,(char*)"GFX ENGINE",0,&item_rect[1],2);
	  	menu_button(150,60,(char*)"SW1",(os9x_softrendering==1?2:1),&item_rect[2],0);
	  	menu_button(200,60,(char*)"SW2",(os9x_softrendering==2?2:1),&item_rect[3],0);
	  	menu_button(10,91,(char*)"TRANSPARENCY",0,&item_rect[4],2);
	  	menu_button(150,91,(char*)"OFF",((os9x_softrendering==2)|(os9x_ShowSub==4)?1:2),&item_rect[5],0);
	  	menu_button(200,91,(char*)"ON",((os9x_softrendering==2)|(os9x_ShowSub==4)?2:1),&item_rect[6],0);	  
	  	menu_button(10,122,(char*)"FAST SPRITES",0,&item_rect[7],2);
	  	menu_button(150,122,(char*)"OFF",(os9x_fastsprite==0?2:1),&item_rect[8],0);	 
	  	menu_button(200,122,(char*)"ON",(os9x_fastsprite?2:1),&item_rect[9],0);	 
	  
	  	menu_button(10,153,(char*)"FRAMESKIP",0,&item_rect[10],2);
	  	menu_bar(150,153,fskipval,11,&item_rect[11]);
	  	if (fskipval<10) sprintf(tmp,"%d",fskipval);
	  	else if (fskipval==10) sprintf(tmp,"AUTO");
	  	else sprintf(tmp,"SKZX");
	  	menu_messageRaw(260,153,tmp);
	  
	  	menu_button(10,184,(char*)"ZOOM",0,&item_rect[12],2);
	  	menu_button(150,184,(char*)"1",((scrmode==0)||(scrmode==2)?2:1),&item_rect[13],0);
	  	menu_button(200,184,(char*)"1.25",((scrmode==1)||(scrmode==3)?2:1),&item_rect[14],0);
	  	menu_button(250,184,(char*)"WIDE",(scrmode==4?2:1),&item_rect[15],0);	 
	  	
	  	
	  	menu_button(10,215,(char*)"FULLSCREEN",0,&item_rect[16],2);
	  	menu_button(150,215,(char*)"OFF",(scrmode>=2?1:2),&item_rect[17],0);
	  	menu_button(200,215,(char*)"ON",(scrmode>=2?2:1),&item_rect[18],0);
	  
	  	menu_button(10,246,(char*)"SMOOTHING",0,&item_rect[19],2);
	  	menu_button(150,246,(char*)"-",((smoothing==0)&&(!hwsmooth)?2:1),&item_rect[20],4);
	  	menu_button(180,246,(char*)"1",(smoothing==1?2:1),&item_rect[21],4);
	  	menu_button(210,246,(char*)"2",(smoothing==2?2:1),&item_rect[22],4);
	  	menu_button(240,246,(char*)"3",(smoothing==3?2:1),&item_rect[23],4);
	  	menu_button(280,246,(char*)"HW",(hwsmooth?2:1),&item_rect[24],3);
	  	
	  	menu_button(10,277,(char*)"FLIPPING",0,&item_rect[25],2);
	  	menu_button(150,277,(char*)"OFF",(os9x_flipping?1:2),&item_rect[26],0);
	  	menu_button(200,277,(char*)"ON",(os9x_flipping?2:1),&item_rect[27],0);
	  		  	
	  	
	  	if (scr) ljp_WinScreenUnlock();
	
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //GFX ENGINE 
	  //SW Fast
	  if (TEST_PEN_MENU(x,y,item_rect[2])) {
	  	redraw=1;os9x_softrendering=1;
	  	ZeroMemory (IPPU.TileCached [TILE_2BIT], (MAX_2BIT_TILES+MAX_4BIT_TILES+MAX_8BIT_TILES)<<1);
    	S9xInitUpdate();
    	S9xReschedule ();
	  }
	  //SW Exact
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {
	  	redraw=1;os9x_softrendering=2;os9x_fastsprite=0;
	  	ZeroMemory (IPPU.TileCached [TILE_2BIT], (MAX_2BIT_TILES+MAX_4BIT_TILES+MAX_8BIT_TILES)<<1);
    	S9xInitUpdate();
    	S9xReschedule ();
	  }
	  //TRANSPARENCY OFF
	  if (TEST_PEN_MENU(x,y,item_rect[5])&&(os9x_softrendering==1)) {
		  os9x_ShowSub=0;
		  redraw=1;
	  }
	  //TRANSPARENCY ON
	  if (TEST_PEN_MENU(x,y,item_rect[6])&&(os9x_softrendering==1)) {
	  	  os9x_ShowSub=4;
	  	  redraw=1;
	  }
	  //FASTSPRITES OFF
	  if (TEST_PEN_MENU(x,y,item_rect[8])&&(os9x_softrendering<2)) {
	  	  os9x_fastsprite=0;
	  	  redraw=1;
	  }
	  //FASTSPRITES ON
	  if (TEST_PEN_MENU(x,y,item_rect[9])&&(os9x_softrendering<2)) {
	  	  os9x_fastsprite=1;
	  	  redraw=1;
	  }
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[11])) {
	  	fskipval=(x-10-item_rect[11].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=2;
	  }
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[13])) {
		  scrmode&=~4;
	  	  scrmode&=~1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[14])) {
		  scrmode&=~4;
	  	  scrmode|=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[15])) {
	  	  scrmode=4;
	  	  redraw=1;
	  }
	  //SCREEN MODES FULL/WIN
	  if (TEST_PEN_MENU(x,y,item_rect[17])) {
	  	  scrmode&=~(2|4);
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[18])) {
	  	  if (scrmode<2) scrmode|=2;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[20])&&scrmode) {
		  if (smoothing==2){DeInitStretchTables();}
	  	  smoothing=0;	  	  
	  	  hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[21])&&scrmode) {
		  if (smoothing==2){DeInitStretchTables();}
	  	  smoothing=1;
	  	  hwsmooth=0;
	  	  redraw=1;	  	  
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[22])&&scrmode) {
	  	  if (smoothing!=2){	 
			if (InitStretchTables()){
				menu_message("Err:InitStretchTables");
			}else{
		  	  smoothing=2;
		  	  hwsmooth=0;
		  	}		
	  	  }
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[23])&&scrmode) {
		  if (smoothing==2){DeInitStretchTables();}
	  	  smoothing=3;
	  	  hwsmooth=0;
	  	  redraw=1;	  	  
	  }
	  //HW SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[24])&&scrmode) {
	  	  hwsmooth=_ZOD_SMOOTHING_;
	  	  if (smoothing==2){DeInitStretchTables();}
	  	  smoothing=0;
	  	  redraw=1;	  	  
	  }
	  //FLIPPING
	  if (TEST_PEN_MENU(x,y,item_rect[26])) {
	  	  os9x_flipping=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[27])) {
	  	  os9x_flipping=1;
	  	  redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  os9x_fskipvalue=fskipval;

  os9x_specialskipframe=0;
  if (os9x_fskipvalue==AUTO_FSKIP) Settings.SkipFrames=AUTO_FRAMERATE;
  else if (os9x_fskipvalue==SKEEZIX_FSKIP) 
  {
	Settings.SkipFrames=0;
    os9x_specialskipframe=1;
  }
  else Settings.SkipFrames=os9x_fskipvalue;
  
  os9x_renderingmode=scrmode;
  os9x_smoothmode=smoothing|hwsmooth;
  
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}

int os9x_ShowMenuSNDConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=snd_stream_vol/16;  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
	    //GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,0);

		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
		menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
		menu_button(150,80,(char*)"OFF",(os9x_soundenabled==0?2:1),&item_rect[2],0);
		menu_button(200,80,(char*)"SIM",(os9x_soundenabled==1?2:1),&item_rect[3],0);	  
		menu_button(250,80,(char*)"ON",(os9x_soundenabled==2?2:1),&item_rect[4],0);	 
	  
	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
	  menu_bar(150,120,vol,128,&item_rect[6]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(270,120,tmp);
	  
		if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {	  	  
		  Settings.NextAPUEnabled = Settings.APUEnabled=os9x_apuenabled=os9x_soundenabled=0;		  
		  CPU.APU_APUExecuting=0;
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  if (!os9x_soundenabled)
	  	  {
	  	  	if (menu_confirm("RESET adviced. Do it ?")) S9xReset();
	  	  }
	  	  Settings.NextAPUEnabled = Settings.APUEnabled=os9x_apuenabled=os9x_soundenabled=1;	  	  
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  if (!os9x_soundenabled)
	  	  {
	  	  	if (menu_confirm("RESET adviced. Do it ?")) S9xReset();
	  	  }
		  Settings.NextAPUEnabled = Settings.APUEnabled=os9x_apuenabled=os9x_soundenabled=2;
		  redraw=1;
	  }
	  
	  //VOLUME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x-10)*128/100;
	  	if (vol<0) vol=0;
	  	if (vol>128) vol=128;
	  	redraw=2;
	  }
	  if (mStopEmulation) break;
  }  
  
	snd_stream_vol=vol*16;  
	
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}

int os9x_ShowMenuOTHERConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(36*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		//GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,50,(char*)"AUTO A",0,&item_rect[1],4);
	  menu_button(100,50,(char*)"OFF",(os9x_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(150,50,(char*)"SLW",(os9x_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(200,50,(char*)"MED",(os9x_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(250,50,(char*)"FST",(os9x_autofireA==3?2:1),&item_rect[5],0);	  
	  menu_button(10,80,(char*)"AUTO B",0,&item_rect[6],4);
	  menu_button(100,80,(char*)"OFF",(os9x_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(150,80,(char*)"SLW",(os9x_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(200,80,(char*)"MED",(os9x_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(250,80,(char*)"FST",(os9x_autofireB==3?2:1),&item_rect[10],0);
	  menu_button(10,110,(char*)"AUTO X",0,&item_rect[11],4);
	  menu_button(100,110,(char*)"OFF",(os9x_autofireX==0?2:1),&item_rect[12],0);
	  menu_button(150,110,(char*)"SLW",(os9x_autofireX==1?2:1),&item_rect[13],0);
	  menu_button(200,110,(char*)"MED",(os9x_autofireX==2?2:1),&item_rect[14],0);
	  menu_button(250,110,(char*)"FST",(os9x_autofireX==3?2:1),&item_rect[15],0);
	  menu_button(10,140,(char*)"AUTO Y",0,&item_rect[16],4);
	  menu_button(100,140,(char*)"OFF",(os9x_autofireY==0?2:1),&item_rect[17],0);
	  menu_button(150,140,(char*)"SLW",(os9x_autofireY==1?2:1),&item_rect[18],0);
	  menu_button(200,140,(char*)"MED",(os9x_autofireY==2?2:1),&item_rect[19],0);
	  menu_button(250,140,(char*)"FST",(os9x_autofireY==3?2:1),&item_rect[20],0);
	  menu_button(10,170,(char*)"AUTO L",0,&item_rect[21],4);
	  menu_button(100,170,(char*)"OFF",(os9x_autofireL==0?2:1),&item_rect[22],0);
	  menu_button(150,170,(char*)"SLW",(os9x_autofireL==1?2:1),&item_rect[23],0);
	  menu_button(200,170,(char*)"MED",(os9x_autofireL==2?2:1),&item_rect[24],0);
	  menu_button(250,170,(char*)"FST",(os9x_autofireL==3?2:1),&item_rect[25],0);
	  menu_button(10,200,(char*)"AUTO R",0,&item_rect[26],4);
	  menu_button(100,200,(char*)"OFF",(os9x_autofireR==0?2:1),&item_rect[27],0);
	  menu_button(150,200,(char*)"SLW",(os9x_autofireR==1?2:1),&item_rect[28],0);
	  menu_button(200,200,(char*)"MED",(os9x_autofireR==2?2:1),&item_rect[29],0);
	  menu_button(250,200,(char*)"FST",(os9x_autofireR==3?2:1),&item_rect[30],0);
	  
	  menu_button(10,250,(char*)"EMU SPEED",0,&item_rect[31],4);
	  menu_bar(130,250,os9x_speedpct,100,&item_rect[32]);
	  StrIToA(tmp,os9x_speedpct);
	  strcat(tmp,"%");
    	menu_messageRaw(240,250,tmp);
    	
      menu_button(10,285,(char*)"CPU CORE",0,&item_rect[33],4);
 	  menu_button(130,285,(char*)"C",(os9x_asmcpu==0?2:1),&item_rect[34],0);
	  menu_button(180,285,(char*)"ASM",(os9x_asmcpu==1?2:1),&item_rect[35],0);
	  
		if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  os9x_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  os9x_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  os9x_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  os9x_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  os9x_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  os9x_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  os9x_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  os9x_autofireB=3;
		  redraw=1;
	  }
	  //AUTOFIRE X
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
		  os9x_autofireX=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[13])) 
	  {
		  os9x_autofireX=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[14])) 
	  {
		  os9x_autofireX=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[15])) 
	  {
		  os9x_autofireX=3;
		  redraw=1;
	  }
	  //AUTOFIRE Y
	  if (TEST_PEN_MENU(x,y,item_rect[17])) 
	  {
		  os9x_autofireY=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[18])) 
	  {
		  os9x_autofireY=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[19])) 
	  {
		  os9x_autofireY=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[20])) 
	  {
		  os9x_autofireY=3;
		  redraw=1;
	  }
	  //AUTOFIRE L
	  if (TEST_PEN_MENU(x,y,item_rect[22])) 
	  {
		  os9x_autofireL=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[23])) 
	  {
		  os9x_autofireL=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[24])) 
	  {
		  os9x_autofireL=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[25])) 
	  {
		  os9x_autofireL=3;
		  redraw=1;
	  }
	  //AUTOFIRE R
	  if (TEST_PEN_MENU(x,y,item_rect[27])) 
	  {
		  os9x_autofireR=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[28])) 
	  {
		  os9x_autofireR=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[29])) 
	  {
		  os9x_autofireR=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[30])) 
	  {
		  os9x_autofireR=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[32])) 
	  {
	  	os9x_speedpct=(x-10-item_rect[32].topLeft.x);
	  	if (os9x_speedpct>100) os9x_speedpct=100;
	  	if (os9x_speedpct<10) os9x_speedpct=10;
	  	redraw=2;
	  }
	  //CPU CORE
	  if (TEST_PEN_MENU(x,y,item_rect[34])) 
	  {
		  if (menu_confirm("RESET needed. Continue ?")) 
		  {
			os9x_asmcpu=0;		  
		  	S9xReset();
		  }
		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[35])) 
	  {
		  if (menu_confirm("RESET needed. Continue ?")) 
		  {
			os9x_asmcpu=1;
		  	S9xReset();
		  }
		  redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}

int os9x_ShowMenuHACKSConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(36*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		//GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
  		//SNES hacks

  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	  	  
	  menu_button(5,90, (char*)"IGN. FIX CLR CHANGES",0,&item_rect[1],5);
	  menu_button(215,90,(char*)"ON",((os9x_hack&PPU_IGNORE_FIXEDCOLCHANGES)?2:1),&item_rect[2],0);
	  menu_button(265,90,(char*)"OFF",((os9x_hack&PPU_IGNORE_FIXEDCOLCHANGES)?1:2),&item_rect[3],0);
	  
	  menu_button(5,130,(char*)"IGN. CLP WIN CHANGES",0,&item_rect[4],5);
	  menu_button(215,130,(char*)"ON",((os9x_hack&PPU_IGNORE_WINDOW)?2:1),&item_rect[5],0);
	  menu_button(265,130,(char*)"OFF",((os9x_hack&PPU_IGNORE_WINDOW)?1:2),&item_rect[6],0);
	  
	  menu_button(5,170,(char*)"IGN. ADD/SUB CHANGES",0,&item_rect[7],5);
	  menu_button(215,170,(char*)"ON",((os9x_hack&PPU_IGNORE_ADDSUB)?2:1),&item_rect[8],0);
	  menu_button(265,170,(char*)"OFF",((os9x_hack&PPU_IGNORE_ADDSUB)?1:2),&item_rect[9],0);
	  
	  menu_button(5,210,(char*)"IGN. PALLETE WRITING",0,&item_rect[10],5);
	  menu_button(215,210,(char*)"ON",((os9x_hack&PPU_IGNORE_PALWRITE)?2:1),&item_rect[11],0);
	  menu_button(265,210,(char*)"OFF",((os9x_hack&PPU_IGNORE_PALWRITE)?1:2),&item_rect[12],0);
	  
		if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //IGN. FIX CLR CHANGES
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  os9x_hack |= PPU_IGNORE_FIXEDCOLCHANGES;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  os9x_hack &= ~PPU_IGNORE_FIXEDCOLCHANGES;
		  redraw=1;
	  }
	  //IGN. CLP WIN CHANGES
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  os9x_hack |= PPU_IGNORE_WINDOW;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
		  os9x_hack &= ~PPU_IGNORE_WINDOW;
		  redraw=1;
	  }
	  //IGN. ADD/SUB CHANGES
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  os9x_hack |= PPU_IGNORE_ADDSUB;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  os9x_hack &= ~PPU_IGNORE_ADDSUB;
		  redraw=1;
	  }
	  //IGN. PALLETE WRITING
	  if (TEST_PEN_MENU(x,y,item_rect[11])) 
	  {
		  os9x_hack |= PPU_IGNORE_PALWRITE;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
		  os9x_hack &= ~PPU_IGNORE_PALWRITE;
		  redraw=1;
	  }
	  
	  if (mStopEmulation) break;
  }  
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int os9x_ShowMenuSave(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  
  
  FILE *savefile;
  int slot[4];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	//GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
  	  	  	  	  	  	
	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  
  	  

	  
	  for (int i=0;i<4;i++)	  
	  {	  
	  		UInt32 long_time;
			DateTimeType date_time;		
			char str[255],str2[5];		
			sprintf(str2,".za%1d",i);
		    S9xGetSaveFilename (str2,sram_filename);		    
			savefile=fopen(sram_filename,"rb");
		    if (savefile) 
	  		{	
			  	slot[i]=1;
			  	fclose(savefile);	
			  	fgetdate(sram_filename,&long_time);		
				TimSecondsToDateTime(long_time,&date_time);
				//date is an ofs from 01 Jan 1900 00:00:00			
				sprintf(str,"%02d%s%02d-%02d:%02d",
				date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
				if (i) 
				{
					menu_messageRaw(150,80+i*30,str);
					menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
				}
				else 
				{
					menu_messageRaw(150,200,str);
					menu_button(10,200,"X",5,&item_rect[6+i],3);
				}
		    }			 
			
	  	}	
  	  	  	  	  	  	
	menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	menu_button(10,50,(char*)"SAVE",0,&item_rect[1],2);	  	  	  
	menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
	menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
	menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
	menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
	  
	  
	  
		if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
			S9xGetSaveFilename (".za0",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
			S9xGetSaveFilename (".za1",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	S9xGetSaveFilename (".za2",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	S9xGetSaveFilename (".za3",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  	if (!slot[1]||(SHOW_OVERWRITE))
		  {os9x_save(".za1");result=1;  break;}
		  else redraw=1;
		
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  	if (!slot[2]||(SHOW_OVERWRITE))
		  {os9x_save(".za2");result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  	if (!slot[3]||(SHOW_OVERWRITE))
		  {os9x_save(".za3");result=1; break;}
		  else redraw=1;
		 
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1]))
	  {
    	  	if (!slot[0]||(SHOW_OVERWRITE))
		  {os9x_save(".za0");result=1;  break;}
		  else redraw=1;
	  	  
		  result=1;
		
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}



int os9x_ShowMenuLoad(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		//GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
	
  	
  	  FILE *savefile;
  	  int slot[5];
  	  slot[0]=slot[1]=slot[2]=slot[3]=slot[4]=0;
  	  
  	  
  	  for (int i=0;i<5;i++)	  
	  {	  
	  		UInt32 long_time;
			DateTimeType date_time;		
			char str[255],str2[5];		
			if (i<4) sprintf(str2,".za%1d",i);
			else sprintf(str2,".zst");
		    S9xGetSaveFilename (str2,sram_filename);		    
			savefile=fopen(sram_filename,"rb");
		    if (savefile) 
	  		{	
			  	slot[i]=1;
			  	fclose(savefile);	
			  	fgetdate(sram_filename,&long_time);		
				TimSecondsToDateTime(long_time,&date_time);
				//date is an ofs from 01 Jan 1900 00:00:00			
				sprintf(str,"%02d%s%02d-%02d:%02d",
				date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
				if (i) 
				{
					if (i<4)
					{
						menu_messageRaw(150,80+i*30,str);
						menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
					}
					else
					{
						menu_messageRaw(150,80+5*30,str);
						menu_button(10,80+5*30,"X",5,&item_rect[6+i],3);
					}
				}
				else 
				{
					menu_messageRaw(150,200,str);
					menu_button(10,200,"X",5,&item_rect[6+i],3);
				}
		    }			 
			
	  	}	
  	  	  	  	  	  	
	menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	menu_button(10,50,(char*)"LOAD",0,NULL,2);	  	  	  
	menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
	menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
	menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
	menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[1],1);
	menu_button(50,230,(char*)"ZSNES",(slot[4]?2:3),&item_rect[5],1);
  	  
  	  
 
	  
		if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;

	  
	  
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
	  	if (menu_confirm("Delete ZSNES?"))
	  	{
		  	S9xGetSaveFilename (".zst",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  
  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	S9xGetSaveFilename (".za0",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	S9xGetSaveFilename (".za1",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	S9xGetSaveFilename (".za2",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	S9xGetSaveFilename (".za3",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[1]))
	  {
    	if (os9x_load(".za0")) {result=1;break;}
	  }
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		if (os9x_load(".za1")) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		if (os9x_load(".za2")) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		if (os9x_load(".za3")) {result=1;break;}	  
	  }
	
	  //ZSNES
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
    	if (os9x_loadzsnes(".zst")) {result=1;break;}
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}


int os9x_ShowMenuConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		//GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
		
		menu_button(180,20,(char*)"BACK" ,6,&item_rect[0],2);	  
	  	menu_button(92, 90,(char*)"GFX"  ,0,&item_rect[1],2);
	  	menu_button(92,135,(char*)"SOUND",0,&item_rect[2],2);
	  	menu_button(92,180,(char*)"OTHER",0,&item_rect[3],2);	  
	  	menu_button(92,235,(char*)"HACKS",0,&item_rect[4],2);	 // *** UN-COMMENT THIS UPON FIXING HACKS MENU *** 
		if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;

	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	os9x_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	os9x_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {	  	  		  
		  os9x_ShowMenuOTHERConfig(savescr);
		  redraw=1;
	  }
	  //HACKS
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {	  	  		  
		  os9x_ShowMenuHACKSConfig(savescr);	 // *** UN-COMMENT THIS UPON FIXING HACKS MENU *** 
		  redraw=1;
	  }
	  if (mStopEmulation) break;

  }  
  ljz_free(item_rect);
  return result;
}

START_EXTERN_C
int os9x_ShowSysInfos(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		//GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
  	  	
				
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(os9x_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(os9x_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d]",strb,os9x_curVolume);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,63,str);				
		sprintf(str,"Used:%dM/%dM",usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,81,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM %ldK/%ldK",freeP/1024,maxP/1024);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
/*		TwGfxInfoType gfxinfo;
		gfxinfo.size=sizeof(gfxinfo);
		TwGfxGetInfo(os9x_mGfxLib,&gfxinfo);		
		menu_button(10,130,"VRAM",6,&my_rect,4);		
		sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);
		*/
		
		menu_button(10,160,"ROM",4,&my_rect,4);						
		sprintf(str,"%s [%s]",Memory.ROMName,(Memory.ROMChecksum + Memory.ROMComplementChecksum != 0xffff ||
	      Memory.ROMChecksum != Memory.sum1) ? "bad checksum" : "checksum ok");
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,str);		
		
		menu_button(10,190,"Type",4,&my_rect,4);
		sprintf(str,"[%s]%s,%s/%s",Memory.MapMode (),Memory.MapType (),Memory.Size (),Memory.KartContents ());
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
	    menu_button(10,220,"SRAM",7,&my_rect,4);
		sprintf(str,"%s",Memory.StaticRAMSize ());
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);
		menu_button(200,220,"TV",7,&my_rect,4);
		sprintf(str,"%s",Memory.TVStandard ());
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);
		
		
		menu_button(10,250,"ROMID",7,&my_rect,4);
		sprintf(str,"%s",Memory.ROMId );
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,str);
		
		menu_button(10,280,"CompanyID",7,&my_rect,4);
		sprintf(str,"%s",Memory.CompanyId);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,str);
		

  	
	  	menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
		if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;

	  
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}





int os9x_ShowMenu()
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr,*tmpscr,*tmpdst;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;
 

  os9x_pause(1);
  Memory.TEMP_DeInit();
    
         
  scr=/*(uint8*)(g_pnobridge -> vram);*/ljp_WinScreenLock(winLockCopy);  
  savescr=(uint8*)ljz_malloc(display_width*display_height*2);  
  if (scr&&savescr)
  {
  	int yy;
	  tmpscr=scr;
  	for (yy=0;yy<display_height-(os9x_renderingmode<2?BELTBAR_SIZE:0);yy++)
  	{
	  for (x=0;x<display_width;x++)
	  {
  		y=((uint16*)tmpscr)[x];
	  	((uint16*)tmpscr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  tmpscr+=display_pitch*2;
	}
	tmpscr=scr;
	tmpdst=savescr;
	for (yy=0;yy<display_height;yy++)
  	{
	    memcpy(tmpdst,tmpscr,display_width*2);
	    tmpdst+=display_width*2;
	    tmpscr+=display_pitch*2;
	}
  }
		if (scr) ljp_WinScreenUnlock();
            
              
  for (;;)
  {  
  	if (redraw)
  	{  	
	  	FILE *savefile;
	  	S9xGetSaveFilename (".za0",sram_filename);
		savefile=fopen(sram_filename,"rb");
	    if (savefile) 
	    {
	  		slot0=1;
		  	fclose(savefile);	
	  	}
	  	else slot0=0;
	  	
		//GUI_REDRAW_BG
	    result=gui_redraw_bg_func(&redraw,&scr,savescr,1);
  		  		  		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(10,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(180,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(10,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(180,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(10,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(180,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(180,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		menu_button(10,250,(char*)"RESET SNES",9,&item_rect[7],2);				
		if (scr) ljp_WinScreenUnlock();
		
  	}
	  redraw=menu_waitPen(&x,&y,1);	  	 	
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {os9x_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (os9x_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (os9x_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  os9x_save(".za0");result=0;break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot0)
		    if (os9x_load(".za0")) {result=0;break;}
	  }
	  //RESET GB
	  if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("Reset SNES ?")) {S9xReset(); result=0;break;}redraw=1;}
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {os9x_ShowSysInfos(savescr);redraw=1;}

		if (mStopEmulation) break;
	}
  ljz_free(item_rect);
  
  if (savescr) ljz_free(savescr);
        
  Memory.TEMP_ReInit();    
  os9x_pause(0);
  return result;
}  

int load_state(int num){
	switch (num){
			case 0:return os9x_load(".za0");break;
			case 1:return os9x_load(".za1");break;
			case 2:return os9x_load(".za2");break;
			case 3:return os9x_load(".za3");break;
			case 4:return os9x_loadzsnes(".zst");break;
		}
	return 0;
}
END_EXTERN_C

int yo_rand_val=0;
int yo_rand(void)
{
	yo_rand_val++;
	return yo_rand_val;
}

char *my_strrchr(const char *s,char c)
{
	char *p,*q;
	p=NULL;
	if (s)
	{
		p=strchr(s,c);
		if (p)
			while (q=strchr(p+1,c)) p=q;
	}
	return p;
}



/***********************************************************/


/*extern "C"
{
typedef int (*__compar_fn_t) (__const void *, __const void *);

#define MEMCPY(dst, src, s)			\
  ((s) == sizeof (int)				\
   ? (*(int *) (dst) = *(int *) (src), (dst))	\
   : memcpy (dst, src, s))

static void msort_with_tmp(char *b,int n,int s,__compar_fn_t cmp,char *t)
{
  char *tmp;
  char *b1, *b2;
  int n1, n2;

  if (n <= 1)
    return;

  n1 = n / 2;
  n2 = n - n1;
  b1 = b;
  b2 = (char *) b + (n1 * s);

  msort_with_tmp (b1, n1, s, cmp, t);
  msort_with_tmp (b2, n2, s, cmp, t);

  tmp = t;

  while (n1 > 0 && n2 > 0)
    {
      if ((*cmp) (b1, b2) <= 0)
	{
	  MEMCPY (tmp, b1, s);
	  b1 += s;
	  --n1;
	}
      else
	{
	  MEMCPY (tmp, b2, s);
	  b2 += s;
	  --n2;
	}
      tmp += s;
    }
  if (n1 > 0)
    memcpy (tmp, b1, n1 * s);
  memcpy (b, t, (n - n2) * s);
}

void qsort(char *b,int n,int s,__compar_fn_t cmp)
{
  int size = n * s;

  char *tmp = (char*)ljz_malloc (size);
  if (tmp == NULL)
  {	
		DEBUGS("msort out of mem");
  }
  else
  {
    msort_with_tmp (b, n, s, cmp, tmp);
    ljz_free (tmp);
  }

}
}*/