#include "snes9x.h"
#include "apu.h"
#include "ppu.h"
#include "dsp1.h"
#include "cpuexec.h"
#include "sa1.h"
#include "cpuops.h"

#include "os9x_asm_cpu.h"

#ifdef __PALM__
//#include "TapWave.h"
#endif

//#define __debug_c_irq__
//#define __debug_c_nmi__
//#define __debug_c_hblank__
//#define __debug_c_io__
//#define __debug_c__

START_EXTERN_C

#ifdef __PALM__
#include "LJZmenu.h"
#endif

int g_debuginfo;
char g_debugbuffer[128];
int g_debugbufferpos=0;


void asm_debuginfo(int num)
{
	char text[20];
	int y,ymax;
	uint8 *ptr;
	if (num==0) 
	{	
	
		ptr=(uint8*)(g_pnobridge->vram);
		for (y=20*((g_debugbufferpos/24)+1);y;y--)
		{
			memset(ptr,0,(g_pnobridge->display_width)*2);
			ptr+=(g_pnobridge->display_pitch)*2;
		}	
		g_debuginfo=1;
		g_debugbufferpos=0;
		memset(g_debugbuffer,0,128);

	}
	if (num==99) 
	{
		g_debuginfo=0;
	}
	sprintf(text,"a%d",num);
	menu_debug(text);
}

void asm_S9xMainLoop(void)
{

	S9xPackStatus();
#ifdef __debug_c__
menu_confirm("go for mainloop");	
#endif
	asmMainLoop(&CPU);
#ifdef __debug_c__
menu_confirm("mainloop ok");	
#endif
	S9xUnpackStatus();	
	

}

uint8 asm_S9xGetByte(uint32 Address)
{
#ifdef __debug_c_io__

	menu_confirm2("gb");
#endif	
	return S9xGetByte(Address);	
}

uint16 asm_S9xGetWord(uint32 Address)
{
#ifdef __debug_c_io__
	menu_confirm2("gw");
#endif	
	return S9xGetWord(Address);	
}


void asm_S9xSetByte(uint32 Address,uint8 value)
{	
#ifdef __debug_c_io__
	menu_confirm2("sb");		
#endif
	S9xSetByte(value,Address);	
}

void asm_S9xSetWord(uint32 Address,uint16 value)
{	
#ifdef __debug_c_io__
	menu_confirm2("sw");
#endif	
	S9xSetWord(value,Address);
}



void asm_S9xSetPCBase(uint32 Address)
{
#ifdef __debug_c_setpc__
	menu_confirm2("spcb");
#endif	
	S9xSetPCBase(Address);	
}


void asm_S9xOpcode_NMI(void)
{	
#ifdef __debug_c_nmi__
	menu_confirm2("nmi");
#endif	
	S9xUnpackStatus();
	S9xOpcode_NMI();
	S9xPackStatus();		
}

void asm_S9xOpcode_IRQ(void)
{	
#ifdef __debug_c_irq__
	menu_confirm2("irq");
#endif	
	S9xUnpackStatus();
	S9xOpcode_IRQ();	
	S9xPackStatus();
}

void asm_S9xDoHBlankProcessing(void)
{	
#ifdef __debug_c_hblank__
	menu_confirm2("hblank");
#endif	
	S9xUnpackStatus();
	S9xDoHBlankProcessing();	
	S9xPackStatus();	
}

void asm_APU_EXECUTE(void)
{
#ifdef __debug_c_apuex__	
	menu_confirm2("apuexec");
#endif	
	while (APU.Cycles <= CPU.Cycles)
	{
		APU_EXECUTE1();
	}
}

void asm_APU_EXECUTE2(void)
{
	ICPU.CPUExecuting = FALSE;
	do
	{
	    APU_EXECUTE1();
	} while (APU.Cycles < CPU.NextEvent);
	ICPU.CPUExecuting = TRUE;
}

END_EXTERN_C
