#include "palmdep.h"
#include "ljPRsc.h"
#include "App_Cst.h"

#include "zlib.h"
#include "unzip.h"
/*************
/*tinus*/
#include "filters.h"
/*********/

#include "PNOMain.h"
/*****************/
#include "LJZmenu.h"
/**************************/
#include "tg16_main.h"

extern UInt32 mStopEmulation;
extern UInt32 device_type;
extern UInt32 ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;


UInt16 *tg16_zodvram;

uint16 *tg16_curRenderingScreenPtr;
uint32 tg16_curRenderingScreenIndex;
uint32 tg16_enabledSound,tg16_sndfreq;
uint32 tg16_renderingmode,tg16_smoothmode;
uint32 tg16_padState;

int32 tg16_frameskipped,tg16_frameskip,tg16_fastforward;
int32 tg16_frameBeginTime;
int32 tg16_speedpct;

int32 tg16_autofireA,tg16_autofireB;
int32 tg16_flipping;
int32 tg16_framecount;


char CurrentROMFile[256];
char tg16_curVolume;
char shortrom_filename[256];

//*** replace 'tg16' here - end ***

char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};


/*************************/
/* sound stuff */
/*************************/
#include "SoundMgr.h"
static SndStreamRef snd_stream=NULL;
Int32 snd_stream_vol;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
/*************************/


/* load/save state*/
int state_load(int n,int only_check){	
	if (only_check){
		//return 1 if file exists
		return 0;
	}
	return 0;
}
void state_save(int n){
}
/* get save filename base don slot number*/
void GetStateFileName(int slot,char *str){
	sprintf(str,"toto.ss%d",slot);
}

static Err tg16_sndCallBack (void *userData,SndStreamRef stream, void *buffer,UInt32 framecountZ)
{
	//scary asm stuff
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}	
	
	
	//sound_mix((int16*)buffer, framecountZ);
	
	
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}

void tg16_pause(int pause){ //replace 'tg16' here (entire function)
	if (pause)
	{
		if (snd_stream) stub_SndStreamGetVolume(snd_stream,&snd_stream_vol);  
		if (tg16_enabledSound==2) 
		{
			stub_SndStreamStop(snd_stream);
			stub_SndStreamDelete(snd_stream);
			snd_stream=NULL;
		}
	}
	else
	{
		tg16_frameBeginTime=GetTickCount()+17*100/tg16_speedpct;
		if (tg16_enabledSound==2) 
		{
			stub_SndStreamCreate(&snd_stream,sndOutput,tg16_sndfreq,/*sndInt16Little*/sndUInt8,/*sndMono*/sndStereo,tg16_sndCallBack,&reg_sys,512,1);
			stub_SndStreamStart(snd_stream);		
			stub_SndStreamSetVolume(snd_stream,snd_stream_vol);
		}
	}
}

void emu_resettimer(void) { //replace 'tg16' here (entire function)
	tg16_frameBeginTime=GetTickCount()+17*100/tg16_speedpct;
}

void tg16_togglesound(void) { //replace 'tg16' here (entire function)
	char tmp[64];
	int i;
	
	tg16_pause(1);
	
	tg16_enabledSound++;
	if (tg16_enabledSound>2) tg16_enabledSound=0;
	
	if (tg16_enabledSound==0) strcpy(tmp,"Sound : OFF");
	else if (tg16_enabledSound==1) strcpy(tmp,"Sound : SIM");
	else if (tg16_enabledSound==2) strcpy(tmp,"Sound : ON");

	menu_message(tmp);
	
	LJP_WAIT(300);
	emu_resettimer();
	
	tg16_pause(0);
}

char tg16_reset(void) { //replace 'tg16' here (entire function)
	tg16_pause(1);
	
  	if (menu_confirm("Reset TG16 ?")) /*emu_reset()*/;
  	
  	emu_resettimer();
  	
  	tg16_pause(0);
}

void tg16_quicksave(void) { //replace 'tg16' here (entire function)
	tg16_pause(1);
	
	if (CONFIRM_SAVE) state_save(0);
	emu_resettimer();
	ClearScreen();
	
	tg16_pause(0);
}

void tg16_quickload(void) { //replace 'tg16' here (entire function)
	tg16_pause(1);
	
	if (state_load(0,1))
	{
		if (CONFIRM_LOAD) state_load(0,0);
		emu_resettimer();
		ClearScreen();
	}
	
	tg16_pause(0);
}

void tg16_end(void){ //replace 'tg16' here (entire function)
	int val;
	ljz_free(tg16_curRenderingScreenPtr);
    

	FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID,tg16_smoothmode);	
	FtrSet(CREATORID, FTR_OPT_SOUND_ID,tg16_enabledSound);
	switch (tg16_sndfreq)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,val);
	
	FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,tg16_renderingmode);
	
	FtrSet(CREATORID, FTR_OPT_FSKIP_ID,tg16_frameskip);	
	
	FtrSet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,snd_stream_vol/16); 
	
	ljz_std_showstat();
}

int init_video(void) //replace 'tg16' here (entire function) / set backbuffer dimensions accordingly
{
	//Init vid, here hardcoded to 256x240
	signed long val1,val2,val;		
	tg16_curRenderingScreenPtr=(uint16*)ljz_malloc(256*240*2);
	memset(tg16_curRenderingScreenPtr,0,256*240*2);
	FtrGet(CREATORID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(CREATORID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
	tg16_renderingmode=val1;
	tg16_smoothmode=val2;
	
	tg16_fastforward=0;
	
	tg16_frameskipped=0;
	
    FtrGet(CREATORID,FTR_OPT_FSKIP_ID,(unsigned long*)&val);     
	tg16_frameskip=val;
	
	FtrGet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,(unsigned long*)&val); 
	snd_stream_vol=val;
	if (snd_stream_vol<0) snd_stream_vol=0;
	if (snd_stream_vol>128) snd_stream_vol=128;
	snd_stream_vol*=16;  
//tinnus
	filters_init();	        
	return 0;
}


int tg16_loadrom(void){ //replace 'tg16' here (entire function)
	//load rom & init stuff
	int val;
	FtrGet(CREATORID,FTR_OPT_SOUND_ID,(unsigned long*)&val);  
	tg16_enabledSound=val;
	
	FtrGet(CREATORID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);  
	if (val==1) tg16_sndfreq=22050;
	else if (val==2) tg16_sndfreq=11025;
	else tg16_sndfreq=44100;		
	
	tg16_speedpct=100;
	tg16_autofireA=0;
	tg16_autofireB=0;
	
	tg16_framecount=0;

	init_video();
//	vid_init();
//	pcm_init();

	char *ftrptr;
    strcpy(CurrentROMFile,TG16_ROMSDIR);    
    FtrGet(CREATORID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
    
    tg16_curVolume=ftrptr[0];
    CurrentROMFile[0]=tg16_curVolume+'0';
    
    ftrptr+=3;
	strcpy(shortrom_filename,ftrptr);  
    strcat(CurrentROMFile,ftrptr);
//    FtrPtrFree(CREATORID, FTR_ROM_FILENAME_ID);
    
//    char strload[128];
//    strcpy(strload,"Loading : ");
//    strcat(strload,shortrom_filename);  
    menu_message(shortrom_filename/*strload*/);
//	loader_init(CurrentROMFile);	
//    emu_running=1;
//	emu_reset();
//    frames_rendered=frames_displayed=0;
//    framelimit_delay=0;
	tg16_frameBeginTime=GetTickCount();    
//	emu_run();		
	tg16_pause(0);	
    return 0; 
}

void tg16_MainLoop(void){ //replace 'tg16' here (entire function)
	//timing code here
	
	//rendering code here
	
	//implementation may vary
}

void tg16_updatevpad(int key){ //replace 'tg16' here (entire function)
	//clear emu pad states here

	if (key & KEY_B1) {
		switch (tg16_autofireA)
	 	{
  			case 0:/*input.pad[0] |= INPUT_BUTTON1;*/ break;
  			case 1:
  	  			if ((tg16_framecount&31)>15)/*input.pad[0] |= INPUT_BUTTON1*/;
  	  			break;
  			case 2:
  	  			if ((tg16_framecount&15)>7) /*input.pad[0] |= INPUT_BUTTON1*/;
  	  			break;
  			case 3:
  	  			if ((tg16_framecount&7)>3) /*input.pad[0] |= INPUT_BUTTON1*/;
  	  			break;  		   
  	 	}
	}
	if (key & KEY_B2) {
		switch (tg16_autofireB)
	 	{
  			case 0:/*input.pad[0] |= INPUT_BUTTON2;*/ break;
  			case 1:
  	  			if ((tg16_framecount&31)>15)/*input.pad[0] |= INPUT_BUTTON2*/;
  	  			break;
  			case 2:
  	  			if ((tg16_framecount&15)>7) /*input.pad[0] |= INPUT_BUTTON2*/;
  	  			break;
  			case 3:
  	  			if ((tg16_framecount&7)>3) /*input.pad[0] |= INPUT_BUTTON2*/;
  	  			break;  		   
  	 	}
	}
/*	if (k_key & KEY_UP) input.pad[0] |= INPUT_UP;
	if (k_key & KEY_DOWN) input.pad[0] |= INPUT_DOWN;
	if (k_key & KEY_LEFT) input.pad[0] |= INPUT_LEFT;
	if (k_key & KEY_RIGHT) input.pad[0] |= INPUT_RIGHT; */
	
	if (key & KEY_RUN) {
//		input.system |= INPUT_START;
	}
	
	//process key
	if (key&KEY_QUICKLOAD)
	{
		if (state_load(0,1))
		{
			if (CONFIRM_LOAD) {tg16_pause(1);state_load(0,0);tg16_pause(0);}
			tg16_frameBeginTime=GetTickCount()+17*100/tg16_speedpct;
			 ClearScreen();
		}
	}
	if (key&KEY_QUICKSAVE)
	{
		if (CONFIRM_SAVE) {tg16_pause(1);state_save(0);tg16_pause(0);}
		tg16_frameBeginTime=GetTickCount()+17*100/tg16_speedpct;
		 ClearScreen();
	}
	if (key&KEY_TURBO)
	{		
		tg16_fastforward=1;		
	}
	else 
	if (tg16_fastforward)
	{
		tg16_fastforward=0;
		tg16_frameBeginTime=GetTickCount()+17*100/tg16_speedpct;
	}
}

void tg16_changefskip(void){ //replace 'tg16' here (entire function)
	char tmp[64];
	int i;
	
	tg16_pause(1);
	
	tg16_frameskip++;
	if (tg16_frameskip>SKEEZIX_FSKIP) tg16_frameskip=0;
	
	
	if (tg16_frameskip==AUTO_FSKIP) strcpy(tmp,"Frameskip : AUTO");
	else if (tg16_frameskip==SKEEZIX_FSKIP) strcpy(tmp,"Frameskip : Skeezix");
	else 
	{
		char tmp2[16];
		strcpy(tmp,"Frameskip : ");
		StrIToA(tmp2,tg16_frameskip);
		strcat(tmp,tmp2);
	}

	menu_message(tmp);
	
	LJP_WAIT(300);
	emu_resettimer();
	
	tg16_pause(0);
}

void tg16_changerendering(void){ //replace 'tg16' here (entire function)
	tg16_renderingmode++;
	
	if (tg16_renderingmode>3) tg16_renderingmode=0;
	if (tg16_renderingmode==2) {
		stub_fullscreen(1);
		LJP_HANDLE_EVENT(tg16_pause)	
	}
	if (tg16_renderingmode==0) {
		stub_fullscreen(0);
		LJP_HANDLE_EVENT(tg16_pause)
	}
	menu_message("Changing screen mode");
	
	LJP_WAIT(300);
	emu_resettimer();
}

int tg16_ShowMenuGFXConfig(uint8 *savescr) //replace 'tg16' here (entire function)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval,hwsmooth;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(22*sizeof(RectangleType));
  char tmp[16];
  

	
  scrmode=tg16_renderingmode;
  smoothing=tg16_smoothmode&_SMOOTH_MASK_;
  hwsmooth=tg16_smoothmode&_ZOD_SMOOTHING_;
	
  fskipval=tg16_frameskip;

	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {  	  	
		GUI_REDRAW_BG(0)
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	  
	  	menu_button(10,80,(char*)"FRAMESKIP",0,&item_rect[1],2);	  
	  	menu_bar(150,80,fskipval,11,&item_rect[2]);
	  	if (fskipval==AUTO_FSKIP) strcpy(tmp,"AUTO");
	  	else if (fskipval==SKEEZIX_FSKIP) strcpy(tmp,"SKZX");
	  	else StrIToA(tmp,fskipval);
	  	menu_messageRaw(260,80,tmp);
	  
	  	menu_button(10,120,(char*)"ZOOM",0,&item_rect[3],2);	  	
	  	menu_button(150,120,(char*)"1",((scrmode==0)||(scrmode==2)?2:1),&item_rect[4],0);
	  	menu_button(200,120,(char*)"2",((scrmode==1)||(scrmode==3)?2:1),&item_rect[5],0);
	  	menu_button(250,120,(char*)"WIDE",(scrmode==4?2:1),&item_rect[6],0);
	  	
	  	menu_button(10,155,(char*)"FULLSCREEN",0,&item_rect[7],2);
	  	menu_button(150,155,(char*)"OFF",(scrmode&2?1:2),&item_rect[8],0);
	  	menu_button(200,155,(char*)"ON",(scrmode&2?2:1),&item_rect[9],0);	  	  	  
	  
	  	menu_button(10,190,(char*)"SMOOTHING",0,&item_rect[10],2);
	  	menu_button(150,190,(char*)"OFF",((smoothing==0)&&(!hwsmooth)?2:1),&item_rect[11],0);	  		  	
	  	menu_button(200,190,(char*)"AdvMAME2x",(smoothing==1?2:1),&item_rect[12],4);
	  	menu_button(2,218,(char*)"LQ2X",(smoothing==2?2:1),&item_rect[13],4);	  	  	  
	  	menu_button(68,218,(char*)"HQ2X",(smoothing==3?2:1),&item_rect[14],4);
	  	menu_button(136,218,(char*)"2xSaI",(smoothing==4?2:1),&item_rect[15],4);
	  	menu_button(202,218,(char*)"Super 2xSaI",(smoothing==5?2:1),&item_rect[16],4);
	  	menu_button(10,246,(char*)"Scale 2xSaI",(smoothing==6?2:1),&item_rect[17],4);
	  	menu_button(160,246,(char*)"HW",(hwsmooth?2:1),&item_rect[18],4);
	  	
	  	menu_button(10,280,(char*)"FLIPPING",0,&item_rect[19],2);
	  	menu_button(150,280,(char*)"OFF",(tg16_flipping?1:2),&item_rect[20],0);
	  	menu_button(200,280,(char*)"ON",(tg16_flipping?2:1),&item_rect[21],0);
	  	
	  	if (scr) ljp_WinScreenUnlock();
	
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[2])) {
	  	fskipval=(x-10-item_rect[2].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }
	  //SCREEN MODES
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[4])) {
		  scrmode&=~4;
	  	  scrmode&=~1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {
		  scrmode&=~4;
	  	  scrmode|=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {
	  	  scrmode=4;
	  	  redraw=1;
	  }
	  //SCREEN MODES WIN/FULL
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {
	  	  scrmode&=~(2|4);
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) {
	  	  if (scrmode<2) scrmode|=2;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[11])) {
	  	  smoothing=0;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[12])) {
	  	  smoothing=1;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[13])) {
	  	  smoothing=2;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[14])) {
	  	  smoothing=3;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[15])) {
	  	  smoothing=4;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[16])) {
	  	  smoothing=5;
	  	  hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[17])) {
	  	  smoothing=6;
	  	  hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[18])) {
	  	  smoothing=0;
	  	  hwsmooth=_ZOD_SMOOTHING_;
	  	  redraw=1;
	  }
	  //FLIPPING
	  if (TEST_PEN_MENU(x,y,item_rect[20])) {
	  	  tg16_flipping=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[21])) {
	  	  tg16_flipping=1;
	  	  redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  tg16_frameskip=fskipval;

  tg16_renderingmode=scrmode;
  tg16_smoothmode=smoothing|hwsmooth;
	
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}



int tg16_ShowMenuSNDConfig(uint8 *savescr) //replace 'tg16' here (entire function)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=snd_stream_vol/16;	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0) 	
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
	  menu_button(150,80,(char*)"OFF",(tg16_enabledSound==0?2:1),&item_rect[2],0);
	  menu_button(200,80,(char*)"SIM",(tg16_enabledSound==1?2:1),&item_rect[3],0);	  
	  menu_button(250,80,(char*)"ON",(tg16_enabledSound==2?2:1),&item_rect[4],0);	 
	  
	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
	  menu_bar(150,120,vol,128,&item_rect[6]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(270,120,tmp);
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  tg16_enabledSound=0;		  
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  tg16_enabledSound=1;	  	  
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  tg16_enabledSound=2;
		  redraw=1;
	  }
	  
	  //VOLUME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x-10)*128/100;
	  	if (vol<0) vol=0;
	  	if (vol>128) vol=128;
	  	redraw=1;
	  }
	  if (mStopEmulation) break;
  }  

	snd_stream_vol=vol*16;
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int tg16_ShowMenuOTHERConfig(uint8 *savescr) //replace 'tg16' here (entire function)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)  	
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"AUTO A",0,&item_rect[1],4);
	  menu_button(100,80,(char*)"OFF",(tg16_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(150,80,(char*)"SLW",(tg16_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(200,80,(char*)"MED",(tg16_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(250,80,(char*)"FST",(tg16_autofireA==3?2:1),&item_rect[5],0);
	  
	  menu_button(10,120,(char*)"AUTO B",0,&item_rect[6],4);
	  menu_button(100,120,(char*)"OFF",(tg16_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(150,120,(char*)"SLW",(tg16_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(200,120,(char*)"MED",(tg16_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(250,120,(char*)"FST",(tg16_autofireB==3?2:1),&item_rect[10],0);
	  
	  menu_button(10,160,(char*)"EMU SPEED",0,&item_rect[11],4);
	  menu_bar(130,160,tg16_speedpct,100,&item_rect[12]);
	  StrIToA(tmp,tg16_speedpct);
	  strcat(tmp,"%");
    	menu_messageRaw(240,160,tmp);
	  
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  tg16_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  tg16_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  tg16_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  tg16_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  tg16_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  tg16_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  tg16_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  tg16_autofireB=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
	  	tg16_speedpct=(x-item_rect[12].topLeft.x);
	  	if (tg16_speedpct>100) tg16_speedpct=100;
	  	if (tg16_speedpct<10) tg16_speedpct=10;
	  	redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}




int tg16_ShowMenuSave(uint8 *savescr) //replace 'tg16' here (entire function)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  FILE *savefile;
  	  int slot[4];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)  	
  		
  	  	  	  	  	  	
	  
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  for (int i=0;i<4;i++) 
  	  	if (state_load(i,1))   	  	
  	  	{
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			GetStateFileName(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
	  	}	  	  	
  	  	  	  	  	  	
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"SAVE",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (!slot[1]||(SHOW_OVERWRITE))
		  {state_save(1);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (!slot[2]||(SHOW_OVERWRITE))
		  {state_save(2);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (!slot[3]||(SHOW_OVERWRITE))
		  {state_save(3);result=1; break;}
		  else redraw=1;
		 
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
		  if (!slot[0]||(SHOW_OVERWRITE))
		  {state_save(0);result=1; break;}
		  else redraw=1;
		 
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}



int tg16_ShowMenuLoad(uint8 *savescr) //replace 'tg16' here (entire function)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
   int slot[4];
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)  	
		
  	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
      for (int i=0;i<4;i++) 
      	if (state_load(i,1)) 
      	{
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			GetStateFileName(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
		}	
      
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"LOAD",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;

  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (slot[1])
		if (state_load(1,0)) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (slot[2])
		if (state_load(2,0)) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot[3])
		if (state_load(3,0)) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	if (slot[0])
    	if (state_load(0,0)) {result=1;break;}
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}


int tg16_ShowMenuConfig(uint8 *savescr) //replace 'tg16' here (entire function)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)  	
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(92,100,(char*)"GFX",0,&item_rect[1],2);
	  menu_button(92,150,(char*)"SOUND",0,&item_rect[2],2);
	  menu_button(92,200,(char*)"OTHER",0,&item_rect[3],2);
	  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	tg16_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	tg16_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  tg16_ShowMenuOTHERConfig(savescr);
		  redraw=1;		  
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}

int tg16_ShowSysInfos(uint8 *savescr) //replace 'tg16' here (entire function)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG(0)				
		
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(tg16_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(tg16_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d]",strb,tg16_curVolume);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,63,str);				
		sprintf(str,"Used:%dM/%dM",usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,81,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM %ldK/%ldK",freeP/1024,maxP/1024);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
		/*TwGfxInfoType gfxinfo;
		gfxinfo.size=sizeof(gfxinfo);
		TwGfxGetInfo(tg16_mGfxLib,&gfxinfo);		
		menu_button(10,130,"VRAM",6,&my_rect,4);		
		sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);*/
						
    		
/*		menu_button(10,160,"ROM",4,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,rom.name);
		
		sprintf(str,"%dKo RAM-%dKo",mbc.romsize,mbc.ramsize);
		menu_button(10,190,"Size",4,&my_rect,4);
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
		menu_button(10,220,"Type",7,&my_rect,4);		
		sprintf(str,"%d Bt:%d Rtc:%d CGB:%d",mbc.type,mbc.batt,rtc.batt,hw.cgb);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);
		
		menu_button(10,250,"CRC",7,&my_rect,4);		
		sprintf(str,"%08X",tg16_romCrc);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,str);
		
		menu_button(10,280,"GoodGB",7,&my_rect,4);		
		int i=DAT_LookFor(tg16_romCrc);
		if (i<0) sprintf(str,"not found");
		else sprintf(str,"%s",MyDat[i].name);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,280,str);
*/		
						  	
	  	menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}


int tg16_ShowMenu(void) //replace 'tg16' here (entire function)
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr,*tmpscr,*tmpdst;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;

  
  tg16_pause(1);
    
       
  scr=/*(uint8*)(g_pnobridge -> vram);*/ljp_WinScreenLock(winLockCopy);  
  savescr=(uint8*)ljz_malloc(display_width*display_height*2);    
  if (scr&&savescr)
  {
	  tmpscr=scr;
  	for (int yy=0;yy<display_height-(tg16_renderingmode<2?BELTBAR_SIZE:0);yy++)
  	{
	  for (x=0;x<display_width;x++)
	  {
  		y=((uint16*)tmpscr)[x];
	  	((uint16*)tmpscr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  tmpscr+=display_pitch*2;
	}
	tmpscr=scr;
	tmpdst=savescr;
	for (int yy=0;yy<display_height;yy++)
  	{
	    memcpy(tmpdst,tmpscr,display_width*2);
	    tmpdst+=display_width*2;
	    tmpscr+=display_pitch*2;
	}
  }
  if (scr) ljp_WinScreenUnlock();
            
              
  for (;;)
  {  
  	if (redraw)
  	{  	
	  	slot0=state_load(0,1);    
  		
  		
		GUI_REDRAW_BG(0)  		
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(10,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(180,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(10,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(180,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(10,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(180,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(180,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		menu_button(10,250,(char*)"RESET TG16",9,&item_rect[7],2);				
		if (scr) ljp_WinScreenUnlock();				
		
  	}
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {tg16_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (tg16_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (tg16_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  state_save(0);
		  result=0;
		  break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot0)
	    if (state_load(0,0)) {result=0;break;}
	  }
	  //RESET GB
	  if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("Reset device ?")) {/*emu_reset();*/ result=0;break;}redraw=1;}
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {tg16_ShowSysInfos(savescr);redraw=1;}

		if (mStopEmulation) break;
	}
  ljz_free(item_rect);
  
  if (savescr) ljz_free(savescr);
            
  tg16_pause(0);
  return result;
}  



