#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "ljPRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif
#include "PNOMain.h"
#include "App_Cst.h"


/**********************************************/
// To be defined in emulation module sources
// look other modules for examples 
/**********************************************/
#include "vcs_main.h"
extern UInt32 vcs_renderingmode;
extern UInt16 *vcs_zodvram;
int vcs_ShowMenu(void);
void vcs_pause(int pause);
void vcs_end(void);
int vcs_loadrom(void);
void vcs_MainLoop(void);
void vcs_updatevpad(int key);
void vcs_changefskip(void);
void vcs_changerendering(void);
/**********************************************/
/**********************************************/

// BUTTONS translation stuff
unsigned int g_translateBtn[20]=
{KEY_FIRE,KEY_SELECT,
KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,
KEY_QUICKLOAD,KEY_QUICKSAVE,KEY_FRAMESKIP,
KEY_SCREENMODE,KEY_TURBO,0,0,0,0,0,0,0,0,0};
unsigned int g_confinput[20];

void ClearScreen(void);

UInt32 mStopEmulation=0;
extern UInt32 ljp_showFPS,ljp_showBeltbar,ljp_showBattMode,ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;
extern UInt32 device_type;
extern int emu_reset;

extern void mainloop_init(void);

unsigned long Run()
{
	Int32 lastTick;
	UInt32 pollcpt=0;
	UInt32 keys,keyval;
    Int16 penX,penY;
    Boolean penDown;    
	//Read the key config
	UInt32 *ftrptr;
    char text[16];
    Int32 framerate = 0;
    Int32 timecpt,framecpt = 0;
	
 	FtrGet(CREATORID,FTR_OPT_INPUTCONF_ID ,(unsigned long*)&ftrptr);
	for (int i=0;i<20;i++) g_confinput[i]=ByteSwap32(ftrptr[i]);
	
	FtrGet(CREATORID,FTR_OPT_SHOWFRAMERATE_ID ,(unsigned long*)&ljp_showFPS);
	FtrGet(CREATORID,FTR_OPT_SHOWBELTBAR_ID ,(unsigned long*)&ljp_showBeltbar);
	FtrGet(CREATORID,FTR_OPT_SHOWBATTMODE_ID ,(unsigned long*)&ljp_showBattMode);
	FtrGet(CREATORID,FTR_OPT_ISLOWRES_ID ,(unsigned long*)&ljp_isLowRes);
	FtrGet(CREATORID,FTR_OPT_CONFIRMOW_ID ,(unsigned long*)&ljp_confirmOW);
	FtrGet(CREATORID,FTR_OPT_CONFIRMSL_ID ,(unsigned long*)&ljp_confirmSL);
	
	//Init VCS		
	//
	//Load the Rom
	mStopEmulation=vcs_loadrom();
	
	mainloop_init();
	
	if (device_type & BF_ZODIAC) {
		vcs_zodvram=(UInt16*) stubzodiacblit ( 0,0,0,0 );
		if (!vcs_zodvram) menu_info("Zodiac VRAM NULL ptr!!");
	}

	ClearScreen();
	//				
	//autoload?
	if (g_pnobridge->game_rom){
		state_load(g_pnobridge->game_rom-1,0);
	}
	
	timecpt=GetTickCount();
	while (!mStopEmulation)
	{
	
   	    //Read key state
	    keys = KeyCurrentState();
	    
		keyval=0;

		//check pen
		if (!(pollcpt&3)) {
			emu_reset=0;
			LJP_CHECK_MENU_ACCESS(vcs_ShowMenu,vcs_renderingmode>=2)
		}
		
		//handle sys event
		if (!(pollcpt&31)) LJP_HANDLE_EVENT(vcs_pause)
		
		//avoid auto-off
		//every 1024 frame => 
		if (!(pollcpt&1023)) EvtResetAutoOffTimer(); 
		
		LJP_UPDATE_KEYS
		
		vcs_updatevpad(keyval);
		
		if (keyval&KEY_FRAMESKIP) 
		{
			vcs_changefskip();
			ClearScreen();
		}
		if (keyval&KEY_SCREENMODE) 
		{
			vcs_changerendering();
			stub_DrawBeltBar();
			ClearScreen();
		}
		

		pollcpt++;
		//hack (VCS target FPS is NOT 60)
		pollcpt++;pollcpt++;
	
		//Emulate of 1 frame
		
		vcs_MainLoop();		
		framecpt++;

		
		if ((vcs_renderingmode<2) &&  ( (ljp_showFPS) || (ljp_showBeltbar) ))
		if (framecpt>=10) {
		  //FPS
		    UInt8 *vr;
			vr=(UInt8*)(g_pnobridge -> vram)/*+(g_pnobridge -> display_pitch)*2*/;		
			framecpt=0;
			framerate=30*1000/(GetTickCount()-timecpt+1);
			timecpt=GetTickCount();

			if (ljp_showBeltbar) {
				beltbar_draw(0,g_pnobridge -> display_height-BELTBAR_SIZE,g_pnobridge -> display_pitch,framerate,0,vr);
			} else if (ljp_showFPS) {
				for (int y=0;y<20;y++)
				{	
					memset(vr,0,80*2);
					vr+=(g_pnobridge -> display_pitch)*2;
				}
				
				text[0]=((framerate/100)%10)+48;
				text[1]=((framerate/10)%10)+48;
				text[2]=((framerate)%10)+48;
				text[3]=0;
				
				menu_messageRaw(5,0,text);
			}
		}
	}

	vcs_end();

	if (device_type & BF_ZODIAC) {
		stubzodiacblit ( 1,0,0,0 );
	}


	return 0;
}



/************************************/


void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height-(vcs_renderingmode<2?BELTBAR_SIZE:0);y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}
