#include "palmdep.h"
#include "ljPRsc.h"
#include "App_Cst.h"

#include "zlib.h"
#include "unzip.h"
/*************
/*tinus*/
#include "filters.h"
/*********/

#include "PNOMain.h"
/*****************/
#include "LJZmenu.h"
/**************************/
#include "vcs_main.h"

extern UInt32 mStopEmulation;
extern UInt32 device_type;
extern UInt32 ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;

UInt16 *vcs_zodvram;

uint16 *vcs_curRenderingScreenPtr;
uint32 vcs_curRenderingScreenIndex;
uint32 vcs_enabledSound,vcs_sndfreq;
uint32 vcs_renderingmode,vcs_smoothmode;
uint32 vcs_padState;

int32 vcs_frameskipped,vcs_frameskip,vcs_fastforward;
int32 vcs_frameBeginTime;
int32 vcs_speedpct;

int32 vcs_autofireA,vcs_autofireB;
int32 vcs_flipping;
int32 vcs_framecount;

int frames_displayed;
int current_keys;
int emu_reset;


char CurrentROMFile[256];
char vcs_curVolume;
char shortrom_filename[256];

char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};


/*************************/
/* sound stuff */
/*************************/
#include "SoundMgr.h"
static SndStreamRef snd_stream=NULL;
Int32 snd_stream_vol;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
/*************************/


/* emu data */
#define STICK 	0x01
struct resource {
	int rr;
	int debug;
	char bank;
	char pad_sens;
	char sc;
	char autoconfig;
	char left;
	char right;
	char swap;
} app_data;
char cart_loaded = 0;
int ExKey;
unsigned char current_screen = 1; //SCREEN_EMU
//unsigned short nflip = 0;
UInt16 g_palette [ 256 ];

extern char *vscreen;
extern unsigned char riotRead[0x298];

/* load/save state*/
int state_load(int n,int only_check){	
	if (only_check){
		//return 1 if file exists
		return 0;
	}
	return 0;
}
void state_save(int n){
}
/* get save filename base don slot number*/
void GetStateFileName(int slot,char *str){
	sprintf(str,"toto.ss%d",slot);
}


static Err vcs_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}				
	Tia_process(bufferZ,frameCountZ);
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}


void vcs_pause(int pause){
	if (pause)
	{
		if (snd_stream) stub_SndStreamGetVolume(snd_stream,&snd_stream_vol);  
		if (vcs_enabledSound==2) 
		{
			stub_SndStreamStop(snd_stream);
			stub_SndStreamDelete(snd_stream);
			snd_stream=NULL;
		}
	}
	else
	{
		vcs_frameBeginTime=GetTickCount()+17*100/vcs_speedpct;
		if (vcs_enabledSound==2) 
		{
			Tia_sound_init(341*100,vcs_sndfreq);
		
			stub_SndStreamCreate(&snd_stream,sndOutput,vcs_sndfreq,/*sndInt16Little*/sndUInt8,/*sndStereo*/sndMono,vcs_sndCallBack,&reg_sys,768,1);
			stub_SndStreamStart(snd_stream);		
			stub_SndStreamSetVolume(snd_stream,snd_stream_vol);
		}
	}
}

void emu_resettimer(void) {
	vcs_frameBeginTime=GetTickCount()+17*100/vcs_speedpct;
}

void vcs_togglesound(void) {
	char tmp[64];
	int i;
	
	vcs_pause(1);
	
	vcs_enabledSound++;
	if (vcs_enabledSound>2) vcs_enabledSound=0;
	
	if (vcs_enabledSound==0) strcpy(tmp,"Sound : OFF");
	else if (vcs_enabledSound==1) strcpy(tmp,"Sound : SIM");
	else if (vcs_enabledSound==2) strcpy(tmp,"Sound : ON");

	menu_message(tmp);
	
	LJP_WAIT(300);
	emu_resettimer();
	
	vcs_pause(0);
}

char vcs_reset(void) {
	vcs_pause(1);
	
  	if (menu_confirm("Reset Atari 2600 ?")) emu_reset=1; // reset
  	
  	emu_resettimer();
  	
  	vcs_pause(0);
}

void vcs_quicksave(void) {
	vcs_pause(1);
	
	if (CONFIRM_SAVE) state_save(0);
	emu_resettimer();
	ClearScreen();
	
	vcs_pause(0);
}

void vcs_quickload(void) {
	vcs_pause(1);
	
	if (state_load(0,1))
	{
		if (CONFIRM_LOAD) state_load(0,0);
		emu_resettimer();
		ClearScreen();
	}
	
	vcs_pause(0);
}






void vcs_end(void){
	int val;
	ljz_free(vcs_curRenderingScreenPtr);    
	
	vcs_pause(1);//stop sound
    

	FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID,vcs_smoothmode);	
	FtrSet(CREATORID, FTR_OPT_SOUND_ID,vcs_enabledSound);
	switch (vcs_sndfreq)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,val);
	
	FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,vcs_renderingmode);
	
	FtrSet(CREATORID, FTR_OPT_FSKIP_ID,vcs_frameskip);	
	
	FtrSet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,snd_stream_vol/16); 
	
	ljz_std_showstat();
}

int init_video(void)
{
	//Init vid, here hardcoded to 64000 bytes
	signed long val1,val2,val;		
	
	vcs_curRenderingScreenPtr=(uint16*)ljz_malloc(160*(192+30)*2); //height is tv_height+tv_overscan
	memset(vcs_curRenderingScreenPtr,0,160*(192+30)*2);
	FtrGet(CREATORID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(CREATORID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
	vcs_renderingmode=val1;
	vcs_smoothmode=val2;
	
	vcs_fastforward=0;
	
	vcs_frameskipped=0;
	
    FtrGet(CREATORID,FTR_OPT_FSKIP_ID,(unsigned long*)&val);     
	vcs_frameskip=val;
	
	FtrGet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,(unsigned long*)&val); 
	snd_stream_vol=val;
	if (snd_stream_vol<0) snd_stream_vol=0;
	if (snd_stream_vol>128) snd_stream_vol=128;
	snd_stream_vol*=16;  
//tinnus
	//filters_init();	        
	return 0;
}


int vcs_loadrom(void){
	//load rom & init stuff
	int val;
	
	 __asm 
	  {
  		ldr  r0, = reg_sys
	  	add	 r0,r0,r10
	  	str	 r9,[r0]
	  	str	 r10,[r0,#4]
	  } 
	
	
	FtrGet(CREATORID,FTR_OPT_SOUND_ID,(unsigned long*)&val);  
	vcs_enabledSound=val;
	
	FtrGet(CREATORID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);  
	if (val==1) vcs_sndfreq=22050;
	else if (val==2) vcs_sndfreq=11025;
	else vcs_sndfreq=22050;//44100;		
	
	vcs_speedpct=100;
	vcs_autofireA=0;
	vcs_autofireB=0;
	
	vcs_framecount=0;

	init_video();
	
	app_data.rr=0; // frameskip
  app_data.debug=0;
  app_data.bank=2;
  app_data.pad_sens=5;
  app_data.sc=0;
  app_data.left=STICK;
  app_data.right=STICK;
  /*	paddle1.pos=0;
	paddle1.val=0;*/
  app_data.autoconfig=0;
  app_data.swap=0;

	char *ftrptr;
	char cat[32];
    strcpy(CurrentROMFile,VCS_ROMSDIR);
    
    //handle categories
  	FtrGet(CREATORID,FTR_OPT_CATEGORY_ID ,(unsigned long*)&ftrptr);
  	strcpy(cat,ftrptr);
  	if ( StrCaselessCompare(cat,"uNaRcHiVeD") != 0) {
  		strcat(CurrentROMFile,cat);
  		strcat(CurrentROMFile,"/");
  	}
     
    FtrGet(CREATORID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
    
    vcs_curVolume=ftrptr[0];
    CurrentROMFile[0]=vcs_curVolume+'0';
    
    ftrptr+=3;
	strcpy(shortrom_filename,ftrptr);  
    strcat(CurrentROMFile,ftrptr);
    
    menu_message(shortrom_filename/*strload*/);

	loadNewCart(CurrentROMFile);

//	loader_init(CurrentROMFile);	
//    emu_running=1;
//	emu_reset();
//    frames_rendered=frames_displayed=0;
//    framelimit_delay=0;
	vcs_frameBeginTime=GetTickCount();    
//	emu_run();		
	vcs_pause(0);	
    return 0; 
}
void vcs_MainLoop(void){
	/*** timing start ***/
	
	frames_displayed++;	
	vcs_frameBeginTime+=17*100/vcs_speedpct;	//60Hz
	
	if ((vcs_frameskip==AUTO_FSKIP)&&(!vcs_fastforward))
	{
		int i,haswaited=0;
		
		//do avoid issue when Tick is looping
		if ((int32)(vcs_frameBeginTime-GetTickCount())>=(int32)(10*17))		
			vcs_frameBeginTime=GetTickCount()+17;				
		while (GetTickCount()<=vcs_frameBeginTime)  haswaited=1;
//		i=vcs_frameBeginTime-GetTickCount()+1;
//        if (i>0) {haswaited=1; SysTaskDelay(i);}
		
		if (haswaited||(vcs_frameskipped>=MAX_FRAME_SKIPPED)) 
		{
			//renderit=true;
			vcs_frameskipped=0;
		}
		else 
		{
			//renderit=false;
			vcs_frameskipped++;
		}
	}
	else
	{	
		if (vcs_frameskip==SKEEZIX_FSKIP) vcs_frameskipped=SKEEZIX_FSKIP;	
		vcs_frameskipped++;
		
		if (vcs_fastforward)
		{
			if (vcs_frameskipped>VCS_TURBOFSKIP)
			{
				vcs_frameskipped=0;
				//renderit=true;
			}
			//else renderit=false;
		}
		else
		{					
			if (vcs_frameskipped>vcs_frameskip)
			{
				vcs_frameskipped=0;
				//renderit=true;
				int i,haswaited;					
				
				//do avoid issue when Tick is looping				
				if ((int32)(vcs_frameBeginTime-GetTickCount())>=(int32)(10*17))				
					vcs_frameBeginTime=GetTickCount()+17;
				while (GetTickCount()<=vcs_frameBeginTime) haswaited=1;
//				i=vcs_frameBeginTime-GetTickCount()+1;
//		        if (i>0) {SysTaskDelay(i);}
	 		   			   										
			}
			else 
			{
				int i;
				//renderit=false;				
				if ((int32)(vcs_frameBeginTime-GetTickCount())>=(int32)(10*17))				
					vcs_frameBeginTime=GetTickCount()+17;
				if (vcs_enabledSound==2)
				{
					while (GetTickCount()<=vcs_frameBeginTime) ;
//					i=vcs_frameBeginTime-GetTickCount()+1;
//			        if (i>0) {SysTaskDelay(i);}
				}
			}
		}
	}
	
	/*** timing end ***/
	
	//vscreen
	if(vcs_frameskip>9) app_data.rr=9; else app_data.rr = vcs_frameskip;
	mainloop();
	
	UInt16 *fline, *tline, *f, *t;
	int xmax=160, ymax=192;

	fline = vcs_curRenderingScreenPtr;
	tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-ymax-BELTBAR_SIZE)>>1) * display_pitch ) + ((display_width-xmax*2)>>1);

    for (int y = 0; y < ymax; y++ ) {
      f = fline;
      t = tline;
      for (int x = 0; x < xmax; x++ ) {
		*t++ = *f;
		*t++ = *f++;
      }
      fline += 160;
      tline += display_pitch;
    }
    

	/*switch (vcs_renderingmode)
  	{
  		case 3:
  		case 1:
  			tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-288-(vcs_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-320)>>1);
  			switch (vcs_smoothmode&_SMOOTH_MASK_){	  			
	  			case 7:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,SCALE_2XSAI,160,144,320,288);
	  			break;
	  			case 6:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,SUPER_EAGLE,160,144,320,288);	  			
	  			break;
		  		case 5:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,SUPER_2XSAI,160,144,320,288);
	  			break;
			  	case 4:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,_2XSAI,160,144,320,288);	  			
  				break;
			  	case 3:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,HQ2X,160,144,320,288);
	  			break;	
	  			case 2:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,LQ2X,160,144,320,288);
	  			break;
		  		case 1:fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,ADVMAME2X,160,144,320,288);
	  			break;
		  		case 0:
		  		
		  			if (device_type&BF_ZODIAC){	
			  			if (vcs_smoothmode&_ZOD_SMOOTHING_) {
						tline = ((UInt16*) vcs_zodvram);				
						vcs_asmfastrender((uint8*)tline,(uint8*)fline,(480-160)<<1);
						stubzodiacblit(3,160,144,6);
						break;
					}
					else if (!vcs_smoothmode) {
						tline = ((UInt16*) vcs_zodvram);				
						vcs_asmfastrender((uint8*)tline,(uint8*)fline,(480-160)<<1);
						stubzodiacblit(3,160,144,2);
						break;
					}
		  		}
		  		else vcs_asmfastrenderx2((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1));
				break;
			}
			break;
		case 2:
  		case 0:
			tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-144-(vcs_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-160)>>1);
		    vcs_asmfastrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch-160)<<1));
		    break;
		case 4:			
			if (device_type&BF_ZODIAC){					
				if (vcs_smoothmode&_ZOD_SMOOTHING_) {
					tline = ((UInt16*) vcs_zodvram);
					vcs_asmfastrender((uint8*)tline,(uint8*)fline,(480-160)<<1);
					stubzodiacblit(3,160,144,5);
					break;
				}
				else if (!vcs_smoothmode) {
					tline = ((UInt16*) vcs_zodvram);
					vcs_asmfastrender((uint8*)tline,(uint8*)fline,(480-160)<<1);
					stubzodiacblit(3,160,144,1);
					break;
				}
					
			}
			if (device_type&BF_HIRESPLUS){
				tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-320-0*BELTBAR_SIZE)>>1) * display_pitch ) + ((display_width-480)>>1);
				if (vcs_smoothmode) fgbZ_filterrender((UInt8*)tline,(UInt8*)fline,(UInt32)((display_pitch)<<1),160*2,SCALE_2XSAI,160,144,480,320);
			}
			break;
	}*/
}

void vcs_updatevpad(int k_key){
	current_keys=0;
	
	if (k_key & KEY_FIRE) {
		switch (vcs_autofireA)
	 	{
  			case 0:current_keys |= KEY_FIRE;; break;
  			case 1:
  	  			if ((vcs_framecount&31)>15) current_keys |= KEY_FIRE;
  	  			break;
  			case 2:
  	  			if ((vcs_framecount&15)>7) current_keys |= KEY_FIRE;
  	  			break;
  			case 3:
  	  			if ((vcs_framecount&7)>3) current_keys |= KEY_FIRE;
  	  			break;  		   
  	 	}
	}
	if (k_key & KEY_SELECT) {
		switch (vcs_autofireB)
	 	{
  			case 0:current_keys |= KEY_SELECT;; break;
  			case 1:
  	  			if ((vcs_framecount&31)>15) current_keys |= KEY_SELECT;
  	  			break;
  			case 2:
  	  			if ((vcs_framecount&15)>7) current_keys |= KEY_SELECT;
  	  			break;
  			case 3:
  	  			if ((vcs_framecount&7)>3) current_keys |= KEY_SELECT;
  	  			break;  		   
  	 	}
	}
	if (k_key & KEY_UP) current_keys |= KEY_UP;
	if (k_key & KEY_DOWN) current_keys |= KEY_DOWN;
	if (k_key & KEY_LEFT) current_keys |= KEY_LEFT;
	if (k_key & KEY_RIGHT) current_keys |= KEY_RIGHT;
	
	//process key
	int key=k_key;
	if (key&KEY_QUICKLOAD)
	{
		if (state_load(0,1))
		{
			if (CONFIRM_LOAD) {vcs_pause(1);state_load(0,0);vcs_pause(0);}
			emu_resettimer();
			 ClearScreen();
		}
	}
	if (key&KEY_QUICKSAVE)
	{
		if (CONFIRM_SAVE) {vcs_pause(1);state_save(0);vcs_pause(0);}
		emu_resettimer();
		 ClearScreen();
	}
	if (key&KEY_TURBO)
	{		
		vcs_fastforward=1;		
	}
	else 
	if (vcs_fastforward)
	{
		vcs_fastforward=0;
		emu_resettimer();
	}
}
void vcs_changefskip(void){
char tmp[64];
	int i;
	
	vcs_pause(1);
	
	vcs_frameskip++;
	if (vcs_frameskip>SKEEZIX_FSKIP) vcs_frameskip=0;
	
	
	if (vcs_frameskip==AUTO_FSKIP) strcpy(tmp,"Frameskip : AUTO");
	else if (vcs_frameskip==SKEEZIX_FSKIP) strcpy(tmp,"Frameskip : Skeezix");
	else 
	{
		char tmp2[16];
		strcpy(tmp,"Frameskip : ");
		StrIToA(tmp2,vcs_frameskip);
		strcat(tmp,tmp2);
	}

	menu_message(tmp);
	
	i=GetTickCount();
	while ((GetTickCount()-i)<300)
	{
	}
	vcs_frameBeginTime=GetTickCount()+17*100/vcs_speedpct;
	
	vcs_pause(0);
}
void vcs_changerendering(void){
}




int vcs_ShowMenuGFXConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval,hwsmooth;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(22*sizeof(RectangleType));
  char tmp[16];
  

	
  scrmode=vcs_renderingmode;
  smoothing=vcs_smoothmode&_SMOOTH_MASK_;
  hwsmooth=vcs_smoothmode&_ZOD_SMOOTHING_;
	
  fskipval=vcs_frameskip;

	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {  	  	
		GUI_REDRAW_BG (1);
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	  
	  	menu_button(10,80,(char*)"FRAMESKIP",0,&item_rect[1],2);	  
	  	menu_bar(150,80,fskipval,11,&item_rect[2]);
	  	if (fskipval==AUTO_FSKIP) strcpy(tmp,"AUTO");
	  	else if (fskipval==SKEEZIX_FSKIP) strcpy(tmp,"SKZX");
	  	else StrIToA(tmp,fskipval);
	  	menu_messageRaw(260,80,tmp);
	  
	  	menu_button(10,120,(char*)"ZOOM",0,&item_rect[3],2);	  	
	  	menu_button(150,120,(char*)"1",((scrmode==0)||(scrmode==2)?2:1),&item_rect[4],0);
	  	menu_button(200,120,(char*)"2",((scrmode==1)||(scrmode==3)?2:1),&item_rect[5],0);
	  	menu_button(250,120,(char*)"WIDE",(scrmode==4?2:1),&item_rect[6],0);
	  	
	  	menu_button(10,155,(char*)"FULLSCREEN",0,&item_rect[7],2);
	  	menu_button(150,155,(char*)"OFF",(scrmode&2?1:2),&item_rect[8],0);
	  	menu_button(200,155,(char*)"ON",(scrmode&2?2:1),&item_rect[9],0);	  	  	  
	  
	  	menu_button(10,190,(char*)"SMOOTHING",0,&item_rect[10],2);
	  	menu_button(150,190,(char*)"OFF",((smoothing==0)&&(!hwsmooth)?2:1),&item_rect[11],0);	  		  	
	  	menu_button(200,190,(char*)"AdvMAME2x",(smoothing==1?2:1),&item_rect[12],4);
	  	menu_button(2,218,(char*)"LQ2X",(smoothing==2?2:1),&item_rect[13],4);	  	  	  
	  	menu_button(68,218,(char*)"HQ2X",(smoothing==3?2:1),&item_rect[14],4);
	  	menu_button(136,218,(char*)"2xSaI",(smoothing==4?2:1),&item_rect[15],4);
	  	menu_button(202,218,(char*)"Super 2xSaI",(smoothing==5?2:1),&item_rect[16],4);
	  	menu_button(10,246,(char*)"Scale 2xSaI",(smoothing==6?2:1),&item_rect[17],4);
	  	menu_button(160,246,(char*)"HW",(hwsmooth?2:1),&item_rect[18],4);
	  	
	  	menu_button(10,280,(char*)"FLIPPING",0,&item_rect[19],2);
	  	menu_button(150,280,(char*)"OFF",(vcs_flipping?1:2),&item_rect[20],0);
	  	menu_button(200,280,(char*)"ON",(vcs_flipping?2:1),&item_rect[21],0);
	  	
	  	if (scr) ljp_WinScreenUnlock();
	
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[2])) {
	  	fskipval=(x-10-item_rect[2].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }
	  //SCREEN MODES
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[4])) {
		  scrmode&=~4;
	  	  scrmode&=~1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {
		  scrmode&=~4;
	  	  scrmode|=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {
	  	  scrmode=4;
	  	  redraw=1;
	  }
	  //SCREEN MODES WIN/FULL
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {
	  	  scrmode&=~(2|4);
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) {
	  	  if (scrmode<2) scrmode|=2;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[11])) {
	  	  smoothing=0;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[12])) {
	  	  smoothing=1;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[13])) {
	  	  smoothing=2;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[14])) {
	  	  smoothing=3;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[15])) {
	  	  smoothing=4;hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[16])) {
	  	  smoothing=5;
	  	  hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[17])) {
	  	  smoothing=6;
	  	  hwsmooth=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[18])) {
	  	  smoothing=0;
	  	  hwsmooth=_ZOD_SMOOTHING_;
	  	  redraw=1;
	  }
	  //FLIPPING
	  if (TEST_PEN_MENU(x,y,item_rect[20])) {
	  	  vcs_flipping=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[21])) {
	  	  vcs_flipping=1;
	  	  redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  vcs_frameskip=fskipval;

  vcs_renderingmode=scrmode;
  vcs_smoothmode=smoothing|hwsmooth;
	
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}



int vcs_ShowMenuSNDConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=snd_stream_vol/16;	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG (1);
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
	  menu_button(150,80,(char*)"OFF",(vcs_enabledSound==0?2:1),&item_rect[2],0);
	  menu_button(200,80,(char*)"SIM",(vcs_enabledSound==1?2:1),&item_rect[3],0);	  
	  menu_button(250,80,(char*)"ON",(vcs_enabledSound==2?2:1),&item_rect[4],0);	 
	  
	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
	  menu_bar(150,120,vol,128,&item_rect[6]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(270,120,tmp);
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  vcs_enabledSound=0;		  
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  vcs_enabledSound=1;	  	  
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  vcs_enabledSound=2;
		  redraw=1;
	  }
	  
	  //VOLUME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x-10)*128/100;
	  	if (vol<0) vol=0;
	  	if (vol>128) vol=128;
	  	redraw=1;
	  }
	  if (mStopEmulation) break;
  }  

	snd_stream_vol=vol*16;
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int vcs_ShowMenuOTHERConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG (1);
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"AUTO A",0,&item_rect[1],4);
	  menu_button(100,80,(char*)"OFF",(vcs_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(150,80,(char*)"SLW",(vcs_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(200,80,(char*)"MED",(vcs_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(250,80,(char*)"FST",(vcs_autofireA==3?2:1),&item_rect[5],0);
	  
	  menu_button(10,120,(char*)"AUTO B",0,&item_rect[6],4);
	  menu_button(100,120,(char*)"OFF",(vcs_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(150,120,(char*)"SLW",(vcs_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(200,120,(char*)"MED",(vcs_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(250,120,(char*)"FST",(vcs_autofireB==3?2:1),&item_rect[10],0);
	  
	  menu_button(10,160,(char*)"EMU SPEED",0,&item_rect[11],4);
	  menu_bar(130,160,vcs_speedpct,100,&item_rect[12]);
	  StrIToA(tmp,vcs_speedpct);
	  strcat(tmp,"%");
    	menu_messageRaw(240,160,tmp);
	  
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  vcs_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  vcs_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  vcs_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  vcs_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  vcs_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  vcs_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  vcs_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  vcs_autofireB=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
	  	vcs_speedpct=(x-item_rect[12].topLeft.x);
	  	if (vcs_speedpct>100) vcs_speedpct=100;
	  	if (vcs_speedpct<10) vcs_speedpct=10;
	  	redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}




int vcs_ShowMenuSave(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  FILE *savefile;
  	  int slot[4];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG (1);
  		
  	  	  	  	  	  	
	  
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  for (int i=0;i<4;i++) 
  	  	if (state_load(i,1))   	  	
  	  	{
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			GetStateFileName(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
	  	}	  	  	
  	  	  	  	  	  	
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"SAVE",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (!slot[1]||(menu_confirm("Overwrite ?")))
		  {state_save(1);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (!slot[2]||(menu_confirm("Overwrite ?")))
		  {state_save(2);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (!slot[3]||(menu_confirm("Overwrite ?")))
		  {state_save(3);result=1; break;}
		  else redraw=1;
		 
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
		  if (!slot[0]||(menu_confirm("Overwrite ?")))
		  {state_save(0);result=1; break;}
		  else redraw=1;
		 
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}



int vcs_ShowMenuLoad(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
   int slot[4];
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG (1);
		
  	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
      for (int i=0;i<4;i++) 
      	if (state_load(i,1)) 
      	{
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			GetStateFileName(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
		}	
      
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"LOAD",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;

  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (slot[1])
		if (state_load(1,0)) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (slot[2])
		if (state_load(2,0)) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot[3])
		if (state_load(3,0)) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	if (slot[0])
    	if (state_load(0,0)) {result=1;break;}
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}


int vcs_ShowMenuConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG (1);
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(92,100,(char*)"GFX",0,&item_rect[1],2);
	  menu_button(92,150,(char*)"SOUND",0,&item_rect[2],2);
	  menu_button(92,200,(char*)"OTHER",0,&item_rect[3],2);
	  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	vcs_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	vcs_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  vcs_ShowMenuOTHERConfig(savescr);
		  redraw=1;		  
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}

int vcs_ShowSysInfos(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		GUI_REDRAW_BG (1);		
		
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(vcs_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(vcs_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d]",strb,vcs_curVolume);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,63,str);				
		sprintf(str,"Used:%dM/%dM",usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,81,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM %ldK/%ldK",freeP/1024,maxP/1024);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
		/*TwGfxInfoType gfxinfo;
		gfxinfo.size=sizeof(gfxinfo);
		TwGfxGetInfo(vcs_mGfxLib,&gfxinfo);		
		menu_button(10,130,"VRAM",6,&my_rect,4);		
		sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);*/
						
    		
/*		menu_button(10,160,"ROM",4,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,rom.name);
		
		sprintf(str,"%dKo RAM-%dKo",mbc.romsize,mbc.ramsize);
		menu_button(10,190,"Size",4,&my_rect,4);
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
		menu_button(10,220,"Type",7,&my_rect,4);		
		sprintf(str,"%d Bt:%d Rtc:%d CGB:%d",mbc.type,mbc.batt,rtc.batt,hw.cgb);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);
		
		menu_button(10,250,"CRC",7,&my_rect,4);		
		sprintf(str,"%08X",vcs_romCrc);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,str);
		
		menu_button(10,280,"GoodGB",7,&my_rect,4);		
		int i=DAT_LookFor(vcs_romCrc);
		if (i<0) sprintf(str,"not found");
		else sprintf(str,"%s",MyDat[i].name);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,280,str);
*/		
						  	
	  	menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}


int vcs_ShowMenu(void)
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr,*tmpscr,*tmpdst;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;

  
  vcs_pause(1);
    
       
  scr=/*(uint8*)(g_pnobridge -> vram);*/ljp_WinScreenLock(winLockCopy);  
  savescr=(uint8*)ljz_malloc(display_width*display_height*2);    
  if (scr&&savescr)
  {
	  tmpscr=scr;
  	for (int yy=0;yy<display_height-(vcs_renderingmode<2?BELTBAR_SIZE:0);yy++)
  	{
	  for (x=0;x<display_width;x++)
	  {
  		y=((uint16*)tmpscr)[x];
	  	((uint16*)tmpscr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  tmpscr+=display_pitch*2;
	}
	tmpscr=scr;
	tmpdst=savescr;
	for (int yy=0;yy<display_height;yy++)
  	{
	    memcpy(tmpdst,tmpscr,display_width*2);
	    tmpdst+=display_width*2;
	    tmpscr+=display_pitch*2;
	}
  }
  if (scr) ljp_WinScreenUnlock();
            
              
  for (;;)
  {  
  	if (redraw)
  	{  	
	  	slot0=state_load(0,1);    
  		
  		
		GUI_REDRAW_BG (1);
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(10,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(180,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(10,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(180,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(10,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(180,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(180,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		menu_button(10,250,(char*)"RESET VCS",9,&item_rect[7],2);				
		if (scr) ljp_WinScreenUnlock();				
		
  	}
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {vcs_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (vcs_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (vcs_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  state_save(0);
		  result=0;
		  break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot0)
	    if (state_load(0,0)) {result=0;break;}
	  }
	  //RESET VCS
	  if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("Reset Atari 2600 ?")) {emu_reset=1; result=0;break;}redraw=1;}
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {vcs_ShowSysInfos(savescr);redraw=1;}

		if (mStopEmulation) break;
	}
  ljz_free(item_rect);
  
  if (savescr) ljz_free(savescr);
            
  vcs_pause(0);
  return result;
}  



