#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "ljPRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif


#include "PNOMain.h"
#include "App_Cst.h"
#include "ljz_std.h"

#include "oswan.h"

unsigned int g_translateBtn[20]=
{KEY_A,KEY_B,KEY_START,KEY_FLIPPED,
KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,
KEY_QUICKLOAD,KEY_QUICKSAVE,KEY_FRAMESKIP,
KEY_SCREENMODE,KEY_TURBO,0,0,0,0,0,0,0};
unsigned int g_confinput[20];


int oswanZ_ShowMenu(void);
void oswanZ_pause(int pause);

void ClearScreen(void);

UInt32 mStopEmulation=0;

extern UInt32 ljp_showFPS,ljp_showBeltbar,ljp_showBattMode,ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;
extern UInt32 oswanZ_renderingmode;
extern UInt16 *oswanZ_zodvram;
extern UInt32 device_type;

unsigned long Run()
{
	Int32 lastTick;
	UInt32 pollcpt=0;
	UInt32 keys,keyval;
    Int16 penX,penY;
    Boolean penDown;    
	//Read the key config
	UInt32 *ftrptr;
    char text[16];
    Int32 framerate = 0;
    Int32 timecpt,framecpt = 0;
	
 	FtrGet(CREATORID,FTR_OPT_INPUTCONF_ID ,(unsigned long*)&ftrptr);
	for (int i=0;i<20;i++) g_confinput[i]=ByteSwap32(ftrptr[i]);
	
	FtrGet(CREATORID,FTR_OPT_SHOWFRAMERATE_ID ,(unsigned long*)&ljp_showFPS);
	FtrGet(CREATORID,FTR_OPT_SHOWBELTBAR_ID ,(unsigned long*)&ljp_showBeltbar);
	FtrGet(CREATORID,FTR_OPT_SHOWBATTMODE_ID ,(unsigned long*)&ljp_showBattMode);
	FtrGet(CREATORID,FTR_OPT_ISLOWRES_ID ,(unsigned long*)&ljp_isLowRes);
	FtrGet(CREATORID,FTR_OPT_CONFIRMOW_ID ,(unsigned long*)&ljp_confirmOW);
	FtrGet(CREATORID,FTR_OPT_CONFIRMSL_ID ,(unsigned long*)&ljp_confirmSL);
	//
	//Load the Rom

	mStopEmulation=oswanZ_loadrom();
	
	if (device_type & BF_ZODIAC) {
		oswanZ_zodvram=(UInt16*) stubzodiacblit ( 0,0,0,0 );
		if (!oswanZ_zodvram) menu_info("Zodiac VRAM NULL ptr!!");
	}

	//
	//Main Loop
	
	//autoload?
	oswanZ_MainLoop();
	if (g_pnobridge->game_rom){
		state_load(g_pnobridge->game_rom-1,0);
	}
	
	ClearScreen();	
	
	timecpt=GetTickCount();
	while (!mStopEmulation)
	{
	
   	    //Read key state
	    keys = KeyCurrentState();
	    
		keyval=0;

		//check pen
		if (!(pollcpt&3)) LJP_CHECK_MENU_ACCESS(oswanZ_ShowMenu,oswanZ_renderingmode>=2)
		
		//handle sys event
		if (!(pollcpt&31)) LJP_HANDLE_EVENT(oswanZ_pause)
		
		//avoid autoff
		//every 1024 frame => 
		if (!(pollcpt&1023)) EvtResetAutoOffTimer(); 
		
		LJP_UPDATE_KEYS
		
		oswanZ_updatevpad(keyval);
		
		if (keyval&KEY_FRAMESKIP) 
		{
			oswanZ_changefskip();
			ClearScreen();
		}
		if (keyval&KEY_SCREENMODE) 
		{
			oswanZ_changerendering();
			stub_DrawBeltBar();
			ClearScreen();
		}
		
		pollcpt++;
		
	
		//Emulate Wonderswan
		
		oswanZ_MainLoop();
		
		framecpt++;
		if ((oswanZ_renderingmode<2) &&  ( (ljp_showFPS) || (ljp_showBeltbar) ))
		if (framecpt>=30) {
		  //FPS
		    UInt8 *vr;
			vr=(UInt8*)(g_pnobridge -> vram)/*+(g_pnobridge -> display_pitch)*2*/;		
			framecpt=0;
			framerate=30*1000/(GetTickCount()-timecpt+1);
			timecpt=GetTickCount();

			if (ljp_showBeltbar) {
				beltbar_draw(0,g_pnobridge -> display_height-BELTBAR_SIZE,g_pnobridge -> display_pitch,framerate,0,vr);
			} else if (ljp_showFPS) {
				for (int y=0;y<20;y++)
				{	
					memset(vr,0,80*2);
					vr+=(g_pnobridge -> display_pitch)*2;
				}
				
				text[0]=((framerate/100)%10)+48;
				text[1]=((framerate/10)%10)+48;
				text[2]=((framerate)%10)+48;
				text[3]=0;
				
				menu_messageRaw(5,0,text);
			}
		}
	}

	oswanZ_end();
	
	if (device_type & BF_ZODIAC) {
		stubzodiacblit ( 1,0,0,0 );
	}


	return 0;
}



/************************************/
#define BELTBAR_BTNSIZE_LOC SCR_ADJ(32)

void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height-(oswanZ_renderingmode<2?BELTBAR_SIZE:0);y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}


int gui_redraw_bg_func(int *red,uint8 **scrP,uint8 *savescr,uint8 batt){
	int redraw;
	int result;
	uint8 *scr;
	redraw=*red;
	scr=*scrP;
	GUI_REDRAW_BG(batt)
	*red=redraw;
	*scrP=scr;
	return result;
}

void oswanZ_handlevent(){
	LJP_HANDLE_EVENT(oswanZ_pause)	
}