///////////////////////////////////////////////////////////////////////////////
// Wonderswan emulator
////////////////////////////////////////////////////////////////////////////////
//
// 13.04.2002: Fixed a small bug causing crashes
//
//
//
//
//////////////////////////////////////////////////////////////////////////////

#define OSWANZ_TURBOFSKIP 15
#define OSWANZ_ROMSDIR "0:/PALM/Programs/LJP/WS/Roms/"
#define OSWANZ_SAVESDIR "0:/PALM/Programs/LJP/WS/Saves/"
#define AUTO_FSKIP 10
#define SKEEZIX_FSKIP 11

#define MAX_FRAME_SKIPPED 10

#include "oswan.h"


//#include <TapWave.h>

//using namespace std;
extern "C" {


#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "ljPRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif

#include "ljZmenu.h"
#include "PNOMain.h"
#include "App_Cst.h"
#include "ljz_std.h"
#include "filters.h"
#include "stretch_nester.h"

Int8 fgetdate( const char *filename,UInt32 *date);
Int8 remove ( const char *filename );
//void ljp_asmfastrender(uint8*a,uint8*b,uint32 c,uint32 d);
void ljp_asmfastrenderX15_224(uint8*a,uint8*b,uint32 c,uint32 d);
void ljp_asmfastrenderX15sm_224(uint8*a,uint8*b,uint32 c,uint32 d);
extern UInt32 device_type;
void oswanZ_handlevent();
}

extern UInt32 ljp_isLowRes,ljp_confirmOW,ljp_confirmSL;
extern "C" void ClearScreen(void);


#undef OF


/*#include <stdio.h>
#include <stdlib.h>
#include <string.h>*/
//#include <malloc.h>
//#include <io.h>
#include <fcntl.h> 
#include <time.h>

#include "log.h"
#include "rom.h"
#include "nec/nec.h"
#include "memory.h"
#include "gpu.h"
#include "io.h"
#include "ws.h"


extern "C" int __getdate_file(const char* name);



////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
#define		LOG_PATH "/PALM/Programs/LJP/WS/wslog.log"

char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};


int			app_gameRunning=0;
int			app_terminate=0;


int			app_rotated=0;


int			ws_videoEnhancementType=0;
int			ws_colourScheme=COLOUR_SCHEME_DEFAULT;
int			ws_system=WS_SYSTEM_COLOR;//WS_SYSTEM_AUTODETECT;

UInt16 *oswanZ_zodvram;

extern uint8 *ws_rom;
extern uint32  romSize;
extern UInt32 mStopEmulation;

char shortrom_filename[256];
char oswanZ_curVolume;
char RomPath[256];

void oswan_updateInput(void);





extern "C" {
void oswanZ_MainLoop(void);
void oswanZ_pause(int pause);
void oswanZ_updatevpad(unsigned int val);
int oswanZ_loadrom();
void oswanZ_end();
void oswanZ_changefskip(void);
void oswanZ_changerendering(void);
int state_load(int num,int test_only);
int state_save(int num);
}


void oswanZ_updateScreen(void);







uint32 oswanZ_enabledSound,oswanZ_sndfreq;
uint32 oswanZ_renderingmode,oswanZ_smoothmode,oswanZ_flipping;
uint32 oswanZ_padState;
int32 oswanZ_frameskipped,oswanZ_frameskip,oswanZ_fastforward;
int32 oswanZ_frameBeginTime;
int32 oswanZ_speedpct;
int32 oswanZ_autofireA,oswanZ_autofireB;
int32 oswanZ_framecount,oswanZ_drawframe;

int32 oswanZ_frameTime;


//#include "filters/standard.h"
int16 backbuffer[224*144];


#include "SoundMgr.h"
SndStreamRef snd_stream;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
uint32 oswanZ_sndbuffsize;
int32 snd_cb_running;
uint32 snd_stream_vol;

static Err oswanZ_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}		
	if (snd_cb_running==0)
	{
		snd_cb_running=1;
//		sound_update((int16*)(bufferZ),frameCountZ);
		snd_cb_running=0;
	}
	
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}



extern "C" {
char 	savename[255];

void emu_resettimer(void) {
	oswanZ_frameBeginTime=GetTickCount()+17*100/oswanZ_speedpct;
}

void oswanZ_togglesound(void) { //*** WONDERSWAN MODULE HAS NO SOUND YET SO DO NOTHING ***
	/*char tmp[64];
	int i;
	
	oswanZ_pause(1);
	
	oswanZ_enabledSound++;
	if (oswanZ_enabledSound>2) oswanZ_enabledSound=0;
	
	if (oswanZ_enabledSound==0) strcpy(tmp,"Sound : OFF");
	else if (oswanZ_enabledSound==1) strcpy(tmp,"Sound : SIM");
	else if (oswanZ_enabledSound==2) strcpy(tmp,"Sound : ON");

	menu_message(tmp);
	
	LJP_WAIT(300);
	emu_resettimer();
	
	oswanZ_pause(0);*/
}

char oswanZ_reset(void) {
	oswanZ_pause(1);
	
  	if (menu_confirm("Reset WS ?")) ws_reset();
  	
  	emu_resettimer();
  	
  	oswanZ_pause(0);
  	
  	return 0;
}

void oswanZ_quicksave(void) {
	oswanZ_pause(1);
	
	if (CONFIRM_SAVE) state_save(0);
	emu_resettimer();
	ClearScreen();
	
	oswanZ_pause(0);
}

void oswanZ_quickload(void) {
	oswanZ_pause(1);
	
	if (!state_load(0,1))
	{
		if (CONFIRM_LOAD) state_load(0,0);
		emu_resettimer();
		ClearScreen();
	}
	
	oswanZ_pause(0);
}

void getstate_filename(int num,char *filename)
{
	char result[256];
	uint32 i=0,j=255,k=255,l=255;
	i=0;
	j=255;
	k=-1;
	while (shortrom_filename[i]!=0) 
	{
		if (shortrom_filename[i]=='.') j=i;
		if (shortrom_filename[i]=='/') k=i;
		if (shortrom_filename[i]=='\\') k=i;
		i++;
	  }
	if (j==255) j=i;  //pas d'extension	  
	memcpy(result,shortrom_filename+k+1,j+1-k-1);    
	result[j+1-k-1]=0;
	sprintf(filename,"%s%ssw%d",OSWANZ_SAVESDIR,result,num);	
	filename[0]=oswanZ_curVolume+'0';

}

int state_load(int num,int test_only)
{
	FILE	*file;			
	getstate_filename(num,savename);
	file = fopen(savename, "rb");
	if (file == NULL)
	{
		return -1;
	}
	fclose(file);
	if (test_only) return 0;
	ws_loadState(savename);
	return 0;
}

int state_save(int num)
{
	getstate_filename(num,savename);	
	ws_saveState(savename);	
	return 0;
}
}

int init_video(void)
{
	return 0;
}

void oswanZ_initparam(void)
{
	signed long val1,val2,val;
	char *ftrptr;
	FtrGet(CREATORID,FTR_OPT_SOUND_ID,(unsigned long*)&val);  
	oswanZ_enabledSound=val;
	FtrGet(CREATORID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);  
	if (val==1) oswanZ_sndfreq=22050;
	else if (val==2) oswanZ_sndfreq=11025;
	else oswanZ_sndfreq=44100;	
	
	
	FtrGet(CREATORID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(CREATORID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);		
	oswanZ_renderingmode=val1;
	oswanZ_smoothmode=val2;

	oswanZ_fastforward=0;	
	oswanZ_frameskipped=0;
	
    FtrGet(CREATORID,FTR_OPT_FSKIP_ID,(unsigned long*)&val); 
	oswanZ_frameskip=val;


//Core settings
		
	oswanZ_speedpct=100;
	oswanZ_autofireA=0;
	oswanZ_autofireB=0;	
	oswanZ_framecount=0;
	oswanZ_drawframe=1;
	init_video();	
    

    strcpy(RomPath,OSWANZ_ROMSDIR);
    
    {//handle categories
    	char cat[32];
	  	FtrGet(CREATORID,FTR_OPT_CATEGORY_ID ,(unsigned long*)&ftrptr);
	  	strcpy(cat,ftrptr);
  		if ( StrCaselessCompare(cat,"uNaRcHiVeD") != 0) {
  			strcat(RomPath,cat);
	  		strcat(RomPath,"/");
	  	}
	  	//FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
  	}
    
    FtrGet(CREATORID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
    
    oswanZ_curVolume=ftrptr[0];
    RomPath[0]=oswanZ_curVolume+'0';
    
    ftrptr+=3;
    strcpy(shortrom_filename,ftrptr);  
    strcat(RomPath,ftrptr);
//    FtrPtrFree(CREATORID, FTR_ROM_FILENAME_ID);	
    
    
/*    FtrGet(CREATORID,FTR_OPT_SOUNDVOLUME_ID,(unsigned long*)&val); 
	snd_stream_vol=val;
	if (snd_stream_vol<0) snd_stream_vol=0;
	if (snd_stream_vol>128) snd_stream_vol=128;
	snd_stream_vol*=16;  */


	filters_init();
	if (oswanZ_smoothmode==2) {
		if (InitStretchTables()) oswanZ_smoothmode=0;
	}
   
    
    oswanZ_frameTime=17; //hardcoded to NTSC
}

void oswanZ_audio_init()
{
}

void oswanZ_initSystem(void)
{     	
	app_rotated=ws_rotated();
	app_gameRunning=1;
	ws_set_system(ws_system);
	ws_set_colour_scheme(ws_colourScheme);
	//ws_buildHalfBrightnessTable();
	ws_reset();
}
	
int oswanZ_loadrom()
{	
	ljz_std_showstat(); 
	
	char strload[256];
	oswanZ_initparam();    			
	
	/* Load game */
    sprintf(strload,"Loading : %s",shortrom_filename);
    menu_message(strload);          		   
//	unsigned long freeM,maxM;	
//	MemHeapFreeBytes(0,&freeM,&maxM);
//	StrPrintF(strload,"mem : %d %d",freeM,maxM);
//	menu_message(strload);
//	menu_waitPen(NULL,NULL,1);


    if(!ws_init(RomPath))
	{
		menu_message("Error loading file");
		menu_waitPen(NULL,NULL,1);
		return 1;
	}	
		
	oswanZ_initSystem();		
    oswanZ_audio_init();            

    oswanZ_frameBeginTime=GetTickCount();
//    if (oswanZ_enabledSound) stub_SndStreamStart(snd_stream);
      

    return 0;  
}
void oswanZ_end()
{
	int val;
	

	oswanZ_pause(1);
	
	

//	stub_SndStreamDelete(snd_stream);  
/*emu*/
	ws_done();	

	

	
	  
 	FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,oswanZ_renderingmode);
	FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID,oswanZ_smoothmode);	

	FtrSet(CREATORID, FTR_OPT_SOUND_ID,oswanZ_enabledSound);
	switch (oswanZ_sndfreq)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,val);	
	
	FtrSet(CREATORID, FTR_OPT_FSKIP_ID,oswanZ_frameskip);

	ljz_std_showstat(); 
}


extern "C" {
void oswanZ_MainLoop(void)
{
	oswanZ_framecount++;
//Throttle speed
	int haswaited;
	oswanZ_frameBeginTime+=oswanZ_frameTime*100/oswanZ_speedpct;	//60Hz
			

	//Frameskip
	if ((oswanZ_frameskip==AUTO_FSKIP)&&(!oswanZ_fastforward))
	{
		
		//do avoid issue when Tick is looping	
		if ((int32)(oswanZ_frameBeginTime-GetTickCount())>=(int32)(20*oswanZ_frameTime))	
			oswanZ_frameBeginTime=GetTickCount()+oswanZ_frameTime*100/oswanZ_speedpct;				
		//while (GetTickCount()<=oswanZ_frameBeginTime)  haswaited=1;
		int i=oswanZ_frameBeginTime-GetTickCount()+1;
        if (i>0) {haswaited=1; SysTaskDelay(i);}
		

	
		if (haswaited) 
		{
			oswanZ_frameskipped=0;
			oswanZ_drawframe=1;
		}
		else 
		{
			oswanZ_frameskipped++;						
			
			if (oswanZ_frameskipped>MAX_FRAME_SKIPPED) 
			{
				oswanZ_frameskipped=0;
				oswanZ_drawframe=1;
			}
			else oswanZ_drawframe=0;
		}			
	}
	else
	{
		if (oswanZ_frameskip==SKEEZIX_FSKIP) oswanZ_frameskipped=SKEEZIX_FSKIP;
		oswanZ_frameskipped++;
		
		if (oswanZ_fastforward)
		{
			if (oswanZ_frameskipped>OSWANZ_TURBOFSKIP)
			{
				oswanZ_frameskipped=0;
				oswanZ_drawframe=1;
			}
			else oswanZ_drawframe=0;
		}
		else
		{								
			if (oswanZ_frameskipped>oswanZ_frameskip)
			{
				oswanZ_frameskipped=0;
				oswanZ_drawframe=1;
			}
			else oswanZ_drawframe=0;
		}
		
		if ((!oswanZ_fastforward)&&(oswanZ_drawframe||(oswanZ_enabledSound==2)))
		{
			//do avoid issue when Tick is looping	
			if ((int32)(oswanZ_frameBeginTime-GetTickCount())>=(int32)(20*oswanZ_frameTime))	
				oswanZ_frameBeginTime=GetTickCount()+oswanZ_frameTime*100/oswanZ_speedpct;				
			//while (GetTickCount()<=oswanZ_frameBeginTime) ;
			int i=oswanZ_frameBeginTime-GetTickCount()+1;
        	if (i>0) {SysTaskDelay(i);}
		}

	}
	
	if (oswanZ_drawframe)
	{
		while (!ws_executeLine(backbuffer,1));		
		oswanZ_updateScreen();
	}
	else
	{
		while (!ws_executeLine(backbuffer,0));
	}
	
	oswan_updateInput();
}

}


void oswanZ_asmfastrender(uint8 *screen,uint8 *source,uint32 offset_pitch)
{
	__asm{
		stmfd r13!,{r3-r12}

		mov	  r3,#144
		bic	  r0,r0,#3
		bic	  r1,r1,#3

	 loopY:	
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r4-r12}
		stmia r0!,{r4-r12}
		
		ldmia r1!,{r5-r8}
		stmia r0!,{r5-r8}
		
		add	  r0,r0,r2 
		
		subs  r3,r3,#1
		bne   loopY
		
		ldmfd r13!,{r3-r12}	
		}	
}


void oswanZ_updateScreen(void)
{	 
//	if (oswanZ_drawframe)
		int width = 224;//(reg[12] & 1) ? 320 : 256;
	    int height = 144;//(reg[1] & 8) ? 240 : 224;
	    
/*    	uint16 *dest=((UInt16*) g_pnobridge -> vram) + ( ((display_height-height)>>1) * display_pitch ) + ((display_width-width)>>1);;
    	uint16 *src=(uint16*)backbuffer;
    	int r,g,b,col;    	
    	for (int y = 0; y < height; y++)
		{
			for (int x = 0; x < width; x++)
			{
				*dest++=*src++;
			}
			dest+=display_pitch-width;
		}*/
		
		UInt16 *fline, *tline;

	fline = ((UInt16*)backbuffer);
	if (!ljp_isLowRes) {		
		switch (oswanZ_renderingmode){
				case 0:
				case 2:	
					tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-144-(oswanZ_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-224)>>1);
					oswanZ_asmfastrender((uint8*)tline,(uint8*)fline,(display_pitch-224)<<1);
					break;		
				case 1:
				case 3:							
					if (device_type&BF_ZODIAC){				
						if (oswanZ_smoothmode&_ZOD_SMOOTHING_) {
							tline = ((UInt16*) oswanZ_zodvram);				
							oswanZ_asmfastrender((uint8*)tline,(uint8*)fline,(480-224)<<1);
							stubzodiacblit(3,224,144,4);
							break;
						}else if (!oswanZ_smoothmode) {
							tline = ((UInt16*) oswanZ_zodvram);				
							oswanZ_asmfastrender((uint8*)tline,(uint8*)fline,(480-224)<<1);
							stubzodiacblit(3,224,144,0);
							break;
						}
					}
					tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-144*5/4-(oswanZ_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) + ((display_width-224*5/4)>>1);
					if (oswanZ_smoothmode==0) ljp_asmfastrenderX15_224((uint8*)tline,(uint8*)fline,144,(display_pitch-224*5/4)<<1);
					else if (oswanZ_smoothmode==1) ljp_asmfastrenderX15sm_224((uint8*)tline,(uint8*)fline,144,(display_pitch-224*5/4)<<1);
					else if (oswanZ_smoothmode==2) StretchNesterTrue_224(fline,tline,224,display_pitch,144);
					else if (oswanZ_smoothmode==3) {
						tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-144*display_width/224-(oswanZ_renderingmode<2?BELTBAR_SIZE:0))>>1) * display_pitch ) /*+ ((display_width-144*display_width/224)>>1)*/;
						fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,224*2,SCALE_2XSAI,224,144,display_width,144*display_width/224);
					}
					break;		
				case 4:
					if (device_type&BF_ZODIAC){						
					if (oswanZ_smoothmode&_ZOD_SMOOTHING_) {
						tline = ((uint16*) oswanZ_zodvram);
						oswanZ_asmfastrender((uint8*)tline,(uint8*)fline,(480-224)<<1);
						stubzodiacblit(3,224,144,5);
						break;
					} else if (!oswanZ_smoothmode) {
						tline = ((uint16*) oswanZ_zodvram);
						oswanZ_asmfastrender((uint8*)tline,(uint8*)fline,(480-224)<<1);
						stubzodiacblit(3,224,144,1);
						break;
					}
					}
					if (device_type&BF_HIRESPLUS){
						tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-320)>>1) * display_pitch ) + ((display_width-480)>>1);
						if (oswanZ_smoothmode) fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,224*2,SCALE_2XSAI,224,(UInt32)144,480,320/*-BELTBAR_SIZE*/);
					}
					break;
			}	
		} else {
			tline = ((UInt16*) g_pnobridge -> vram) + ( ((g_pnobridge -> display_height-102-BELTBAR_SIZE)>>1) * display_pitch ) + ((display_width-160)>>1);
			fgbZ_filterrender((uint8*)tline,(uint8*)fline,display_pitch*2,224*2,SCALE_2XSAI,224,144,160,102);
		}
}


extern "C" {
void oswanZ_pause(int pause)
{	
   if (pause)
	{
		//if (snd_stream) stub_SndStreamGetVolume(snd_stream,&snd_stream_vol);  
//		if (oswanZ_enabledSound) stub_SndStreamStop(snd_stream);
	}
	else
	{
		oswanZ_frameBeginTime=GetTickCount()+oswanZ_frameTime*100/oswanZ_speedpct;
/*		if (oswanZ_enabledSound) {
			stub_SndStreamCreate(&snd_stream,sndOutput,fgbZ_sndfreq,sndUInt8,sndStereo,oswanZ_sndCallBack,&reg_sys,512,1);
			stub_SndStreamStart(snd_stream);		
			stub_SndStreamSetVolume(snd_stream,snd_stream_vol);
		}*/
	}
}


void oswanZ_changefskip(void)
{
	char tmp[64];
	int i;
	

	oswanZ_frameskip++;
	if (oswanZ_frameskip>SKEEZIX_FSKIP) oswanZ_frameskip=0;
	
	
	if (oswanZ_frameskip==AUTO_FSKIP) sprintf(tmp,"Frameskip : AUTO");
	else if (oswanZ_frameskip==SKEEZIX_FSKIP) sprintf(tmp,"Frameskip : Skeezix");
	else sprintf(tmp,"Frameskip : %d",oswanZ_frameskip);	
	//DrawMessage(tmp,0);
	menu_message(tmp);
	
	i=GetTickCount();
	while ((GetTickCount()-i)<300)
	{
	}
	oswanZ_frameBeginTime=GetTickCount()+oswanZ_frameTime*100/oswanZ_speedpct;
}
void oswanZ_changerendering(void)
{	
	oswanZ_renderingmode++;
	if (oswanZ_renderingmode>3) oswanZ_renderingmode=0;
	if (oswanZ_renderingmode==2) {
		stub_fullscreen(1);
		oswanZ_handlevent();		
	}
	if (oswanZ_renderingmode==0) {
		stub_fullscreen(0);
		oswanZ_handlevent();
	}
	menu_message("Changing screen mode");
	oswanZ_frameBeginTime=GetTickCount();
	while ((GetTickCount()-oswanZ_frameBeginTime)<300){
	}
	oswanZ_frameBeginTime=GetTickCount()+oswanZ_frameTime*100/oswanZ_speedpct;
}


void oswanZ_updatevpad(unsigned int val)
{
	oswanZ_padState=val;
}
}
/****************************************************************************/


void oswan_updateInput(void)
{

	ws_key_button_1=0;	
	if (oswanZ_padState&KEY_A)
   	 switch (oswanZ_autofireA)
	 {
  		case 0:ws_key_button_1=1; break;
  		case 1:
  	  		if ((oswanZ_framecount&31)>15) ws_key_button_1=1;
  	  		break;
  		case 2:
  	  		if ((oswanZ_framecount&15)>7) ws_key_button_1=1;
  	  		break;
  		case 3:
  	  		if ((oswanZ_framecount&7)>3) ws_key_button_1=1;
  	  		break;  		   
  	 }
  	 
  	ws_key_button_2=0;	
  	if (oswanZ_padState&KEY_B)
	 switch (oswanZ_autofireB)
	 {
  		case 0:ws_key_button_2=1; break;
  		case 1:
  	  		if ((oswanZ_framecount&31)>15) ws_key_button_2=1;
  	  		break;
  		case 2:
  	  		if ((oswanZ_framecount&15)>7) ws_key_button_2=1;
  	  		break;
  		case 3:
  	  		if ((oswanZ_framecount&7)>3) ws_key_button_2=1;
  	  		break;  		   
  	 }
	
	

	if (oswanZ_padState&KEY_START) ws_key_start=1;
	else ws_key_start=0;
	if (oswanZ_padState&KEY_UP) ws_key_up=1;
	else ws_key_up=0;
	if (oswanZ_padState&KEY_DOWN) ws_key_down=1;
	else ws_key_down=0;
	if (oswanZ_padState&KEY_LEFT) ws_key_left=1;
	else ws_key_left=0;
	if (oswanZ_padState&KEY_RIGHT) ws_key_right=1;
	else ws_key_right=0;
	if (oswanZ_padState&KEY_FLIPPED) ws_key_flipped=1;
	else ws_key_flipped=0;
	
	if (oswanZ_padState&KEY_TURBO)
	{		
		oswanZ_fastforward=1;		
	}
	else 
	if (oswanZ_fastforward)
	{
		oswanZ_fastforward=0;
		oswanZ_frameBeginTime=GetTickCount()+oswanZ_frameTime*100/oswanZ_speedpct;
	}
	
	if (oswanZ_padState&KEY_QUICKLOAD)
	{
		if (!state_load(0,1))
		{
			if (CONFIRM_LOAD) state_load(0,0);
			oswanZ_frameBeginTime=GetTickCount()+oswanZ_frameTime*100/oswanZ_speedpct;
		}
	}
	if (oswanZ_padState&KEY_QUICKSAVE)
	{
		if (CONFIRM_SAVE) state_save(0);
			oswanZ_frameBeginTime=GetTickCount()+oswanZ_frameTime*100/oswanZ_speedpct;
	}
}


extern "C" {

int gui_redraw_bg_func(int *red,uint8 **scrP,uint8 *savescr,uint8 batt);

int oswanZ_ShowMenuGFXConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval,hwsmooth;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(23*sizeof(RectangleType));
  char tmp[16];
  

	
  scrmode=oswanZ_renderingmode;
  smoothing=oswanZ_smoothmode&_SMOOTH_MASK_;
  hwsmooth=oswanZ_smoothmode&_ZOD_SMOOTHING_;
	
  fskipval=oswanZ_frameskip;

	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {  	  	
		result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
	  
	  	menu_button(10,80,(char*)"FRAMESKIP",0,&item_rect[1],2);	  
	  	menu_bar(150,80,fskipval,11,&item_rect[2]);
	  	if (fskipval==AUTO_FSKIP) strcpy(tmp,"AUTO");
	  	else if (fskipval==SKEEZIX_FSKIP) strcpy(tmp,"SKZX");
	  	else StrIToA(tmp,fskipval);
	  	menu_messageRaw(260,80,tmp);
	  
	  	menu_button(10,120,(char*)"ZOOM",0,&item_rect[3],2);	  	
	  	menu_button(150,120,(char*)"1",((scrmode==0)||(scrmode==2)?2:1),&item_rect[4],0);
	  	menu_button(200,120,(char*)"1.25",((scrmode==1)||(scrmode==3)?2:1),&item_rect[5],0);
	  	menu_button(250,120,(char*)"WIDE",(scrmode==4?2:1),&item_rect[6],0);
	  	
	  	menu_button(10,155,(char*)"FULLSCREEN",0,&item_rect[7],2);
	  	menu_button(150,155,(char*)"OFF",(scrmode&2?1:2),&item_rect[8],0);
	  	menu_button(200,155,(char*)"ON",(scrmode&2?2:1),&item_rect[9],0);	  	  	  
	  
	  	menu_button(10,230,(char*)"SMOOTHING",0,&item_rect[10],2);
	  		menu_button(150,230,(char*)"-",((smoothing==0)&&(!hwsmooth)?2:1),&item_rect[11],4);
		  	menu_button(180,230,(char*)"1",(smoothing==1?2:1),&item_rect[12],4);
		  	menu_button(210,230,(char*)"2",(smoothing==2?2:1),&item_rect[13],4);
	  		menu_button(240,230,(char*)"3",(smoothing==3?2:1),&item_rect[14],4);
		  	menu_button(280,230,(char*)"HW",(hwsmooth?2:1),&item_rect[15],3);
	  	
	  	menu_button(10,280,(char*)"FLIPPING",0,&item_rect[19],2);
	  	menu_button(150,280,(char*)"OFF",(oswanZ_flipping?1:2),&item_rect[20],0);
	  	menu_button(200,280,(char*)"ON",(oswanZ_flipping?2:1),&item_rect[21],0);
	  	
	  	if (scr) ljp_WinScreenUnlock();
	
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[2])) {
	  	fskipval=(x-10-item_rect[2].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }
	  //SCREEN MODES
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[4])) {
		  scrmode&=~4;
	  	  scrmode&=~1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {
		  scrmode&=~4;
	  	  scrmode|=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {
	  	  scrmode=4;
	  	  redraw=1;
	  }
	  //SCREEN MODES WIN/FULL
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {
	  	  scrmode&=~(2|4);
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) {
	  	  if (scrmode<2) scrmode|=2;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[11])&&scrmode) {
			  if (smoothing==2){DeInitStretchTables();}
		  	  smoothing=0;
	  		  hwsmooth=0;	  	  
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[12])&&scrmode) {
			  if (smoothing==2){DeInitStretchTables();}
		  	  smoothing=1;
		  	  hwsmooth=0;
	  		  redraw=1;	  	  
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[13])&&scrmode) {
	  		  if (smoothing!=2){	 
				if (InitStretchTables()){
					menu_message("Err:InitStretchTables");
				}else{
			  	  smoothing=2;
		  		  hwsmooth=0;
			  	}
		  	  }
		  	  redraw=1;
		  }
		  if (TEST_PEN_MENU(x,y,item_rect[14])&&scrmode) {
			  if (smoothing==2){DeInitStretchTables();}
		  	  smoothing=3;
		  	  hwsmooth=0;
		  	  redraw=1;	  	  
		  }
		  //HW SMOOTHING
		  if (TEST_PEN_MENU(x,y,item_rect[15])&&scrmode) {
		  	  hwsmooth=_ZOD_SMOOTHING_;
		  	  if (smoothing==2){DeInitStretchTables();}
		  	  smoothing=0;
		  	  redraw=1;	  	  
		  }
	  //FLIPPING
	  if (TEST_PEN_MENU(x,y,item_rect[20])) {
	  	  oswanZ_flipping=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[21])) {
	  	  oswanZ_flipping=1;
	  	  redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  oswanZ_frameskip=fskipval;

  oswanZ_renderingmode=scrmode;
  oswanZ_smoothmode=smoothing|hwsmooth;
	
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}



int oswanZ_ShowMenuSNDConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=snd_stream_vol/16;	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
	  menu_button(150,80,(char*)"OFF",(oswanZ_enabledSound==0?2:1),&item_rect[2],0);
	  menu_button(200,80,(char*)"SIM",(oswanZ_enabledSound==1?2:1),&item_rect[3],0);	  
	  menu_button(250,80,(char*)"ON",(oswanZ_enabledSound==2?2:1),&item_rect[4],0);	 
	  
	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
	  menu_bar(150,120,vol,128,&item_rect[6]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(270,120,tmp);
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  oswanZ_enabledSound=0;		  
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  oswanZ_enabledSound=1;	  	  
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  oswanZ_enabledSound=2;
		  redraw=1;
	  }
	  
	  //VOLUME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x-10)*128/100;
	  	if (vol<0) vol=0;
	  	if (vol>128) vol=128;
	  	redraw=1;
	  }
	  if (mStopEmulation) break;
  }  

	snd_stream_vol=vol*16;
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int oswanZ_ShowMenuOTHERConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"AUTO A",0,&item_rect[1],4);
	  menu_button(100,80,(char*)"OFF",(oswanZ_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(150,80,(char*)"SLW",(oswanZ_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(200,80,(char*)"MED",(oswanZ_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(250,80,(char*)"FST",(oswanZ_autofireA==3?2:1),&item_rect[5],0);
	  
	  menu_button(10,120,(char*)"AUTO B",0,&item_rect[6],4);
	  menu_button(100,120,(char*)"OFF",(oswanZ_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(150,120,(char*)"SLW",(oswanZ_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(200,120,(char*)"MED",(oswanZ_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(250,120,(char*)"FST",(oswanZ_autofireB==3?2:1),&item_rect[10],0);
	  
	  menu_button(10,160,(char*)"EMU SPEED",0,&item_rect[11],4);
	  menu_bar(130,160,oswanZ_speedpct,100,&item_rect[12]);
	  StrIToA(tmp,oswanZ_speedpct);
	  strcat(tmp,"%");
    	menu_messageRaw(240,160,tmp);
	  
		if (scr) ljp_WinScreenUnlock();	  
  	  }
	  redraw=menu_waitPen(&x,&y,0);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  oswanZ_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  oswanZ_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  oswanZ_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  oswanZ_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  oswanZ_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  oswanZ_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  oswanZ_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  oswanZ_autofireB=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
	  	oswanZ_speedpct=(x-item_rect[12].topLeft.x);
	  	if (oswanZ_speedpct>100) oswanZ_speedpct=100;
	  	if (oswanZ_speedpct<10) oswanZ_speedpct=10;
	  	redraw=1;
	  }
	  if (mStopEmulation) break;
  }  
  
  if (!mStopEmulation) menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}




int oswanZ_ShowMenuSave(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  FILE *savefile;
  	  int slot[4];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
  		
  	  	  	  	  	  	
	  
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  for (int i=0;i<4;i++) 
  	  	if (!state_load(i,1))   	  	
  	  	{
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			getstate_filename(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
	  	}	  	  	
  	  	  	  	  	  	
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"SAVE",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			getstate_filename(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			getstate_filename(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			getstate_filename(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			getstate_filename(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (!slot[1]||(SHOW_OVERWRITE))
		  {state_save(1);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (!slot[2]||(SHOW_OVERWRITE))
		  {state_save(2);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (!slot[3]||(SHOW_OVERWRITE))
		  {state_save(3);result=1; break;}
		  else redraw=1;
		 
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
		  if (!slot[0]||(SHOW_OVERWRITE))
		  {state_save(0);result=1; break;}
		  else redraw=1;
		 
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}



int oswanZ_ShowMenuLoad(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
   int slot[4];
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
  	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
      for (int i=0;i<4;i++) 
      	if (!state_load(i,1)) 
      	{
      		char str[255];		
			UInt32 long_time;
			DateTimeType date_time;			
			slot[i]=1;			
			getstate_filename(i,str);		
			fgetdate(str,&long_time);		
			TimSecondsToDateTime(long_time,&date_time);
			
			sprintf(str,"%02d%s%02d-%02d:%02d",
			date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
			if (i) 
			{
				menu_messageRaw(150,80+i*30,str);
				menu_button(10,80+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(150,200,str);
				menu_button(10,200,"X",5,&item_rect[6+i],3);
			}
		}	
      
		  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		  menu_button(10,50,(char*)"LOAD",0,&item_rect[1],2);	  	  	  
		  menu_button(50,110,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
		  menu_button(50,140,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
		  menu_button(50,170,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
		  menu_button(50,200,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;

  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			getstate_filename(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			getstate_filename(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			getstate_filename(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			getstate_filename(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (slot[1])
		if (!state_load(1,0)) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (slot[2])
		if (!state_load(2,0)) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot[3])
		if (!state_load(3,0)) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	if (slot[0])
    	if (!state_load(0,0)) {result=1;break;}
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}


int oswanZ_ShowMenuConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
  		
  	  	  	  	  	  	
	  menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(92,100,(char*)"GFX",0,&item_rect[1],2);
	  //menu_button(92,150,(char*)"SOUND",0,&item_rect[2],2);
	  menu_button(92,200,(char*)"OTHER",0,&item_rect[3],2);
	  if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	oswanZ_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  /*if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	oswanZ_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }*/
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  oswanZ_ShowMenuOTHERConfig(savescr);
		  redraw=1;		  
	  }
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}

int oswanZ_ShowSysInfos(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
		result=gui_redraw_bg_func(&redraw,&scr,savescr,0);
		
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(oswanZ_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(oswanZ_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d]",strb,oswanZ_curVolume);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,63,str);				
		sprintf(str,"Used:%dM/%dM",usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,81,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM %ldK/%ldK",freeP/1024,maxP/1024);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
						
    		
		
						  	
	  	menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) ljp_WinScreenUnlock();
  	  }
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  if (mStopEmulation) break;
  }  
  ljz_free(item_rect);
  return result;
}

int oswanZ_ShowMenu(void){
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr,*tmpscr,*tmpdst;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;

  
  oswanZ_pause(1);
    
       
  scr=/*(uint8*)(g_pnobridge -> vram);*/ljp_WinScreenLock(winLockCopy);  
  savescr=(uint8*)ljz_malloc(display_width*display_height*2);    
  if (scr&&savescr)
  {
	  tmpscr=scr;
  	for (int yy=0;yy<display_height-(oswanZ_renderingmode<2?BELTBAR_SIZE:0);yy++)
  	{
	  for (x=0;x<display_width;x++)
	  {
  		y=((uint16*)tmpscr)[x];
	  	((uint16*)tmpscr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  tmpscr+=display_pitch*2;
	}
	tmpscr=scr;
	tmpdst=savescr;
	for (int yy=0;yy<display_height;yy++)
  	{
	    memcpy(tmpdst,tmpscr,display_width*2);
	    tmpdst+=display_width*2;
	    tmpscr+=display_pitch*2;
	}
  }
  if (scr) ljp_WinScreenUnlock();
            
              
  for (;;)
  {  
  	if (redraw)
  	{  	
	  	slot0=!state_load(0,1);    
  		
  		
		//GUI_REDRAW_BG(1)  		
		result=gui_redraw_bg_func(&redraw,&scr,savescr,1);
		
		menu_button(180,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(10,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(180,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(10,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(180,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(10,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(180,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(180,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		menu_button(10,250,(char*)"RESET WS",9,&item_rect[7],2);				
		if (scr) ljp_WinScreenUnlock();				
		
  	}
	  redraw=menu_waitPen(&x,&y,1);	  
	  if (redraw==2) {mStopEmulation=1; break;}
	  if (redraw) x=y=-1;
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {oswanZ_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (oswanZ_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (oswanZ_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  state_save(0);
		  result=0;
		  break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot0)
	      if (!state_load(0,0)) {result=0;break;}
	  }
	  //RESET WS
	  if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("Reset WS ?")) {ws_reset(); result=0;break;}redraw=1;}
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {oswanZ_ShowSysInfos(savescr);redraw=1;}

		if (mStopEmulation) break;
	}
  ljz_free(item_rect);
  
  if (savescr) ljz_free(savescr);
            
  oswanZ_pause(0);
  return result;

}
}
