#include <PalmOS.h>
#include <StringMgr.h>
#include <VFSMgr.h>

#include "ljPRsc.h"
#include "App_Cst.h"
#include "App_Fx.h"

#include "LJP_mac.h"

#include "Host68k.h"
#include "TapWave/TwChars.h"

#include "palm5way.h"
#include "pnobridge.h"

#include <PalmOS.h>

extern char device_type;
extern char g_inputfld[255];
extern int g_num_entries;
extern int g_num_cat_entries;
extern char **g_listchoice,**g_catlistchoice;
extern t_ljp_pref g_ljp_pref;
extern UInt32 ljp_isLowRes;

extern int g_config_mode;
extern Int16 g_prev_form;

extern int g_rom_system;
extern Int32 g_autoload;

#define MAX_ROM_LISTED 1024
#define MAX_CATEGORIES 16

/***********************************************************************
 *
 * FUNCTION:    ConfigFrmHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "ConfigForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
void ConfigUpdateControls(int *config_mode,FormType *frmP,int only_set)
{	
	ListType *list,*list2;
	Char strtmp[4];
	switch (g_ljp_pref.g_conf_system)
	{
		case SYS_GENZ:
		case SYS_SNES:	
		case SYS_NEOPOPZ:
		case SYS_SMS:
		case SYS_GG:
		case SYS_VCS:
		break;
		case SYS_NES:
		case SYS_GB:
		case SYS_TG16Z:
			if (*config_mode>2) *config_mode=2;
		break;
		case SYS_OSWANZ:
			if (*config_mode>1) *config_mode=1;
		break;
	}

	
	switch (g_ljp_pref.g_conf_system)
	{
		case SYS_SNES:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2List) );
			LstSetSelection(list,g_ljp_pref.g_SnesScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2List) );
			LstSetSelection(list2,g_ljp_pref.g_SnesSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_NES:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2List) );
			LstSetSelection(list,g_ljp_pref.g_NesScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2List) );
			LstSetSelection(list2,g_ljp_pref.g_NesSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_GB:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1List) );
			LstSetSelection(list,g_ljp_pref.g_GBScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1List) );
			LstSetSelection(list2,g_ljp_pref.g_GBSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_GENZ:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2List) );
			LstSetSelection(list,g_ljp_pref.g_GENZScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2List) );
			LstSetSelection(list2,g_ljp_pref.g_GENZSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_NEOPOPZ:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1List) );
			LstSetSelection(list,g_ljp_pref.g_NEOPOPZScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1List) );
			LstSetSelection(list2,g_ljp_pref.g_NEOPOPZSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_OSWANZ:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2List) );
			LstSetSelection(list,g_ljp_pref.g_OSWANZScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2List) );
			LstSetSelection(list2,g_ljp_pref.g_OSWANZSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_TG16Z:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2List) );
			LstSetSelection(list,g_ljp_pref.g_TG16ZScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2List) );
			LstSetSelection(list2,g_ljp_pref.g_TG16ZSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_SMS:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2List) );
			LstSetSelection(list,g_ljp_pref.g_SMSScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2List) );
			LstSetSelection(list2,g_ljp_pref.g_SMSSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_GG:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1List) );
			LstSetSelection(list,g_ljp_pref.g_GGScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1List) );
			LstSetSelection(list2,g_ljp_pref.g_GGSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
		case SYS_VCS:
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1List) );
			LstSetSelection(list,g_ljp_pref.g_VCSScreenMode);
			list2=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1List) );
			LstSetSelection(list2,g_ljp_pref.g_VCSSmoothing&_SMOOTH_MASK_);
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1Popup) ),LstGetSelectionText(list,LstGetSelection(list)));
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1Popup) ),LstGetSelectionText(list2,LstGetSelection(list2)));
		break;
	}
	
	
	
	
	
	list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOFSkipList) );
	switch (g_ljp_pref.g_conf_system)
	{
		case SYS_SNES:LstSetSelection(list,g_ljp_pref.g_SnesFSkip);
		break;
		case SYS_NES:LstSetSelection(list,g_ljp_pref.g_NesFSkip);
		break;
		case SYS_GB:LstSetSelection(list,g_ljp_pref.g_GBFSkip);
		break;
		case SYS_GENZ:LstSetSelection(list,g_ljp_pref.g_GENZFSkip);
		break;
		case SYS_NEOPOPZ:LstSetSelection(list,g_ljp_pref.g_NEOPOPZFSkip);
		break;
		case SYS_OSWANZ:LstSetSelection(list,g_ljp_pref.g_OSWANZFSkip);
		break;
		case SYS_TG16Z:LstSetSelection(list,g_ljp_pref.g_TG16ZFSkip);
		break;
		case SYS_SMS:LstSetSelection(list,g_ljp_pref.g_SMSFSkip);
		break;
		case SYS_GG:LstSetSelection(list,g_ljp_pref.g_GGFSkip);
		break;
		case SYS_VCS:LstSetSelection(list,g_ljp_pref.g_VCSFSkip);
		break;
	}
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOFSkipPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
	
	list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFreqList) );
	switch (g_ljp_pref.g_conf_system)
	{
		case SYS_SNES:LstSetSelection(list,g_ljp_pref.g_SnesSoundFreq);
		break;
		case SYS_NES:LstSetSelection(list,g_ljp_pref.g_NesSoundFreq);
		break;
		case SYS_GB:LstSetSelection(list,g_ljp_pref.g_GBSoundFreq);
		break;
		case SYS_GENZ:LstSetSelection(list,g_ljp_pref.g_GENZSoundFreq);
		break;
		case SYS_NEOPOPZ:LstSetSelection(list,g_ljp_pref.g_NEOPOPZSoundFreq);
		break;
		case SYS_OSWANZ:LstSetSelection(list,g_ljp_pref.g_OSWANZSoundFreq);
		break;
		case SYS_TG16Z:LstSetSelection(list,g_ljp_pref.g_TG16ZSoundFreq);
		break;
		case SYS_SMS:LstSetSelection(list,g_ljp_pref.g_SMSSoundFreq);
		break;
		case SYS_GG:LstSetSelection(list,g_ljp_pref.g_GGSoundFreq);
		break;
		case SYS_VCS:LstSetSelection(list,g_ljp_pref.g_VCSSoundFreq);
		break;
	}
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFreqPopup) ),LstGetSelectionText(list,LstGetSelection(list)));

	
	switch (g_ljp_pref.g_conf_system)
	{
		case SYS_SNES:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_SnesSmoothing&_ZOD_SMOOTHING_);
		
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_SnesSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_SnesSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_SnesSound==2));				
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_SnesSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_SnesSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		

		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmASMCPUCORE),(g_ljp_pref.g_SnesASMCPU==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmCCPUCORE),(g_ljp_pref.g_SnesASMCPU==0));
					
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERFixColChangesCheckbox),(g_ljp_pref.g_SnesHack & PPU_IGNORE_FIXEDCOLCHANGES));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERWindowCheckbox),(g_ljp_pref.g_SnesHack & PPU_IGNORE_WINDOW));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERAddSubCheckbox),(g_ljp_pref.g_SnesHack & PPU_IGNORE_ADDSUB));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERPalWriteCheckbox),(g_ljp_pref.g_SnesHack & PPU_IGNORE_PALWRITE));
		
		break;
		case SYS_NES:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_NesSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_NesSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_NesSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_NesSound==2));
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_NesSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_NesSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		

		
		break;
		case SYS_GB:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_GBSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_GBSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_GBSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_GBSound==2));
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_GBSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_GBSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		
		break;		
		case SYS_GENZ:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_GENZSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),!(g_ljp_pref.g_GENZSound&3));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_GENZSound&3)==1);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_GENZSound&3)==2);
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_GENZSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_GENZSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDZX80Checkbox),(g_ljp_pref.g_GENZSound&4));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFASTCheckbox),(g_ljp_pref.g_GENZSound&8));
		
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmASMCPUCORE),(g_ljp_pref.g_GENZASMCPU==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmCCPUCORE),(g_ljp_pref.g_GENZASMCPU==0));
		
		break;
		case SYS_NEOPOPZ:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_NEOPOPZSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_NEOPOPZSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_NEOPOPZSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_NEOPOPZSound==2));
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_NEOPOPZSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_NEOPOPZSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		
		
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmCOMPEMUACC),(g_ljp_pref.g_NEOPOPZEmuAccuracy==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmMEDEMUACC),(g_ljp_pref.g_NEOPOPZEmuAccuracy==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmFASTEMUACC),(g_ljp_pref.g_NEOPOPZEmuAccuracy==2));
		break;
		case SYS_OSWANZ:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_OSWANZSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_OSWANZSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_OSWANZSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_OSWANZSound==2));
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_OSWANZSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_OSWANZSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		
		break;
		case SYS_TG16Z:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_TG16ZSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_TG16ZSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_TG16ZSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_TG16ZSound==2));
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_TG16ZSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_TG16ZSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		
		break;
		case SYS_SMS:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_SMSSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_SMSSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_SMSSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_SMSSound==2));
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_SMSSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_SMSSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		
		break;
		case SYS_GG:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_GGSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_GGSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_GGSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_GGSound==2));
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_GGSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_GGSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		
		break;			
		case SYS_VCS:
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox),g_ljp_pref.g_VCSSmoothing&_ZOD_SMOOTHING_);
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF),(g_ljp_pref.g_VCSSound==0));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM),(g_ljp_pref.g_VCSSound==1));
		FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON),(g_ljp_pref.g_VCSSound==2));
		CtlSetSliderValues  (FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider)),NULL,NULL,NULL,&(g_ljp_pref.g_VCSSoundVol));
		StrPrintF(strtmp,"%3d",g_ljp_pref.g_VCSSoundVol*100/64);
		FrmCopyLabel(frmP,ConfFrmSOUNDVOLUMEValue,strtmp);		
		
		break;		
	}
	
	FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESFastSpritesCheckbox),g_ljp_pref.g_SnesFastSprite);
	FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESTranspCheckbox),g_ljp_pref.g_SnesTransparency);
	list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESRenderList) );
	LstSetSelection(list,g_ljp_pref.g_SnesRender);
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESRenderPopup) ),LstGetSelectionText(list,LstGetSelection(list)));	
	
	switch (*config_mode)
		{
			int i,j;
			FieldType *field;
			case 0://input
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpINPUTButton),1);
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpAUDIOButton),0);			
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpVIDEOButton),0);
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpOTHERButton),0);
				
				
				switch (g_ljp_pref.g_conf_system)
				{	
					case SYS_NES:j=0;break;
					case SYS_SNES:j=1;break;
					case SYS_GB:j=2;break;
					case SYS_GENZ:j=3;break;
					case SYS_NEOPOPZ:j=4;break;
					case SYS_OSWANZ:j=5;break;
					case SYS_TG16Z:j=6;break;
					case SYS_SMS:j=7;break;
					case SYS_GG:j=8;break;
					case SYS_VCS:j=9;break;
				}	
				g_inputfld[0]=0;			
				
				{
				Char strtmp[16];
				for (i=0;i<20;i++)
				{					
					/*if (g_ljp_pref.g_inputconf[j][i] & 0x00010000)
					StrCopy(strtmp, "RockerUp");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00020000)
					StrCopy(strtmp, "RockerDn");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00040000)
					StrCopy(strtmp, "RockerLt");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00080000)
					StrCopy(strtmp, "RockerRt");
					else */if (g_ljp_pref.g_inputconf[j][i] == 0x00100000)
					StrCopy(strtmp, "RockerCt");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00800000)
					StrCopy(strtmp, "Launcher");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x04000000)
					StrCopy(strtmp, "Trigger L");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x08000000)
					StrCopy(strtmp, "Trigger R");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x10000000)
					StrCopy(strtmp, "Blue ");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x20000000)
					StrCopy(strtmp, "Yellow ");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x40000000)
					StrCopy(strtmp, "Green ");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x80000000)
					StrCopy(strtmp, "Red ");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00008000)
					StrCopy(strtmp, "Function");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x01000000)
					StrCopy(strtmp, "NavLeft ");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x02000000)
					StrCopy(strtmp, "NavRight");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00000002)
					StrCopy(strtmp, "PageUp ");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00000004)
					StrCopy(strtmp, "PageDown");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00000008)
					StrCopy(strtmp, "Calendar");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00000010)
					StrCopy(strtmp, "PhoneBk ");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00000020)
					StrCopy(strtmp, "ToDo ");
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00000040)
					StrCopy(strtmp, "Memo ");
					
					else if (g_ljp_pref.g_inputconf[j][i] == keyBitPower)
					StrCopy(strtmp, "Power ");
					else if (g_ljp_pref.g_inputconf[j][i] == keyBitCradle)
					StrCopy(strtmp, "Cradle ");
					else if (g_ljp_pref.g_inputconf[j][i] == keyBitAntenna)
					StrCopy(strtmp, "Antenna ");
					else if (g_ljp_pref.g_inputconf[j][i] == keyBitContrast)
					StrCopy(strtmp, "Contrast ");
					
					else if (g_ljp_pref.g_inputconf[j][i] == BTN_TL)
					StrCopy(strtmp, "S.TopL ");
					else if (g_ljp_pref.g_inputconf[j][i] == BTN_TR)
					StrCopy(strtmp, "S.TopR ");
					else if (g_ljp_pref.g_inputconf[j][i] == BTN_BL)
					StrCopy(strtmp, "S.BottomL ");
					else if (g_ljp_pref.g_inputconf[j][i] == BTN_BR)
					StrCopy(strtmp, "S.BottomR ");
					
					else if (g_ljp_pref.g_inputconf[j][i] == 0x00000000)
					StrCopy(strtmp, "None ");
					else
					StrPrintF(strtmp,"%lx",g_ljp_pref.g_inputconf[j][i]);
					
					StrCat(g_inputfld,strtmp);					
					StrCat(g_inputfld,"\n");
				}
				}
				field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
				FldSetTextPtr(field,g_inputfld);
				FldRecalculateField (field,1);
				
			break;
			case 2://audio
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpINPUTButton),0);
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpAUDIOButton),1);			
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpVIDEOButton),0);
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpOTHERButton),0);
				
			break;
			case 1://video
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpINPUTButton),0);
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpAUDIOButton),0);			
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpVIDEOButton),1);					
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpOTHERButton),0);
			break;
			case 3://other
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpINPUTButton),0);
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpAUDIOButton),0);			
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpVIDEOButton),0);					
				FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpOTHERButton),1);
			break;
		}
						
	if (only_set) return;
	
	switch (g_ljp_pref.g_conf_system)
	{
		case SYS_GENZ:
		case SYS_SNES:
		case SYS_NEOPOPZ:
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmGrpAUDIOButton) ));
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmGrpOTHERButton) ));
		break;
		case SYS_NES:
		case SYS_GB:				
		case SYS_TG16Z:
		case SYS_SMS:
		case SYS_GG:
		case SYS_VCS:
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmGrpAUDIOButton) ));
			CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmGrpOTHERButton) ));
		break;
		case SYS_OSWANZ:
			CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmGrpAUDIOButton) ));			
			CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmGrpOTHERButton) ));
		break;
	}

	
	
	/*CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSNESList) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNESList) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGBList) ));*/
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGBList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGENZList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNESList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSNESList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNGPList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTWSList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTTG16ZList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSMSList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGGList) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTVCSList) );

	
	
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmASSIGNButton) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmASSIGNMULTPButton) ));
	
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESFastSpritesCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESTranspCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESRenderPopup) ));
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEODispsizeLabel));
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothingLabel));
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOFSkipLabel) );
	
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1Popup) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2Popup) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1Popup) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOFSkipPopup) ));		
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESRenderLabel) );
	
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFreqPopup) ));		
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDZX80Checkbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFASTCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider) ));
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDLabel) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFreqLabel) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMELabel) );
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMEValue) );


	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmCPUCoreLabel));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmASMCPUCORE) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmCCPUCORE) ));	

	
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfFrmEMUACCLabel));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmCOMPEMUACC) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmMEDEMUACC) ));	
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmFASTEMUACC) ));	
	
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERFixColChangesCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERWindowCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERAddSubCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERPalWriteCheckbox) ));
	
	switch (*config_mode)
		{
			case 0://input
				CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmASSIGNButton) ));
				CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmASSIGNMULTPButton) ));
				switch (g_ljp_pref.g_conf_system)
				{
					case SYS_SNES:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSNESList) );break;
					case SYS_NES:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNESList) );break;
					case SYS_GB:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGBList) );break;
					case SYS_GENZ:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGENZList) );break;
					case SYS_NEOPOPZ:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNGPList) );break;
					case SYS_OSWANZ:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTWSList) );break;
					case SYS_TG16Z:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTTG16ZList) );break;
					case SYS_SMS:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSMSList) );break;
					case SYS_GG:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGGList) );break;
					case SYS_VCS:FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTVCSList) );break;
				}				
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );

			break;
			case 2://audio
				
				switch (g_ljp_pref.g_conf_system)
				{					
					case SYS_GENZ:
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDZX80Checkbox) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFASTCheckbox) ));
					case SYS_SNES:
					case SYS_NES:
					case SYS_GB:
					case SYS_TG16Z:
					case SYS_NEOPOPZ:
					case SYS_SMS:
					case SYS_GG:
					case SYS_VCS:
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDON) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDSIM) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDOFF) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFreqPopup) ));		
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMESlider) ));
						FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDLabel) );
						FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFreqLabel) );
						FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMELabel) );
						FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDVOLUMEValue) );
						break;
				}
				
			break;
			case 1://video
				if (device_type&_ZODIAC_DEVICE_) CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox) ));
				if (!ljp_isLowRes) {
				  switch (g_ljp_pref.g_conf_system){
					case SYS_GB:
					case SYS_NEOPOPZ:
					case SYS_GG:				
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom1Popup) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing1Popup) ));
						break;
					case SYS_SNES:
					case SYS_NES:
					case SYS_GENZ:
					case SYS_TG16Z:
					case SYS_SMS:
					case SYS_VCS:					
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZoom2Popup) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothing2Popup) ));
						break;	
				  }
				}
				CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOFSkipPopup) ));				
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEODispsizeLabel));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSmoothingLabel));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOFSkipLabel) );
				if (g_ljp_pref.g_conf_system==SYS_SNES)
				{		
					FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESRenderLabel) );
					CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESFastSpritesCheckbox) ));
					CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESTranspCheckbox) ));
					CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESRenderPopup) ));
				}
			break;
			case 3://other
			switch (g_ljp_pref.g_conf_system)
				{					
					case SYS_SNES:
						FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmCPUCoreLabel));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmASMCPUCORE) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmCCPUCORE) ));	
						
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERFixColChangesCheckbox) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERWindowCheckbox) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERAddSubCheckbox) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERPalWriteCheckbox) ));
					break;
					case SYS_GENZ:
						FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmCPUCoreLabel));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmASMCPUCORE) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmCCPUCORE) ));	
					break;
					case SYS_NEOPOPZ:
						FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfFrmEMUACCLabel));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmCOMPEMUACC) ));
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmMEDEMUACC) ));	
						CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmFASTEMUACC) ));	
					break;
					
				}
			break;
		}
		
	
}


Boolean ConfigFrmHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err				err = errNone;
//	static int		frmloaded=0;

	switch (eventP->eType) 
	{
		ListType *list;
		case frmOpenEvent:
		{			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpINPUTButton),1);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpAUDIOButton),0);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpVIDEOButton),0);			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpINPUTButton),0);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmGrpOTHERButton),0);						
			
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemListConf) );
			switch (g_ljp_pref.g_conf_system)
			{
				case SYS_NES:LstSetSelection(list,0);
				break;
				case SYS_SNES:LstSetSelection(list,1);
				break;
				case SYS_GB:LstSetSelection(list,2);
				break;
				case SYS_GENZ:LstSetSelection(list,3);
				break;
				case SYS_NEOPOPZ:LstSetSelection(list,4);
				break;
				case SYS_OSWANZ:LstSetSelection(list,5);
				break;
				case SYS_TG16Z:LstSetSelection(list,6);
				break;
				case SYS_SMS:LstSetSelection(list,7);
				break;
				case SYS_GG:LstSetSelection(list,8);
				break;
				case SYS_VCS:LstSetSelection(list,9);
				break;
			}
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemPopupConf) ),LstGetSelectionText(list,LstGetSelection(list)));

			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_SYSTEM_ICON(g_ljp_pref.g_conf_system,_CONSOLE_BMP_X_,_CONSOLE_BMP_Y_)
			if (scr) WinScreenUnlock();
			}
			ConfigUpdateControls(&g_config_mode,frmP,0);			
			
						
			ASK_FOR_UPDATE	
			handled = true;
			break;
		}
		case frmCloseEvent:							
		{	
			
			break;
		}		
		case popSelectEvent:
			switch ( eventP->data.ctlSelect.controlID ) 
			{
				case SystemPopupConf:
				{
					ListType *list;
					switch (eventP->data.popSelect.selection)
					{
						case 0:g_ljp_pref.g_conf_system=SYS_NES;break;
						case 1:g_ljp_pref.g_conf_system=SYS_SNES;break;
						case 2:g_ljp_pref.g_conf_system=SYS_GB;break;
						case 3:g_ljp_pref.g_conf_system=SYS_GENZ;break;
						case 4:g_ljp_pref.g_conf_system=SYS_NEOPOPZ;break;
						case 5:g_ljp_pref.g_conf_system=SYS_OSWANZ;break;
						case 6:g_ljp_pref.g_conf_system=SYS_TG16Z;break;
						case 7:g_ljp_pref.g_conf_system=SYS_SMS;break;
						case 8:g_ljp_pref.g_conf_system=SYS_GG;break;
						case 9:g_ljp_pref.g_conf_system=SYS_VCS;break;
					}
					g_ljp_pref.g_sysfilter = g_ljp_pref.g_conf_system;
					
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemListConf) );
					if (list) CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemPopupConf) ),LstGetSelectionText(list,LstGetSelection(list)));
					
					UPDATE_UI_COLORS(g_ljp_pref.g_conf_system)
					
					
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					break;
				}								
				/*VIDEO*/
				case ConfFrmVIDEOSmoothing1Popup:
				case ConfFrmVIDEOSmoothing2Popup: {
					int val=eventP->data.popSelect.selection;
					switch (g_ljp_pref.g_conf_system) {
						case SYS_SNES:
							g_ljp_pref.g_SnesSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_SnesSmoothing|=val;
							break;
						case SYS_NES:
							g_ljp_pref.g_NesSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_NesSmoothing|=val;
							break;
						case SYS_GB:
							g_ljp_pref.g_GBSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_GBSmoothing|=val;
							break;
						case SYS_GENZ:
							g_ljp_pref.g_GENZSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_GENZSmoothing|=val;
							break;
						case SYS_NEOPOPZ:
							g_ljp_pref.g_NEOPOPZSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_NEOPOPZSmoothing|=val;
							break;
						case SYS_OSWANZ:
							g_ljp_pref.g_OSWANZSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_OSWANZSmoothing|=val;
							break;
						case SYS_TG16Z:
							g_ljp_pref.g_TG16ZSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_TG16ZSmoothing|=val;
							break;
						case SYS_SMS:
							g_ljp_pref.g_SMSSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_SMSSmoothing|=val;
							break;
						case SYS_GG:
							g_ljp_pref.g_GGSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_GGSmoothing|=val;
							break;
						case SYS_VCS:
							g_ljp_pref.g_VCSSmoothing&=~_SMOOTH_MASK_;
							g_ljp_pref.g_VCSSmoothing|=val;
							break;
					}
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					break;
				}
				
				case ConfFrmVIDEOZoom1Popup:
				case ConfFrmVIDEOZoom2Popup: {
					int val=eventP->data.popSelect.selection;
					switch (g_ljp_pref.g_conf_system) {
						case SYS_SNES:g_ljp_pref.g_SnesScreenMode=val;break;
						case SYS_NES:g_ljp_pref.g_NesScreenMode=val;break;
						case SYS_GB:g_ljp_pref.g_GBScreenMode=val;break;
						case SYS_GENZ:g_ljp_pref.g_GENZScreenMode=val;break;
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZScreenMode=val;break;
						case SYS_OSWANZ:g_ljp_pref.g_OSWANZScreenMode=val;break;
						case SYS_TG16Z:g_ljp_pref.g_TG16ZScreenMode=val;break;
						case SYS_SMS:g_ljp_pref.g_SMSScreenMode=val;break;
						case SYS_GG:g_ljp_pref.g_GGScreenMode=val;break;
						case SYS_VCS:g_ljp_pref.g_VCSScreenMode=val;break;
					}
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					break;
				}
				case ConfFrmVIDEOFSkipPopup:
				{
					int val=eventP->data.popSelect.selection;
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:g_ljp_pref.g_SnesFSkip=val;break;
						case SYS_NES:g_ljp_pref.g_NesFSkip=val;
						if (val==11) {menu_inform("Not implemented, same as 0");}
						break;
						case SYS_GB:g_ljp_pref.g_GBFSkip=val;
						if (val==11) {menu_inform("Not implemented, same as 0");}
						break;
						case SYS_GENZ:g_ljp_pref.g_GENZFSkip=val;
						break;
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZFSkip=val;
						if (val==11) {menu_inform("Not implemented, same as 0");}
						break;
						case SYS_OSWANZ:g_ljp_pref.g_OSWANZFSkip=val;
						if (val==11) {menu_inform("Not implemented, same as 0");}
						break;
						case SYS_TG16Z:g_ljp_pref.g_TG16ZFSkip=val;
						break;
						case SYS_SMS:g_ljp_pref.g_SMSFSkip=val;
						if (val==11) {menu_inform("Not implemented, same as 0");}
						break;
						case SYS_GG:g_ljp_pref.g_GGFSkip=val;
						if (val==11) {menu_inform("Not implemented, same as 0");}
						break;
						case SYS_VCS:g_ljp_pref.g_VCSFSkip=val;
						if (val==11) {menu_inform("Not implemented, same as 0");}
						break;
					}
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					break;
				}
				case ConfFrmVIDEOSNESRenderPopup:
				{
					g_ljp_pref.g_SnesRender=eventP->data.popSelect.selection;
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					break;
				}
				/*SOUND*/
				case ConfFrmSOUNDFreqPopup:
				{
					int val=eventP->data.popSelect.selection;
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:g_ljp_pref.g_SnesSoundFreq=val;break;
						case SYS_NES:g_ljp_pref.g_NesSoundFreq=val;break;
						case SYS_GB:g_ljp_pref.g_GBSoundFreq=val;break;
						case SYS_GENZ:g_ljp_pref.g_GENZSoundFreq=val;break;
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZSoundFreq=val;break;
						case SYS_OSWANZ:g_ljp_pref.g_OSWANZSoundFreq=val;break;
						case SYS_TG16Z:g_ljp_pref.g_TG16ZSoundFreq=val;break;
						case SYS_SMS:g_ljp_pref.g_SMSSoundFreq=val;break;
						case SYS_GG:g_ljp_pref.g_GGSoundFreq=val;break;
						case SYS_VCS:g_ljp_pref.g_VCSSoundFreq=val;break;
					}
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					break;
				}
			}
			break;
		case ctlRepeatEvent:
		{
			switch (eventP->data.ctlRepeat.controlID )
			{
				case ConfFrmSOUNDVOLUMESlider:
				{					
					Char strtmp[4];					
					StrPrintF(strtmp,"%3d",eventP->data.ctlRepeat.value*100/64);
					FrmCopyLabel  (frmP,ConfFrmSOUNDVOLUMEValue,strtmp);
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:g_ljp_pref.g_SnesSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_NES:g_ljp_pref.g_NesSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_GB:g_ljp_pref.g_GBSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_GENZ:g_ljp_pref.g_GENZSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_OSWANZ:g_ljp_pref.g_OSWANZSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_TG16Z:g_ljp_pref.g_TG16ZSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_SMS:g_ljp_pref.g_SMSSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_GG:g_ljp_pref.g_GGSoundVol=eventP->data.ctlRepeat.value;break;
						case SYS_VCS:g_ljp_pref.g_VCSSoundVol=eventP->data.ctlRepeat.value;break;
					}
//					handled=true;
					break;
				}				
			}
			break;
		}
		case ctlSelectEvent:
		{
			switch ( eventP->data.ctlSelect.controlID ) 
			{			
				case ConfFrmHELPButton:
					g_prev_form=ConfigForm;
					
					FrmGotoForm(HelpForm);										
					handled=true;
					break;
				case ConfFrmHOMEButton:

					FrmGotoForm(LauncherForm);
					handled=true;
					break;
				case ConfFrmGrpINPUTButton:
					g_config_mode=0;
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					handled=true;
					break;							
				case ConfFrmGrpAUDIOButton:					
					g_config_mode=2;
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					handled=true;
					break;	
				case ConfFrmGrpVIDEOButton:
					g_config_mode=1;
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					handled=true;
					break;
				case ConfFrmGrpOTHERButton:
					g_config_mode=3;
					ConfigUpdateControls(&g_config_mode,frmP,0);
					ASK_FOR_UPDATE
					handled=true;
					break;
		/*INPUT*/
				case ConfFrmASSIGNButton:
				{
					ListType *list;
					UInt32 i,j,k,old_mask;
					FieldType *field;
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_NES:j=0;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNESList) ); break;
						case SYS_SNES:j=1;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSNESList) ); break;
						case SYS_GB:j=2;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGBList) ); break;
						case SYS_GENZ:j=3;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGENZList) ); break;
						case SYS_NEOPOPZ:j=4;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNGPList) ); break;
						case SYS_OSWANZ:j=5;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTWSList) ); break;
						case SYS_TG16Z:j=6;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTTG16ZList) ); break;
						case SYS_SMS:j=7;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSMSList) ); break;
						case SYS_GG:j=8;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGGList) ); break;
						case SYS_VCS:j=9;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTVCSList) ); break;
					}	
					i=LstGetSelection(list);
					
					
					ljp_FadeScreen();					
					menu_messageXY(0,0,120,80,"TL",0x0AC00A);
					menu_messageXY(196,0,120,80,"TR",0x0AC00A);
					menu_messageXY(0,236,120,80,"BL",0x0AC00A);
					menu_messageXY(196,236,120,80,"BR",0x0AC00A);
					menu_messageXY(158-80-40,180,80,30,"Cancel",0x80600A);
					menu_messageXY(158+80-40,180,80,30,"None",0x80600A);
					menu_message("Press a button or hit screen");
					#ifndef _ZIRE31_KEYS_
					old_mask=KeySetMask(~keyBitsAll);	
					#endif
					if (menu_waitBtn(1,0,&k)) 
					{	
						int l;
						if (k)
							for (l=0;l<20;l++) 
								if (g_ljp_pref.g_inputconf[j][l]==k) g_ljp_pref.g_inputconf[j][l]=0;
						g_ljp_pref.g_inputconf[j][i]=k;
						ConfigUpdateControls(&g_config_mode,frmP,0);
					}
					#ifndef _ZIRE31_KEYS_
					KeySetMask(old_mask/*keyBitsAll*/);
					#endif
					
					if (i<LstGetNumberOfItems(list)-1) i++;
					LstSetSelection(list,i);
					
					field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
					FldSetScrollPosition(field,0);				
					FldScrollField(field,LstGetTopItem(list),winDown);		
					ASK_FOR_UPDATE
				}
				break;
				
				case ConfFrmASSIGNMULTPButton:
				{
					ListType *list;
					UInt32 i,j,k,old_mask;
					FieldType *field;
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_NES:j=0;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNESList) ); break;
						case SYS_SNES:j=1;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSNESList) ); break;
						case SYS_GB:j=2;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGBList) ); break;
						case SYS_GENZ:j=3;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGENZList) ); break;
						case SYS_NEOPOPZ:j=4;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNGPList) ); break;
						case SYS_OSWANZ:j=5;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTWSList) ); break;
						case SYS_TG16Z:j=6;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTTG16ZList) ); break;
						case SYS_SMS:j=7;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSMSList) ); break;
						case SYS_GG:j=8;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGGList) ); break;
						case SYS_VCS:j=9;list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTVCSList) ); break;
					}	
					
					for (i=LstGetSelection(list);i<LstGetNumberOfItems(list);i++){
						LstSetSelection(list,i);
								
						ljp_FadeScreen();					
						menu_messageXY(0,0,120,80,"TL",0x0AC00A);
						menu_messageXY(196,0,120,80,"TR",0x0AC00A);
						menu_messageXY(0,236,120,80,"BL",0x0AC00A);
						menu_messageXY(196,236,120,80,"BR",0x0AC00A);
						menu_messageXY(158-80-40,180,80,30,"Cancel",0x80600A);
						menu_messageXY(158+80-40,180,80,30,"None",0x80600A);
						menu_message("Press a button or hit screen");
						#ifndef _ZIRE31_KEYS_
						old_mask=KeySetMask(~keyBitsAll);	
						#endif
						if (menu_waitBtn(1,0,&k)) {	
							int l;
							if (k)
								for (l=0;l<20;l++) 
									if (g_ljp_pref.g_inputconf[j][l]==k) g_ljp_pref.g_inputconf[j][l]=0;
							g_ljp_pref.g_inputconf[j][i]=k;
							ConfigUpdateControls(&g_config_mode,frmP,0);
						} else break;
						#ifndef _ZIRE31_KEYS_
						KeySetMask(old_mask/*keyBitsAll*/);
						#endif
					
						field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
						FldSetScrollPosition(field,0);				
						FldScrollField(field,LstGetTopItem(list),winDown);		
						ASK_FOR_UPDATE
					}
				}
				break;
		/*OTHER*/
				case ConfFrmASMCPUCORE:
				{
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:g_ljp_pref.g_SnesASMCPU=1;break;
						case SYS_GENZ:g_ljp_pref.g_GENZASMCPU=1;break;
					}
					handled=true;
					break;
				}
				case ConfFrmCCPUCORE:
				{
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:g_ljp_pref.g_SnesASMCPU=0;break;
						case SYS_GENZ:g_ljp_pref.g_GENZASMCPU=0;break;
					}
					handled=true;
					break;
				}
				case ConfFrmCOMPEMUACC:
				{
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZEmuAccuracy=0;break;
					}
					handled=true;
					break;
				}
				case ConfFrmMEDEMUACC:
				{
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZEmuAccuracy=1;break;
					}
					handled=true;
					break;
				}
				case ConfFrmFASTEMUACC:
				{
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZEmuAccuracy=2;break;
					}
					handled=true;
					break;
				}
					
					
					case ConfFrmOTHERFixColChangesCheckbox:
					{
						switch (g_ljp_pref.g_conf_system)
						{
							int val;
							
							case SYS_SNES:
							{
								val=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERFixColChangesCheckbox));
								if (val) g_ljp_pref.g_SnesHack |= PPU_IGNORE_FIXEDCOLCHANGES;
								else g_ljp_pref.g_SnesHack &= ~PPU_IGNORE_FIXEDCOLCHANGES;
								break;
							}
						}
						handled=true;
						break;
					}
					case ConfFrmOTHERWindowCheckbox:
					{
						switch (g_ljp_pref.g_conf_system)
						{
							int val;
							
							case SYS_SNES:
							{
								val=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERWindowCheckbox));
								if (val) g_ljp_pref.g_SnesHack |= PPU_IGNORE_WINDOW;
								else g_ljp_pref.g_SnesHack &= ~PPU_IGNORE_WINDOW;
								break;
							}
						}
						handled=true;
						break;
					}
					case ConfFrmOTHERAddSubCheckbox:
					{
						switch (g_ljp_pref.g_conf_system)
						{
							int val;
							
							case SYS_SNES:
							{
								val=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERAddSubCheckbox));
								if (val) g_ljp_pref.g_SnesHack |= PPU_IGNORE_ADDSUB;
								else g_ljp_pref.g_SnesHack &= ~PPU_IGNORE_ADDSUB;
								break;
							}
						}
						handled=true;
						break;
					}
					case ConfFrmOTHERPalWriteCheckbox:
					{
						switch (g_ljp_pref.g_conf_system)
						{
							int val;
							
							case SYS_SNES:
							{
								val=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmOTHERPalWriteCheckbox));
								if (val) g_ljp_pref.g_SnesHack |= PPU_IGNORE_PALWRITE;
								else g_ljp_pref.g_SnesHack &= ~PPU_IGNORE_PALWRITE;
								break;
							}
						}
						handled=true;
						break;
					}
					
					
		
		/*VIDEO*/															
				case ConfFrmVIDEOZodSmoothCheckbox:
				{
					int val=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOZodSmoothCheckbox));
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:
							if (val) g_ljp_pref.g_SnesSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_SnesSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_NES:
							if (val) g_ljp_pref.g_NesSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_NesSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_GB:
							if (val) g_ljp_pref.g_GBSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_GBSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_GENZ:
							if (val) g_ljp_pref.g_GENZSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_GENZSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_NEOPOPZ:
							if (val) g_ljp_pref.g_NEOPOPZSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_NEOPOPZSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_OSWANZ:
							if (val) g_ljp_pref.g_OSWANZSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_OSWANZSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_TG16Z:
							if (val) g_ljp_pref.g_TG16ZSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_TG16ZSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_SMS:
							if (val) g_ljp_pref.g_SMSSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_SMSSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_GG:
							if (val) g_ljp_pref.g_GGSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_GGSmoothing&=~_ZOD_SMOOTHING_;
							break;
						case SYS_VCS:
							if (val) g_ljp_pref.g_VCSSmoothing|=_ZOD_SMOOTHING_;
							else g_ljp_pref.g_VCSSmoothing&=~_ZOD_SMOOTHING_;
							break;
					}
					handled = true;
					break;
				}
				case ConfFrmVIDEOSNESTranspCheckbox:
					g_ljp_pref.g_SnesTransparency=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESTranspCheckbox));
					handled = true;
					break;
				case ConfFrmVIDEOSNESFastSpritesCheckbox:
					g_ljp_pref.g_SnesFastSprite=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmVIDEOSNESFastSpritesCheckbox));
					handled = true;
					break;
			/*SOUND*/
				case ConfFrmSOUNDOFF:
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:g_ljp_pref.g_SnesSound=0;break;
						case SYS_NES:g_ljp_pref.g_NesSound=0;break;
						case SYS_GB:g_ljp_pref.g_GBSound=0;break;						
						case SYS_GENZ:g_ljp_pref.g_GENZSound=0;
						case SYS_SMS:g_ljp_pref.g_SMSSound=0;break;						
						case SYS_GG:g_ljp_pref.g_GGSound=0;break;						
						case SYS_VCS:g_ljp_pref.g_VCSSound=0;break;		
						ConfigUpdateControls(&g_config_mode,frmP,0);
						ASK_FOR_UPDATE
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZSound=0;break;
						case SYS_OSWANZ:g_ljp_pref.g_OSWANZSound=0;break;
						case SYS_TG16Z:g_ljp_pref.g_TG16ZSound=0;break;			
					}
					handled = true;
					break;
				case ConfFrmSOUNDSIM:
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:
							//if (FrmCustomAlert ( MsgConfirm,"Sound emulation can cause random crash. Continue ?", NULL, NULL )==0) {
									g_ljp_pref.g_SnesSound=1;
						   		/*}else{
						   			ConfigUpdateControls(&g_config_mode,frmP,0);
								ASK_FOR_UPDATE
								}*/
							break;
							
						case SYS_NES:g_ljp_pref.g_NesSound=1;break;
						case SYS_GB:g_ljp_pref.g_GBSound=1;break;
						case SYS_GENZ:g_ljp_pref.g_GENZSound&=~3;g_ljp_pref.g_GENZSound|=1|4;
						case SYS_SMS:g_ljp_pref.g_SMSSound=1;break;						
						case SYS_GG:g_ljp_pref.g_GGSound=1;break;						
						case SYS_VCS:g_ljp_pref.g_VCSSound=1;break;
						ConfigUpdateControls(&g_config_mode,frmP,0);
						ASK_FOR_UPDATE
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZSound=1;break;
						case SYS_OSWANZ:g_ljp_pref.g_OSWANZSound=1;break;
						case SYS_TG16Z:g_ljp_pref.g_TG16ZSound=1;break;
					}
					handled = true;
					break;

				case ConfFrmSOUNDON:
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_SNES:
							//if (FrmCustomAlert ( MsgConfirm,"Sound emulation can cause random crash. Continue ?", NULL, NULL )==0) {
									g_ljp_pref.g_SnesSound=2;
						   	/*	}else{
						   			ConfigUpdateControls(&g_config_mode,frmP,0);
									ASK_FOR_UPDATE
								}*/
							break;
						case SYS_NES:g_ljp_pref.g_NesSound=2;break;
						case SYS_GB:g_ljp_pref.g_GBSound=2;break;
						case SYS_GENZ:g_ljp_pref.g_GENZSound&=~3;g_ljp_pref.g_GENZSound|=2;break;
						case SYS_NEOPOPZ:g_ljp_pref.g_NEOPOPZSound=2;break;
						case SYS_OSWANZ:g_ljp_pref.g_OSWANZSound=2;break;
						case SYS_TG16Z:g_ljp_pref.g_TG16ZSound=2;break;
						case SYS_SMS:g_ljp_pref.g_SMSSound=2;break;
						case SYS_GG:g_ljp_pref.g_GGSound=2;break;
						case SYS_VCS:g_ljp_pref.g_VCSSound=2;break;
					}
					handled = true;
					break;
				case ConfFrmSOUNDZX80Checkbox:
					handled = true;
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_GENZ:
							if (!g_ljp_pref.g_GENZSound) g_ljp_pref.g_GENZSound|=1;//if sound off,the put in sim
							g_ljp_pref.g_GENZSound&=~4;g_ljp_pref.g_GENZSound|=(FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDZX80Checkbox))?4:0);
							ConfigUpdateControls(&g_config_mode,frmP,0);
							ASK_FOR_UPDATE
							break;
					}
					break;
				case ConfFrmSOUNDFASTCheckbox:
					handled = true;
					switch (g_ljp_pref.g_conf_system)
					{
						case SYS_GENZ:
							//force sound on
							g_ljp_pref.g_GENZSound&=~(8|3);g_ljp_pref.g_GENZSound|=2|(FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,ConfFrmSOUNDFASTCheckbox))?8:0);
							ConfigUpdateControls(&g_config_mode,frmP,0);
							ASK_FOR_UPDATE
							break;
					}
					break;
					
					
			}	
			break;			
		}
		case penUpEvent:
		{
			if (g_config_mode==0)
			{	
				ListType *list;		
				FieldType *field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
				FldSetScrollPosition(field,0);
				
				switch (g_ljp_pref.g_conf_system)
				{
					case SYS_SNES:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSNESList) ); break;
					case SYS_NES:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNESList) ); break;
					case SYS_GB:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGBList) ); break;;
					case SYS_GENZ:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGENZList) ); break;
					case SYS_NEOPOPZ:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTNGPList) ); break;
					case SYS_OSWANZ:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTWSList) ); break;
					case SYS_TG16Z:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTTG16ZList) ); break;;
					case SYS_SMS:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTSMSList) ); break;;
					case SYS_GG:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTGGList) ); break;;
					case SYS_VCS:list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTVCSList) ); break;;
				}
				FldScrollField(field,LstGetTopItem(list),winDown);		
				ASK_FOR_UPDATE
			}
			break;
		}
		
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:		
			/**/						
			//ConfigUpdateControls(&g_config_mode,frmP,0);
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_SYSTEM_ICON(g_ljp_pref.g_conf_system,_CONSOLE_BMP_X_,_CONSOLE_BMP_Y_)
			if (scr) WinScreenUnlock();
			}			
			handled=true;
			break;
		
	}
	
	
	
	//if (hack1 || hack2 || hack3 || hack4) DEBUGU32(g_ljp_pref.g_SnesHack);
    
	return handled;
}


void Sort_Entries(char **listchoice,int num,int bypass_start)
{
	int i,j;
    char *a,*b;

    if (num<2)
      return;
    
    for (i=0;i<num;i++)
      {
        for (j=0;j<num-1;j++)
          {
          	a=listchoice[j]; 
          	b=listchoice[j+1];
          	if (bypass_start) {a+=3;b+=3;}
            if (StrCaselessCompare(a, b)>0)
              {
                char * temp;
                temp = listchoice[j];
                listchoice[j] = listchoice[j+1];
                listchoice[j+1] = temp;
              }
          }
      }
}

void InitCategoryList(ListType *list,int _system2list, FormType *frmP)
{
	Err			err = errNone;
	char		tmpName[32];
	int 		cur_entry=0;	
	int 		total_size=0;
	UInt16 		volRefNum;			
	UInt32 		volIterator;
	
	char syscatref[32];
	
//DEBUGS("init categories");
	
	if (g_catlistchoice) MemPtrFree(g_catlistchoice);
	
	g_num_cat_entries = MAX_CATEGORIES;
	g_catlistchoice=(char**)MemPtrNew(g_num_cat_entries*sizeof(char*));
	if (!g_catlistchoice) 			
	{			
		LstSetListChoices(list,(char**)NULL,0);		
		menu_inform("Browser : not enough memory!");
		return;
	}	
	
		
/*************************
  First pass : NES  
/*************************/  
	//if (_system2list&SYS_NES)
	{

if (_system2list&SYS_NES)     StrCopy(syscatref,g_ljp_pref.g_NesLastCat); else
if (_system2list&SYS_SNES)    StrCopy(syscatref,g_ljp_pref.g_SnesLastCat); else
if (_system2list&SYS_GB)      StrCopy(syscatref,g_ljp_pref.g_GBLastCat); else
if (_system2list&SYS_GENZ)    StrCopy(syscatref,g_ljp_pref.g_GENZLastCat); else
if (_system2list&SYS_NEOPOPZ) StrCopy(syscatref,g_ljp_pref.g_NEOPOPZLastCat); else
if (_system2list&SYS_OSWANZ)  StrCopy(syscatref,g_ljp_pref.g_OSWANZLastCat); else
if (_system2list&SYS_TG16Z)   StrCopy(syscatref,g_ljp_pref.g_TG16ZLastCat); else
if (_system2list&SYS_SMS)     StrCopy(syscatref,g_ljp_pref.g_SMSLastCat); else
if (_system2list&SYS_GG)      StrCopy(syscatref,g_ljp_pref.g_GGLastCat); else
if (_system2list&SYS_VCS)     StrCopy(syscatref,g_ljp_pref.g_VCSLastCat);

	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			
			if (_system2list&SYS_NES)     err = VFSFileOpen(volRefNum, __NES_ROMS_DIR__,     vfsModeRead, &dirRef); else
			if (_system2list&SYS_SNES)    err = VFSFileOpen(volRefNum, __SNES_ROMS_DIR__,    vfsModeRead, &dirRef); else
			if (_system2list&SYS_GB)      err = VFSFileOpen(volRefNum, __GB_ROMS_DIR__,      vfsModeRead, &dirRef); else
			if (_system2list&SYS_GENZ)    err = VFSFileOpen(volRefNum, __GENZ_ROMS_DIR__,    vfsModeRead, &dirRef); else
			if (_system2list&SYS_NEOPOPZ) err = VFSFileOpen(volRefNum, __NEOPOPZ_ROMS_DIR__, vfsModeRead, &dirRef); else
			if (_system2list&SYS_OSWANZ)  err = VFSFileOpen(volRefNum, __OSWANZ_ROMS_DIR__,  vfsModeRead, &dirRef); else
			if (_system2list&SYS_TG16Z)   err = VFSFileOpen(volRefNum, __TG16Z_ROMS_DIR__,   vfsModeRead, &dirRef); else
			if (_system2list&SYS_SMS)     err = VFSFileOpen(volRefNum, __SMS_ROMS_DIR__,     vfsModeRead, &dirRef); else
			if (_system2list&SYS_GG)      err = VFSFileOpen(volRefNum, __GG_ROMS_DIR__,      vfsModeRead, &dirRef); else
			if (_system2list&SYS_VCS)     err = VFSFileOpen(volRefNum, __VCS_ROMS_DIR__,     vfsModeRead, &dirRef);
			
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 31;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
				
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						int add_entry=0;
						
						if (info.attributes & vfsFileAttrDirectory) { //it's a directory
							add_entry=1;
						}
						
						if (add_entry)
						{
//							DEBUGS(info.nameP);
										
							g_catlistchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1);
							if (!g_catlistchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_catlistchoice[cur_entry]");
								break;
							}
							StrCopy(g_catlistchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1;
							cur_entry++;
							if (cur_entry>=g_num_cat_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 31;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop

				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here

			break;
		}
		if (cur_entry>=g_num_cat_entries) break;
	}
   }
   
   
   
   if (cur_entry==g_num_cat_entries)
    {
    	char str[128];
    	StrPrintF(str,"Cannot show more than %d categories",g_num_cat_entries);
    	menu_inform(str);

    }

			
	//if (cur_entry)
	{
		signed short selindex=-1;
		int i;
		char* str="Unarchived";

		if (cur_entry) Sort_Entries(g_catlistchoice,cur_entry,0);
		
//		cur_entry++;
//DEBUGS("add unarchived");

		//StrCopy(str,"Unarchived");
		g_catlistchoice[cur_entry] = (char*)MemPtrNew(StrLen(str)+1);
		if (!g_catlistchoice[cur_entry]) {
			DEBUGS("MemPtrNew error g_catlistchoice[cur_entry]");
		}
		StrCopy(g_catlistchoice[cur_entry],str);
		
//		total_size+=StrLen(str)+1;

		cur_entry++;
		
		for (i=0;i<cur_entry;i++)
		if (StrCaselessCompare(syscatref,g_catlistchoice[i])==0)
		{selindex=i;break;}
		
		if (selindex==-1)
		for (i=0;i<cur_entry;i++)
		if (StrCaselessCompare("uNaRcHiVeD",g_catlistchoice[i])==0)
		{selindex=i;break;}

//DEBUGS("set choices");
		LstSetListChoices(list,/*(char**)NULL*/g_catlistchoice,cur_entry);
//DEBUGS("set height");
		LstSetHeight(list,cur_entry);
//DEBUGS("draw list");

		if (selindex>=0) 
		{
			LstMakeItemVisible(list,selindex);
			LstSetSelection(list,selindex);
		}
		else
		{
			LstMakeItemVisible(list,0);
			LstSetSelection(list,0);
		}
		g_num_cat_entries=cur_entry;
	}
//	DEBUGS("end init categories");
}

void InitRomList(ListType *list,int _system2list,const char* category)
{
	Err			err = errNone;
	char		tmpName[128];
	int 		cur_entry=0;	
	int 		total_size=0;
	UInt16 		volRefNum;			
	UInt32 		volIterator; 
	
	g_num_entries = MAX_ROM_LISTED;//max 512 roms
//DEBUGS("romlist Alloc");	
	g_listchoice=(char**)MemPtrNew(g_num_entries*sizeof(char*));	


	if (!g_listchoice) 			
	{		
//DEBUGS("ko");			
		LstSetListChoices(list,(char**)NULL,0);		
		menu_inform("Browser : not enough memory!");
		return;
	}			
//DEBUGS("ok");
#ifndef TESTING_ONLY	
/*************************
  First pass : NES  
/*************************/  
	if (_system2list&SYS_NES)
	{
	
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __NES_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[256];
				StrCopy(path,__NES_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __NES_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
				
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						
//						DEBUGS(info.nameP);
						
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;	
						
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".nes") != 0))
						{
							add_entry=0;
						}
						if (add_entry)
						{
							
											
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_N-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop

				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here

			break;
		}
		if (cur_entry>=g_num_entries) break;
	}
//DEBUGS("ok");	
	}
/*************************
  Second pass : SNES  
/*************************/  
//DEBUGS("ok, go snes");			
    if ((_system2list&SYS_SNES)&&(cur_entry<g_num_entries))
    {
//DEBUGS("snes");    
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __SNES_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__SNES_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __SNES_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".spc") != 0)&&(StrCaselessCompare(ext, ".smc") != 0)&&(StrCaselessCompare(ext, ".sfc") != 0)&&(StrCaselessCompare(ext, ".fig") != 0)&&(StrCaselessCompare(ext, ".bin") != 0)&&(StrCaselessCompare(ext, ".1") != 0))
						{							
							add_entry=0;
						}						
						if (add_entry)
						{	
							
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_S-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
//DEBUGS("ok");	
	}		
	
/*************************
  Third pass : GB
/*************************/  

    if ((_system2list&SYS_GB)&&(cur_entry<g_num_entries))
    {
//DEBUGS("gb");    
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __GB_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__GB_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __GB_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;							
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".gb") != 0)&&(StrCaselessCompare(ext, ".gbc") != 0)&&(StrCaselessCompare(ext, ".sgb") != 0))
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_G-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
//DEBUGS("ok");	
	}		
/*************************
  Fourth pass : Genesis
/*************************/  
    if ((_system2list&SYS_GENZ)&&(cur_entry<g_num_entries))
    {
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __GENZ_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__GENZ_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __GENZ_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;							
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".smd") != 0)&&(StrCaselessCompare(ext, ".bin") != 0))
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_M-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
	}		
	
/*************************
  Fourth pass : Neogeo Pocket
/*************************/  
    if ((_system2list&SYS_NEOPOPZ)&&(cur_entry<g_num_entries))
    {
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __NEOPOPZ_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__NEOPOPZ_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __NEOPOPZ_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{

						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;							
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".ngp") != 0)&&(StrCaselessCompare(ext, ".ngc") != 0)&&(StrCaselessCompare(ext, ".npc") != 0))
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_P-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
	}		

/*************************
  Fifth pass : wonderswan
/*************************/  
    if ((_system2list&SYS_OSWANZ)&&(cur_entry<g_num_entries))
    {
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __OSWANZ_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__OSWANZ_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __OSWANZ_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;							
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".ws") != 0)&&(StrCaselessCompare(ext, ".wsc") != 0))
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_W-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
	}	

/*************************
  Sixth pass : tg16
/*************************/  
    if ((_system2list&SYS_TG16Z)&&(cur_entry<g_num_entries))
    {
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __TG16Z_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__TG16Z_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __TG16Z_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;							
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".pce") != 0)&&(StrCaselessCompare(ext, ".gsx") != 0))
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_T-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
	}	
	
	/*************************
  8th pass : SMS
/*************************/  

    if ((_system2list&SYS_SMS)&&(cur_entry<g_num_entries))
    {
//DEBUGS("sms");    
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __SMS_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__SMS_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __SMS_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;							
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".sms") != 0))
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_A-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
//DEBUGS("ok");	
	}		
	
	/*************************
  9th pass : GG
/*************************/  

    if ((_system2list&SYS_GG)&&(cur_entry<g_num_entries))
    {
//DEBUGS("sms");    
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __GG_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__GG_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __GG_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;							
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".gg") != 0))
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_R-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
//DEBUGS("ok");	
	}	
	
/*************************
  10th pass : Atari VCS
/*************************/  

    if ((_system2list&SYS_VCS)&&(cur_entry<g_num_entries))
    {
//DEBUGS("sms/gg");    
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			if (StrCaselessCompare(category,"unarchived") == 0) {
//		DEBUGS("unarchived");
				err = VFSFileOpen(volRefNum, __VCS_ROMS_DIR__, vfsModeRead, &dirRef);
			} else {
				char path[128];
				StrCopy(path,__VCS_ROMS_DIR__);
				StrCat(path,category);
				StrCat(path,(const char*)"/");
				err = VFSFileOpen(volRefNum, path, vfsModeRead, &dirRef);
				
				if (err != errNone) err = VFSFileOpen(volRefNum, __VCS_ROMS_DIR__, vfsModeRead, &dirRef);
				
//				DEBUGS(path);
			}
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;
						while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;							
						if ( (StrCaselessCompare(ext, ".zip") != 0)&&(StrCaselessCompare(ext, ".vcs") != 0)&&(StrCaselessCompare(ext, ".bin") != 0)&&(StrCaselessCompare(ext, ".raw") != 0)/*&&(StrCaselessCompare(ext, ".gg") != 0)*/)
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							StrCopy(g_listchoice[cur_entry],"_V-");
							g_listchoice[cur_entry][0]=volRefNum;
							StrCat(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1+3;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop
				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here
			break;
		}
		if (cur_entry>=g_num_entries) break;
	}		
//DEBUGS("ok");	
	}
	
#endif		
	
	
#ifdef TESTING_ONLY	
{
	int i;
	for (i=0;i<30;i++)
	{
		StrCopy(tmpName,"AeyoNfkjslmf1]1222222222222222224646!.fggd.gdf.zip");
		tmpName[0]+=i>>2;
		g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1+3);
		StrCopy(g_listchoice[cur_entry],"_N-");
		g_listchoice[cur_entry][0]='0';
		StrCat(g_listchoice[cur_entry],tmpName);
		total_size+=StrLen(tmpName)+1+3;
		cur_entry++;
	}
}	
#endif

    if (cur_entry==g_num_entries)
    {
    	char str[128];
    	StrPrintF(str,"Cannot show more than %d files",g_num_entries);
    	menu_inform(str);

    }

			
	if (cur_entry)
	{
		signed short selindex=-1;
		int i;

		Sort_Entries(g_listchoice,cur_entry,1);

		for (i=0;i<cur_entry;i++)
		if (StrCompare(g_ljp_pref.g_lastrom,g_listchoice[i])==0)
		{selindex=i;break;}

		LstSetListChoices(list,(char**)NULL,cur_entry);

		if (selindex>=0) 
		{
			LstMakeItemVisible(list,selindex);
			LstSetSelection(list,selindex);
		}
		else
		{
			LstMakeItemVisible(list,0);
			LstSetSelection(list,0);
		}
		g_num_entries=cur_entry;

	}
	else
	{		
		MemPtrFree(g_listchoice);
		g_listchoice=NULL;
		LstSetListChoices(list,(char**)NULL,0);		
		switch (_system2list)
		{
			case SYS_NES:
				menu_inform("No ROM!");
//				menu_message(__NES_ROMS_DIR__);
				break;
			case SYS_SNES:
				menu_inform("No ROM!");
//				menu_message(__SNES_ROMS_DIR__);
				break;
			case SYS_GB:
				menu_inform("No ROM!");
//				menu_message(__GB_ROMS_DIR__);
				break;
			case SYS_GENZ:
				menu_inform("No ROM!");
//				menu_message(__GENZ_ROMS_DIR__);
				break;
			case SYS_NEOPOPZ:
				menu_inform("No ROM!");
//				menu_message(__NEOPOPZ_ROMS_DIR__);
				break;
			case SYS_OSWANZ:
				menu_inform("No ROM!");
//				menu_message(__OSWANZ_ROMS_DIR__);
				break;
			case SYS_TG16Z:
				menu_inform("No ROM!");
//				menu_message(__TG16Z_ROMS_DIR__);
				break;
			case SYS_SMS:
				menu_inform("No ROM!");
//				menu_message(__SMSGG_ROMS_DIR__);
				break;
			case SYS_GG:
				menu_inform("No ROM!");
//				menu_message(__SMSGG_ROMS_DIR__);
				break;
			case SYS_VCS:
				menu_inform("No ROM!");
//				menu_message(__VCS_ROMS_DIR__);
				break;
		}		
	}
	

}


Boolean HandleKeyDownEvent(EventType* eventP) {
	FormType* 		frmP = FrmGetActiveForm();
	int handled;

	switch (eventP->data.keyDown.chr)
	{
		case vchrPageDown:
		case vchrRockerDown:
		case vchrThumbWheelDown:
		case vchrActionDown:
		{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
			Int16 currentItem=LstGetSelection(list);
			if (currentItem<LstGetNumberOfItems(list)-1) LstSetSelection(list,currentItem+1);
			else LstSetSelection(list,0);
			handled = true;					
		}
		break;
		case vchrPageUp:
		case vchrRockerUp:
		case vchrThumbWheelUp:
		case vchrActionUp:
		{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
			Int16 currentItem=LstGetSelection(list);
			if (currentItem>0) LstSetSelection(list,currentItem-1);
			else LstSetSelection(list,LstGetNumberOfItems(list)-1);
			handled = true;					
		}
		break;
		
		case vchrRockerRight:
		case vchrActionRight:
		{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
			Int16 currentItem=LstGetSelection(list);
			if (currentItem<LstGetNumberOfItems(list)-11) LstSetSelection(list,currentItem+10);
			else LstSetSelection(list,LstGetNumberOfItems(list)-1);
			handled = true;				
		} break;
		
		case vchrRockerLeft:
		case vchrActionLeft:
		{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
			Int16 currentItem=LstGetSelection(list);
			if (currentItem>9) LstSetSelection(list,currentItem-10);
			else LstSetSelection(list,0);
			handled = true;			
		} break;
		
		case vchrNavChange:
			if (!(eventP->data.keyDown.keyCode & (navBitSelect|navChangeSelect))) break;
		case vchrNavSelect:{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
			RGBColorType col;
			if ((LstGetSelection(list)<g_num_entries)&&(LstGetSelection(list)>=0)){
				g_autoload=0;
				LAUNCH_ROM(g_listchoice[LstGetSelection(list)])
				handled = true;
			}
		} break;
	}
	
	if (handled) return handled;
	
	switch (eventP->data.keyDown.keyCode)
	{
		case 1028: //left
		case 4:
		{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
			Int16 currentItem=LstGetSelection(list);
			if (currentItem>9) LstSetSelection(list,currentItem-10);
			else LstSetSelection(list,0);
			handled = true;			
		} break;
		case 2056: //right
		case 8:
		{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
			Int16 currentItem=LstGetSelection(list);
			if (currentItem<LstGetNumberOfItems(list)-11) LstSetSelection(list,currentItem+10);
			else LstSetSelection(list,LstGetNumberOfItems(list)-1);
			handled = true;				
		} break;
		default:
		if (handled) return handled;
		{	
			char tmp[16];
			StrPrintF(tmp,"%04X",eventP->data.keyDown.keyCode);
			DEBUGS(tmp);
			StrPrintF(tmp,"%04X",eventP->data.keyDown.chr);
			DEBUGS(tmp);
		}
	}
	
	return handled;
}

void OtherUpdateControls(int *page,FormType *frmP) {
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmLaunchFXCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmSoundCheckbox) ));
	
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmConfirmOWCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmConfirmSLCheckbox) ));
	
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmFramerateCheckbox) ));
	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmBeltbarCheckbox) ));
//	CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmNoDAACheckbox) ));
	
	switch (*page) {
		case 0: {//launcher
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpLauncherButton),1);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpGUIButton),0);			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpMiscButton),0);
		
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmLaunchFXCheckbox) ));
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmSoundCheckbox) ));
		} break;
		case 1: {//gui
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpLauncherButton),0);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpGUIButton),1);			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpMiscButton),0);
			
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmConfirmOWCheckbox) ));
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmConfirmSLCheckbox) ));
		} break;
		case 2: {//misc
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpLauncherButton),0);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpGUIButton),0);			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpMiscButton),1);
		
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmFramerateCheckbox) ));
			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmBeltbarCheckbox) ));
//			CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,OtherFrmNoDAACheckbox) ));
		} break;
	}
}

void RegisterDirs(void) {
			/*Register file type for emu module*/
			VFSRegisterDefaultDirectory ( ".zem", expMediaType_Any, VFSPATH );
		    VFSRegisterDefaultDirectory ( ".ZEM", expMediaType_Any, VFSPATH );
		
			/*Register file type for roms*/
			VFSRegisterDefaultDirectory ( ".nes", expMediaType_Any, __NES_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".NES", expMediaType_Any, __NES_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".smc", expMediaType_Any, __SNES_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".SMC", expMediaType_Any, __SNES_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".gb",  expMediaType_Any, __GB_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".GB",  expMediaType_Any, __GB_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".gbc", expMediaType_Any, __GB_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".GBC", expMediaType_Any, __GB_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".smd", expMediaType_Any, __GENZ_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".SMD", expMediaType_Any, __GENZ_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".bin", expMediaType_Any, __GENZ_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".BIN", expMediaType_Any, __GENZ_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".sms", expMediaType_Any, __SMS_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".SMS", expMediaType_Any, __SMS_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".gg",  expMediaType_Any, __GG_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".GG",  expMediaType_Any, __GG_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".ngp", expMediaType_Any, __NEOPOPZ_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".NGP", expMediaType_Any, __NEOPOPZ_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".ws",  expMediaType_Any, __OSWANZ_ROMS_DIR__ );
		    VFSRegisterDefaultDirectory ( ".WS",  expMediaType_Any, __OSWANZ_ROMS_DIR__ );
}



void drawBeltBar(void) {
	MemHandle hRsc=NULL;
	if (ljp_isLowRes) {
		hRsc = DmGetResource(bitmapRsc, BBLAUNCHERBMP);
		if (hRsc) {
			BitmapType* bitmapP = (BitmapType*) MemHandleLock(hRsc);
			WinPaintBitmap(bitmapP, (0*32), (320-32)/2 );
			MemHandleUnlock(hRsc);
			DmReleaseResource(hRsc);
		}
	} else {
		//hires								
		BitmapTypeV3* bmpV3;
		WinPushDrawState();				
		WinSetCoordinateSystem(kCoordinatesNative);								
		hRsc = DmGetResource(bitmapRsc, BBLAUNCHERBMPHR);
		if (hRsc) {
			BitmapType* bitmapP = (BitmapType*) MemHandleLock(hRsc);
			bmpV3 = BmpCreateBitmapV3(bitmapP, kDensityDouble, (void*)((long)(BmpGetBits(bitmapP))+14), 0);
			WinDrawBitmap((BitmapType *)bmpV3, 0, (320-32) );
			BmpDelete((BitmapType*)bmpV3);
			MemHandleUnlock(hRsc);
			DmReleaseResource(hRsc);											   					
		}
		WinPopDrawState();				
	}
}


