#include <PalmOS.h>
#include <StringMgr.h>

#include "ljPRsc.h"
#include "App_Cst.h"
#include "App_Fx.h"
#include "pnobridge.h"

#include "Host68k.h"
#include "TapWave/TwChars.h"

#include <PalmOS.h>

#include "LJP_mac.h"

#define winDisplayChangedEvent 0x4101

extern t_ljp_pref g_ljp_pref;
extern Int16 g_prev_form;
extern UInt32 ljp_isLowRes;

t_ggenie_code *g_ggenie_list;
Int16 g_cur_ggeniecode;
Int8 g_newcode=0;
Int8 g_system_val;
UInt16	g_ggenie_num_entries;

char IsHexDigit(char c){
	if ((c>='a')&&(c<='f')) return 1;
	if ((c>='A')&&(c<='F')) return 1;
	if ((c>='0')&&(c<='9')) return 1;	
	return 0;
}


char IsNesDigit(char c){
	char accepted[16]={'A','P','Z','L','G','I','T','Y','E','O','X','U','K','S','V','N'};
	int i;
	for (i=0;i<16;i++) if (c==accepted[i]) return 1;
	return 0;
}

char IsGenDigit(char c){
	char accepted[32]=
	{'A','B','C','D','E','F','G','H','J','K','L','M','N','P','R','S',
	 'T','V','W','X','Y','Z','0','1','2','3','4','5','6','7','8','9',};
	int i;
	
	for (i=0;i<32;i++) if (c==accepted[i]) return 1;
	return 0;
}

// XXXXXX or XXXX
//
char IsNESCode(char *code){
	int i=StrLen(code);
	if (i==6){
		return IsNesDigit(code[0])&
			   IsNesDigit(code[1])&
			   IsNesDigit(code[2])&
			   IsNesDigit(code[3])&
			   IsNesDigit(code[4])&
			   IsNesDigit(code[5]);
	}
	if (i==4){
		return IsNesDigit(code[0])&
			   IsNesDigit(code[1])&
			   IsNesDigit(code[2])&
			   IsNesDigit(code[3]);

	}
	return 0;
}
// XXX-XXX-XXX
char IsGBCode(char *code){
	int i=StrLen(code);
	if (i==11){
		return IsHexDigit(code[0])&
			   IsHexDigit(code[1])&
			   IsHexDigit(code[2])&
			   (code[3]=='-')&
			   IsHexDigit(code[4])&
			   IsHexDigit(code[5])&
			   IsHexDigit(code[6])&
			   (code[7]=='-')&
			   IsHexDigit(code[8])&
			   IsHexDigit(code[9])&
			   IsHexDigit(code[10]);
	}
	return 0;
}
// XXXX-XXXX
char IsSNESCode(char *code){
	int i=StrLen(code);
	if (i==9){
		return IsHexDigit(code[0])&
			   IsHexDigit(code[1])&
			   IsHexDigit(code[2])&			   
			   IsHexDigit(code[3])&
			   (code[4]=='-')&
			   IsHexDigit(code[5])&
			   IsHexDigit(code[6])&
			   IsHexDigit(code[7])&
			   IsHexDigit(code[8]);
	}
	return 0;
}
// XXXX-XXXX
char IsGENCode(char *code){
	int i=StrLen(code);
	if (i==9){
		return IsGenDigit(code[0])&
			   IsGenDigit(code[1])&
			   IsGenDigit(code[2])&			   
			   IsGenDigit(code[3])&
			   (code[4]=='-')&
			   IsGenDigit(code[5])&
			   IsGenDigit(code[6])&
			   IsGenDigit(code[7])&
			   IsGenDigit(code[8]);
	}
	return 0;
}

void	drawGGenieList	(Int16	i,RectangleType	*bounds,Char		**items)
	{
	Char *p,q[64];	
	Int16 j=0;
	Int16 wid;
	Boolean notruncated;
	IndexedColorType selectColor = UIColorGetTableEntryIndex(UIObjectSelectedForeground);
	IndexedColorType myColor=0;
	IndexedColorType itemColor = WinSetForeColor(myColor);	
	RGBColorType fg,bg;	
	
	WinSetForeColor(itemColor);	
	if (i>=g_ggenie_num_entries) return;	
	p=g_ggenie_list[i].description;
		
	while (p[j++]);
	
	WinPushDrawState();	
    WinSetDrawMode(winPaint);
    
	j--;    
	
	if (g_ggenie_list[i].active){		
		fg.r=80;fg.g=0;fg.b=120;
		//bg.r=200;bg.g=255;bg.b=200;
	}else{		
		fg.r=200;fg.g=200;fg.b=200;
		//bg.r=255;bg.g=255;bg.b=255;
	}
			
	
	if (itemColor == selectColor)
		{fg.r^=255;fg.g^=255;fg.b^=255;
		bg.r^=255;bg.g^=255;bg.b^=255;}
	        	
    WinSetTextColorRGB(&fg,NULL);    
//    WinSetBackColorRGB(&bg,NULL);


	wid=110;
	FntCharsInWidth(p,&wid,&j,&notruncated);
	if (!notruncated)
	{
		if (j>63) {j=63;DEBUGS("drawList => truncated string with > 63chars");}
		p=q;//(Char*)MemPtrNew(j);
		MemMove(p,g_ggenie_list[i].description,j);
		p[j]=0;
		p[j-1]='.';p[j-2]='.';p[j-3]='.';
	}
	
	
	WinSetCoordinateSystem(kCoordinatesNative);
	
	WinPaintChars(p,j,SCR_ADJ(bounds->topLeft.x*2),
			SCR_ADJ(bounds->topLeft.y*2));
			
	WinSetDrawMode(winOverlay);
	
	if (itemColor == selectColor)
	{
	fg.r<<=1;fg.g<<=1;fg.b<<=1;
    WinSetTextColorRGB(&fg,NULL);
	WinPaintChars(p,j,SCR_ADJ(bounds->topLeft.x*2-1),
			SCR_ADJ(bounds->topLeft.y*2-1));
	}		
//	if (!notruncated) MemPtrFree(p);
	WinPopDrawState();	
	}


Boolean GGenieFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err				err = errNone;
	UInt16 pref_size;
//	static int		frmloaded=0;
	

	switch (eventP->eType) {
		ListType *list;
		
		case frmOpenEvent:{						
		
			FrmCustomAlert(MsgAlert,"Game Genie code can be input & saved, but aren't used in current version", NULL, NULL);
			
			g_newcode=0;
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemListGGenie) );
			switch (g_ljp_pref.g_conf_system){
				case SYS_NES:LstSetSelection(list,0);g_system_val=0;
				break;
				case SYS_SNES:LstSetSelection(list,1);g_system_val=1;
				break;
				case SYS_GB:LstSetSelection(list,2);g_system_val=2;
				break;
				case SYS_GENZ:LstSetSelection(list,3);g_system_val=3;
				break;
				case SYS_NEOPOPZ:LstSetSelection(list,4);g_system_val=4;
				break;
				case SYS_OSWANZ:LstSetSelection(list,5);g_system_val=5;
				break;
				case SYS_TG16Z:LstSetSelection(list,6);g_system_val=6;
				break;
				case SYS_SMS:LstSetSelection(list,7);g_system_val=7;
				break;
				case SYS_GG:LstSetSelection(list,8);g_system_val=8;
				break;
				case SYS_VCS:LstSetSelection(list,9);g_system_val=9;
				break;
			}
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemPopupGGenie) ),LstGetSelectionText(list,LstGetSelection(list)));						

			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_SYSTEM_ICON(g_ljp_pref.g_conf_system,_CONSOLE_BMP_X_,_CONSOLE_BMP_Y_)
			if (scr) WinScreenUnlock();
			}			
			
			g_ggenie_num_entries=0;
			g_ggenie_list=NULL;
			pref_size=0;
			if (PrefGetAppPreferences(CREATORID,0x0002+g_system_val,(void*)NULL,(UInt16*)(&pref_size),(unsigned char)1)==VERSION_DB){
				if (pref_size){
					g_ggenie_list=(t_ggenie_code*)MemPtrNew(pref_size);
					g_ggenie_num_entries=pref_size/sizeof(t_ggenie_code);
					PrefGetAppPreferences(CREATORID,0x0002+g_system_val,(void*)g_ggenie_list,(UInt16*)(&pref_size),(unsigned char)1);
				}
			}
			
			LstNewList((void**)&frmP,FORM_LISTGGenie_ID,43,25,112,80,FntGetFont(),9,0);
			list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTGGenie_ID) );
			LstSetDrawFunction (list, (ListDrawDataFuncPtr) drawGGenieList);
									
						
			LstSetListChoices(list,(char**)NULL,g_ggenie_num_entries);
						
						
			ASK_FOR_UPDATE	
			handled = true;
			break;
		}
		case frmCloseEvent:
			if (g_ggenie_num_entries){
				int i;
								
				PrefSetAppPreferences(CREATORID,0x0002+g_system_val,(short)VERSION_DB,(void*)NULL,(short)0,(unsigned char)1);
				PrefSetAppPreferences(CREATORID,0x0002+g_system_val,(short)VERSION_DB,(void*)g_ggenie_list,(short)(sizeof(t_ggenie_code)*g_ggenie_num_entries),(unsigned char)1);
				
				MemPtrFree(g_ggenie_list);
				
			}
			break;
		case lstSelectEvent:
			switch ( eventP->data.lstSelect.listID)	{
				case FORM_LISTGGenie_ID:
				
				if (eventP->data.lstSelect.selection<g_ggenie_num_entries){
					FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,GGenieFrmActiveCheckbox),
					  g_ggenie_list[eventP->data.lstSelect.selection].active);
					ASK_FOR_UPDATE
				}
				break;
			}
			break;
		case popSelectEvent:
			switch ( eventP->data.ctlSelect.controlID ) {
				case SystemPopupGGenie:	{
					ListType *list;
					
					/*store & load codes*/
					/*if (g_ggenie_num_entries)*/{
						int i;								
						PrefSetAppPreferences(CREATORID,0x0002+g_system_val,(short)VERSION_DB,(void*)NULL,(short)0,(unsigned char)1);
						if (g_ggenie_num_entries) {
							PrefSetAppPreferences(CREATORID,0x0002+g_system_val,(short)VERSION_DB,(void*)g_ggenie_list,(short)(sizeof(t_ggenie_code)*g_ggenie_num_entries),(unsigned char)1);				
							MemPtrFree(g_ggenie_list);				
						}
					}
					
					switch (eventP->data.popSelect.selection) {
						case 0:g_ljp_pref.g_conf_system=SYS_SNES;g_system_val=0;
						break;
						case 1:g_ljp_pref.g_conf_system=SYS_NES;g_system_val=1;break;
						case 2:g_ljp_pref.g_conf_system=SYS_GB;g_system_val=2;break;
						case 3:g_ljp_pref.g_conf_system=SYS_GENZ;g_system_val=3;
						break;
						case 4:g_ljp_pref.g_conf_system=SYS_NEOPOPZ;g_system_val=4;
						break;
						case 5:g_ljp_pref.g_conf_system=SYS_OSWANZ;g_system_val=5;	
						break;
						case 6:g_ljp_pref.g_conf_system=SYS_TG16Z;g_system_val=6;break;
						case 7:g_ljp_pref.g_conf_system=SYS_SMS;g_system_val=7;break;
						case 8:g_ljp_pref.g_conf_system=SYS_GG;g_system_val=8;break;
						case 9:g_ljp_pref.g_conf_system=SYS_VCS;g_system_val=9;break;
					}
					
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemListGGenie) );
					if (list) CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemPopupGGenie) ),LstGetSelectionText(list,LstGetSelection(list)));
					
					UPDATE_UI_COLORS(g_ljp_pref.g_conf_system)
					
					
					
					g_ggenie_num_entries=0;
					g_ggenie_list=NULL;
					pref_size=0;
					if (PrefGetAppPreferences(CREATORID,0x0002+g_system_val,(void*)NULL,(UInt16*)(&pref_size),(unsigned char)1)==VERSION_DB){
						if (pref_size){
							g_ggenie_list=(t_ggenie_code*)MemPtrNew(pref_size);
							g_ggenie_num_entries=pref_size/sizeof(t_ggenie_code);
							PrefGetAppPreferences(CREATORID,0x0002+g_system_val,(void*)g_ggenie_list,(UInt16*)(&pref_size),(unsigned char)1);
						}
					}
					
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTGGenie_ID) );					
					LstSetListChoices(list,(char**)NULL,g_ggenie_num_entries);
					if (g_ggenie_num_entries){
						LstMakeItemVisible(list,0);
						LstSetSelection(list,0);
					}
					
				
					ASK_FOR_UPDATE
					break;
				}
			}
			break;
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case GGenieFrmHELPButton:
					g_prev_form=GGenieForm;					
					FrmGotoForm(HelpForm);										
					handled=true;
					break;
				case GGenieFrmHOMEButton:
					FrmGotoForm(LauncherForm);
					handled=true;
					break;
				case GGenieFrmActiveCheckbox:{
					Int16 idx;
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTGGenie_ID) );
					idx=LstGetSelection(list);
					if ((idx>=0)&&(idx<g_ggenie_num_entries)){
						g_ggenie_list[idx].active=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,GGenieFrmActiveCheckbox));
						ASK_FOR_UPDATE
					}
					handled=true;
					break;
				}	
				case GGenieFrmNewButton:
					g_cur_ggeniecode=-1;
					FrmPopupForm(GGenieCodeForm);
					handled=true;
					break;
				case GGenieFrmEditButton:{
					Int16 idx;
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTGGenie_ID) );
					idx=LstGetSelection(list);
					if ((idx>=0)&&(idx<g_ggenie_num_entries)){
						g_cur_ggeniecode=idx;
						FrmPopupForm(GGenieCodeForm);
					}
					handled=true;
					break;
				}
				case GGenieFrmDeleteButton:{
					Int16 idx;
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTGGenie_ID) );
					idx=LstGetSelection(list);
					if ((idx>=0)&&(idx<g_ggenie_num_entries)){
						
						if (g_ggenie_num_entries>1){
							t_ggenie_code *tmp;
							tmp=(t_ggenie_code*)MemPtrNew(sizeof(t_ggenie_code)*(g_ggenie_num_entries-1));
							if (idx) MemMove(tmp,g_ggenie_list,sizeof(t_ggenie_code)*idx);
							if (idx<g_ggenie_num_entries-1) MemMove(tmp,&(g_ggenie_list[idx+1]),sizeof(t_ggenie_code)*(g_ggenie_num_entries-idx-1));
							MemPtrFree(g_ggenie_list);
							g_ggenie_list=tmp;
						}else{
							MemPtrFree(g_ggenie_list);							
							g_ggenie_list=NULL;
						}
						g_ggenie_num_entries--;
						LstSetListChoices(list,(char**)NULL,g_ggenie_num_entries);
						ASK_FOR_UPDATE
					}
					handled=true;
					break;
				}
			}
			break;			
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:		
			{UInt8 *scr=WinScreenLock(winLockCopy);
			
			if (g_newcode){
				g_newcode=0;
				list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTGGenie_ID) );			
				LstSetListChoices(list,(char**)NULL,g_ggenie_num_entries);
			}
			
			FrmDrawForm(frmP);
			DRAW_SYSTEM_ICON(g_ljp_pref.g_conf_system,_CONSOLE_BMP_X_,_CONSOLE_BMP_Y_)
			if (scr) WinScreenUnlock();
			}			
			handled=true;
			break;
		
	}    
	return handled;
}


Boolean GGenieCodeFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err				err = errNone;
//	static int		frmloaded=0;
	

	switch (eventP->eType) {
		ListType *list;
		case frmOpenEvent:{						
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_SYSTEM_ICON(g_ljp_pref.g_conf_system,_CONSOLE_BMP_X_,_CONSOLE_BMP_Y_)
			if (scr) WinScreenUnlock();
			}			
			
			if (g_cur_ggeniecode>=0){
				FldInsert((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,GGenieCodeDescriptionField)),
					g_ggenie_list[g_cur_ggeniecode].description,
					StrLen(g_ggenie_list[g_cur_ggeniecode].description));
				FldInsert((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,GGenieCodeDataField)),
					g_ggenie_list[g_cur_ggeniecode].code,
					StrLen(g_ggenie_list[g_cur_ggeniecode].code));
			}
			
			ASK_FOR_UPDATE	
			handled = true;
			break;
		}
		case frmCloseEvent:							
			break;
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case GGenieCodeOKButton:{
						char *descr,*data;
						descr=FldGetTextPtr((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,GGenieCodeDescriptionField)));
						data=FldGetTextPtr((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,GGenieCodeDataField)));
						if (descr&&data){
							char valid_code;
							valid_code=1;
							switch (g_system_val){
								case 0:
								if (!IsSNESCode(data)) {menu_inform("Wrong code format!");valid_code=0;}break;
								case 1:
								if (!IsNESCode(data)) {menu_inform("Wrong code format!");valid_code=0;}break;
								case 2:
								if (!IsGBCode(data)) {menu_inform("Wrong code format!");valid_code=0;}break;
								case 3:
								if (!IsGENCode(data)) {menu_inform("Wrong code format!");valid_code=0;}break;
								case 4:
								case 5:
								case 6:
								case 7:
								case 8:
								case 9:break;
							}
							if (valid_code){
							if (g_cur_ggeniecode==-1){
								if (g_ggenie_num_entries) {
									t_ggenie_code *tmp;
									tmp=(t_ggenie_code*)MemPtrNew(sizeof(t_ggenie_code)*(g_ggenie_num_entries+1));
									MemMove(tmp,g_ggenie_list,sizeof(t_ggenie_code)*g_ggenie_num_entries);
									MemPtrFree(g_ggenie_list);
									g_ggenie_list=tmp;
								}
								else g_ggenie_list=(t_ggenie_code*)MemPtrNew(sizeof(t_ggenie_code));
								g_ggenie_num_entries++;							
								{
									StrCopy(g_ggenie_list[g_ggenie_num_entries-1].description,descr);
									StrCopy(g_ggenie_list[g_ggenie_num_entries-1].code,data);
								}
								g_ggenie_list[g_ggenie_num_entries-1].active=0;
								g_newcode=1;
								FrmReturnToForm(GGenieForm);
							}else{
								StrCopy(g_ggenie_list[g_cur_ggeniecode].description,descr);
								StrCopy(g_ggenie_list[g_cur_ggeniecode].code,data);
								g_newcode=1;
								FrmReturnToForm(GGenieForm);
							}
							}else{ASK_FOR_UPDATE};
						}else {
							menu_inform("Please fill in all fields");
							ASK_FOR_UPDATE
						}
					}					
					handled=true;
					break;
				case GGenieCodeCancelButton:
					FrmReturnToForm(GGenieForm);
					handled=true;
					break;	
			}
			break;			
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:		
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (scr) WinScreenUnlock();
			}
			handled=true;
			break;
	}
	return handled;
}
