#ifndef __LJP_mac_h__
#define __LJP_mac_h__

/***********************
/* 0 => standard 320x320
/* 1 => hires+ device
/* 2 => clie device
/* 4 => zodiac
/***********************/
#define _ZODIAC_DEVICE_ 4
#define _CLIE_DEVICE_ 2
#define _HIRES_PLUS_DEVICE_ 1


#define UPDATE_UI_COLORS(v) \
{ \
			RGBColorType col; \
			int cr,cg,cb;\
			switch (v) \
			{\
				case SYS_NES:cr=200;cg=200;cb=200; \
				break; \
				case SYS_SNES:cr=250;cg=210;cb=240; \
				break; \
				case SYS_GB:cr=255;cg=255;cb=128; \
				break; \
				case SYS_GENZ:cr=230;cg=190;cb=220; \
				break; \
				case SYS_NEOPOPZ:cr=200;cg=220;cb=240; \
				break; \
				case SYS_OSWANZ:cr=200;cg=240;cb=220; \
				break; \
				case SYS_TG16Z:cr=255;cg=230;cb=230; \
				break; \
				case SYS_SMS:cr=160;cg=255;cb=138; \
				break; \
				case SYS_GG:cr=200;cg=255;cb=128; \
				break; \
				case SYS_VCS:cr=180;cg=80;cb=30; \
				break; \
			}			 \
			col.r=cr;col.g=cg;col.b=cb; \
			UIColorSetTableEntry(UIFormFill,&col);			 \
			col.r>>=1;col.g>>=1;col.b>>=1; \
			UIColorSetTableEntry(UIFormFrame,&col); \
			col.r=255;col.g=245;col.b=250; \
			UIColorSetTableEntry(UIObjectFill,&col);			 \
			col.r=(cr)>>1;\
			col.g=(cg)>>1;\
			col.b=(cb)>>1;\
			UIColorSetTableEntry(UIObjectFrame,&col); \
}

#define ASK_FOR_UPDATE \
	{EventType my_event; \
	my_event.eType=frmUpdateEvent;\
	EvtAddEventToQueue(&my_event);}

	
#define DRAW_SYSTEM_ICON(S,X,Y)\
	{\
		MemHandle hRsc=NULL;\
			switch (S)\
			{\
				case SYS_NES:hRsc = DmGetResource(bitmapRsc, NESBMP);break;\
				case SYS_SNES:hRsc = DmGetResource(bitmapRsc, SNESBMP);break;\
				case SYS_GB:hRsc = DmGetResource(bitmapRsc, GBBMP);break;\
				case SYS_GENZ:hRsc = DmGetResource(bitmapRsc, GENESISBMP);break;\
				case SYS_NEOPOPZ:hRsc = DmGetResource(bitmapRsc, NGPBMP);break;\
				case SYS_OSWANZ:hRsc = DmGetResource(bitmapRsc, WSBMP);break;\
				case SYS_TG16Z:hRsc = DmGetResource(bitmapRsc, TG16BMP);break;\
				case SYS_SMS:hRsc = DmGetResource(bitmapRsc, SMSBMP);break;\
				case SYS_GG:hRsc = DmGetResource(bitmapRsc, GGBMP);break;\
				case SYS_VCS:hRsc = DmGetResource(bitmapRsc, VCSBMP);break;\
			}\
			if (hRsc)\
			{	BitmapType* bitmapP = (BitmapType*) MemHandleLock(hRsc);\
				WinPaintBitmap(bitmapP, X, Y);\
				MemHandleUnlock(hRsc);\
				DmReleaseResource(hRsc);}\
   }


#define LAUNCH_ROM(filename) {\
	RGBColorType col;\
	char *ftrptr;\
	if (filename){\
		FtrPtrNew(CREATORID, FTR_ROM_FILENAME_ID , 256, (void **)&ftrptr);\
		DmStrCopy(ftrptr,0,filename);\
		g_rom_system=0;\
		if (filename[1]=='N') g_rom_system=SYS_NES;\
		if (filename[1]=='S') g_rom_system=SYS_SNES;\
		if (filename[1]=='G') g_rom_system=SYS_GB;\
		if (filename[1]=='M') g_rom_system=SYS_GENZ;\
		if (filename[1]=='P') g_rom_system=SYS_NEOPOPZ;\
		if (filename[1]=='W') g_rom_system=SYS_OSWANZ;\
		if (filename[1]=='T') g_rom_system=SYS_TG16Z;	\
		if (filename[1]=='A') g_rom_system=SYS_SMS;	\
		if (filename[1]=='R') g_rom_system=SYS_GG;	\
		if (filename[1]=='V') g_rom_system=SYS_VCS;	\
		WinPushDrawState();										\
		col.r=0;col.g=0;col.b=0;\
		UIColorSetTableEntry(UIFormFill,&col);\
		UIColorSetTableEntry(UIObjectFill,&col);			\
		col.r=0;col.g=0;col.b=0;\
		UIColorSetTableEntry(UIFormFrame,&col);\
		UIColorSetTableEntry(UIObjectFrame,&col);			\
		Stop_Mod();\
		if (g_ljp_pref.g_showLaunchFX) DoNiceTransition(1);\
  		FrmGotoForm(BlankForm);\
  		WinPopDrawState(); \
	}\
	}


#endif
