#ifndef __3dngine_h__
#define __3dngine_h__


#ifndef int64
typedef signed long long int64;
#endif

extern Int32 funcSMULT1616(Int32 a,Int32 b,Int32 dummy1,Int32 dummy2);
extern Int32 funcUMULT1616(UInt32 a,UInt32 b,Int32 dummy1,Int32 dummy2);
extern Int32 funcSMULT32(Int32 a,Int32 b,Int32 dummy1,Int32 dummy2);
extern UInt32 funcUMULT32(UInt32 a,UInt32 b,Int32 dummy1,Int32 dummy2);
extern UInt32 funcUADDMULT1616(UInt32 a,UInt32 b,UInt32 c,UInt32 d);
extern Int32 funcSADDMULT1616(Int32 a,Int32 b,Int32 c,Int32 d);
extern Int32 funcSADDMULT32(Int32 a,Int32 b,Int32 c,Int32 d);
extern UInt32 funcUADDMULT32(UInt32 a,UInt32 b,UInt32 c,UInt32 d);


#define SMULT1616(res,a,b) {\
	res=funcSMULT1616(a,b,0,0);}
	
#define UMULT1616(res,a,b) {\
	res=funcUMULT1616(a,b,0,0);}
			
#define SMULT32(res,a,b) {\
	res=funcSMULT32(a,b,0,0);}
	
#define UMULT32(res,a,b) {\
	res=funcUMULT32(a,b,0,0);}
			
#define UADDMULT1616(res,a,b,c,d) {\
	res=funcUADDMULT1616(a,b,c,d);}
			
#define SADDMULT1616(res,a,b,c,d) {\
	res=funcSADDMULT1616(a,b,c,d);}

#define SADDMULT32(res,a,b,c,d) {\
	res=funcSADDMULT32(a,b,c,d);}
			
#define UADDMULT32(res,a,b,c,d) {\
	res=funcUADDMULT32(a,b,c,d);}
	


#define _fixpoint_shifter 16

#undef SCREEN_WIDTH
#define SCREEN_WIDTH 320
#undef SCREEN_HEIGHT
#define SCREEN_HEIGHT 320
#define SCREEN_WIDTH_2 160
#define SCREEN_HEIGHT_2 160
#define SCREEN_CENTER_X 160
#define SCREEN_CENTER_Y 160

#define TEXTURE_SIZE 63
#define TEXTURE_MASK 63
#define TEXTURE_SHIFT 6

#define ZclipMin 4<<_fixpoint_shifter
#define ZclipMax 512<<_fixpoint_shifter /*max : int32 et fixed point sur 16, donc 31>>16 -> 15 -> 32767*/


int y3DEngine_Init(char *filename,int star);
int y3DEngine_Render(unsigned char*vbuffer,int *interact_mode);
void y3DEngine_RenderAuto(uint8 *vbuffer,Int32 cpt);
int y3DEngine_Close(void);


typedef struct MS3DHeader						// File Header
{
	char m_ID[10];
	int m_version;
} MS3DHeader;
#define sizeof_MS3DHeader 14

typedef struct MS3DVertex						// Vertex info
{	
	char m_flags;
    float m_vertex[3];
	char m_boneID;
	char m_refCount;
} MS3DVertex;
#define sizeof_MS3DVertex 15

typedef struct MS3DTriangle						// Triangle info
{
	uint16 m_flags;
	uint16 m_vertexIndices[3];
	float m_vertexNormals[3][3];
	float m_s[3], m_t[3];
	char m_smoothingGroup;
	char m_groupIndex;
} MS3DTriangle;
#define sizeof_MS3DTriangle 70

typedef struct MS3DMaterial						// Material info
{
    char m_name[32];
    float m_ambient[4];
    float m_diffuse[4];
    float m_specular[4];
    float m_emissive[4];
    float m_shininess;					// 0.0f - 128.0f
    float m_transparency;				// 0.0f - 1.0f
    char m_mode;						// 0, 1, 2 (unused now)
    char m_texture[128];
    char m_alphamap[128];
} MS3DMaterial;
#define sizeof_MS3DMaterial 361


typedef struct Mesh								//	Mesh struct
{
	int m_materialIndex;
	int m_numTriangles;
	int *m_pTriangleIndices;
	int32 m_center[3];
	int32 m_position[3];
} Mesh;

typedef struct Triangle							//	Triangle struct
{
	int32 m_Normals[3];
	uint8 m_s[3], m_t[3];
	int m_vertexIndices[3];
	int m_Z;
	int32 m_NormalsTransformed[3];
	int mesh;
} Triangle;

typedef struct Vertex							//	Vertex struct
{	
	int32 m_location[3];	
	int32 m_transformed[3];	
	int32 m_projected[2];
	int32 m_normal[3];
	int32 m_transformednormal[3];		
	char m_boneID;	
	int mesh;
} Vertex;


#define SHOW_3D_INTRO(time_func) {\
    	UInt16 *buff,*p,*q;\
    	int i;\
    	buff=(UInt16*)malloc(320*320*2);\
    	if (!buff) {DEBUGS("Alloc error");}\
    	else\
    	{\
    		if (y3DEngine_Init("",1)) {DEBUGS("error at 3d init");}\
    		else\
    		{\
    			lastTick=time_func();\
			    for (;;)\
    			{\
	    			y3DEngine_RenderAuto(buff,time_func()-lastTick);\
	    			p=buff;\
		    		q=((UInt16*) g_pnobridge -> vram);\
		    		for (i=0;i<320;i++)\
		    		{\
	    				memcpy(q,p,320*2);\
						p+=320;\
						q+=g_pnobridge -> display_pitch;\
		    		}\
		    		EvtGetPen(&penX,&penY,&penDown);\
					if (penDown) break;\
			    }\
			    y3DEngine_Close();\
			}\
		    free(buff);\
		}\
	}

#endif

