#ifndef h_PNOMain_h
#define h_PNOMain_h

#include "pnobridge.h"

#ifdef __PACE__
#define LJP_HANDLE_EVENT(_pause_func) {\
			EventType myevent; \
			for (;;) {\
				if (stub_filter_event(&myevent)) {\
					if (_pause_func) _pause_func(1);\
					stub_handle_sysevent(&myevent);\
					if (_pause_func) _pause_func(0);\
				} else break;\
			}\
		}

#define LJP_HANDLE_EVENT_NOFUNC() {\
			EventType myevent; \
			for (;;) {\
				if (stub_filter_event(&myevent)) {\
					stub_handle_sysevent(&myevent);\
				} else break;\
			}\
		}		
#else
#include "palmos5.h"
#define LJP_HANDLE_EVENT(_pause_func) {\
		EventType myevent; \
		EvtFlushKeyQueue();\
		EvtFlushPenQueue();\
		while (SysEventAvail()) {\
		  	SysEventGet(&myevent,0); \
			if (myevent.eType==nilEvent) break; \
			switch (myevent.eType){\
				case appStopEvent:if (menu_confirm("Exit emulator ?")) mStopEmulation=1;\
				case keyDownEvent:\
				case keyUpEvent:\
				case keyHoldEvent:\
				case penDownEvent:\
				case penUpEvent:\
				case penMoveEvent:\
					break;\
				case winExitEvent:\
					_pause_func(1);\
					break;\
				case winEnterEvent:\
					_pause_func(0);\
				case frmUpdateEvent:\
				case winDisplayChangedEvent:{\
					WinHandle winh;\
				    BitmapType *winb;\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					WinPushDrawState();\
					WinSetCoordinateSystem(kCoordinatesNative);\
					WinGetDisplayExtent(&display_width,&display_height);\
					WinPopDrawState();\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					ClearScreen();\
					break;}\
				default:{\
					_pause_func(1);\
					SysHandleEvent(&myevent);\
					_pause_func(0);\
				}\
			}\
		}\
		}
#define LJP_HANDLE_EVENT_NOFUNC()  {\
		EventType myevent; \
		while ( SysEventAvail()) {\
		  	SysEventGet(&myevent,0); \
			if (myevent.eType==nilEvent) break; \
			switch (myevent.eType){\
				case appStopEvent:penDown=1;if (menu_confirm("Exit emulator ?")) result=2;else result=1;break;\
				case winEnterEvent:\
				case frmUpdateEvent:\
				case penDownEvent:\
				case penUpEvent:\
				case penMoveEvent:\
				case keyDownEvent:\
				case keyUpEvent:\
				case keyHoldEvent:\
				case winExitEvent:\
				SysHandleEvent(&myevent);break;\
				case winDisplayChangedEvent:{\
					WinHandle winh;\
				    BitmapType *winb;\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					WinPushDrawState();\
					WinSetCoordinateSystem(kCoordinatesNative);\
					WinGetDisplayExtent(&display_width,&display_height);\
					WinPopDrawState();\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					ClearScreen();\
					result=1;penDown=1;\
					break;}\
				default:{\
					SysHandleEvent(&myevent);\
				}\
			}\
		}\
		}  

  

#endif	

#define SCR_BUT_WIDTH 100

#define LJP_CHECK_MENU_ACCESS(_menu_func,_videomode_fullscreen) {\
			EvtGetPen(&penX,&penY,&penDown);\
			penX*=_PEN_ADJUST_FACTORX_;\
			penY*=_PEN_ADJUST_FACTORY_;\
			if (penDown) {\
			 	if ((penY>0)&&(penY<SCR_BUT_WIDTH)&&(penX>display_width-SCR_BUT_WIDTH)&&(penX<display_width)) keys|=BTN_TR;\
				else if ((penY>display_height-SCR_BUT_WIDTH-(_videomode_fullscreen?0:BELTBAR_SIZE))&&(penY<display_height-(_videomode_fullscreen?0:BELTBAR_SIZE))&&(penX>display_width-SCR_BUT_WIDTH)&&(penX<display_width)) keys|=BTN_BR;\
				else if ((penY>0)&&(penY<SCR_BUT_WIDTH)&&(penX>0)&&(penX<SCR_BUT_WIDTH)) keys|=BTN_TL;\
				else if ((penY>display_height-SCR_BUT_WIDTH-(_videomode_fullscreen?0:BELTBAR_SIZE))&&(penY<display_height-(_videomode_fullscreen?0:BELTBAR_SIZE))&&(penX>0)&&(penX<SCR_BUT_WIDTH)) keys|=BTN_BL;\
				else if ((penY>display_height-(_videomode_fullscreen?0:BELTBAR_SIZE))&&(penY<display_height)) beltbar_click(penX);\
				else if ((penX>0)&&(penX<display_width)&&(penY>0)&&(penY<display_height-(_videomode_fullscreen?0:BELTBAR_SIZE))){\
					WinHandle winh;\
				    BitmapType *winb;\
					stub_fullscreen(0);\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					WinPushDrawState();\
					WinSetCoordinateSystem(kCoordinatesNative);\
					WinGetDisplayExtent(&display_width,&display_height);\
					WinPopDrawState();\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					switch (_menu_func()) {\
						case 1:mStopEmulation=1;break;\
					}\
					if (_videomode_fullscreen) stub_fullscreen(1);\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					WinPushDrawState();\
					WinSetCoordinateSystem(kCoordinatesNative);\
					WinGetDisplayExtent(&display_width,&display_height);\
					WinPopDrawState();\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					if (!(_videomode_fullscreen)) stub_DrawBeltBar();\
					ClearScreen();\
				}\
			}	\
		}

#define LJP_UPDATE_KEYS {\
	if ((keys==BTN_TL)||(keys==BTN_TR)||(keys==BTN_BL)||(keys==BTN_BR)){\
	for (int i=0;i<20;i++)\
		 if (g_confinput[i]!=0)\
				if (keys==g_confinput[i]) keyval|=g_translateBtn[i];\
	}\
	else { \
	for (int i=0;i<20;i++)\
		 if (g_confinput[i]!=0)\
				if ( (keys & g_confinput[i])==g_confinput[i]) keyval|=g_translateBtn[i];\
	}\
}

#define LJP_WAIT(ms) {\
	int i=GetTickCount();\
	while ((GetTickCount()-i)<ms);\
	}
	
extern UInt32 ljp_showBeltbar;

#define BELTBAR_SIZE   (ljp_showBeltbar ? SCR_ADJ(32) : 0)
#define SHOW_OVERWRITE (ljp_confirmOW ? menu_confirm("Overwrite ?") : 1)
#define CONFIRM_SAVE   (ljp_confirmSL ? menu_confirm("Save state ?") : 1)
#define CONFIRM_LOAD   (ljp_confirmSL ? menu_confirm("Load state ?") : 1)
		
extern UInt16 ticks_per_sec;
extern pnobridge_t *g_pnobridge;
extern const void *g_my_emulStateP;
extern UInt16 display_pitch,display_height,display_width;


UInt32 host_events ( UInt32 foo );
int rand(void);

Int32 GetTickCount();

/*double cos(double a);
double sin(double a);
double tan(double a);
double atan(double a);
double sqrt(double a);
*/

Err stub_SndStreamCreate(SndStreamRef *channel,	/* channel-ID is stored here */
						SndStreamMode mode,			/* input/output, enum */
						UInt32 samplerate,				/* in frames/second, e.g. 44100, 48000 */
						SndSampleType type,				/* enum, e.g. sndInt16 */
						SndStreamWidth width,			/* enum, e.g. sndMono */
						SndStreamBufferCallback func,	/* function that gets called to fill a buffer */
						void *userdata,					/* gets passed in to the above function */
						UInt32 buffsize,				/* preferred buffersize in frames, not guaranteed, use 0 for default */
						Boolean armNative);
Err stub_SndStreamDelete(SndStreamRef channel);
Err stub_SndStreamStart(SndStreamRef channel);
Err stub_SndStreamStop(SndStreamRef channel);
Err stub_SndStreamSetVolume(SndStreamRef channel, Int32 volume);
Err stub_SndStreamGetVolume(SndStreamRef channel, Int32 *volume);
Err stub_DrawBeltBar(void);

void stub_fullscreen(int fs);
UInt32 stubzodiacblit ( UInt32 mode, UInt32 w,UInt32 h,UInt32 s );
UInt32 stub_BatteryInfo(void);

#endif
