
#include "palmdep.h"
#include "ljPRsc.h"
#include "App_Cst.h"
#include "pnobridge.h"
#include "PNOMain.h"

//#define BELTBAR_SIZE 32
#define BELTBAR_BTNSIZE 32

#define	BELTBAR_ACTION_LAUNCHER 2
#define	BELTBAR_ACTION_QUICKSAVE 4
#define	BELTBAR_ACTION_QUICKLOAD 8
#define	BELTBAR_ACTION_SOUND 16
#define	BELTBAR_ACTION_RESET 32
#define	BELTBAR_ACTION_FPS 64
#define	BELTBAR_ACTION_BATTERY 128
#define	BELTBAR_ACTION_CLOCK 256


int bar_cmd[10] = {
	BELTBAR_ACTION_LAUNCHER,
	BELTBAR_ACTION_QUICKSAVE,
	BELTBAR_ACTION_QUICKLOAD,
	BELTBAR_ACTION_SOUND,
	BELTBAR_ACTION_RESET,
	BELTBAR_ACTION_FPS,
	BELTBAR_ACTION_FPS,
	BELTBAR_ACTION_BATTERY,
	BELTBAR_ACTION_CLOCK,
	BELTBAR_ACTION_CLOCK
};

//externs
extern int mStopEmulation;
extern void emu_resettimer(void);

extern UInt32 ljp_showFPS, ljp_showBattMode, ljp_isLowRes;

#ifdef _SMSGG_
	extern void smsgg_quicksave(void);
	extern void smsgg_quickload(void);
	extern void smsgg_changefskip(void);
	extern void smsgg_togglesound(void);
	extern void smsgg_reset(void);
	extern void smsgg_pause(int);
	#define qsavefunc smsgg_quicksave
	#define qloadfunc smsgg_quickload
	#define fskipfunc smsgg_changefskip
	#define soundfunc smsgg_togglesound
	#define resetfunc smsgg_reset
	#define pausefunc smsgg_pause
#else
	#ifdef _VCS_
		extern void vcs_quicksave(void);
		extern void vcs_quickload(void);
		extern void vcs_changefskip(void);
		extern void vcs_togglesound(void);
		extern void vcs_reset(void);
		extern void vcs_pause(int);
		#define qsavefunc vcs_quicksave
		#define qloadfunc vcs_quickload
		#define fskipfunc vcs_changefskip
		#define soundfunc vcs_togglesound
		#define resetfunc vcs_reset
		#define pausefunc vcs_pause
	#else
		#ifdef _GB_
			extern void fgbZ_quicksave(void);
			extern void fgbZ_quickload(void);
			extern void fgbZ_changefskip(void);
			extern void fgbZ_togglesound(void);
			extern void fgbZ_reset(void);
			extern void fgbZ_pause(int);
			#define qsavefunc fgbZ_quicksave
			#define qloadfunc fgbZ_quickload
			#define fskipfunc fgbZ_changefskip
			#define soundfunc fgbZ_togglesound
			#define resetfunc fgbZ_reset
			#define pausefunc fgbZ_pause
		#else
			#ifdef _GENZ_
				extern void genZ_quicksave(void);
				extern void genZ_quickload(void);
				extern void genZ_changefskip(void);
				extern void genZ_togglesound(void);
				extern void genZ_reset(void);
				extern void genZ_pause(int);
				#define qsavefunc genZ_quicksave
				#define qloadfunc genZ_quickload
				#define fskipfunc genZ_changefskip
				#define soundfunc genZ_togglesound
				#define resetfunc genZ_reset
				#define pausefunc genZ_pause
			#else
				#ifdef _NES_
					extern void NES_quicksave(void);
					extern void NES_quickload(void);
					extern void lj_changefskip(void);
					extern void NES_togglesound(void);
					extern void NES_reset(void);
					extern void ljZ_PauseAudio(int);
					#define qsavefunc NES_quicksave
					#define qloadfunc NES_quickload
					#define fskipfunc lj_changefskip
					#define soundfunc NES_togglesound
					#define resetfunc NES_reset
					#define pausefunc ljZ_PauseAudio
				#else
					#ifdef _SNES_
						extern void SNES_quicksave(void);
						extern void SNES_quickload(void);
						extern void os9x_changefskip(void);
						extern void SNES_togglesound(void);
						extern void SNES_reset(void);
						extern void os9x_pause(int);
						#define qsavefunc SNES_quicksave
						#define qloadfunc SNES_quickload
						#define fskipfunc os9x_changefskip
						#define soundfunc SNES_togglesound
						#define resetfunc SNES_reset
						#define pausefunc os9x_pause
					#else
						#ifdef _NEOPOPZ_
							extern void neopopZ_quicksave(void);
							extern void neopopZ_quickload(void);
							extern void neopopZ_changefskip(void);
							extern void neopopZ_togglesound(void);
							extern void neopopZ_reset(void);
							extern void neopopZ_pause(int);
							#define qsavefunc neopopZ_quicksave
							#define qloadfunc neopopZ_quickload
							#define fskipfunc neopopZ_changefskip
							#define soundfunc neopopZ_togglesound
							#define resetfunc neopopZ_reset
							#define pausefunc neopopZ_pause
						#else
							#ifdef _WS_
								extern void oswanZ_quicksave(void);
								extern void oswanZ_quickload(void);
								extern void oswanZ_changefskip(void);
								extern void oswanZ_togglesound(void);
								extern void oswanZ_reset(void);
								extern void oswanZ_pause(int);
								#define qsavefunc oswanZ_quicksave
								#define qloadfunc oswanZ_quickload
								#define fskipfunc oswanZ_changefskip
								#define soundfunc oswanZ_togglesound
								#define resetfunc oswanZ_reset
								#define pausefunc oswanZ_pause
							#else
								#ifdef _TG16_
									extern void tg16_quicksave(void);
									extern void tg16_quickload(void);
									extern void tg16_changefskip(void);
									extern void tg16_togglesound(void);
									extern void tg16_reset(void);
									extern void tg16_pause(int);
									#define qsavefunc tg16_quicksave
									#define qloadfunc tg16_quickload
									#define fskipfunc tg16_changefskip
									#define soundfunc tg16_togglesound
									#define resetfunc tg16_reset
									#define pausefunc tg16_pause
								#else
									#ifdef _EMPTY_ //replace 'empty' here and copy whole block below
										extern void empty_quicksave(void);
										extern void empty_quickload(void);
										extern void empty_changefskip(void);
										extern void empty_togglesound(void);
										extern void empty_reset(void);
										extern void empty_pause(int);
										#define qsavefunc empty_quicksave
										#define qloadfunc empty_quickload
										#define fskipfunc empty_changefskip
										#define soundfunc empty_togglesound
										#define resetfunc empty_reset
										#define pausefunc empty_pause
									#endif
								#endif
							#endif
						#endif
					#endif
				#endif
			#endif
		#endif
	#endif
#endif
		
//control vars
//char batt_disp = 1; // 1=bar  2=percent  3=voltage

int beltbar_click(int x)
{
	int btn = (x / SCR_ADJ(BELTBAR_BTNSIZE));
	int result = 0;
	
	/*char tmp[16];
	sprintf(tmp,"beltbar btn %d",btn);
	menu_message(tmp);menu_waitPen(NULL,NULL,1);*/
	
	switch (bar_cmd[btn]) {
		case BELTBAR_ACTION_LAUNCHER:
			pausefunc(1);
			if (menu_confirm("Exit emulator ?")) mStopEmulation=1;
			pausefunc(0);
			break;
		case BELTBAR_ACTION_QUICKSAVE:
			qsavefunc();
			break;
		case BELTBAR_ACTION_QUICKLOAD:
			qloadfunc();
			break;
		case BELTBAR_ACTION_SOUND:
			soundfunc();
			break;
		case BELTBAR_ACTION_RESET:
			resetfunc();
			break;
	}
	
	if ( (x > (5*SCR_ADJ(BELTBAR_BTNSIZE)) ) && (x < (5*SCR_ADJ(BELTBAR_BTNSIZE) + 42) ) ) {
		//clicked FPS - change frameskip
		fskipfunc();
	} else if ( (x > (6*SCR_ADJ(BELTBAR_BTNSIZE) + 16) ) && (x < (6*SCR_ADJ(BELTBAR_BTNSIZE) + 52) ) ) {
		//clicked battery - change battery meter display mode
		
		pausefunc(1);
		
		ljp_showBattMode++;
		if (ljp_showBattMode > 3) ljp_showBattMode = 1;
		
		if (ljp_showBattMode==1) menu_message("Battery : Bar");
		else if (ljp_showBattMode==2) menu_message("Battery : Percent");
		else menu_message("Battery : Voltage");
		
		LJP_WAIT(300);
		emu_resettimer();
		
		pausefunc(0);
	}
}

#define draw_bmp(id,X,Y) {\
	hRsc = DmGetResource(bitmapRsc, id);\
	if (hRsc)\
	{	BitmapType* bitmapP = (BitmapType*) MemHandleLock(hRsc);\
		WinPaintBitmap(bitmapP, X/2, Y/2);\
		MemHandleUnlock(hRsc);\
		DmReleaseResource(hRsc);\
	}\
}

void beltbar_draw(int x, int y, int pitch, int fps, char redraw, UInt8* vram)
{
	MemHandle hRsc=NULL;
	char text[4];
	UInt8* vr=vram;
	
	//extern UInt32 ljp_showFPS, ljp_showClock, ljp_showBattery, ljp_showBattMode;
	
	
	
	//Battery - 6* + 18
	//if ( (ljp_showBattery) || (ljp_showClock) ) {
	if ( (ljp_showBeltbar) ) {
		RGBColorType fg;
		UInt32 pluggedIn,percent,voltage;
		DateTimeType date_time;			
		UInt32 seconds;
		RectangleType rect;	
		int penDown;
		char tmpstring[32];
		int basex, basey, tmpx;
	
		/*if (ljp_showBattery)*/ {
			basex = x*(ljp_isLowRes ? 1 : 2) + ((6*BELTBAR_BTNSIZE) + 18) / 2;
			basey = (y+SCR_ADJ(12)) / (ljp_isLowRes ? 1 : 2);
	
			for (int i=y+SCR_ADJ(12); i<(y+BELTBAR_SIZE); i++)
			{
				vr=vram + (i* pitch*2) + (x + (6*BELTBAR_BTNSIZE) + 18)*SCR_ADJ(2); //do not try to understand why I put the SCR_ADJ there... :P --Tinnus
				memset(vr,0,36*SCR_ADJ(2));
			}
		
			if (ljp_showBattMode<3) {
				percent=stub_BatteryInfo();pluggedIn=percent>>8;percent&=0xFF;
			} else {
				voltage=stub_BatteryInfo2();pluggedIn=voltage>>16;voltage&=0xFFFF;
			}
		
			WinPushDrawState ();
			if (ljp_isLowRes) WinSetCoordinateSystem(kCoordinatesNative);
			switch (ljp_showBattMode) {
				case 1:
					fg.r=240;fg.g=230;fg.b=190;
					WinSetForeColorRGB(&fg,NULL);
					WinSetDrawMode(winPaint);
					rect.topLeft.x=basex+1;
					rect.topLeft.y=basey+1;
					rect.extent.x=15;
					rect.extent.y=8;
					WinPaintRectangle(&rect,0);
					rect.topLeft.x=basex+16;
					rect.topLeft.y=basey+3;
					rect.extent.x=2;
					rect.extent.y=4;
					WinPaintRectangle(&rect,0);
					fg.r=0;fg.g=0;fg.b=0;
					WinSetForeColorRGB(&fg,NULL);
					rect.topLeft.x=basex+2;
					rect.topLeft.y=basey+2;
					rect.extent.x=13;
					rect.extent.y=6;
					WinPaintRectangle(&rect,0);
					fg.r=255;fg.g=255;fg.b=200;
					WinSetForeColorRGB(&fg,NULL);
					rect.topLeft.y=basey+3;
					rect.extent.x=percent/10 + 1;
					rect.extent.y=4;
			
					rect.topLeft.x=basex+3;
					WinPaintRectangle(&rect,0);
			
					break;
				case 2:		
					sprintf(tmpstring,"%d",percent);
					if (percent==100) {
						tmpx = basex * 2 + 1;
					} else {
						tmpx = basex * 2 + 7;
					}
					menu_messageRaw(tmpx,basey*2,tmpstring);
			
					break;
				case 3:
					sprintf(tmpstring,"%d",voltage);
					tmpx = basex * 2 + 1;
					menu_messageRaw(tmpx,basey*2,tmpstring);
			
					break;
			}
	
			if (pluggedIn) {
				fg.r=255;fg.g=255;fg.b=0;
				WinSetForeColorRGB(&fg,NULL);
				WinDrawLine(basex+10,basey+0,basex+6,basey+5);WinDrawLine(basex+11,basey+0,basex+7,basey+4);
				WinDrawLine(basex+7,basey+4,basex+10,basey+4);WinDrawLine(basex+6,basey+5,basex+10,basey+5);
				WinDrawLine(basex+10,basey+5,basex+6,basey+9);WinDrawLine(basex+11,basey+4,basex+7,basey+9);
			}
	
			WinPopDrawState();
	
		}	
	
		/*if (ljp_showClock)*/ {
			//Clock - 7* + 24
			basex = (x + (7*BELTBAR_BTNSIZE) + 16) /*/ 2*/; basey*=2;
		
			for (int i=basey; i<(y+BELTBAR_SIZE); i++)
			{
				vr=vram + (i* pitch*2) + (x + (basex+20))*SCR_ADJ(2);
				memset(vr,0,54*SCR_ADJ(2));
			}
	
			if (ljp_isLowRes) basey+=3;
	
			seconds=TimGetSeconds();
			TimSecondsToDateTime(seconds,&date_time);
			sprintf(tmpstring,"%02d:%02d",date_time.hour,date_time.minute);
			//WinPaintChars(tmpstring,strlen(tmpstring),basex+20,basey);
			menu_messageRaw(basex+20,basey,tmpstring);
		}
		
		//FPS - 5* + 4
		if (ljp_showFPS) {
			for (int i=basey; i<(y+BELTBAR_SIZE); i++)
			{
				vr=vram + (i* pitch*2) + (x + (5*BELTBAR_BTNSIZE) + 2)*SCR_ADJ(2);
				memset(vr,0,38*SCR_ADJ(2));
			}
			text[0]=((fps/100)%10)+48;
			text[1]=((fps/10)%10)+48;
			text[2]=((fps)%10)+48;
			text[3]=0;
			menu_messageRaw(x + (5*BELTBAR_BTNSIZE) + 4,basey,text);
		}
	}
}






