
#include "neopop.h"
#include "TLCS900H.h"
#include "interrupt.h"
#include "mem.h"
#include "bios.h"
#include "dma.h"

//=========================================================================
_u8  f_dash;
//_u32 gprBank[4][4], gprBank[4][4];
tw tlcs;

/*
_u8   rg->opcode1;    //The opcode1 byte o_pcode
_u8   rg->opcode2;   //The opcode2 o_pcode
_u8   rg->regsel;      	//big rg->regsel
_u32  rg->memadr;    	//Result of addressing mode
int   rg->argsize;   	//operand rg->argsize, 0 = Byte, 1 = Word, 2 = Long
_u8   rg->slot;    //The slot big cache code
BOOL  rg->regvector;   //Register code used?
_u8   rg->timer;     //How many state changes?
_u8   rg->timer; //How many extra state changes?
*/

//_u32 ipc;
//_u8*  gpcptr;
//_u16 (rg->status);

_u8* _ipc;
//_u32 _ipcr;


//=============================================================================


//=========================================================================

__inline void inchangedSP(tw*rg)
{
  int base;
  rg->statusRFP = (((rg->status) & 0x300) >> 8);

/*
  //Previous
  rg->index[0x14] = (((rg->statusRFP-1)&3)<<4)+0x0;
  rg->index[0x15] = (((rg->statusRFP-1)&3)<<4)+0x4;
  rg->index[0x16] = (((rg->statusRFP-1)&3)<<4)+0x8;
  rg->index[0x17] = (((rg->statusRFP-1)&3)<<4)+0xC;
*/

  base = (rg->statusRFP<<4);
  //Current
  rg->index[0x18] = base+0x0;
  rg->index[0x19] = base+0x4;
  rg->index[0x1A] = base+0x8;
  rg->index[0x1B] = base+0xC;
}

void changedSP(tw*rg)
{
	inchangedSP(rg);
}

//=============================================================================

_u8 statusIFF(tw*rg) 
{
  _u8 iff = ((rg->status) & 0x7000) >> 12;

  if (iff == 1)
    return 0;
  else
    return iff;
}

void setStatusIFF(tw*rg,_u8 iff)
{
  (rg->status) = ((rg->status) & 0x8FFF) | ((iff & 0x7) << 12);
}

//=============================================================================

__inline void setStatusRFP(tw*rg,_u8 rfp)
{
  (rg->status) = ((rg->status) & 0xF8FF) | ((rfp & 0x3) << 8);
  inchangedSP(rg);
}


_u32 rErr;

//=============================================================================
// POKE - start
__inline void parityB(tw*rg,_u8 value)
{
  // On replie tous les bits sur le bit 2 (avec les xor-ca fait parit)
  value ^= value>>4;
  value ^= value<<2;
  value ^= value>>1;
  (rg->status)	= ((rg->status)&0xFFFB)|((~value)&4);
	//  SETFLAG_V((count & 1) == 0);
}

__inline void parityW(tw*rg,_u16 value)
{
  // On replie tous les bits sur le bit 2 (avec les xor-ca fait parit)
  value ^= value>>8;
  value ^= value>>4;
  value ^= value<<2;
  value ^= value>>1;
  (rg->status)	= ((rg->status)&0xFFFB)|((~value)&4);
  //SETFLAG_V((count & 1) == 0);
}
// POKE - end

//=========================================================================

//=============================================================================

__inline _u16 generic_DIV_B(tw*rg,_u16 val, _u8 div)
{
  if (div == 0)
  { 
    SETFLAG_V1
    return (val << 8) | ((val >> 8) ^ 0xFF);
  }
  else
  {
    _u16 quo = val / (_u16)div;
    _u16 rem = val % (_u16)div;
    if (quo > 0xFF) SETFLAG_V1 else SETFLAG_V0
    return (quo & 0xFF) | ((rem & 0xFF) << 8);
  }
}

__inline _u32 generic_DIV_W(tw*rg,_u32 val, _u16 div)
{
  if (div == 0)
  { 
    SETFLAG_V1
    return (val << 16) | ((val >> 16) ^ 0xFFFF);
  }
  else
  {
    _u32 quo = val / (_u32)div;
    _u32 rem = val % (_u32)div;
    if (quo > 0xFFFF) SETFLAG_V1 else SETFLAG_V0
    return (quo & 0xFFFF) | ((rem & 0xFFFF) << 16);
  }
}

//=============================================================================

__inline _u16 generic_DIVS_B(tw*rg,_s16 val, _s8 div)
{
  if (div == 0)
  {
    SETFLAG_V1
    return (val << 8) | ((val >> 8) ^ 0xFF);
  }
  else
  {
    _s16 quo = val / (_s16)div;
    _s16 rem = val % (_s16)div;
    if (quo > 0xFF) SETFLAG_V1 else SETFLAG_V0
    return (quo & 0xFF) | ((rem & 0xFF) << 8);
  }
}

__inline _u32 generic_DIVS_W(tw*rg,_s32 val, _s16 div)
{
  if (div == 0)
  {
    SETFLAG_V1
    return (val << 16) | ((val >> 16) ^ 0xFFFF);
  }
  else
  {
    _s32 quo = val / (_s32)div;
    _s32 rem = val % (_s32)div;
    if (quo > 0xFFFF) SETFLAG_V1 else SETFLAG_V0
    return (quo & 0xFFFF) | ((rem & 0xFFFF) << 16);
  }
}

//=============================================================================

__inline _u8 generic_ADD_B(tw*rg,_u8 dst, _u8 src)
{
  _u8 half = (dst & 0xF) + (src & 0xF);
  _u32 resultC = (_u32)dst + (_u32)src;
  _u8 result = (_u8)(resultC & 0xFF);

  SETFLAG_S(result & 0x80);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

//  if ((((_s8)dst >= 0) && ((_s8)src >= 0) && ((_s8)result < 0)) ||
//    (((_s8)dst < 0)  && ((_s8)src < 0) && ((_s8)result >= 0)))
//  {SETFLAG_V1} else {SETFLAG_V0}

//  if ((TRUE && TRUE && FALSE) || ((FALSE  && FALSE && TRUE))
// donc FALSE ou FALSE => FALSE donc seulement SETFLAG_V0
//  {SETFLAG_V1} else {SETFLAG_V0}
//SETFLAG_V0;

  if ((((_s8)dst >= 0) && ((_s8)src >= 0) && ((_s8)result < 0)) ||
    (((_s8)dst < 0)  && ((_s8)src < 0) && ((_s8)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}

  SETFLAG_N0;
  SETFLAG_C(resultC > 0xFF);

  return result;
}

__inline _u16 generic_ADD_W(tw*rg,_u16 dst, _u16 src)
{
  _u16 half = (dst & 0xF) + (src & 0xF);
  _u32 resultC = (_u32)dst + (_u32)src;
  _u16 result = (_u16)(resultC & 0xFFFF);

  SETFLAG_S(result & 0x8000);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

  if ((((_s16)dst >= 0) && ((_s16)src >= 0) && ((_s16)result < 0)) ||
      (((_s16)dst < 0)  && ((_s16)src < 0) && ((_s16)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}


  SETFLAG_N0;
  SETFLAG_C(resultC > 0xFFFF);

  return result;
}

__inline _u32 generic_ADD_L(tw*rg,_u32 dst, _u32 src)
{
  _u64 resultC = (_u64)dst + (_u64)src;
  _u32 result = (_u32)(resultC & 0xFFFFFFFF);

  SETFLAG_S(result & 0x80000000);
  SETFLAG_Z(result == 0);

  if ((((_s32)dst >= 0) && ((_s32)src >= 0) && ((_s32)result < 0)) || 
    (((_s32)dst < 0)  && ((_s32)src < 0) && ((_s32)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}

  
  SETFLAG_N0;
  SETFLAG_C(resultC > 0xFFFFFFFF);

  return result;
}

//=============================================================================

__inline _u8 generic_ADC_B(tw*rg,_u8 dst, _u8 src)
{
  _u8 half = (dst & 0xF) + (src & 0xF) + FLAG_C;
  _u32 resultC = (_u32)dst + (_u32)src + (_u32)FLAG_C;
  _u8 result = (_u8)(resultC & 0xFF);

  SETFLAG_S(result & 0x80);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

  if ((((_s8)dst >= 0) && ((_s8)src >= 0) && ((_s8)result < 0)) ||
    (((_s8)dst < 0)  && ((_s8)src < 0) && ((_s8)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}

  SETFLAG_N0;
  SETFLAG_C(resultC > 0xFF);

  return result;
}

__inline _u16 generic_ADC_W(tw*rg,_u16 dst, _u16 src)
{
  _u16 half = (dst & 0xF) + (src & 0xF) + FLAG_C;
  _u32 resultC = (_u32)dst + (_u32)src + (_u32)FLAG_C;
  _u16 result = (_u16)(resultC & 0xFFFF);

  SETFLAG_S(result & 0x8000);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

  if ((((_s16)dst >= 0) && ((_s16)src >= 0) && ((_s16)result < 0)) || 
    (((_s16)dst < 0)  && ((_s16)src < 0) && ((_s16)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}


  SETFLAG_N0;
  SETFLAG_C(resultC > 0xFFFF);

  return result;
}

__inline _u32 generic_ADC_L(tw*rg,_u32 dst, _u32 src)
{
  _u64 resultC = (_u64)dst + (_u64)src + (_u64)FLAG_C;
  _u32 result = (_u32)(resultC & 0xFFFFFFFF);

  SETFLAG_S(result & 0x80000000);
  SETFLAG_Z(result == 0);

  if ((((_s32)dst >= 0) && ((_s32)src >= 0) && ((_s32)result < 0)) || 
    (((_s32)dst < 0)  && ((_s32)src < 0) && ((_s32)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}
  
  SETFLAG_N0;
  SETFLAG_C(resultC > 0xFFFFFFFF);

  return result;
}

//=============================================================================

__inline _u8 xgeneric_SUB_B(tw*rg,_u8 dst, _u8 src)
{
  _u8 half = (dst & 0xF) - (src & 0xF);
  _u32 resultC = (_u32)dst - (_u32)src;
  _u8 result = (_u8)(resultC & 0xFF);

  SETFLAG_S(result & 0x80);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

  if ((((_s8)dst >= 0) && ((_s8)src < 0) && ((_s8)result < 0)) ||
    (((_s8)dst < 0) && ((_s8)src >= 0) && ((_s8)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}

  SETFLAG_N1;
  SETFLAG_C(resultC > 0xFF);

  return result;
}

__inline _u16 xgeneric_SUB_W(tw*rg,_u16 dst, _u16 src)
{
  _u16 half = (dst & 0xF) - (src & 0xF);
  _u32 resultC = (_u32)dst - (_u32)src;
  _u16 result = (_u16)(resultC & 0xFFFF);

  SETFLAG_S(result & 0x8000);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

  if ((((_s16)dst >= 0) && ((_s16)src < 0) && ((_s16)result < 0)) ||
    (((_s16)dst < 0) && ((_s16)src >= 0) && ((_s16)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}

  SETFLAG_N1;
  SETFLAG_C(resultC > 0xFFFF);

  return result;
}

__inline _u32 xgeneric_SUB_L(tw*rg,_u32 dst, _u32 src)
{
  _u64 resultC = (_u64)dst - (_u64)src;
  _u32 result = (_u32)(resultC & 0xFFFFFFFF);

  SETFLAG_S(result & 0x80000000);
  SETFLAG_Z(result == 0);

  if ((((_s32)dst >= 0) && ((_s32)src < 0) && ((_s32)result < 0)) ||
    (((_s32)dst < 0) && ((_s32)src >= 0) && ((_s32)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}


  SETFLAG_N1;
  SETFLAG_C(resultC > 0xFFFFFFFF);

  return result;
}

//=============================================================================

__inline _u8 generic_SBC_B(tw*rg,_u8 dst, _u8 src)
{
  _u8 half = (dst & 0xF) - (src & 0xF) - FLAG_C;
  _u32 resultC = (_u32)dst - (_u32)src - (_u32)FLAG_C;
  _u8 result = (_u8)(resultC & 0xFF);

  SETFLAG_S(result & 0x80);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

  if ((((_s8)dst >= 0) && ((_s8)src < 0) && ((_s8)result < 0)) ||
    (((_s8)dst < 0) && ((_s8)src >= 0) && ((_s8)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}

  SETFLAG_N1;
  SETFLAG_C(resultC > 0xFF);

  return result;
}

__inline _u16 generic_SBC_W(tw*rg,_u16 dst, _u16 src)
{
  _u16 half = (dst & 0xF) - (src & 0xF) - FLAG_C;
  _u32 resultC = (_u32)dst - (_u32)src - (_u32)FLAG_C;
  _u16 result = (_u16)(resultC & 0xFFFF);

  SETFLAG_S(result & 0x8000);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

  if ((((_s16)dst >= 0) && ((_s16)src < 0) && ((_s16)result < 0)) ||
    (((_s16)dst < 0) && ((_s16)src >= 0) && ((_s16)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}

  SETFLAG_N1;
  SETFLAG_C(resultC > 0xFFFF);

  return result;
}

__inline _u32 generic_SBC_L(tw*rg,_u32 dst, _u32 src)
{
  _u64 resultC = (_u64)dst - (_u64)src - (_u64)FLAG_C;
  _u32 result = (_u32)(resultC & 0xFFFFFFFF);

  SETFLAG_S(result & 0x80000000);
  SETFLAG_Z(result == 0);

  if ((((_s32)dst >= 0) && ((_s32)src < 0) && ((_s32)result < 0)) ||
    (((_s32)dst < 0) && ((_s32)src >= 0) && ((_s32)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}

  
  SETFLAG_N1;
  SETFLAG_C(resultC > 0xFFFFFFFF);

  return result;
}

extern asm_generic_ADD_B(_u32 dst, _u32 src,_u16* flags);
extern asm_generic_ADD_W(_u32 dst, _u32 src,_u16* flags);
extern asm_generic_ADD_L(_u32 dst, _u32 src,_u16* flags);
extern asm_generic_SUB_B(_u32 dst, _u32 src,_u16* flags);
extern asm_generic_SUB_W(_u32 dst, _u32 src,_u16* flags);
extern asm_generic_SUB_L(_u32 dst, _u32 src,_u16* flags);



#define generic_ADD_B(rg,a,b) asm_generic_ADD_B(a,b,&(rg->status)) 
#define generic_ADD_W(rg,a,b) asm_generic_ADD_W(a,b,&(rg->status)) 
#define generic_ADD_L(rg,a,b) asm_generic_ADD_L(a,b,&(rg->status)) 
//#define generic_ADC_B(rg,a,b) asm_generic_ADC_B(a,b,&(rg->status)) 
//#define generic_ADC_W(rg,a,b) asm_generic_ADC_W(a,b,&(rg->status)) 
//#define generic_ADC_L(rg,a,b) asm_generic_ADC_L(a,b,&(rg->status)) 

#define generic_SUB_B(rg,a,b) asm_generic_SUB_B(a,b,&(rg->status)) 
#define generic_SUB_W(rg,a,b) asm_generic_SUB_W(a,b,&(rg->status)) 
#define generic_SUB_L(rg,a,b) asm_generic_SUB_L(a,b,&(rg->status)) 
//#define generic_SBC_B(rg,a,b) asm_generic_SBC_B(a,b,&(rg->status)) 
//#define generic_SBC_W(rg,a,b) asm_generic_SBC_W(a,b,&(rg->status)) 
//#define generic_SBC_L(rg,a,b) asm_generic_SBC_L(a,b,&(rg->status)) 

/*
#define generic_SUB_B(rg, a,b) xgeneric_SUB_B(rg,a,b) 
#define generic_SUB_W(rg, a,b) xgeneric_SUB_W(rg,a,b) 
#define generic_SUB_L(rg, a,b) xgeneric_SUB_L(rg,a,b) 

#define generic_SBC_B(rg, a,b) xgeneric_SUB_B(rg,a,b) 
#define generic_SBC_W(rg, a,b) xgeneric_SUB_W(rg,a,b) 
#define generic_SBC_L(rg, a,b) xgeneric_SUB_L(rg,a,b) 
*/
/*
__inline _u8 generic_SUB_B(_u8 dst, _u8 src)
{
  _u8 result;

  result = asm_generic_ADD_B(rg,dst,-src, &(rg->status) );
  SETFLAG_N1;

  return result;
}

__inline _u16 generic_SUB_W(_u16 dst, _u16 src)
{
  _u16 result;
  result = asm_generic_ADD_W(dst,-src,&(rg->status));
  SETFLAG_N1;

  return result;
}

__inline _u32 generic_SUB_L(_u32 dst, _u32 src)
{
  _u32 result;
  result = asm_generic_ADD_L(dst,-src,&(rg->status));
  SETFLAG_N1;

  return result;
}

//=============================================================================

__inline _u8 generic_SBC_B(_u8 dst, _u8 src)
{
  _u8 result;
  result = asm_generic_ADD_B(rg,dst,-(src+FLAG_C),&(rg->status));
  SETFLAG_N1;

  return result;
}

__inline _u16 generic_SBC_W(_u16 dst, _u16 src)
{
  _u16 result;
  result = asm_generic_ADD_W(dst,-(src+FLAG_C),&(rg->status));
  SETFLAG_N1;

  return result;
}

__inline _u32 generic_SBC_L(_u32 dst, _u32 src)
{
  _u32 result;
  result = asm_generic_ADD_L(dst,-(src+FLAG_C),&(rg->status));
  SETFLAG_N1;

  return result;
}
*/

//=============================================================================
//POKE

__inline BOOL conditionCode(tw*rg,int cc)
{
  switch(cc)
  {
  case 0: return 0; //(F)
  case 1: return 1&(DFLAG_S ^ DFLAG_V); //(LT)
  case 2: return 1&(DFLAG_Z | (DFLAG_S ^ DFLAG_V));  //(LE)
  case 3: return 1&(DFLAG_C | DFLAG_Z); //(ULE)
  case 4: return 1&(DFLAG_V);  //(OV)
  case 5: return 1&(DFLAG_S);  //(MI)
  case 6: return 1&(DFLAG_Z);  //(Z)
  case 7: return 1&(DFLAG_C);  //(C)
  case 8: return 1; //always True             
  case 9: return 1&(~(DFLAG_S ^ DFLAG_V)); //(GE)
  case 10: return 1&(~(DFLAG_Z | (DFLAG_S ^ DFLAG_V)));  //(GT)
  case 11: return 1&(~(DFLAG_C | DFLAG_Z)); //(UGT)
  case 12: return 1&(~(DFLAG_V));  //(NOV)
  case 13: return 1&(~(DFLAG_S));  //(PL)
  case 14: return 1&(~(DFLAG_Z));  //(NZ)
  case 15: return 1&(~(DFLAG_C));  //(NC)
  }

  return FALSE;
}

BOOL conditionCode2(tw*rg,int cc)
{
  switch(cc)
  {
  case 0: return 0; //(F)
  case 1: if (FLAG_S ^ FLAG_V) return 1; else return 0; //(LT)
  case 2: if (FLAG_Z | (FLAG_S ^ FLAG_V)) return 1; else return 0;  //(LE)
  case 3: if (FLAG_C | FLAG_Z) return 1; else return 0; //(ULE)
  case 4: if (FLAG_V) return 1; else return 0;  //(OV)
  case 5: if (FLAG_S) return 1; else return 0;  //(MI)
  case 6: if (FLAG_Z) return 1; else return 0;  //(Z)
  case 7: if (FLAG_C) return 1; else return 0;  //(C)
  case 8: return 1; //always True                           
  case 9: if (FLAG_S ^ FLAG_V) return 0; else return 1; //(GE)
  case 10:if (FLAG_Z | (FLAG_S ^ FLAG_V)) return 0; else return 1;  //(GT)
  case 11:if (FLAG_C | FLAG_Z) return 0; else return 1; //(UGT)
  case 12:if (FLAG_V) return 0; else return 1;  //(NOV)
  case 13:if (FLAG_S) return 0; else return 1;  //(PL)
  case 14:if (FLAG_Z) return 0; else return 1;  //(NZ)
  case 15:if (FLAG_C) return 0; else return 1;  //(NC)
  }

  return FALSE;
}

//=============================================================================

static _u8 deflod[16]={	0x80,0xE0,0xE0,0xE4,0x80,0xE8,0xE4,0xEC,
						0x80,0xF0,0xE8,0xF4,0x80,0xF8,0xEC,0xFC };
						
__inline _u8 get_rr_Target(tw*rg)
{
//  _u8 target = 0x80;

  if (rg->argsize == 0 && rg->opcode1 == 0xC7)
    return rg->slot;


  return deflod[((rg->opcode1&7)<<1)|rg->argsize];
  /*
  
  //Create a regCode
  switch(rg->opcode1 & 7)
  {
  case 0: if (rg->argsize == 1)  target = 0xE0;  break;
  case 1: 
    if (rg->argsize == 0)  target = 0xE0;
    if (rg->argsize == 1)  target = 0xE4;
    break;
  case 2: if (rg->argsize == 1)  target = 0xE8;  break;
  case 3:
    if (rg->argsize == 0)  target = 0xE4;
    if (rg->argsize == 1)  target = 0xEC;
    break;
  case 4: if (rg->argsize == 1)  target = 0xF0;  break;
  case 5: 
    if (rg->argsize == 0)  target = 0xE8;
    if (rg->argsize == 1)  target = 0xF4;
    break;
  case 6: if (rg->argsize == 1)  target = 0xF8;  break;
  case 7:
    if (rg->argsize == 0)  target = 0xEC;
    if (rg->argsize == 1)  target = 0xFC;
    break;
  }

  return target;
  */
}

__inline _u8 get_RR_Target(tw*rg)
{

  return deflod[((rg->opcode2&7)<<1)|rg->argsize];

/*  _u8 target = 0x80;

  //Create a regCode
  switch(rg->opcode2 & 7)
  {
  case 0: if (rg->argsize == 1)  target = 0xE0;  break;
  case 1: 
    if (rg->argsize == 0)  target = 0xE0;
    if (rg->argsize == 1)  target = 0xE4;
    break;
  case 2: if (rg->argsize == 1)  target = 0xE8;  break;
  case 3:
    if (rg->argsize == 0)  target = 0xE4;
    if (rg->argsize == 1)  target = 0xEC;
    break;
  case 4: if (rg->argsize == 1)  target = 0xF0;  break;
  case 5: 
    if (rg->argsize == 0)  target = 0xE8;
    if (rg->argsize == 1)  target = 0xF4;
    break;
  case 6: if (rg->argsize == 1)  target = 0xF8;  break;
  case 7:
    if (rg->argsize == 0)  target = 0xEC;
    if (rg->argsize == 1)  target = 0xFC;
    break;
  }

  return target;
  */
}

//=========================================================================







static void ExXWA(tw*rg)   {rg->memadr = regL0;}
static void ExXBC(tw*rg)   {rg->memadr = regL1;}
static void ExXDE(tw*rg)   {rg->memadr = regL2;}
static void ExXHL(tw*rg)   {rg->memadr = regL3;}
static void ExXIX(tw*rg)   {rg->memadr = regL4;}
static void ExXIY(tw*rg)   {rg->memadr = regL5;}
static void ExXIZ(tw*rg)   {rg->memadr = regL6;}
static void ExXSP(tw*rg)   {rg->memadr = regL7;}

static void ExXWAd(tw*rg)  {rg->memadr = regL0 + (_s8)FETCH8; rg->timer += 2;}
static void ExXBCd(tw*rg)  {rg->memadr = regL1 + (_s8)FETCH8; rg->timer += 2;}
static void ExXDEd(tw*rg)  {rg->memadr = regL2 + (_s8)FETCH8; rg->timer += 2;}
static void ExXHLd(tw*rg)  {rg->memadr = regL3 + (_s8)FETCH8; rg->timer += 2;}
static void ExXIXd(tw*rg)  {rg->memadr = regL4 + (_s8)FETCH8; rg->timer += 2;}
static void ExXIYd(tw*rg)  {rg->memadr = regL5 + (_s8)FETCH8; rg->timer += 2;}
static void ExXIZd(tw*rg)  {rg->memadr = regL6 + (_s8)FETCH8; rg->timer += 2;}
static void ExXSPd(tw*rg)  {rg->memadr = regL7 + (_s8)FETCH8; rg->timer += 2;}

static void Ex8(tw*rg)   {rg->memadr = FETCH8;    rg->timer += 2;}
static void Ex16(tw*rg)    {rg->memadr = fetch16(rg); rg->timer += 2;}
static void Ex24(tw*rg)    {rg->memadr = fetch24(rg); rg->timer += 3;}

__inline static void ExR32(tw*rg)
{
  _u8 data = FETCH8;

  if (data == 0x03)
  {
    _u8 rIndex, r32;
    r32 = FETCH8;   //r32
    rIndex = FETCH8;  //r8
    rg->memadr = rCodeL(r32) + (_s8)rCodeB(rIndex);
    rg->timer += 8;
    return;
  }

  if (data == 0x07)
  {
    _u8 rIndex, r32;
    r32 = FETCH8;   //r32
    rIndex = FETCH8;  //r16
    rg->memadr = rCodeL(r32) + (_s16)rCodeW(rIndex);
    rg->timer += 8;
    return;
  }

  //Undocumented mode!
  if (data == 0x13)
  {
    rg->memadr = get_pc(rg) + (_s16)fetch16(rg);
    rg->timer += 8; //Unconfirmed... doesn't make much difference
    return;
  }

  rg->timer += 5;

  if ((data & 3) == 1)
    rg->memadr = rCodeL(data) + (_s16)fetch16(rg);
  else
    rg->memadr = rCodeL(data);
}

__inline static void ExDec(tw*rg)
{
  _u8 data = FETCH8;
  _u8 r32 = data & 0xFC;

  rg->timer += 3;


  switch(data & 3)
  {
  case 0: rCodeL(r32) -= 1; rg->memadr = rCodeL(r32);  break;
  case 1: rCodeL(r32) -= 2; rg->memadr = rCodeL(r32);  break;
  case 2: rCodeL(r32) -= 4; rg->memadr = rCodeL(r32);  break;
  }
}

__inline static void ExInc(tw*rg)
{
  _u8 data = FETCH8;
  _u8 r32 = data & 0xFC;

  rg->timer += 3;

  switch(data & 3)
  {
  case 0: rg->memadr = rCodeL(r32);  rCodeL(r32) += 1;   break;
  case 1: rg->memadr = rCodeL(r32);  rCodeL(r32) += 2;   break;
  case 2: rg->memadr = rCodeL(r32);  rCodeL(r32) += 4;   break;
  }
}

__inline static void ExRC(tw*rg)
{
  rg->regvector = TRUE;
  rg->slot = FETCH8;
  rg->timer += 1;
}

//=========================================================================

__inline static void e(tw*rg)
{

}

__inline static void es(tw*rg)
{

}

__inline static void ed(tw*rg)
{

}

__inline static void er(tw*rg)
{

}

//=========================================================================

//rg->secondary (SRC) Instruction decode
static void (*srcDecode[256])(tw*rg) = 
{
/*0*/ es,     es,     es,     es,     srcPUSH,  es,     srcRLD,   srcRRD,
    es,     es,     es,     es,     es,     es,     es,     es,
/*1*/ srcLDI,   srcLDIR,  srcLDD,   srcLDDR,  srcCPI,   srcCPIR,  srcCPD,   srcCPDR,
    es,     srcLD16m, es,     es,     es,     es,     es,     es,
/*2*/ srcLD,    srcLD,    srcLD,    srcLD,    srcLD,    srcLD,    srcLD,    srcLD,
    es,     es,     es,     es,     es,     es,     es,     es,
/*3*/ srcEX,    srcEX,    srcEX,    srcEX,    srcEX,    srcEX,    srcEX,    srcEX,
    srcADDi,  srcADCi,  srcSUBi,  srcSBCi,  srcANDi,  srcXORi,  srcORi,   srcCPi,
/*4*/ srcMUL,   srcMUL,   srcMUL,   srcMUL,   srcMUL,   srcMUL,   srcMUL,   srcMUL,
    srcMULS,  srcMULS,  srcMULS,  srcMULS,  srcMULS,  srcMULS,  srcMULS,  srcMULS,
/*5*/ srcDIV,   srcDIV,   srcDIV,   srcDIV,   srcDIV,   srcDIV,   srcDIV,   srcDIV,
    srcDIVS,  srcDIVS,  srcDIVS,  srcDIVS,  srcDIVS,  srcDIVS,  srcDIVS,  srcDIVS,
/*6*/ srcINC,   srcINC,   srcINC,   srcINC,   srcINC,   srcINC,   srcINC,   srcINC,
    srcDEC,   srcDEC,   srcDEC,   srcDEC,   srcDEC,   srcDEC,   srcDEC,   srcDEC,
/*7*/ es,     es,     es,     es,     es,     es,     es,     es,
    srcRLC,   srcRRC,   srcRL,    srcRR,    srcSLA,   srcSRA,   srcSLL,   srcSRL,
/*8*/ srcADDRm, srcADDRm, srcADDRm, srcADDRm, srcADDRm, srcADDRm, srcADDRm, srcADDRm,
    srcADDmR, srcADDmR, srcADDmR, srcADDmR, srcADDmR, srcADDmR, srcADDmR, srcADDmR,
/*9*/ srcADCRm, srcADCRm, srcADCRm, srcADCRm, srcADCRm, srcADCRm, srcADCRm, srcADCRm,
    srcADCmR, srcADCmR, srcADCmR, srcADCmR, srcADCmR, srcADCmR, srcADCmR, srcADCmR,
/*A*/ srcSUBRm, srcSUBRm, srcSUBRm, srcSUBRm, srcSUBRm, srcSUBRm, srcSUBRm, srcSUBRm,
    srcSUBmR, srcSUBmR, srcSUBmR, srcSUBmR, srcSUBmR, srcSUBmR, srcSUBmR, srcSUBmR,
/*B*/ srcSBCRm, srcSBCRm, srcSBCRm, srcSBCRm, srcSBCRm, srcSBCRm, srcSBCRm, srcSBCRm,
    srcSBCmR, srcSBCmR, srcSBCmR, srcSBCmR, srcSBCmR, srcSBCmR, srcSBCmR, srcSBCmR,
/*C*/ srcANDRm, srcANDRm, srcANDRm, srcANDRm, srcANDRm, srcANDRm, srcANDRm, srcANDRm,
    srcANDmR, srcANDmR, srcANDmR, srcANDmR, srcANDmR, srcANDmR, srcANDmR, srcANDmR,
/*D*/ srcXORRm, srcXORRm, srcXORRm, srcXORRm, srcXORRm, srcXORRm, srcXORRm, srcXORRm,
    srcXORmR, srcXORmR, srcXORmR, srcXORmR, srcXORmR, srcXORmR, srcXORmR, srcXORmR,
/*E*/ srcORRm,  srcORRm,  srcORRm,  srcORRm,  srcORRm,  srcORRm,  srcORRm,  srcORRm,
    srcORmR,  srcORmR,  srcORmR,  srcORmR,  srcORmR,  srcORmR,  srcORmR,  srcORmR,
/*F*/ srcCPRm,  srcCPRm,  srcCPRm,  srcCPRm,  srcCPRm,  srcCPRm,  srcCPRm,  srcCPRm,
    srcCPmR,  srcCPmR,  srcCPmR,  srcCPmR,  srcCPmR,  srcCPmR,  srcCPmR,  srcCPmR
};

//rg->secondary (DST) Instruction decode
static void (*dstDecode[256])(tw*rg) = 
{
/*0*/ dstLDBi,  ed,     dstLDWi,  ed,     dstPOPB,  ed,     dstPOPW,  ed,
    ed,     ed,     ed,     ed,     ed,     ed,     ed,     ed,
/*1*/ ed,     ed,     ed,     ed,     dstLDBm16,  ed,     dstLDWm16,  ed,
    ed,     ed,     ed,     ed,     ed,     ed,     ed,     ed,
/*2*/ dstLDAW,  dstLDAW,  dstLDAW,  dstLDAW,  dstLDAW,  dstLDAW,  dstLDAW,  dstLDAW,
    dstANDCFA,  dstORCFA, dstXORCFA,  dstLDCFA, dstSTCFA, ed,     ed,     ed,
/*3*/ dstLDAL,  dstLDAL,  dstLDAL,  dstLDAL,  dstLDAL,  dstLDAL,  dstLDAL,  dstLDAL,
    ed,     ed,     ed,     ed,     ed,     ed,     ed,     ed,
/*4*/ dstLDBR,  dstLDBR,  dstLDBR,  dstLDBR,  dstLDBR,  dstLDBR,  dstLDBR,  dstLDBR,
    ed,     ed,     ed,     ed,     ed,     ed,     ed,     ed,
/*5*/ dstLDWR,  dstLDWR,  dstLDWR,  dstLDWR,  dstLDWR,  dstLDWR,  dstLDWR,  dstLDWR,
    ed,     ed,     ed,     ed,     ed,     ed,     ed,     ed,
/*6*/ dstLDLR,  dstLDLR,  dstLDLR,  dstLDLR,  dstLDLR,  dstLDLR,  dstLDLR,  dstLDLR,
    ed,     ed,     ed,     ed,     ed,     ed,     ed,     ed,
/*7*/ ed,     ed,     ed,     ed,     ed,     ed,     ed,     ed,
    ed,     ed,     ed,     ed,     ed,     ed,     ed,     ed,
/*8*/ dstANDCF, dstANDCF, dstANDCF, dstANDCF, dstANDCF, dstANDCF, dstANDCF, dstANDCF,
    dstORCF,  dstORCF,  dstORCF,  dstORCF,  dstORCF,  dstORCF,  dstORCF,  dstORCF,
/*9*/ dstXORCF, dstXORCF, dstXORCF, dstXORCF, dstXORCF, dstXORCF, dstXORCF, dstXORCF,
    dstLDCF,  dstLDCF,  dstLDCF,  dstLDCF,  dstLDCF,  dstLDCF,  dstLDCF,  dstLDCF,
/*A*/ dstSTCF,  dstSTCF,  dstSTCF,  dstSTCF,  dstSTCF,  dstSTCF,  dstSTCF,  dstSTCF,  
    dstTSET,  dstTSET,  dstTSET,  dstTSET,  dstTSET,  dstTSET,  dstTSET,  dstTSET,
/*B*/ dstRES,   dstRES,   dstRES,   dstRES,   dstRES,   dstRES,   dstRES,   dstRES,
    dstSET,   dstSET,   dstSET,   dstSET,   dstSET,   dstSET,   dstSET,   dstSET,
/*C*/ dstCHG,   dstCHG,   dstCHG,   dstCHG,   dstCHG,   dstCHG,   dstCHG,   dstCHG,
    dstBIT,   dstBIT,   dstBIT,   dstBIT,   dstBIT,   dstBIT,   dstBIT,   dstBIT,
/*D*/ dstJP,    dstJP,    dstJP,    dstJP,    dstJP,    dstJP,    dstJP,    dstJP,
    dstJP,    dstJP,    dstJP,    dstJP,    dstJP,    dstJP,    dstJP,    dstJP,
/*E*/ dstCALL,  dstCALL,  dstCALL,  dstCALL,  dstCALL,  dstCALL,  dstCALL,  dstCALL,
    dstCALL,  dstCALL,  dstCALL,  dstCALL,  dstCALL,  dstCALL,  dstCALL,  dstCALL,
/*F*/ dstRET,   dstRET,   dstRET,   dstRET,   dstRET,   dstRET,   dstRET,   dstRET,
    dstRET,   dstRET,   dstRET,   dstRET,   dstRET,   dstRET,   dstRET,   dstRET
};

//rg->secondary (REG) Instruction decode
static void (*regDecode[256])(tw*rg) = 
{
/*0*/ er,     er,     er,     regLDi,   regPUSH,  regPOP,   regCPL,   regNEG,
    regMULi,  regMULSi, regDIVi,  regDIVSi, regLINK,  regUNLK,  regBS1F,  regBS1B,
/*1*/ regDAA,   er,     regEXTZ,  regEXTS,  regPAA,   er,     regMIRR,  er,
    er,     regMULA,  er,     er,     regDJNZ,  er,     er,     er,
/*2*/ regANDCFi,  regORCFi, regXORCFi,  regLDCFi, regSTCFi, er,     er,     er,
    regANDCFA,  regORCFA, regXORCFA,  regLDCFA, regSTCFA, er,     regLDCcrr,  regLDCrcr,
/*3*/ regRES,   regSET,   regCHG,   regBIT,   regTSET,  er,     er,     er,
    regMINC1, regMINC2, regMINC4, er,     regMDEC1, regMDEC2, regMDEC4, er,
/*4*/ regMUL,   regMUL,   regMUL,   regMUL,   regMUL,   regMUL,   regMUL,   regMUL,
    regMULS,  regMULS,  regMULS,  regMULS,  regMULS,  regMULS,  regMULS,  regMULS,
/*5*/ regDIV,   regDIV,   regDIV,   regDIV,   regDIV,   regDIV,   regDIV,   regDIV,
    regDIVS,  regDIVS,  regDIVS,  regDIVS,  regDIVS,  regDIVS,  regDIVS,  regDIVS,
/*6*/ regINC,   regINC,   regINC,   regINC,   regINC,   regINC,   regINC,   regINC,
    regDEC,   regDEC,   regDEC,   regDEC,   regDEC,   regDEC,   regDEC,   regDEC,
/*7*/ regSCC,   regSCC,   regSCC,   regSCC,   regSCC,   regSCC,   regSCC,   regSCC,
    regSCC,   regSCC,   regSCC,   regSCC,   regSCC,   regSCC,   regSCC,   regSCC,
/*8*/ regADD,   regADD,   regADD,   regADD,   regADD,   regADD,   regADD,   regADD,
    regLDRr,  regLDRr,  regLDRr,  regLDRr,  regLDRr,  regLDRr,  regLDRr,  regLDRr,
/*9*/ regADC,   regADC,   regADC,   regADC,   regADC,   regADC,   regADC,   regADC,
    regLDrR,  regLDrR,  regLDrR,  regLDrR,  regLDrR,  regLDrR,  regLDrR,  regLDrR,
/*A*/ regSUB,   regSUB,   regSUB,   regSUB,   regSUB,   regSUB,   regSUB,   regSUB,
    regLDr3,  regLDr3,  regLDr3,  regLDr3,  regLDr3,  regLDr3,  regLDr3,  regLDr3,
/*B*/ regSBC,   regSBC,   regSBC,   regSBC,   regSBC,   regSBC,   regSBC,   regSBC,
    regEX,    regEX,    regEX,    regEX,    regEX,    regEX,    regEX,    regEX,
/*C*/ regAND,   regAND,   regAND,   regAND,   regAND,   regAND,   regAND,   regAND,
    regADDi,  regADCi,  regSUBi,  regSBCi,  regANDi,  regXORi,  regORi,   regCPi,
/*D*/ regXOR,   regXOR,   regXOR,   regXOR,   regXOR,   regXOR,   regXOR,   regXOR,
    regCPr3,  regCPr3,  regCPr3,  regCPr3,  regCPr3,  regCPr3,  regCPr3,  regCPr3,
/*E*/ regOR,    regOR,    regOR,    regOR,    regOR,    regOR,    regOR,    regOR,
    regRLCi,  regRRCi,  regRLi,   regRRi,   regSLAi,  regSRAi,  regSLLi,  regSRLi,
/*F*/ regCP,    regCP,    regCP,    regCP,    regCP,    regCP,    regCP,    regCP,
    regRLCA,  regRRCA,  regRLA,   regRRA,   regSLAA,  regSRAA,  regSLLA,  regSRLA
};

//=========================================================================

static _u8 rCodeConversionB[8] = { 0xE1, 0xE0, 0xE5, 0xE4, 0xE9, 0xE8, 0xED, 0xEC };
static _u8 rCodeConversionW[8] = { 0xE0, 0xE4, 0xE8, 0xEC, 0xF0, 0xF4, 0xF8, 0xFC };
static _u8 rCodeConversionL[8] = { 0xE0, 0xE4, 0xE8, 0xEC, 0xF0, 0xF4, 0xF8, 0xFC };


__inline static void reg_BRC(tw*rg)
{
	ExRC(rg);
  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2&7;
  rg->argsize = 0;         //Byte Size

  if (rg->regvector == FALSE)
  {
    rg->regvector = TRUE;
    rg->slot = rCodeConversionB[rg->opcode1 & 7];
  }

  (*regDecode[rg->opcode2])(rg);   //Call
}

__inline static void reg_WRC(tw*rg)
{
	ExRC(rg);
  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2&7;
  rg->argsize = 1;         //Word Size

  if (rg->regvector == FALSE)
  {
    rg->regvector = TRUE;
//    rg->slot = rCodeConversionW[rg->opcode1 & 7];
	rg->slot = 0xE0+((rg->opcode1 & 7)<<2);

  }

  (*regDecode[rg->opcode2])(rg);   //Call
}

__inline static void reg_LRC(tw*rg)
{
	ExRC(rg);
  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2&7;
  rg->argsize = 2;         //Long Size

  if (rg->regvector == FALSE)
  {
    rg->regvector = TRUE;
    //rg->slot = rCodeConversionL[rg->opcode1 & 7];
	rg->slot = 0xE0+((rg->opcode1 & 7)<<2);
  }

  (*regDecode[rg->opcode2])(rg);   //Call
}


#define srcxxopt(a,z,b)\
	__inline static void a(tw*rg)\
	{z;rg->opcode2 = FETCH8;rg->regsel=rg->opcode2&7;\
	rg->argsize=b;(*srcDecode[rg->opcode2])(rg);}

#define dstxxopt(a,z)\
	__inline static void a(tw*rg)\
	{z;rg->opcode2 = FETCH8;rg->regsel=rg->opcode2&7;\
	(*dstDecode[rg->opcode2])(rg);}

srcxxopt( src_ExDecB, ExDec(rg), 0 )
srcxxopt( src_ExDecW, ExDec(rg), 1 )
srcxxopt( src_ExDecL, ExDec(rg), 2 )
dstxxopt( dst_ExDec, ExDec(rg) )

srcxxopt( src_ExIncB, ExInc(rg), 0 )
srcxxopt( src_ExIncW, ExInc(rg), 1 )
srcxxopt( src_ExIncL, ExInc(rg), 2 )
dstxxopt( dst_ExInc, ExInc(rg) )

srcxxopt( src_ExR32B, ExR32(rg), 0 )
srcxxopt( src_ExR32W, ExR32(rg), 1 )
srcxxopt( src_ExR32L, ExR32(rg), 2 )
dstxxopt( dst_ExR32, ExR32(rg) )


#define srcxx(a,b,c)\
	__inline static void a(tw*rg)\
	{rg->memadr=regL(b);rg->opcode2 = FETCH8;rg->regsel=rg->opcode2&7;\
	rg->argsize=c;(*srcDecode[rg->opcode2])(rg);}

#define dstxx(a,b)\
	__inline static void a(tw*rg)\
	{rg->memadr=regL(b);rg->opcode2 = FETCH8;rg->regsel=rg->opcode2&7;\
	(*dstDecode[rg->opcode2])(rg);}

#define srcxxd(a,b,c)\
	__inline static void a(tw*rg)\
	{rg->memadr=regL(b)+(_s8)FETCH8;rg->timer+=2;rg->opcode2 = FETCH8;rg->regsel=rg->opcode2&7;\
	rg->argsize=c;(*srcDecode[rg->opcode2])(rg);}

#define dstxxd(a,b)\
	__inline static void a(tw*rg)\
	{rg->memadr=regL(b)+(_s8)FETCH8;rg->timer+=2;rg->opcode2 = FETCH8;rg->regsel=rg->opcode2&7;\
	(*dstDecode[rg->opcode2])(rg);}

/*
static void Ex8(tw*rg)   {rg->memadr = FETCH8;    rg->timer += 2;}
static void Ex16(tw*rg)    {rg->memadr = fetch16(rg); rg->timer += 2;}
static void Ex24(tw*rg)    {rg->memadr = fetch24(rg); rg->timer += 3;}
*/

#define FETCH16 (fetch16(rg))
#define FETCH24 (fetch24(rg))
#define FETCH32 (fetch32(rg))


srcxx(src_B_XWA,0,0)
srcxx(src_B_XBC,1,0)
srcxx(src_B_XDE,2,0)
srcxx(src_B_XHL,3,0)
srcxx(src_B_XIX,4,0)
srcxx(src_B_XIY,5,0)
srcxx(src_B_XIZ,6,0)
srcxx(src_B_XSP,7,0)

srcxx(src_W_XWA,0,1)
srcxx(src_W_XBC,1,1)
srcxx(src_W_XDE,2,1)
srcxx(src_W_XHL,3,1)
srcxx(src_W_XIX,4,1)
srcxx(src_W_XIY,5,1)
srcxx(src_W_XIZ,6,1)
srcxx(src_W_XSP,7,1)

srcxx(src_L_XWA,0,2)
srcxx(src_L_XBC,1,2)
srcxx(src_L_XDE,2,2)
srcxx(src_L_XHL,3,2)
srcxx(src_L_XIX,4,2)
srcxx(src_L_XIY,5,2)
srcxx(src_L_XIZ,6,2)
srcxx(src_L_XSP,7,2)

dstxx(dst_XWA,0)
dstxx(dst_XBC,1)
dstxx(dst_XDE,2)
dstxx(dst_XHL,3)
dstxx(dst_XIX,4)
dstxx(dst_XIY,5)
dstxx(dst_XIZ,6)
dstxx(dst_XSP,7)

srcxxd(src_B_XWAd,0,0)
srcxxd(src_B_XBCd,1,0)
srcxxd(src_B_XDEd,2,0)
srcxxd(src_B_XHLd,3,0)
srcxxd(src_B_XIXd,4,0)
srcxxd(src_B_XIYd,5,0)
srcxxd(src_B_XIZd,6,0)
srcxxd(src_B_XSPd,7,0)

srcxxd(src_W_XWAd,0,1)
srcxxd(src_W_XBCd,1,1)
srcxxd(src_W_XDEd,2,1)
srcxxd(src_W_XHLd,3,1)
srcxxd(src_W_XIXd,4,1)
srcxxd(src_W_XIYd,5,1)
srcxxd(src_W_XIZd,6,1)
srcxxd(src_W_XSPd,7,1)

srcxxd(src_L_XWAd,0,2)
srcxxd(src_L_XBCd,1,2)
srcxxd(src_L_XDEd,2,2)
srcxxd(src_L_XHLd,3,2)
srcxxd(src_L_XIXd,4,2)
srcxxd(src_L_XIYd,5,2)
srcxxd(src_L_XIZd,6,2)
srcxxd(src_L_XSPd,7,2)

dstxxd(dst_XWAd,0)
dstxxd(dst_XBCd,1)
dstxxd(dst_XDEd,2)
dstxxd(dst_XHLd,3)
dstxxd(dst_XIXd,4)
dstxxd(dst_XIYd,5)
dstxxd(dst_XIZd,6)
dstxxd(dst_XSPd,7)


#define srcxex(a,b,c,d)\
	__inline static void a(tw*rg)\
	{rg->memadr=b;rg->timer+=2+d;rg->opcode2=FETCH8;rg->regsel=rg->opcode2&7;\
	rg->argsize=c;(*srcDecode[rg->opcode2])(rg);}

#define dstxex(a,b,c)\
	__inline static void a(tw*rg)\
	{rg->memadr=b;rg->timer+=2+c;rg->opcode2=FETCH8;rg->regsel=rg->opcode2&7;\
	(*dstDecode[rg->opcode2])(rg);}

srcxex(src_8_8, FETCH8,0,0 )
srcxex(src_16_8, FETCH16,0,0 )
srcxex(src_24_8, FETCH24,0,1 )
srcxex(src_8_16, FETCH8,1,0 )
srcxex(src_16_16, FETCH16,1,0 )
srcxex(src_24_16, FETCH24,1,1 )
srcxex(src_8_32, FETCH8,2,0 )
srcxex(src_16_32, FETCH16,2,0 )
srcxex(src_24_32, FETCH24,2,1 )

dstxex(dst_8, FETCH8,0 )
dstxex(dst_16, FETCH16,0 )
dstxex(dst_24, FETCH24,1 )


__inline static void src_B(tw*rg)
{
  //_u8 reg1 = (rg->opcode1)&7;
  //rg->memadr = regL(reg1);

  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 0;         //Byte Size

  (*srcDecode[rg->opcode2])(rg);   //Call
}

__inline static void src_W(tw*rg)
{
  //_u8 reg1 = (rg->opcode1)&7;
  //rg->memadr = regL(reg1);

  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 1;         //Word Size

  (*srcDecode[rg->opcode2])(rg);   //Call
}

__inline static void src_L(tw*rg)
{
  //_u8 reg1 = (rg->opcode1)&7;
  //rg->memadr = regL(reg1);

  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode

  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 2;         //Long Size

  (*srcDecode[rg->opcode2])(rg);   //Call
}

__inline static void dst(tw*rg)
{
  //_u8 reg1 = (rg->opcode1)&7;
  //rg->memadr = regL(reg1);

  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;

  (*dstDecode[rg->opcode2])(rg);   //Call
}

__inline static void src_B_d(tw*rg)
{
  //_u8 reg1 = rg->opcode1&7;
  //rg->memadr = regL(reg1) + (_s8)FETCH8; rg->timer += 2;

  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 0;         //Byte Size

  (*srcDecode[rg->opcode2])(rg);   //Call
}

__inline static void src_W_d(tw*rg)
{
  //_u8 reg1 = rg->opcode1&7;
  //rg->memadr = regL(reg1) + (_s8)FETCH8; rg->timer += 2;

  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 1;         //Word Size

  (*srcDecode[rg->opcode2])(rg);   //Call
}

__inline static void src_L_d(tw*rg)
{
  //_u8 reg1 = rg->opcode1&7;
  //rg->memadr = regL(reg1) + (_s8)FETCH8; rg->timer += 2;

  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode

  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 2;         //Long Size

  (*srcDecode[rg->opcode2])(rg);   //Call
}

__inline static void dst_d(tw*rg)
{
  //_u8 reg1 = rg->opcode1&7;
  //rg->memadr = regL(reg1) + (_s8)FETCH8; rg->timer += 2;

  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;

  (*dstDecode[rg->opcode2])(rg);   //Call
}

__inline static void reg_B(tw*rg)
{
  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 0;         //Byte Size

  if (rg->regvector == FALSE)
  {
    rg->regvector = TRUE;
    rg->slot = rCodeConversionB[rg->opcode1 & 7];
  }

  (*regDecode[rg->opcode2])(rg);   //Call
}

__inline static void reg_W(tw*rg)
{
  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 1;         //Word Size

  if (rg->regvector == FALSE)
  {
    rg->regvector = TRUE;
    rg->slot = rCodeConversionW[rg->opcode1 & 7];
  }

  (*regDecode[rg->opcode2])(rg);   //Call
}

__inline static void reg_L(tw*rg)
{
  rg->opcode2 = FETCH8;      //Get the rg->opcode2 o_pcode
  rg->regsel = rg->opcode2 & 7;
  rg->argsize = 2;         //Long Size

  if (rg->regvector == FALSE)
  {
    rg->regvector = TRUE;
    rg->slot = rCodeConversionL[rg->opcode1 & 7];
  }

  (*regDecode[rg->opcode2])(rg);   //Call
}

//=============================================================================

//Primary Instruction decode
/*static*/ void (*decode[256])(tw*rg) = 
{
/*0*/ sngNOP,   sngNORMAL,  sngPUSHSR,  sngPOPSR, sngMAX,   sngHALT,  sngEI,    sngRETI,
    sngLD8_8, sngPUSH8, sngLD8_16,  sngPUSH16,  sngINCF,  sngDECF,  sngRET,   sngRETD,
/*1*/ sngRCF,   sngSCF,   sngCCF,   sngZCF,   sngPUSHA, sngPOPA,  sngEX,    sngLDF,
    sngPUSHF, sngPOPF,  sngJP16,  sngJP24,  sngCALL16,  sngCALL24,  sngCALR,  iBIOSHLE,
/*2*/ sngLDB0,   sngLDB1,   sngLDB2,   sngLDB3,   sngLDB4,   sngLDB5,   sngLDB6,   sngLDB7,
    sngPUSHW0, sngPUSHW1, sngPUSHW2, sngPUSHW3, sngPUSHW4, sngPUSHW5, sngPUSHW6, sngPUSHW7,
/*3*/ sngLDW0,   sngLDW1,   sngLDW2,   sngLDW3,   sngLDW4,   sngLDW5,   sngLDW6,   sngLDW7,
    sngPUSHL0, sngPUSHL1, sngPUSHL2, sngPUSHL3, sngPUSHL4, sngPUSHL5, sngPUSHL6, sngPUSHL7,
/*4*/ sngLDL0,   sngLDL1,   sngLDL2,   sngLDL3,   sngLDL4,   sngLDL5,   sngLDL6,   sngLDL7,
    sngPOPW0,  sngPOPW1,  sngPOPW2,  sngPOPW3,  sngPOPW4,  sngPOPW5,  sngPOPW6,  sngPOPW7,
/*5*/ e,      e,      e,      e,      e,      e,      e,      e,
    sngPOPL0,  sngPOPL1,  sngPOPL2,  sngPOPL3,  sngPOPL4,  sngPOPL5,  sngPOPL6,  sngPOPL7,
/*6*/ sngJR_F,    sngJR_LT,    sngJR_LE,    sngJR_ULE,    sngJR_OV,    sngJR_MI,    sngJR_Z,    sngJR_C,
    sngJR_T,    sngJR_GE,    sngJR_GT,    sngJR_UGT,    sngJR_NOV,    sngJR_PL,    sngJR_NZ,    sngJR_NC,
/*7*/ sngJRL_F,   sngJRL_LT,   sngJRL_LE,   sngJRL_ULE,   sngJRL_OV,   sngJRL_MI,   sngJRL_Z,   sngJRL_C,
    sngJRL_T,   sngJRL_GE,   sngJRL_GT,   sngJRL_UGT,   sngJRL_NOV,   sngJRL_PL,   sngJRL_NZ,   sngJRL_NC,
/*8*/ src_B_XWA,    src_B_XBC,    src_B_XDE,    src_B_XHL,    src_B_XIX,    src_B_XIY,    src_B_XIZ,    src_B_XSP,
    src_B_XWAd,    src_B_XBCd,    src_B_XDEd,    src_B_XHLd,    src_B_XIXd,    src_B_XIYd,    src_B_XIZd,    src_B_XSPd,
/*9*/ src_W_XWA,    src_W_XBC,    src_W_XDE,    src_W_XHL,    src_W_XIX,    src_W_XIY,    src_W_XIZ,    src_W_XSP,
    src_W_XWAd,    src_W_XBCd,    src_W_XDEd,    src_W_XHLd,    src_W_XIXd,    src_W_XIYd,    src_W_XIZd,    src_W_XSPd,
/*A*/ src_L_XWA,    src_L_XBC,    src_L_XDE,    src_L_XHL,    src_L_XIX,    src_L_XIY,    src_L_XIZ,    src_L_XSP,
    src_L_XWAd,    src_L_XBCd,    src_L_XDEd,    src_L_XHLd,    src_L_XIXd,    src_L_XIYd,    src_L_XIZd,    src_L_XSPd,
/*B*/ dst_XWA,    dst_XBC,    dst_XDE,    dst_XHL,    dst_XIX,    dst_XIY,    dst_XIZ,    dst_XSP,
    dst_XWAd,    dst_XBCd,    dst_XDEd,    dst_XHLd,    dst_XIXd,    dst_XIYd,    dst_XIZd,    dst_XSPd,
/*C*/ src_8_8,    src_16_8,    src_24_8,    src_ExR32B,    src_ExDecB,    src_ExIncB,    e,      reg_BRC,
    reg_B,    reg_B,    reg_B,    reg_B,    reg_B,    reg_B,    reg_B,    reg_B,
/*D*/ src_8_16,    src_16_16,    src_24_16,    src_ExR32W,    src_ExDecW,    src_ExIncW,    e,      reg_WRC,
    reg_W,    reg_W,    reg_W,    reg_W,    reg_W,    reg_W,    reg_W,    reg_W,
/*E*/ src_8_32,    src_16_32,    src_24_32,    src_ExR32L,    src_ExDecL,    src_ExIncL,    e,      reg_LRC,
    reg_L,    reg_L,    reg_L,    reg_L,    reg_L,    reg_L,    reg_L,    reg_L,
/*F*/ dst_8,    dst_16,    dst_24,    dst_ExR32,    dst_ExDec,    dst_ExInc,    e,      sngLDX,
    sngSWI,   sngSWI,   sngSWI,   sngSWI,   sngSWI,   sngSWI,   sngSWI,   sngSWI
};

//=============================================================================

/*__inline*/
 _u8 doTLCS900H_Fast( )
{
  tw* rg = &tlcs;    
  rg->timer = 0;
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  return (rg->timer);
}


 _u8 doTLCS900H_Med( )
{
  tw* rg = &tlcs;    
  rg->timer = 0;
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  return (rg->timer);
}

 _u8 doTLCS900H_Comp( )
{
  tw* rg = &tlcs;    
  rg->timer = 0;
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode

  return (rg->timer);
}


_u8 doTLCS900H_Z80_Fast(void)
{
  tw* rg = &tlcs;    
  rg->timer = 0;
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  if (Z80ACTIVE)
  {Z80EMULATE}
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  if (Z80ACTIVE)
  {Z80EMULATE}
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  if (Z80ACTIVE)
  {Z80EMULATE}
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  if (Z80ACTIVE)
  {Z80EMULATE}
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
    
  return (rg->timer);
}


_u8 doTLCS900H_Z80_Med(void)
{
  tw* rg = &tlcs;    
  rg->timer = 0;
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  if (Z80ACTIVE)
  {Z80EMULATE}
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  if (Z80ACTIVE)
  {Z80EMULATE}
  rg->regvector = FALSE;
  rg->opcode1 = FETCH8; //Get the rg->opcode1 byte
  (*decode[rg->opcode1])(rg); //Decode  
  return (rg->timer);
}

//=============================================================================

// DST CODE 

//=========================================================================

//===== LD (rg->memadr),#
__inline void dstLDBi(tw*rg)
{
  storeB(rg->memadr, FETCH8);
  rg->timer += 5;
}

//===== LD (rg->memadr),#
__inline void dstLDWi(tw*rg)
{
  storeW(rg->memadr, fetch16(rg));
  rg->timer += 6;
}

//===== POP (rg->memadr)
__inline void dstPOPB(tw*rg)
{
  storeB(rg->memadr, pop8(rg));
  rg->timer += 6;
}

//===== POP (rg->memadr)
__inline void dstPOPW(tw*rg)
{
  storeW(rg->memadr, pop16(rg));
  rg->timer += 6;
}

//===== LD (rg->memadr),(nn)
__inline void dstLDBm16(tw*rg)
{
  storeB(rg->memadr, loadB(fetch16(rg)));
  rg->timer += 8;
}

//===== LD (rg->memadr),(nn)
__inline void dstLDWm16(tw*rg)
{
  storeW(rg->memadr, loadW(fetch16(rg)));
  rg->timer += 8;
}

//===== LDA rg->regsel,rg->memadr
__inline void dstLDAW(tw*rg)
{
  regW(rg->regsel) =(_u16)rg->memadr;
  rg->timer += 4;
}

//===== LDA rg->regsel,rg->memadr
__inline void dstLDAL(tw*rg)
{
  regL(rg->regsel) = (_u32)rg->memadr;
  rg->timer += 4;
}

//===== ANDCF A,(rg->memadr)
__inline void dstANDCFA(tw*rg)
{
  _u8 bit = REGA & 0xF;
  _u8 mbit = (loadB(rg->memadr) >> bit) & 1;
  if (bit < 8) SETFLAG_C(mbit & FLAG_C);
  rg->timer += 8;
}

//===== ORCF A,(rg->memadr)
__inline void dstORCFA(tw*rg)
{
  _u8 bit = REGA & 0xF;
  _u8 mbit = (loadB(rg->memadr) >> bit) & 1;
  if (bit < 8) SETFLAG_C(mbit | FLAG_C);
  rg->timer += 8;
}

//===== XORCF A,(rg->memadr)
__inline void dstXORCFA(tw*rg)
{
  _u8 bit = REGA & 0xF;
  _u8 mbit = (loadB(rg->memadr) >> bit) & 1;
  if (bit < 8) SETFLAG_C(mbit ^ FLAG_C);
  rg->timer += 8;
}

//===== LDCF A,(rg->memadr)
__inline void dstLDCFA(tw*rg)
{
  _u8 bit = REGA & 0xF;
  _u8 mask = (1 << bit);
  if (bit < 8) SETFLAG_C(loadB(rg->memadr) & mask);
  rg->timer += 8;
}

//===== STCF A,(rg->memadr)
__inline void dstSTCFA(tw*rg)
{
  _u8 bit = REGA & 0xF;
  _u8 cmask = ~(1 << bit);
  _u8 set = FLAG_C << bit;
  if (bit < 8) storeB(rg->memadr, (loadB(rg->memadr) & cmask) | set); 
  rg->timer += 8;
}

//===== LD (rg->memadr),rg->regsel
__inline void dstLDBR(tw*rg)
{
  storeB(rg->memadr, regB(rg->regsel));
  rg->timer += 4;
}

//===== LD (rg->memadr),rg->regsel
__inline void dstLDWR(tw*rg)
{
  storeW(rg->memadr, regW(rg->regsel));
  rg->timer += 4;
}

//===== LD (rg->memadr),rg->regsel
__inline void dstLDLR(tw*rg)
{
  storeL(rg->memadr, regL(rg->regsel));
  rg->timer += 6;
}

//===== ANDCF #3,(rg->memadr)
__inline void dstANDCF(tw*rg)
{
  _u8 bit = rg->regsel;
  _u8 mbit = (loadB(rg->memadr) >> bit) & 1;
  SETFLAG_C(mbit & FLAG_C);
  rg->timer += 8;
}

//===== ORCF #3,(rg->memadr)
__inline void dstORCF(tw*rg)
{
  _u8 bit = rg->regsel;
  _u8 mbit = (loadB(rg->memadr) >> bit) & 1;
  SETFLAG_C(mbit | FLAG_C);
  rg->timer += 8;
}

//===== XORCF #3,(rg->memadr)
__inline void dstXORCF(tw*rg)
{
  _u8 bit = rg->regsel;
  _u8 mbit = (loadB(rg->memadr) >> bit) & 1;
  SETFLAG_C(mbit ^ FLAG_C);
  rg->timer += 8;
}

//===== LDCF #3,(rg->memadr)
__inline void dstLDCF(tw*rg)
{
  _u8 bit = rg->regsel;
  _u32 mask = (1 << bit);
  SETFLAG_C(loadB(rg->memadr) & mask);
  rg->timer += 8;
}

//===== STCF #3,(rg->memadr)
__inline void dstSTCF(tw*rg)
{
  _u8 bit = rg->regsel;
  _u8 cmask = ~(1 << bit);
  _u8 set = FLAG_C << bit;
  storeB(rg->memadr, (loadB(rg->memadr) & cmask) | set); 
  rg->timer += 8;
}

//===== TSET #3,(rg->memadr)
__inline void dstTSET(tw*rg)
{
  SETFLAG_Z(! (loadB(rg->memadr) & (1 << rg->regsel)) );
  storeB(rg->memadr, loadB(rg->memadr) | (1 << rg->regsel));

  SETFLAG_H1
  SETFLAG_N0
  rg->timer += 10;
}

//===== RES #3,(rg->memadr)
__inline void dstRES(tw*rg)
{
  storeB(rg->memadr, loadB(rg->memadr) & (~(1 << rg->regsel)));
  rg->timer += 8;
}

//===== SET #3,(rg->memadr)
__inline void dstSET(tw*rg)
{
  storeB(rg->memadr, loadB(rg->memadr) | (1 << rg->regsel));
  rg->timer += 8;
}

//===== CHG #3,(rg->memadr)
__inline void dstCHG(tw*rg)
{
  storeB(rg->memadr, loadB(rg->memadr) ^ (1 << rg->regsel));
  rg->timer += 8;
}

//===== BIT #3,(rg->memadr)
__inline void dstBIT(tw*rg)
{
  SETFLAG_Z(! (loadB(rg->memadr) & (1 << rg->regsel)) );
  SETFLAG_H1;
  SETFLAG_N0;
  rg->timer += 8;
}

//===== JP cc,rg->memadr
__inline void dstJP(tw*rg)
{
  if (conditionCode(rg,rg->opcode2 & 0xF))
  {
    set_pc(rg,rg->memadr);
    rg->timer += 9;
  }
  else
  {
    rg->timer += 6;
  }
}

//===== CALL cc,rg->memadr
__inline void dstCALL(tw*rg)
{
  if (conditionCode(rg,rg->opcode2 & 0xF))
  {
    push32(rg,get_pc(rg));
    set_pc(rg,rg->memadr);
    rg->timer += 12;
  }
  else
  {
    rg->timer += 6;
  }
}

//===== RET cc
__inline void dstRET(tw*rg)
{
  if (conditionCode(rg,rg->opcode2 & 0xF))
  {
    set_pc(rg,pop32(rg));
    rg->timer += 12;
  }
  else
  {
    rg->timer += 6;
  }
}

//=============================================================================


// REG CODE



//=========================================================================

//===== LD r,#
__inline void regLDi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = FETCH8;   rg->timer += 4; break;
  case 1: rCodeW(rg->slot) = fetch16(rg);  rg->timer += 4; break;
  case 2: rCodeL(rg->slot) = fetch32(rg);  rg->timer += 6; break;
  }
}

//===== PUSH r
__inline void regPUSH(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: push8(rg,rCodeB(rg->slot));  rg->timer += 5;break;
  case 1: push16(rg,rCodeW(rg->slot)); rg->timer += 5;break;
  case 2: push32(rg,rCodeL(rg->slot)); rg->timer += 7;break;
  }
}

//===== POP r
__inline void regPOP(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = pop8(rg);   rg->timer += 6;break;
  case 1: rCodeW(rg->slot) = pop16(rg);  rg->timer += 6;break;
  case 2: rCodeL(rg->slot) = pop32(rg);  rg->timer += 8;break;
  }
}

//===== CPL r
__inline void regCPL(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = ~ rCodeB(rg->slot);  break;
  case 1: rCodeW(rg->slot) = ~ rCodeW(rg->slot);  break;
  }

  SETFLAG_H1;
  SETFLAG_N1;
  rg->timer += 4;
}

//===== NEG r
__inline void regNEG(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = generic_SUB_B(rg,0, rCodeB(rg->slot)); break;
  case 1: rCodeW(rg->slot) = generic_SUB_W(rg,0, rCodeW(rg->slot)); break;
  }
  rg->timer += 5;
}

//===== MUL rr,#
__inline void regMULi(tw*rg)
{
  _u8 target = get_rr_Target(rg);
  if (target == 0x80)
  {
    return;
  }

  switch(rg->argsize)
  {
  case 0: rCodeW(target) = (rCodeW(target) & 0xFF) * FETCH8;
    rg->timer += 18; break;
  case 1: rCodeL(target) = (rCodeL(target) & 0xFFFF) * fetch16(rg);
    rg->timer += 26; break;
  }
}

//===== MULS rr,#
__inline void regMULSi(tw*rg)
{
  _u8 target = get_rr_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: rCodeW(target) = (_s8)(rCodeW(target) & 0xFF) * (_s8)FETCH8;
    rg->timer += 18; break;
  case 1: rCodeL(target) = (_s16)(rCodeL(target) & 0xFFFF) * (_s16)fetch16(rg);
    rg->timer += 26; break;
  }
}

//===== DIV rr,#
__inline void regDIVi(tw*rg)
{
  _u8 target = get_rr_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: { rCodeW(target) =  generic_DIV_B(rg,rCodeW(target), FETCH8);
        rg->timer += 22;
        break;  }

  case 1: { rCodeL(target) =  generic_DIV_W(rg,rCodeL(target), fetch16(rg));
        rg->timer += 30;
        break;  }
  }
}

//===== DIVS rr,#
__inline void regDIVSi(tw*rg)
{
  _u8 target = get_rr_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: { rCodeW(target) =  generic_DIVS_B(rg,rCodeW(target), FETCH8);
        rg->timer += 24;
        break;  }

  case 1: { rCodeL(target) =  generic_DIVS_W(rg,rCodeL(target), fetch16(rg));
        rg->timer += 32;
        break;  }
  }
}

//===== LINK r,dd
__inline void regLINK(tw*rg)
{
  _s16 d = (_s16)fetch16(rg);
  push32(rg,rCodeL(rg->slot));
  rCodeL(rg->slot) = REGXSP;
  REGXSP += d;
  rg->timer += 10;
}

//===== UNLK r
__inline void regUNLK(tw*rg)
{
  REGXSP = rCodeL(rg->slot);
  rCodeL(rg->slot) = pop32(rg);
  rg->timer += 8;
}

//===== BS1F A,r
__inline void regBS1F(tw*rg)
{
  _u16 data = rCodeW(rg->slot), mask = 0x0001;
  _u8 i;
  
  SETFLAG_V0;
  for (i = 0; i < 15; i++)
  {
    if (data & mask)
    {
      REGA = i;
      return;
    }

    mask <<= 1;
  }

  SETFLAG_V1;
  rg->timer += 4;
}

//===== BS1B A,r
__inline void regBS1B(tw*rg)
{
  _u16 data = rCodeW(rg->slot), mask = 0x8000;
  _u8 i;
  
  SETFLAG_V0;
  for (i = 0; i < 15; i++)
  {
    if (data & mask)
    {
      REGA = 15 - i;
      return;
    }

    mask >>= 1;
  }

  SETFLAG_V1;
  rg->timer += 4;
}

//===== DAA r
__inline void regDAA(tw*rg)
{
  _u16 resultC;
  _u8 src = rCodeB(rg->slot), result, added, half;
  BOOL setC = FALSE;

  _u8 upper4 = (src & 0xF0);
  _u8 lower4 = (src & 0x0F);

  if (FLAG_C) // {C = 1}
  {
    if (FLAG_H) // {H = 1}
    {
      setC = TRUE;
      added = 0x66;
    }
    else    // {H = 0}
    {
      if      (lower4 < 0x0a)   { added = 0x60; }
      else            { added = 0x66; }
      setC = TRUE;
    }
  }
  else  // {C = 0}
  {
    if (FLAG_H) // {H = 1}
    {
      if    (src < 0x9A)    { added = 0x06; }
      else            { added = 0x66; }
    }
    else    // {H = 0}
    {
      if    ((upper4 < 0x90) && (lower4 > 0x9)) { added = 0x06; }
      else if ((upper4 > 0x80) && (lower4 > 0x9)) { added = 0x66; }
      else if ((upper4 > 0x90) && (lower4 < 0xa)) { added = 0x60; }
    }
  }

  if (FLAG_N)
  {
    resultC = (_u16)src - (_u16)added;
    half = (src & 0xF) - (added & 0xF);
  }
  else
  {
    resultC = (_u16)src + (_u16)added;
    half = (src & 0xF) + (added & 0xF);
  }

  result = (_u8)(resultC & 0xFF); 

  SETFLAG_S(result & 0x80);
  SETFLAG_Z(result == 0);
  SETFLAG_H(half > 0xF);

  if (FLAG_N)   SETFLAG_C(result > src || setC)
  else      SETFLAG_C(result < src || setC)
  
  parityB(rg,result);
  rCodeB(rg->slot) = result;
  rg->timer += 6;
}

//===== EXTZ r
__inline void regEXTZ(tw*rg)
{
  switch(rg->argsize)
  {
  case 1: rCodeW(rg->slot) &= 0xFF;  break;
  case 2: rCodeL(rg->slot) &= 0xFFFF;  break;
  }

  rg->timer += 4;
}

//===== EXTS r
__inline void regEXTS(tw*rg)
{
  switch(rg->argsize)
  {
  case 1: if (rCodeW(rg->slot) & 0x0080) 
        { rCodeW(rg->slot) |= 0xFF00; } else 
        { rCodeW(rg->slot) &= 0x00FF; }
    break;
    
  case 2: if (rCodeL(rg->slot) & 0x00008000) 
        { rCodeL(rg->slot) |= 0xFFFF0000; } else 
        { rCodeL(rg->slot) &= 0x0000FFFF; }
    break;
  }

  rg->timer += 5;
}

//===== PAA r
__inline void regPAA(tw*rg)
{
  switch(rg->argsize)
  {
  case 1: if (rCodeW(rg->slot) & 0x1) rCodeW(rg->slot)++; break;
  case 2: if (rCodeL(rg->slot) & 0x1) rCodeL(rg->slot)++; break;
  }
  rg->timer += 4;
}

//===== MIRR r
__inline void regMIRR(tw*rg)
{
  _u16 src = rCodeW(rg->slot), dst = 0, bit;

  //Undocumented - see p165 of CPU .PDF
  //Seems to mirror bits completely, ie. 1234 -> 4321

  for (bit = 0; bit < 16; bit++)
    if (src & (1 << bit))
      dst |= (1 << (15 - bit));

  rCodeW(rg->slot) = dst;
  rg->timer += 4;
}

//===== MULA rr
__inline void regMULA(tw*rg)
{
  _u32 src = (_s16)loadW(regL(2/*XDE*/)) * (_s16)loadW(regL(3/*XHL*/));
  _u32 dst = rCodeL(rg->slot);
  _u32 result = dst + src;

  SETFLAG_S(result & 0x80000000);
  SETFLAG_Z(result == 0);

  if ((((_s32)dst >= 0) && ((_s32)src >= 0) && ((_s32)result < 0)) || 
    (((_s32)dst < 0)  && ((_s32)src < 0) && ((_s32)result >= 0)))
  {SETFLAG_V1} else {SETFLAG_V0}
  
  rg->timer += 31;
}

//===== DJNZ r,d
__inline void regDJNZ(tw*rg)
{
  _s8 offset = FETCH8;

  rg->timer += 7;

  switch(rg->argsize)
  {
  case 0: 
    rCodeB(rg->slot) --;
    if (rCodeB(rg->slot) != 0)
    {
      rg->timer += 11;
      mov_pc(rg,offset);
    }
    break;

  case 1: 
    rCodeW(rg->slot) --;
    if (rCodeW(rg->slot) != 0)
    {
      rg->timer += 11;
      mov_pc(rg,offset);
    }
    break;
  }
}

//===== ANDCF #,r
__inline void regANDCFi(tw*rg)
{
  _u8 data, bit = FETCH8 & 0xF;
  switch(rg->argsize)
  {
  case 0: { data = (rCodeB(rg->slot) >> bit) & 1;
        if (bit < 8) SETFLAG_C(FLAG_C & data); 
        break; }

  case 1: { data = (rCodeW(rg->slot) >> bit) & 1;
        SETFLAG_C(FLAG_C & data); 
        break; }
  }
  rg->timer += 4;
}

//===== ORCF #,r
__inline void regORCFi(tw*rg)
{
  _u8 data, bit = FETCH8 & 0xF;
  switch(rg->argsize)
  {
  case 0: { data = (rCodeB(rg->slot) >> bit) & 1;
        if (bit < 8) SETFLAG_C(FLAG_C | data); 
        break; }

  case 1: { data = (rCodeW(rg->slot) >> bit) & 1;
        SETFLAG_C(FLAG_C | data); 
        break; }
  }
  rg->timer += 4;
}

//===== XORCF #,r
__inline void regXORCFi(tw*rg)
{
  _u8 data, bit = FETCH8 & 0xF;
  switch(rg->argsize)
  {
  case 0: { data = (rCodeB(rg->slot) >> bit) & 1;
        if (bit < 8) SETFLAG_C(FLAG_C ^ data); 
        break; }

  case 1: { data = (rCodeW(rg->slot) >> bit) & 1;
        SETFLAG_C(FLAG_C ^ data); 
        break; }
  }
  rg->timer += 4;
}

//===== LDCF #,r
__inline void regLDCFi(tw*rg)
{
  _u8 bit = FETCH8 & 0xF;
  switch(rg->argsize)
  {
  case 0: { _u8 mask = (1 << bit);
        if (bit < 8)
          SETFLAG_C(rCodeB(rg->slot) & mask);
        break; }


  case 1: { _u16 mask = (1 << bit);
        SETFLAG_C(rCodeW(rg->slot) & mask);
        break; }
  }

  rg->timer += 4;
}

//===== STCF #,r
__inline void regSTCFi(tw*rg)
{
  _u8 bit = FETCH8 & 0xF;
  switch(rg->argsize)
  {
  case 0: { _u8 cmask = ~(1 << bit);
        _u8 set = FLAG_C << bit;
        if (bit < 8) rCodeB(rg->slot) = (rCodeB(rg->slot) & cmask) | set;
        break;  }

  case 1: { _u16 cmask = ~(1 << bit);
        _u16 set = FLAG_C << bit;
        rCodeW(rg->slot) = (rCodeW(rg->slot) & cmask) | set;
        break;  }
  }

  rg->timer += 4;
}

//===== ANDCF A,r
__inline void regANDCFA(tw*rg)
{
  _u8 data, bit = REGA & 0xF;
  switch(rg->argsize)
  {
  case 0: { data = (rCodeB(rg->slot) >> bit) & 1;
        if (bit < 8) SETFLAG_C(FLAG_C & data); 
        break; }

  case 1: { data = (rCodeW(rg->slot) >> bit) & 1;
        SETFLAG_C(FLAG_C & data); 
        break; }
  }
  rg->timer += 4;
}

//===== ORCF A,r
__inline void regORCFA(tw*rg)
{
  _u8 data, bit = REGA & 0xF;
  switch(rg->argsize)
  {
  case 0: { data = (rCodeB(rg->slot) >> bit) & 1;
        if (bit < 8) SETFLAG_C(FLAG_C | data); 
        break; }

  case 1: { data = (rCodeW(rg->slot) >> bit) & 1;
        SETFLAG_C(FLAG_C | data); 
        break; }
  }
  rg->timer += 4;
}

//===== XORCF A,r
__inline void regXORCFA(tw*rg)
{
  _u8 data, bit = REGA & 0xF;
  switch(rg->argsize)
  {
  case 0: { data = (rCodeB(rg->slot) >> bit) & 1;
        if (bit < 8) SETFLAG_C(FLAG_C ^ data); 
        break; }

  case 1: { data = (rCodeW(rg->slot) >> bit) & 1;
        SETFLAG_C(FLAG_C ^ data); 
        break; }
  }
  rg->timer += 4;
}

//===== LDCF A,r
__inline void regLDCFA(tw*rg)
{
  _u8 bit = REGA & 0xF;
  _u32 mask = (1 << bit);

  switch(rg->argsize)
  {
  case 0: if (bit < 8) SETFLAG_C(rCodeB(rg->slot) & mask); break;
  case 1: SETFLAG_C(rCodeW(rg->slot) & mask); break;
  }

  rg->timer += 4;
}

//===== STCF A,r
__inline void regSTCFA(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 bit = REGA & 0xF;
        _u8 cmask = ~(1 << bit);
        _u8 set = FLAG_C << bit;
        if (bit < 8) rCodeB(rg->slot) = (rCodeB(rg->slot) & cmask) | set;
        break;  }

  case 1: { _u8 bit = REGA & 0xF;
        _u16 cmask = ~(1 << bit);
        _u16 set = FLAG_C << bit;
        rCodeW(rg->slot) = (rCodeW(rg->slot) & cmask) | set;
        break;  }
  }

  rg->timer += 4;
}

//===== LDC cr,r
__inline void regLDCcrr(tw*rg)
{
  _u8 cr = FETCH8;

  switch(rg->argsize)
  {
  case 0: dmaStoreB(cr, rCodeB(rg->slot)); break;
  case 1: dmaStoreW(cr, rCodeW(rg->slot)); break;
  case 2: dmaStoreL(cr, rCodeL(rg->slot)); break;
  }

  rg->timer += 8;
}

//===== LDC r,cr
__inline void regLDCrcr(tw*rg)
{
  _u8 cr = FETCH8;

  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = dmaLoadB(cr); break;
  case 1: rCodeW(rg->slot) = dmaLoadW(cr); break;
  case 2: rCodeL(rg->slot) = dmaLoadL(cr); break;
  }

  rg->timer += 8;
}

//===== RES #,r
__inline void regRES(tw*rg)
{
  _u8 b = FETCH8 & 0xF;

  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) &= ~(_u8)(1 << b); break;
  case 1: rCodeW(rg->slot) &= ~(_u16)(1 << b); break;
  }

  rg->timer += 4;
}

//===== SET #,r
__inline void regSET(tw*rg)
{
  _u8 b = FETCH8 & 0xF;

  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) |= (1 << b); break;
  case 1: rCodeW(rg->slot) |= (1 << b); break;
  }

  rg->timer += 4;
}

//===== CHG #,r
__inline void regCHG(tw*rg)
{
  _u8 b = FETCH8 & 0xF;

  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) ^= (1 << b); break;
  case 1: rCodeW(rg->slot) ^= (1 << b); break;
  }

  rg->timer += 4;
}

//===== BIT #,r
__inline void regBIT(tw*rg)
{
  _u8 b = FETCH8 & 0xF;
  
  switch(rg->argsize)
  {
  case 0: SETFLAG_Z(! (rCodeB(rg->slot) & (1 << b))  );  break;
  case 1: SETFLAG_Z(! (rCodeW(rg->slot) & (1 << b))  );  break;
  }

  SETFLAG_H1;
  SETFLAG_N0;
  rg->timer += 4;
}

//===== TSET #,r
__inline void regTSET(tw*rg)
{
  _u8 b = FETCH8 & 0xF;
  
  switch(rg->argsize)
  {
  case 0: SETFLAG_Z(! (rCodeB(rg->slot) & (1 << b))  );  
      rCodeB(rg->slot) |= (1 << b);
      break;

  case 1: SETFLAG_Z(! (rCodeW(rg->slot) & (1 << b))  );
      rCodeW(rg->slot) |= (1 << b);
      break;
  }

  SETFLAG_H1
  SETFLAG_N0
  rg->timer += 6;
}

//===== MINC1 #,r
__inline void regMINC1(tw*rg)
{
  _u16 num = fetch16(rg) + 1;

  if (rg->argsize == 1)
  {
    if ((rCodeW(rg->slot) % num) == (num - 1))
      rCodeW(rg->slot) -= (num - 1);
    else
      rCodeW(rg->slot) += 1;
  }

  rg->timer += 8;
}

//===== MINC2 #,r
__inline void regMINC2(tw*rg)
{
  _u16 num = fetch16(rg) + 2;

  if (rg->argsize == 1)
  {
    if ((rCodeW(rg->slot) % num) == (num - 2))
      rCodeW(rg->slot) -= (num - 2);
    else
      rCodeW(rg->slot) += 2;
  }

  rg->timer += 8;
}

//===== MINC4 #,r
__inline void regMINC4(tw*rg)
{
  _u16 num = fetch16(rg) + 4;

  if (rg->argsize == 1)
  {
    if ((rCodeW(rg->slot) % num) == (num - 4))
      rCodeW(rg->slot) -= (num - 4);
    else
      rCodeW(rg->slot) += 4;
  }

  rg->timer += 8;
}

//===== MDEC1 #,r
__inline void regMDEC1(tw*rg)
{
  _u16 num = fetch16(rg) + 1;

  if (rg->argsize == 1)
  {
    if ((rCodeW(rg->slot) % num) == 0)
      rCodeW(rg->slot) += (num - 1);
    else
      rCodeW(rg->slot) -= 1;
  }

  rg->timer += 7;
}

//===== MDEC2 #,r
__inline void regMDEC2(tw*rg)
{
  _u16 num = fetch16(rg) + 2;

  if (rg->argsize == 1)
  {
    if ((rCodeW(rg->slot) % num) == 0)
      rCodeW(rg->slot) += (num - 2);
    else
      rCodeW(rg->slot) -= 2;
  }

  rg->timer += 7;
}

//===== MDEC4 #,r
__inline void regMDEC4(tw*rg)
{
  _u16 num = fetch16(rg) + 4;

  if (rg->argsize == 1)
  {
    if ((rCodeW(rg->slot) % num) == 0)
      rCodeW(rg->slot) += (num - 4);
    else
      rCodeW(rg->slot) -= 4;
  }

  rg->timer += 7;
}

//===== MUL RR,r
__inline void regMUL(tw*rg)
{
  _u8 target = get_RR_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: rCodeW(target) = (rCodeW(target) & 0xFF) * rCodeB(rg->slot);
    rg->timer += 18; break;
  case 1: rCodeL(target) = (rCodeL(target) & 0xFFFF) * rCodeW(rg->slot); 
    rg->timer += 26; break;
  }
}

//===== MULS RR,r
__inline void regMULS(tw*rg)
{
  _u8 target = get_RR_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: rCodeW(target) = (_s8)(rCodeW(target) & 0xFF) * (_s8)rCodeB(rg->slot); 
    rg->timer += 18; break;
  case 1: rCodeL(target) = (_s16)(rCodeL(target) & 0xFFFF) * (_s16)rCodeW(rg->slot); 
    rg->timer += 26; break;
  }
}

//===== DIV RR,r
__inline void regDIV(tw*rg)
{
  _u8 target = get_RR_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: { rCodeW(target) =  generic_DIV_B(rg,rCodeW(target), rCodeB(rg->slot));
        rg->timer += 22;
        break;  }

  case 1: { rCodeL(target) =  generic_DIV_W(rg,rCodeL(target), rCodeW(rg->slot));
        rg->timer += 30;
        break;  }
  }
}

//===== DIVS RR,r
__inline void regDIVS(tw*rg)
{
  _u8 target = get_RR_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: { rCodeW(target) = generic_DIVS_B(rg,rCodeW(target), rCodeB(rg->slot));
        rg->timer += 24;
        break;  }

  case 1: { rCodeL(target) = generic_DIVS_W(rg,rCodeL(target), rCodeW(rg->slot));
        rg->timer += 32;
        break;  }
  }
}

//===== INC #3,r
__inline void regINC(tw*rg)
{
  _u8 val = rg->regsel;
  if (val == 0)
    val = 8;

  switch(rg->argsize)
  {
  case 0: { _u8 dst = rCodeB(rg->slot);
        _u8 half = (dst & 0xF) + val;
        _u32 resultC = dst + val;
        _u8 result = (_u8)(resultC & 0xFF);
        SETFLAG_S(result & 0x80);

        if (((_s8)dst >= 0) && ((_s8)result < 0))
        {SETFLAG_V1} else {SETFLAG_V0}

        SETFLAG_H(half > 0xF);
        SETFLAG_Z(result == 0);
        SETFLAG_N0;
        rCodeB(rg->slot) = result;
        break;  }

  case 1: { rCodeW(rg->slot) += val; break; }

  case 2: { rCodeL(rg->slot) += val; break; }
  }

  rg->timer += 4;
}

//===== DEC #3,r
__inline void regDEC(tw*rg)
{
  _u8 val = rg->regsel;
  if (val == 0)
    val = 8;

  switch(rg->argsize)
  {
  case 0: { _u8 dst = rCodeB(rg->slot);
        _u8 half = (dst & 0xF) - val;
        _u32 resultC = dst - val;
        _u8 result = (_u8)(resultC & 0xFF);
        SETFLAG_S(result & 0x80);

        if (((_s8)dst < 0) && ((_s8)result >= 0))
        {SETFLAG_V1} else {SETFLAG_V0}

        SETFLAG_H(half > 0xF);
        SETFLAG_Z(result == 0);
        SETFLAG_N1;
        rCodeB(rg->slot) = result;
        rg->timer += 4;
        break;  }

  case 1: { rCodeW(rg->slot) -= val; rg->timer += 4; break; }

  case 2: { rCodeL(rg->slot) -= val; rg->timer += 5; break; }
  }
}

//===== SCC cc,r
__inline void regSCC(tw*rg)
{
  _u32 result;

  if (conditionCode(rg,rg->opcode2 & 0xF))
    result = 1;
  else
    result = 0;

  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = (_u8)result; break;
  case 1: rCodeW(rg->slot) = (_u16)result; break;
  }

  rg->timer += 6;
}

//===== LD rg->regsel,r
__inline void regLDRr(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = rCodeB(rg->slot);  break;
  case 1: regW(rg->regsel) = rCodeW(rg->slot);  break;
  case 2: regL(rg->regsel) = rCodeL(rg->slot);  break;
  }

  rg->timer += 4;
}

//===== LD r,rg->regsel
__inline void regLDrR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = regB(rg->regsel);  break;
  case 1: rCodeW(rg->slot) = regW(rg->regsel);  break;
  case 2: rCodeL(rg->slot) = regL(rg->regsel);  break;
  }

  rg->timer += 4;
}

//===== ADD rg->regsel,r
__inline void regADD(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = generic_ADD_B(rg,regB(rg->regsel), rCodeB(rg->slot)); rg->timer += 4; break;
  case 1: regW(rg->regsel) = generic_ADD_W(rg,regW(rg->regsel), rCodeW(rg->slot)); rg->timer += 4; break;
  case 2: regL(rg->regsel) = generic_ADD_L(rg,regL(rg->regsel), rCodeL(rg->slot)); rg->timer += 7; break;
  }
}

//===== ADC rg->regsel,r
__inline void regADC(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = generic_ADC_B(rg,regB(rg->regsel), rCodeB(rg->slot)); rg->timer += 4; break;
  case 1: regW(rg->regsel) = generic_ADC_W(rg,regW(rg->regsel), rCodeW(rg->slot)); rg->timer += 4; break;
  case 2: regL(rg->regsel) = generic_ADC_L(rg,regL(rg->regsel), rCodeL(rg->slot)); rg->timer += 7; break;
  }
}

//===== SUB rg->regsel,r
__inline void regSUB(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = generic_SUB_B(rg,regB(rg->regsel), rCodeB(rg->slot)); rg->timer += 4; break;
  case 1: regW(rg->regsel) = generic_SUB_W(rg,regW(rg->regsel), rCodeW(rg->slot)); rg->timer += 4; break;
  case 2: regL(rg->regsel) = generic_SUB_L(rg,regL(rg->regsel), rCodeL(rg->slot)); rg->timer += 7; break;
  }
}

//===== SBC rg->regsel,r
__inline void regSBC(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = generic_SBC_B(rg,regB(rg->regsel), rCodeB(rg->slot)); rg->timer += 4; break;
  case 1: regW(rg->regsel) = generic_SBC_W(rg,regW(rg->regsel), rCodeW(rg->slot)); rg->timer += 4; break;
  case 2: regL(rg->regsel) = generic_SBC_L(rg,regL(rg->regsel), rCodeL(rg->slot)); rg->timer += 7; break;
  }
}

//===== LD r,#3
__inline void regLDr3(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = rg->regsel;  break;
  case 1: rCodeW(rg->slot) = rg->regsel;  break;
  case 2: rCodeL(rg->slot) = rg->regsel;  break;
  }

  rg->timer += 4;
}

//===== EX rg->regsel,r
__inline void regEX(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8  temp = regB(rg->regsel); regB(rg->regsel) = rCodeB(rg->slot); rCodeB(rg->slot) = temp; break;}
  case 1: { _u16 temp = regW(rg->regsel); regW(rg->regsel) = rCodeW(rg->slot); rCodeW(rg->slot) = temp; break;}
  case 2: { _u32 temp = regL(rg->regsel); regL(rg->regsel) = rCodeL(rg->slot); rCodeL(rg->slot) = temp; break;}
  }

  rg->timer += 5;
}

//===== ADD r,#
__inline void regADDi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = generic_ADD_B(rg,rCodeB(rg->slot), FETCH8); rg->timer += 4;break;
  case 1: rCodeW(rg->slot) = generic_ADD_W(rg,rCodeW(rg->slot), fetch16(rg)); rg->timer += 4;break;
  case 2: rCodeL(rg->slot) = generic_ADD_L(rg,rCodeL(rg->slot), fetch32(rg)); rg->timer += 7;break;
  }
}

//===== ADC r,#
__inline void regADCi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = generic_ADC_B(rg,rCodeB(rg->slot), FETCH8); rg->timer += 4;break;
  case 1: rCodeW(rg->slot) = generic_ADC_W(rg,rCodeW(rg->slot), fetch16(rg)); rg->timer += 4;break;
  case 2: rCodeL(rg->slot) = generic_ADC_L(rg,rCodeL(rg->slot), fetch32(rg)); rg->timer += 7;break;
  }
}

//===== SUB r,#
__inline void regSUBi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = generic_SUB_B(rg,rCodeB(rg->slot), FETCH8); rg->timer += 4;break;
  case 1: rCodeW(rg->slot) = generic_SUB_W(rg,rCodeW(rg->slot), fetch16(rg)); rg->timer += 4;break;
  case 2: rCodeL(rg->slot) = generic_SUB_L(rg,rCodeL(rg->slot), fetch32(rg)); rg->timer += 7;break;
  }
}

//===== SBC r,#
__inline void regSBCi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: rCodeB(rg->slot) = generic_SBC_B(rg,rCodeB(rg->slot), FETCH8); rg->timer += 4;break;
  case 1: rCodeW(rg->slot) = generic_SBC_W(rg,rCodeW(rg->slot), fetch16(rg)); rg->timer += 4;break;
  case 2: rCodeL(rg->slot) = generic_SBC_L(rg,rCodeL(rg->slot), fetch32(rg)); rg->timer += 7;break;
  }
}

//===== CP r,#
__inline void regCPi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: generic_SUB_B(rg,rCodeB(rg->slot), FETCH8); rg->timer += 4;break;
  case 1: generic_SUB_W(rg,rCodeW(rg->slot), fetch16(rg));rg->timer += 4; break;
  case 2: generic_SUB_L(rg,rCodeL(rg->slot), fetch32(rg));rg->timer += 7; break;
  }
}

//===== AND r,#
__inline void regANDi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = rCodeB(rg->slot) & FETCH8;
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80);
        parityB(rg,result);
        rg->timer += 4;
        break; }
  
  case 1: { _u16 result = rCodeW(rg->slot) & fetch16(rg);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x8000);
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = rCodeL(rg->slot) & fetch32(rg);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80000000);
        rg->timer += 7;
        break; }
  }

  SETFLAG_H1;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== OR r,#
__inline void regORi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = rCodeB(rg->slot) | FETCH8;
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        rCodeB(rg->slot) = result;
        parityB(rg,result);
        rg->timer += 4;
        break; }

  case 1: { _u16 result = rCodeW(rg->slot) | fetch16(rg);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        rCodeW(rg->slot) = result;
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = rCodeL(rg->slot) | fetch32(rg);
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        rCodeL(rg->slot) = result;
        rg->timer += 7;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== XOR r,#
__inline void regXORi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = rCodeB(rg->slot) ^ FETCH8;
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        rCodeB(rg->slot) = result;
        parityB(rg,result);
        rg->timer += 4;
        break; }

  case 1: { _u16 result = rCodeW(rg->slot) ^ fetch16(rg);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        rCodeW(rg->slot) = result;
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = rCodeL(rg->slot) ^ fetch32(rg);
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        rCodeL(rg->slot) = result;
        rg->timer += 7;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== AND rg->regsel,r
__inline void regAND(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) & rCodeB(rg->slot);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        regB(rg->regsel) = result;
        parityB(rg,result);
        rg->timer += 4;
        break; }

  case 1: { _u16 result = regW(rg->regsel) & rCodeW(rg->slot);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        regW(rg->regsel) = result;
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = regL(rg->regsel) & rCodeL(rg->slot);
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        regL(rg->regsel) = result;
        rg->timer += 7;
        break; }
  }

  SETFLAG_H1;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== OR rg->regsel,r
__inline void regOR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) | rCodeB(rg->slot);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        regB(rg->regsel) = result;
        parityB(rg,result);
        rg->timer += 4;
        break; }

  case 1: { _u16 result = regW(rg->regsel) | rCodeW(rg->slot);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        regW(rg->regsel) = result;
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = regL(rg->regsel) | rCodeL(rg->slot);
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        regL(rg->regsel) = result;
        rg->timer += 7;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== XOR rg->regsel,r
__inline void regXOR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) ^ rCodeB(rg->slot);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        regB(rg->regsel) = result;
        parityB(rg,result);
        rg->timer += 4;
        break; }

  case 1: { _u16 result = regW(rg->regsel) ^ rCodeW(rg->slot);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        regW(rg->regsel) = result;
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = regL(rg->regsel) ^ rCodeL(rg->slot);
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        regL(rg->regsel) = result;
        rg->timer += 7;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== CP r,#3
__inline void regCPr3(tw*rg)
{ 
  switch(rg->argsize)
  {
  case 0: generic_SUB_B(rg,rCodeB(rg->slot), rg->regsel);  break;
  case 1: generic_SUB_W(rg,rCodeW(rg->slot), rg->regsel);  break;
  }

  rg->timer += 4;
}

//===== CP rg->regsel,r
__inline void regCP(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: generic_SUB_B(rg,regB(rg->regsel), rCodeB(rg->slot));rg->timer += 4; break;
  case 1: generic_SUB_W(rg,regW(rg->regsel), rCodeW(rg->slot));rg->timer += 4; break;
  case 2: generic_SUB_L(rg,regL(rg->regsel), rCodeL(rg->slot));rg->timer += 7; break;
  }
}

//===== RLC #,r
__inline void regRLCi(tw*rg)
{
  int i;
  _u8 sa = FETCH8 & 0xF;
  if (sa == 0) sa = 16;

  switch(rg->argsize)
  {
  case 0:   for (i = 0; i < sa; i++) 
        {
          SETFLAG_C(rCodeB(rg->slot) & 0x80);
          rCodeB(rg->slot) <<= 1;
          if (FLAG_C) rCodeB(rg->slot) |= 1;
        }
        SETFLAG_S(rCodeB(rg->slot) & 0x80);
        SETFLAG_Z(rCodeB(rg->slot) == 0);
        parityB(rg,rCodeB(rg->slot));
        rg->timer += 6 + (2*sa);
        break;
    
  case 1:   for (i = 0; i < sa; i++) 
        { 
          SETFLAG_C(rCodeW(rg->slot) & 0x8000); 
          rCodeW(rg->slot) <<= 1;
          if (FLAG_C) rCodeW(rg->slot) |= 1;
        }
        SETFLAG_S(rCodeW(rg->slot) & 0x8000);
        SETFLAG_Z(rCodeW(rg->slot) == 0);
        parityW(rg,rCodeW(rg->slot));
        rg->timer += 6 + (2*sa);
        break;

  case 2:   for (i = 0; i < sa; i++) 
        {
          SETFLAG_C(rCodeL(rg->slot) & 0x80000000);
          rCodeL(rg->slot) <<= 1;
          if (FLAG_C) rCodeL(rg->slot) |= 1;
        }
        SETFLAG_S(rCodeL(rg->slot) & 0x80000000);
        SETFLAG_Z(rCodeL(rg->slot) == 0);
        rg->timer += 8 + (2*sa);
        break;
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== RRC #,r
__inline void regRRCi(tw*rg)
{
  int i;
  _u8 sa = FETCH8 & 0xF;
  if (sa == 0) sa = 16;

  switch(rg->argsize)
  {
  case 0:   for (i = 0; i < sa; i++) 
        {
          SETFLAG_C(rCodeB(rg->slot) & 1);
          rCodeB(rg->slot) >>= 1;
          if (FLAG_C) rCodeB(rg->slot) |= 0x80;
        }
        SETFLAG_S(rCodeB(rg->slot) & 0x80);
        SETFLAG_Z(rCodeB(rg->slot) == 0);
        parityB(rg,rCodeB(rg->slot));

        rg->timer += 6 + (2*sa);
        break;
    
  case 1:   for (i = 0; i < sa; i++) 
        {
          SETFLAG_C(rCodeW(rg->slot) & 1);
          rCodeW(rg->slot) >>= 1;
          if (FLAG_C) rCodeW(rg->slot) |= 0x8000;
        }
        SETFLAG_S(rCodeW(rg->slot) & 0x8000);
        SETFLAG_Z(rCodeW(rg->slot) == 0);
        parityW(rg,rCodeW(rg->slot));
        rg->timer += 6 + (2*sa);
        break;

  case 2:   for (i = 0; i < sa; i++) 
        {
          SETFLAG_C(rCodeL(rg->slot) & 1);
          rCodeL(rg->slot) >>= 1;
          if (FLAG_C) rCodeL(rg->slot) |= 0x80000000;
        }
        SETFLAG_S(rCodeL(rg->slot) & 0x80000000);
        SETFLAG_Z(rCodeL(rg->slot) == 0);
        rg->timer += 8 + (2*sa);
        break;
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== RL #,r
__inline void regRLi(tw*rg)
{
  int i;
  BOOL tem_pc;
  _u8 sa = FETCH8 & 0xF;
  if (sa == 0) sa = 16;

  switch(rg->argsize)
  {
  case 0: { _u8 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeB(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x80);
          result <<= 1;
          if (tem_pc) result |= 1;
          rCodeB(rg->slot) = result;
        }
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 6 + (2*sa);
        break; }
    
  case 1: { _u16 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeW(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x8000);
          result <<= 1;
          if (tem_pc) result |= 1;
          rCodeW(rg->slot) = result;
        }
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 6 + (2*sa);
        break; }

  case 2: { _u32 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeL(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x80000000);
          result <<= 1;
          if (tem_pc) result |= 1;
          rCodeL(rg->slot) = result;
        }
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        rg->timer += 8 + (2*sa);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== RR #,r
__inline void regRRi(tw*rg)
{
  int i;
  BOOL tem_pc;
  _u8 sa = FETCH8 & 0xF;
  if (sa == 0) sa = 16;

  switch(rg->argsize)
  {
  case 0: { _u8 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeB(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x01);
          result >>= 1;
          if (tem_pc) result |= 0x80;
          rCodeB(rg->slot) = result;
        }
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        rg->timer += 6 + (2*sa);
        parityB(rg,result);
        break; }
    
  case 1: { _u16 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeW(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x01);
          result >>= 1;
          if (tem_pc) result |= 0x8000;
          rCodeW(rg->slot) = result;
        }
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        rg->timer += 6 + (2*sa);
        parityW(rg,result);
        break; }

  case 2: { _u32 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeL(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x01);
          result >>= 1;
          if (tem_pc) result |= 0x80000000;
          rCodeL(rg->slot) = result;
        }
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        rg->timer += 8 + (2*sa);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== SLA #,r
__inline void regSLAi(tw*rg)
{
  _s8 sa = FETCH8 & 0xF;
  if (sa == 0) sa = 16;
  sa--;

  switch(rg->argsize)
  {
  case 0: { _s8 result, data = (_s8)rCodeB(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x80);
        result <<= 1;
        SETFLAG_S(result & 0x80);
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 8 + (2*sa);
        break;  }
  
  case 1: { _s16 result, data = (_s16)rCodeW(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x8000);
        result <<= 1;
        SETFLAG_S(result & 0x8000);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8 + (2*sa);
        break;  }

  case 2: { _s32 result, data = (_s32)rCodeL(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x80000000);
        result <<= 1;
        SETFLAG_S(result & 0x80000000);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        rg->timer += 10 + (2*sa);
        break;  }

  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== SRA #,r
__inline void regSRAi(tw*rg)
{
  _s8 sa = FETCH8 & 0xF;
  if (sa == 0) sa = 16;
  sa--;

  switch(rg->argsize)
  {
  case 0: { _s8 data = (_s8)rCodeB(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x80);
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 8 + (2*sa);
        break; }

  case 1: { _s16 data = (_s16)rCodeW(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x8000);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8 + (2*sa);
        break; }

  case 2: { _s32 data = (_s32)rCodeL(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x80000000);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        rg->timer += 10 + (2*sa);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== SLL #,r
__inline void regSLLi(tw*rg)
{
  _u8 sa = FETCH8 & 0xF;
  if (sa == 0) sa = 16;
  sa--;

  switch(rg->argsize)
  {
  case 0: { _u8 result, data = rCodeB(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x80);
        result <<= 1;
        SETFLAG_S(result & 0x80);
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 8 + (2*sa);
        break;  }
  
  case 1: { _u16 result, data = rCodeW(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x8000);
        result <<= 1;
        SETFLAG_S(result & 0x8000);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8 + (2*sa);
        break;  }

  case 2: { _u32 result, data = rCodeL(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x80000000);
        result <<= 1;
        SETFLAG_S(result & 0x80000000);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        rg->timer += 10 + (2*sa);
        break;  }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== SRL #,r
__inline void regSRLi(tw*rg)
{
  _u8 sa = FETCH8 & 0xF;
  if (sa == 0) sa = 16;
  sa--;

  switch(rg->argsize)
  {
  case 0: { _u8 data = rCodeB(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x80);
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 8 + (2*sa);
        break; }

  case 1: { _u16 data = rCodeW(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x8000);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8 + (2*sa);
        break; }

  case 2: { _u32 data = rCodeL(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x80000000);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        rg->timer += 10 + (2*sa);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== RLC A,r
__inline void regRLCA(tw*rg)
{
  int i;
  _u8 sa = REGA & 0xF;
  if (sa == 0) sa = 16;

  switch(rg->argsize)
  {
  case 0: for (i = 0; i < sa; i++) 
      {
        SETFLAG_C(rCodeB(rg->slot) & 0x80); 
        rCodeB(rg->slot) <<= 1;
        if (FLAG_C) rCodeB(rg->slot) |= 1; 
      }
      SETFLAG_S(rCodeB(rg->slot) & 0x80);
      SETFLAG_Z(rCodeB(rg->slot) == 0);
      rg->timer += 6 + (2*sa);
      parityB(rg,rCodeB(rg->slot));
      break;
    
  case 1: for (i = 0; i < sa; i++) 
      {
        SETFLAG_C(rCodeW(rg->slot) & 0x8000);
        rCodeW(rg->slot) <<= 1;
        if (FLAG_C) rCodeW(rg->slot) |= 1;
      }
      SETFLAG_S(rCodeW(rg->slot) & 0x8000);
      SETFLAG_Z(rCodeW(rg->slot) == 0);
      rg->timer += 6 + (2*sa);
      parityW(rg,rCodeW(rg->slot));
      break;

  case 2: for (i = 0; i < sa; i++) 
      {
        SETFLAG_C(rCodeL(rg->slot) & 0x80000000);
        rCodeL(rg->slot) <<= 1;
        if (FLAG_C) rCodeL(rg->slot) |= 1;
      }
      SETFLAG_S(rCodeL(rg->slot) & 0x80000000);
      SETFLAG_Z(rCodeL(rg->slot) == 0);
      rg->timer += 8 + (2*sa);
      break;
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== RRC A,r
__inline void regRRCA(tw*rg)
{
  int i;
  _u8 sa = REGA & 0xF;
  if (sa == 0) sa = 16;

  switch(rg->argsize)
  {
  case 0: for (i = 0; i < sa; i++) 
      {
        SETFLAG_C(rCodeB(rg->slot) & 1);
        rCodeB(rg->slot) >>= 1;
        if (FLAG_C) rCodeB(rg->slot) |= 0x80;  
      }
      SETFLAG_S(rCodeB(rg->slot) & 0x80);
      SETFLAG_Z(rCodeB(rg->slot) == 0);
      parityB(rg,rCodeB(rg->slot));
      rg->timer += 6 + (2*sa);
      break;
    
  case 1: for (i = 0; i < sa; i++) 
      {
        SETFLAG_C(rCodeW(rg->slot) & 1); 
        rCodeW(rg->slot) >>= 1;
        if (FLAG_C) rCodeW(rg->slot) |= 0x8000;
      }
      SETFLAG_S(rCodeW(rg->slot) & 0x8000);
      SETFLAG_Z(rCodeW(rg->slot) == 0);
      parityW(rg,rCodeW(rg->slot));
      rg->timer += 6 + (2*sa);
      break;

  case 2: for (i = 0; i < sa; i++) 
      {
        SETFLAG_C(rCodeL(rg->slot) & 1);
        rCodeL(rg->slot) >>= 1;
        if (FLAG_C) rCodeL(rg->slot) |= 0x80000000;
      }
      SETFLAG_S(rCodeL(rg->slot) & 0x80000000);
      SETFLAG_Z(rCodeL(rg->slot) == 0);
      rg->timer += 8 + (2*sa);
      break;
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== RL A,r
__inline void regRLA(tw*rg)
{
  int i;
  BOOL tem_pc;
  _u8 sa = REGA & 0xF;
  if (sa == 0) sa = 16;

  switch(rg->argsize)
  {
  case 0: { _u8 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeB(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x80);
          result <<= 1;
          if (tem_pc) result |= 1;
          rCodeB(rg->slot) = result;
        }
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        rg->timer += 6 + (2*sa);
        parityB(rg,result);
        break; }
    
  case 1: { _u16 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeW(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x8000);
          result <<= 1;
          if (tem_pc) result |= 1;
          rCodeW(rg->slot) = result;
        }
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        rg->timer += 6 + (2*sa);
        parityW(rg,result);
        break; }

  case 2: { _u32 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeL(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x80000000);
          result <<= 1;
          if (tem_pc) result |= 1;
          rCodeL(rg->slot) = result;
        }
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        rg->timer += 8 + (2*sa);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== RR A,r
__inline void regRRA(tw*rg)
{
  int i;
  BOOL tem_pc;
  _u8 sa = REGA & 0xF;
  if (sa == 0) sa = 16;

  switch(rg->argsize)
  {
  case 0: { _u8 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeB(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x01);
          result >>= 1;
          if (tem_pc) result |= 0x80;
          rCodeB(rg->slot) = result;
        }
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        rg->timer += 6 + (2*sa);
        parityB(rg,result);
        break; }
    
  case 1: { _u16 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeW(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x01);
          result >>= 1;
          if (tem_pc) result |= 0x8000;
          rCodeW(rg->slot) = result;
        }
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        rg->timer += 6 + (2*sa);
        parityW(rg,result);
        break; }

  case 2: { _u32 result;
        for (i = 0; i < sa; i++) 
        {
          result = rCodeL(rg->slot);
          tem_pc = FLAG_C;
          SETFLAG_C(result & 0x01);
          result >>= 1;
          if (tem_pc) result |= 0x80000000;
          rCodeL(rg->slot) = result;
        }
        SETFLAG_S(result & 0x80000000);
        SETFLAG_Z(result == 0);
        rg->timer += 8 + (2*sa);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== SLA A,r
__inline void regSLAA(tw*rg)
{
  _s8 sa = REGA & 0xF;
  if (sa == 0) sa = 16;
  sa--;

  switch(rg->argsize)
  {
  case 0: { _s8 result, data = (_s8)rCodeB(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x80);
        result <<= 1;
        SETFLAG_S(result & 0x80);
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 8 + (2*sa);
        break;  }
  
  case 1: { _s16 result, data = (_s16)rCodeW(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x8000);
        result <<= 1;
        SETFLAG_S(result & 0x8000);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8 + (2*sa);
        break;  }

  case 2: { _s32 result, data = (_s32)rCodeL(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x80000000);
        result <<= 1;
        SETFLAG_S(result & 0x80000000);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        rg->timer += 10 + (2*sa);
        break;  }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== SRA A,r
__inline void regSRAA(tw*rg)
{
  _s8 sa = REGA & 0xF;
  if (sa == 0) sa = 16;
  sa--;

  switch(rg->argsize)
  {
  case 0: { _s8 data = (_s8)rCodeB(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x80);
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 8 + (2*sa);
        break; }

  case 1: { _s16 data = (_s16)rCodeW(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x8000);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8 + (2*sa);
        break; }

  case 2: { _s32 data = (_s32)rCodeL(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x80000000);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        rg->timer += 10 + (2*sa);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== SLL A,r
__inline void regSLLA(tw*rg)
{
  _u8 sa = REGA & 0xF;
  if (sa == 0) sa = 16;
  sa--;

  switch(rg->argsize)
  {
  case 0: { _u8 result, data = rCodeB(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x80);
        result <<= 1;
        SETFLAG_S(result & 0x80);
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 8 + (2*sa);
        break;  }
  
  case 1: { _u16 result, data = rCodeW(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x8000);
        result <<= 1;
        SETFLAG_S(result & 0x8000);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8 + (2*sa);
        break;  }

  case 2: { _u32 result, data = rCodeL(rg->slot);
        result = (data << sa);
        SETFLAG_C(result & 0x80000000);
        result <<= 1;
        SETFLAG_S(result & 0x80000000);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        rg->timer += 10 + (2*sa);
        break;  }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== SRL A,r
__inline void regSRLA(tw*rg)
{
  _u8 sa = REGA & 0xF;
  if (sa == 0) sa = 16;
  sa--;

  switch(rg->argsize)
  {
  case 0: { _u8 data = rCodeB(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x80);
        rCodeB(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 8 + (2*sa);
        break; }

  case 1: { _u16 data = rCodeW(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x8000);
        rCodeW(rg->slot) = result;
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8 + (2*sa);
        break; }

  case 2: { _u32 data = rCodeL(rg->slot), result;
        result = (data >> sa);
        SETFLAG_C(result & 1);
        result >>= 1;
        SETFLAG_S(result & 0x80000000);
        rCodeL(rg->slot) = result;
        SETFLAG_Z(result == 0);
        rg->timer += 10 + (2*sa);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
}

//=============================================================================


// INTERPRETEUR SINGLE


//=========================================================================

//===== NOP
__inline void sngNOP(tw*rg)
{
  rg->timer += 2;
}

//===== NORMAL
__inline void sngNORMAL(tw*rg)
{
  //Not supported
  rg->timer += 4;
}

//===== PUSH SR
__inline void sngPUSHSR(tw*rg)
{
  push16(rg,(rg->status));
  rg->timer += 4;
}

//===== POP SR
__inline void sngPOPSR(tw*rg)
{
  (rg->status) = pop16(rg); inchangedSP(rg);
  rg->timer += 6;
}

//===== MAX
__inline void sngMAX(tw*rg)
{
  //Not supported
  rg->timer += 4;
}

//===== HALT
__inline void sngHALT(tw*rg)
{
  system_message("CPU halt requested and ignored.\nPlease send me a saved state.");
  rg->timer += 8;
}

//===== EI #3
__inline void sngEI(tw*rg)
{
  setStatusIFF(rg,FETCH8);
  rg->timer += 5;
}

//===== RETI
__inline void sngRETI(tw*rg)
{
  _u16 temp = pop16(rg);
  set_pc(rg,pop32(rg));
  (rg->status) = temp; inchangedSP(rg);
  rg->timer += 12;
}

//===== LD (n), n
__inline void sngLD8_8(tw*rg)
{
  _u8 dst = FETCH8;
  _u8 src = FETCH8;
  storeB(dst, src);
  rg->timer += 5;
}

//===== PUSH n
__inline void sngPUSH8(tw*rg)
{
  _u8 data = FETCH8;
  push8(rg,data);
  rg->timer += 4;
}

//===== LD (n), nn
__inline void sngLD8_16(tw*rg)
{
  _u8 dst = FETCH8;
  _u16 src = fetch16(rg);
  storeW(dst, src);
  rg->timer += 6;
}

//===== PUSH nn
__inline void sngPUSH16(tw*rg)
{
  push16(rg,fetch16(rg));
  rg->timer += 5;
}

//===== INCF
__inline void sngINCF(tw*rg)
{
  setStatusRFP(rg,(((rg->status) & 0x300) >> 8) + 1);
  rg->timer += 2;
}

//===== DECF
__inline void sngDECF(tw*rg)
{
  setStatusRFP(rg,(((rg->status) & 0x300) >> 8) - 1);
  rg->timer += 2;
}

//===== RET condition
__inline void sngRET(tw*rg)
{
  set_pc(rg,pop32(rg));
  rg->timer += 9;
}

//===== RETD dd
__inline void sngRETD(tw*rg)
{
  _s16 d = (_s16)fetch16(rg);
  set_pc(rg,pop32(rg));
  REGXSP += d;
  rg->timer += 9;
}

//===== RCF
__inline void sngRCF(tw*rg)
{
  SETFLAG_N0;
  SETFLAG_V0;
  SETFLAG_C0;
  rg->timer += 2;
}

//===== SCF
__inline void sngSCF(tw*rg)
{
  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C1;
  rg->timer += 2;
}

//===== CCF
__inline void sngCCF(tw*rg)
{
  SETFLAG_N0;
  SETFLAG_C(!FLAG_C);
  rg->timer += 2;
}

//===== ZCF
__inline void sngZCF(tw*rg)
{
  SETFLAG_N0;
  SETFLAG_C(!FLAG_Z);
  rg->timer += 2;
}

//===== PUSH A
__inline void sngPUSHA(tw*rg)
{
  push8(rg,REGA);
  rg->timer += 3;
}

//===== POP A
__inline void sngPOPA(tw*rg)
{
  REGA = pop8(rg);
  rg->timer += 4;
}

//===== EX F,F'
__inline void sngEX(tw*rg)
{
  _u8 f = (rg->status) & 0xFF;
  (rg->status) = ((rg->status) & 0xFF00) | f_dash;
  f_dash = f;
  rg->timer += 2;
}

//===== LDF #3
__inline void sngLDF(tw*rg)
{
  setStatusRFP(rg,FETCH8);
  rg->timer += 2;
}

//===== PUSH F
__inline void sngPUSHF(tw*rg)
{
  push8(rg,(rg->status) & 0xFF);
  rg->timer += 3;
}

//===== POP F
__inline void sngPOPF(tw*rg)
{
  (rg->status) = ((rg->status) & 0xFF00) | pop8(rg);
  rg->timer += 4;
}

//===== JP nn
__inline void sngJP16(tw*rg)
{
  set_pc(rg,fetch16(rg));
  rg->timer += 7;
}

//===== JP nnn
__inline void sngJP24(tw*rg)
{
  set_pc(rg,fetch24(rg));
  rg->timer += 7;
}

//===== CALL #16
__inline void sngCALL16(tw*rg)
{
  _u32 target = fetch16(rg);
  push32(rg,get_pc(rg));
  set_pc(rg,target);
  rg->timer += 12;
}

//===== CALL #24
__inline void sngCALL24(tw*rg)
{
  _u32 target = fetch24(rg);
  push32(rg,get_pc(rg));
  set_pc(rg,target);
  rg->timer += 12;
}

//===== CALR $+3+d16
__inline void sngCALR(tw*rg)
{
  _u32 target = (_s16)fetch16(rg) + get_pc(rg);
  push32(rg,get_pc(rg));
  set_pc(rg,target);
  rg->timer += 12;
}

//===== LD rg->regsel, n
__inline void sngLDB0(tw*rg)
{
  regB0 = FETCH8;
  rg->timer += 2;
}
__inline void sngLDB1(tw*rg)
{
  regB1 = FETCH8;
  rg->timer += 2;
}
__inline void sngLDB2(tw*rg)
{
  regB2 = FETCH8;
  rg->timer += 2;
}
__inline void sngLDB3(tw*rg)
{
  regB3 = FETCH8;
  rg->timer += 2;
}
__inline void sngLDB4(tw*rg)
{
  regB4 = FETCH8;
  rg->timer += 2;
}
__inline void sngLDB5(tw*rg)
{
  regB5 = FETCH8;
  rg->timer += 2;
}
__inline void sngLDB6(tw*rg)
{
  regB6 = FETCH8;
  rg->timer += 2;
}
__inline void sngLDB7(tw*rg)
{
  regB7 = FETCH8;
  rg->timer += 2;
}

//===== PUSH RR
__inline void sngPUSHW0(tw*rg)
{
  push16(rg,regW0);
  rg->timer += 3;
}
__inline void sngPUSHW1(tw*rg)
{
  push16(rg,regW1);
  rg->timer += 3;
}
__inline void sngPUSHW2(tw*rg)
{
  push16(rg,regW2);
  rg->timer += 3;
}
__inline void sngPUSHW3(tw*rg)
{
  push16(rg,regW3);
  rg->timer += 3;
}
__inline void sngPUSHW4(tw*rg)
{
  push16(rg,regW4);
  rg->timer += 3;
}
__inline void sngPUSHW5(tw*rg)
{
  push16(rg,regW5);
  rg->timer += 3;
}
__inline void sngPUSHW6(tw*rg)
{
  push16(rg,regW6);
  rg->timer += 3;
}
__inline void sngPUSHW7(tw*rg)
{
  push16(rg,regW7);
  rg->timer += 3;
}

//===== LD RR, nn
__inline void sngLDW0(tw*rg)
{
  regW0 = fetch16(rg);
  rg->timer += 3;
}
__inline void sngLDW1(tw*rg)
{
  regW1 = fetch16(rg);
  rg->timer += 3;
}
__inline void sngLDW2(tw*rg)
{
  regW2 = fetch16(rg);
  rg->timer += 3;
}
__inline void sngLDW3(tw*rg)
{
  regW3 = fetch16(rg);
  rg->timer += 3;
}
__inline void sngLDW4(tw*rg)
{
  regW4 = fetch16(rg);
  rg->timer += 3;
}
__inline void sngLDW5(tw*rg)
{
  regW5 = fetch16(rg);
  rg->timer += 3;
}
__inline void sngLDW6(tw*rg)
{
  regW6 = fetch16(rg);
  rg->timer += 3;
}
__inline void sngLDW7(tw*rg)
{
  regW7 = fetch16(rg);
  rg->timer += 3;
}

//===== PUSH XRR
__inline void sngPUSHL0(tw*rg)
{
  push32(rg,regL0);
  rg->timer += 5;
}
__inline void sngPUSHL1(tw*rg)
{
  push32(rg,regL1);
  rg->timer += 5;
}
__inline void sngPUSHL2(tw*rg)
{
  push32(rg,regL2);
  rg->timer += 5;
}
__inline void sngPUSHL3(tw*rg)
{
  push32(rg,regL3);
  rg->timer += 5;
}
__inline void sngPUSHL4(tw*rg)
{
  push32(rg,regL4);
  rg->timer += 5;
}
__inline void sngPUSHL5(tw*rg)
{
  push32(rg,regL5);
  rg->timer += 5;
}
__inline void sngPUSHL6(tw*rg)
{
  push32(rg,regL6);
  rg->timer += 5;
}
__inline void sngPUSHL7(tw*rg)
{
  push32(rg,regL7);
  rg->timer += 5;
}

//===== LD XRR, nnnn
__inline void sngLDL0(tw*rg)
{
  regL0 = fetch32(rg);
  rg->timer += 5;
}
__inline void sngLDL1(tw*rg)
{
  regL1 = fetch32(rg);
  rg->timer += 5;
}
__inline void sngLDL2(tw*rg)
{
  regL2 = fetch32(rg);
  rg->timer += 5;
}
__inline void sngLDL3(tw*rg)
{
  regL3 = fetch32(rg);
  rg->timer += 5;
}
__inline void sngLDL4(tw*rg)
{
  regL4 = fetch32(rg);
  rg->timer += 5;
}
__inline void sngLDL5(tw*rg)
{
  regL5 = fetch32(rg);
  rg->timer += 5;
}
__inline void sngLDL6(tw*rg)
{
  regL6 = fetch32(rg);
  rg->timer += 5;
}
__inline void sngLDL7(tw*rg)
{
  regL7 = fetch32(rg);
  rg->timer += 5;
}

//===== POP RR
__inline void sngPOPW0(tw*rg)
{
  regW0 = pop16(rg);
  rg->timer += 4;
}
__inline void sngPOPW1(tw*rg)
{
  regW1 = pop16(rg);
  rg->timer += 4;
}
__inline void sngPOPW2(tw*rg)
{
  regW2 = pop16(rg);
  rg->timer += 4;
}
__inline void sngPOPW3(tw*rg)
{
  regW3 = pop16(rg);
  rg->timer += 4;
}
__inline void sngPOPW4(tw*rg)
{
  regW4 = pop16(rg);
  rg->timer += 4;
}
__inline void sngPOPW5(tw*rg)
{
  regW5 = pop16(rg);
  rg->timer += 4;
}
__inline void sngPOPW6(tw*rg)
{
  regW6 = pop16(rg);
  rg->timer += 4;
}
__inline void sngPOPW7(tw*rg)
{
  regW7 = pop16(rg);
  rg->timer += 4;
}

//===== POP XRR
__inline void sngPOPL0(tw*rg)
{
  regL0 = pop32(rg);
  rg->timer += 6;
}
__inline void sngPOPL1(tw*rg)
{
  regL1 = pop32(rg);
  rg->timer += 6;
}
__inline void sngPOPL2(tw*rg)
{
  regL2 = pop32(rg);
  rg->timer += 6;
}
__inline void sngPOPL3(tw*rg)
{
  regL3 = pop32(rg);
  rg->timer += 6;
}
__inline void sngPOPL4(tw*rg)
{
  regL4 = pop32(rg);
  rg->timer += 6;
}
__inline void sngPOPL5(tw*rg)
{
  regL5 = pop32(rg);
  rg->timer += 6;
}
__inline void sngPOPL6(tw*rg)
{
  regL6 = pop32(rg);
  rg->timer += 6;
}
__inline void sngPOPL7(tw*rg)
{
  regL7 = pop32(rg);
  rg->timer += 6;
}

/*
//===== JR cc,_pc + d
__inline void sngJR(tw*rg)
{
  if (conditionCode(rg,rg->opcode1 & 0xF))
  {
    rg->timer += 8;
    mov_pc( rg,(_s8)FETCH8 );
  }
  else
  {
    rg->timer += 4;
    FETCH8;
  }
}

//===== JRL cc,_pc + dd
__inline void sngJRL(tw*rg)
{
  if (conditionCode(rg,rg->opcode1 & 0xF))
  {
    rg->timer += 8;
    mov_pc( rg,(_s16)fetch16(rg) );
  }
  else
  {
    rg->timer += 4;
    fetch16(rg);
  }
}

*/

//POKE
//Comme ca on pourra facilement les mettre les macro dans des switch si on veut

#define aaJR(a)\
	{_s8 dep = FETCH8;if (a){rg->timer += 8;mov_pc(rg,dep);} else rg->timer += 4;}

void sngJR_F	(tw*rg)	aaJR(CF_F)
void sngJR_LT	(tw*rg)	aaJR(CF_LT)
void sngJR_LE	(tw*rg)	aaJR(CF_LE)
void sngJR_ULE	(tw*rg)	aaJR(CF_ULE)
void sngJR_OV	(tw*rg)	aaJR(CF_OV)
void sngJR_MI	(tw*rg)	aaJR(CF_MI)
void sngJR_Z	(tw*rg)	aaJR(CF_Z)
void sngJR_C	(tw*rg)	aaJR(CF_C)
void sngJR_T	(tw*rg)	aaJR(CF_T)
void sngJR_GE	(tw*rg)	aaJR(CF_GE)
void sngJR_GT	(tw*rg)	aaJR(CF_GT)
void sngJR_UGT	(tw*rg)	aaJR(CF_UGT)
void sngJR_NOV	(tw*rg)	aaJR(CF_NOV)
void sngJR_PL	(tw*rg)	aaJR(CF_PL)
void sngJR_NZ	(tw*rg)	aaJR(CF_NZ)
void sngJR_NC	(tw*rg)	aaJR(CF_NC)

#define aaJRL(a)\
	{_s16 dep = fetch16(rg);if (a){rg->timer += 8;mov_pc(rg,dep);} else rg->timer += 4;}

void sngJRL_F	(tw*rg)	aaJRL(CF_F)
void sngJRL_LT	(tw*rg)	aaJRL(CF_LT)
void sngJRL_LE	(tw*rg)	aaJRL(CF_LE)
void sngJRL_ULE	(tw*rg)	aaJRL(CF_ULE)
void sngJRL_OV	(tw*rg)	aaJRL(CF_OV)
void sngJRL_MI	(tw*rg)	aaJRL(CF_MI)
void sngJRL_Z	(tw*rg)	aaJRL(CF_Z)
void sngJRL_C	(tw*rg)	aaJRL(CF_C)
void sngJRL_T	(tw*rg)	aaJRL(CF_T)
void sngJRL_GE	(tw*rg)	aaJRL(CF_GE)
void sngJRL_GT	(tw*rg)	aaJRL(CF_GT)
void sngJRL_UGT	(tw*rg)	aaJRL(CF_UGT)
void sngJRL_NOV	(tw*rg)	aaJRL(CF_NOV)
void sngJRL_PL	(tw*rg)	aaJRL(CF_PL)
void sngJRL_NZ	(tw*rg)	aaJRL(CF_NZ)
void sngJRL_NC	(tw*rg)	aaJRL(CF_NC)



//===== LDX dst,src
__inline void sngLDX(tw*rg)
{
  _u8 dst, src;

  FETCH8;     //00
  dst = FETCH8; //#8
  FETCH8;     //00
  src = FETCH8; //#
  FETCH8;     //00

  storeB(dst, src);
  rg->timer += 9;
}

//===== SWI num
__inline void sngSWI(tw*rg)
{
  rg->timer += 16;

  switch(rg->opcode1 & 7)
  {
    //System Call
  case 1: push32(rg,get_pc(rg));  
      set_pc( rg,loadL(0xFFFE00 + (rCodeB(0x31) << 2)));
      break;

  case 3: interrupt(0); //SWI 3
      break;

  case 4: interrupt(1); //SWI 4
      break;

  case 5: interrupt(2); //SWI 5
      break;

  case 6: interrupt(3); //SWI 6
      break;

  default: break;
  }
}

//=============================================================================

// INTERPRETER SRC


//=========================================================================


//===== PUSH (rg->memadr)
__inline void srcPUSH(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: push8(rg,loadB(rg->memadr));  break;
  case 1: push16(rg,loadW(rg->memadr)); break;
  }
  rg->timer += 7;
}

//===== RLD A,(rg->memadr)
__inline void srcRLD(tw*rg)
{
  _u8 al = REGA & 0xF, m, mh, ml;

  m = loadB(rg->memadr);
  mh = (m & 0xF0) >> 4;
  ml = (m & 0x0F) << 4;
  
  REGA = (REGA & 0xF0) | mh;
  storeB(rg->memadr, ml | al);

  SETFLAG_S(REGA & 0x80);
  SETFLAG_Z(REGA == 0);
  SETFLAG_H0
  SETFLAG_N0
  parityB(rg,REGA);

  rg->timer += 12;
}

//===== RRD A,(rg->memadr)
__inline void srcRRD(tw*rg)
{
  _u8 al = (REGA & 0xF) << 4, m, mh, ml;

  m = loadB(rg->memadr);
  mh = (m & 0xF0) >> 4;
  ml = m & 0x0F;
  
  REGA = (REGA & 0xF0) | ml;
  storeB(rg->memadr, al | mh);

  SETFLAG_S(REGA & 0x80);
  SETFLAG_Z(REGA == 0);
  SETFLAG_H0
  SETFLAG_N0
  parityB(rg,REGA);

  rg->timer += 12;
}

//===== LDI
__inline void srcLDI(tw*rg)
{
  _u8 dst = 2/*XDE*/, src = 3/*XHL*/;
  if ((rg->opcode1 & 0xF) == 5) { dst = 4/*XIX*/; src = 5/*XIY*/; }

  switch(rg->argsize)
  {
  case 0:
    storeB(regL(dst), loadB(regL(src)));
    regL(dst) += 1;
    regL(src) += 1;
    break;

  case 1:
    storeW(regL(dst), loadW(regL(src)));
    regL(dst) += 2;
    regL(src) += 2;
    break;
  }

  REGBC --;
  SETFLAG_V(REGBC);

  SETFLAG_H0;
  SETFLAG_N0;
  rg->timer += 10;
}

//===== LDIR
__inline void srcLDIR(tw*rg)
{
  _u8 dst = 2/*XDE*/, src = 3/*XHL*/;
  if ((rg->opcode1 & 0xF) == 5) { dst = 4/*XIX*/; src = 5/*XIY*/; }

  rg->timer += 10;


  do
  {
    switch(rg->argsize)
    {
    case 0: if (debug_abort_memory == FALSE)
          storeB(regL(dst), loadB(regL(src)));
      regL(dst) += 1;
      regL(src) += 1;
      break;

    case 1: if (debug_abort_memory == FALSE)
          storeW(regL(dst), loadW(regL(src)));
      regL(dst) += 2;
      regL(src) += 2;
      break;
    }

    REGBC --;
    SETFLAG_V(REGBC);

    rg->timer += 14;
  }
  while (FLAG_V);

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== LDIR
__inline void srcLDIRnew(tw*rg)
{
  _u32  rsrc;
  _u32  rdst;
  _u32  cnt;

  _u8 dst = 2/*XDE*/, src = 3/*XHL*/;
  if ((rg->opcode1 & 0xF) == 5) { dst = 4/*XIX*/; src = 5/*XIY*/; }

  rg->timer += 10;

  rsrc = regL(src);
  rdst = regL(dst);
  cnt  = REGBC;
  
  if ( rg->argsize==0 )
  {
	do
  	{
       storeB(rdst, loadB(rsrc) );
       rdst+=1;
       rsrc+=1;
    } while ( --REGBC );
  }
  else if ( rg->argsize==1 )
  {
	do
  	{
       storeW(rdst, loadW(rsrc) );
       rdst+=2;
       rsrc+=2;
    } while ( --REGBC );
  }

  rg->timer += 14*cnt;
  regL(src) = rsrc;
  regL(dst) = rdst;

  REGBC = 0;
  SETFLAG_V(REGBC);
  SETFLAG_H0;
  SETFLAG_N0;
}

//===== LDD
__inline void srcLDD(tw*rg)
{
  _u8 dst = 2/*XDE*/, src = 3/*XHL*/;
  if ((rg->opcode1 & 0xF) == 5) { dst = 4/*XIX*/; src = 5/*XIY*/; }

  switch(rg->argsize)
  {
  case 0:
    storeB(regL(dst), loadB(regL(src)));
    regL(dst) -= 1;
    regL(src) -= 1;
    break;

  case 1:
    storeW(regL(dst), loadW(regL(src)));
    regL(dst) -= 2;
    regL(src) -= 2;
    break;
  }

  REGBC --;
  SETFLAG_V(REGBC);

  SETFLAG_H0;
  SETFLAG_N0;
  rg->timer += 10;
}

//===== LDDR
__inline void srcLDDR(tw*rg)
{
  _u8 dst = 2/*XDE*/, src = 3/*XHL*/;
  if ((rg->opcode1 & 0xF) == 5) { dst = 4/*XIX*/; src = 5/*XIY*/; }

  rg->timer += 10;

  do
  {
    switch(rg->argsize)
    {
    case 0:
      if (debug_abort_memory == FALSE)
        storeB(regL(dst), loadB(regL(src)));
      regL(dst) -= 1;
      regL(src) -= 1;
      break;

    case 1:
      if (debug_abort_memory == FALSE)
        storeW(regL(dst), loadW(regL(src)));
      regL(dst) -= 2;
      regL(src) -= 2;
      break;
    }

    REGBC --;
    SETFLAG_V(REGBC);

    rg->timer += 14;
  }
  while (FLAG_V);

  SETFLAG_H0;
  SETFLAG_N0;
}

//===== CPI
__inline void srcCPI(tw*rg)
{
  _u8 TR = rg->opcode1 & 7;

  switch(rg->argsize)
  {
  case 0: generic_SUB_B(rg,REGA, loadB(regL(TR)));
      regL(TR) ++; break;

  case 1: generic_SUB_W(rg,REGWA, loadW(regL(TR)));
      regL(TR) += 2; break;
  }

  REGBC --;
  SETFLAG_V(REGBC);

  rg->timer += 8;
}

//===== CPIR
__inline void srcCPIR(tw*rg)
{
  _u8 TR = rg->opcode1 & 7;

  rg->timer += 10;

  do
  {
    switch(rg->argsize)
    {
    case 0: if (debug_abort_memory == FALSE)
          generic_SUB_B(rg,REGA, loadB(regL(TR)));
        regL(TR) ++; break;

    case 1: if (debug_abort_memory == FALSE)
          generic_SUB_W(rg,REGWA, loadW(regL(TR)));
        regL(TR) += 2; break;
    }

    REGBC --;
    SETFLAG_V(REGBC);

    rg->timer += 14;
  }
  while (FLAG_V && (FLAG_Z == FALSE));
}

//===== CPD
__inline void srcCPD(tw*rg)
{
  _u8 TR = rg->opcode1 & 7;

  switch(rg->argsize)
  {
  case 0: generic_SUB_B(rg,REGA, loadB(regL(TR)));
      regL(TR) --; break;

  case 1: generic_SUB_W(rg,REGWA, loadW(regL(TR)));
      regL(TR) -= 2; break;
  }

  REGBC --;
  SETFLAG_V(REGBC);

  rg->timer += 8;
}

//===== CPDR
__inline void srcCPDR(tw*rg)
{
  _u8 TR = rg->opcode1 & 7;

  rg->timer += 10;

  do
  {
    switch(rg->argsize)
    {
    case 0: if (debug_abort_memory == FALSE)
          generic_SUB_B(rg,REGA, loadB(regL(TR)));
        regL(TR) -= 1; break;

    case 1: if (debug_abort_memory == FALSE)
          generic_SUB_W(rg,REGWA, loadW(regL(TR)));
        regL(TR) -= 2; break;
    }

    REGBC --;
    SETFLAG_V(REGBC);

    rg->timer += 14;
  }
  while (FLAG_V && (FLAG_Z == FALSE));
}

//===== LD (nn),(rg->memadr)
__inline void srcLD16m(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(fetch16(rg), loadB(rg->memadr)); break;
  case 1: storeW(fetch16(rg), loadW(rg->memadr)); break;
  }

  rg->timer += 8;
}

//===== LD rg->regsel,(rg->memadr)
__inline void srcLD(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = loadB(rg->memadr); rg->timer += 4; break;
  case 1: regW(rg->regsel) = loadW(rg->memadr); rg->timer += 4; break;
  case 2: regL(rg->regsel) = loadL(rg->memadr); rg->timer += 6; break;
  }
}

//===== EX (rg->memadr),rg->regsel
__inline void srcEX(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 temp = regB(rg->regsel); 
        regB(rg->regsel) = loadB(rg->memadr); 
        storeB(rg->memadr, temp); break;   }

  case 1: { _u16 temp = regW(rg->regsel); 
        regW(rg->regsel) = loadW(rg->memadr); 
        storeW(rg->memadr, temp); break;   }
  }

  rg->timer += 6;
}

//===== ADD (rg->memadr),#
__inline void srcADDi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(rg->memadr, generic_ADD_B(rg,loadB(rg->memadr), FETCH8)); rg->timer += 7;break;
  case 1: storeW(rg->memadr, generic_ADD_W(rg,loadW(rg->memadr), fetch16(rg))); rg->timer += 8;break;
  }
}

//===== ADC (rg->memadr),#
__inline void srcADCi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(rg->memadr, generic_ADC_B(rg,loadB(rg->memadr), FETCH8)); rg->timer += 7;break;
  case 1: storeW(rg->memadr, generic_ADC_W(rg,loadW(rg->memadr), fetch16(rg))); rg->timer += 8;break;
  }
}

//===== SUB (rg->memadr),#
__inline void srcSUBi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(rg->memadr, generic_SUB_B(rg,loadB(rg->memadr), FETCH8)); rg->timer += 7;break;
  case 1: storeW(rg->memadr, generic_SUB_W(rg,loadW(rg->memadr), fetch16(rg))); rg->timer += 8;break;
  }
}

//===== SBC (rg->memadr),#
__inline void srcSBCi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(rg->memadr, generic_SBC_B(rg,loadB(rg->memadr), FETCH8)); rg->timer += 7;break;
  case 1: storeW(rg->memadr, generic_SBC_W(rg,loadW(rg->memadr), fetch16(rg))); rg->timer += 8;break;
  }
}

//===== AND (rg->memadr),#
__inline void srcANDi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = loadB(rg->memadr) & FETCH8;
        storeB(rg->memadr, result);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 7;
        break; }

  case 1: { _u16 result = loadW(rg->memadr) & fetch16(rg);
        storeW(rg->memadr, result);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8;
        break; }
  }

  SETFLAG_H1;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== OR (rg->memadr),#
__inline void srcORi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = loadB(rg->memadr) | FETCH8;

        storeB(rg->memadr, result);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 7;
        break; }

  case 1: { _u16 result = loadW(rg->memadr) | fetch16(rg);
        storeW(rg->memadr, result);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== XOR (rg->memadr),#
__inline void srcXORi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = loadB(rg->memadr) ^ FETCH8;
        storeB(rg->memadr, result);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        rg->timer += 7;
        break; }

  case 1: { _u16 result = loadW(rg->memadr) ^ fetch16(rg);
        storeW(rg->memadr, result);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        rg->timer += 8;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== CP (rg->memadr),#
__inline void srcCPi(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: generic_SUB_B(rg,loadB(rg->memadr), FETCH8);  break;
  case 1: generic_SUB_W(rg,loadW(rg->memadr), fetch16(rg)); break;
  }
  
  rg->timer += 6;
}

//===== MUL RR,(rg->memadr)
__inline void srcMUL(tw*rg)
{
  _u8 target = get_RR_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: rCodeW(target) = (rCodeW(target) & 0xFF) * loadB(rg->memadr);
    rg->timer += 18; break;
  case 1: rCodeL(target) = (rCodeL(target) & 0xFFFF) * loadW(rg->memadr);
    rg->timer += 26; break;
  }
}

//===== MULS RR,(rg->memadr)
__inline void srcMULS(tw*rg)
{
  _u8 target = get_RR_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: rCodeW(target) = (_s8)(rCodeW(target) & 0xFF) * (_s8)loadB(rg->memadr);
    rg->timer += 18; break;
  case 1: rCodeL(target) = (_s16)(rCodeL(target) & 0xFFFF) * (_s16)loadW(rg->memadr);
    rg->timer += 26; break;
  }
}

//===== DIV RR,(rg->memadr)
__inline void srcDIV(tw*rg)
{
  _u8 target = get_RR_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: { rCodeW(target) = generic_DIV_B(rg,rCodeW(target), loadB(rg->memadr));
        rg->timer += 22;
        break;  }
        
  case 1: { rCodeL(target) = generic_DIV_W(rg,rCodeL(target), loadW(rg->memadr));
        rg->timer += 30;
        break;  }
  }
}

//===== DIVS RR,(rg->memadr)
__inline void srcDIVS(tw*rg)
{
  _u8 target = get_RR_Target(rg);
  if (target == 0x80)
    return;

  switch(rg->argsize)
  {
  case 0: { rCodeW(target) = generic_DIVS_B(rg,rCodeW(target), loadB(rg->memadr));
        rg->timer += 24;
        break;  }

  case 1: { rCodeL(target) = generic_DIVS_W(rg,rCodeL(target), loadW(rg->memadr));
        rg->timer += 32;
        break;  }
  }
}

//===== INC #3,(rg->memadr)
__inline void srcINC(tw*rg)
{
  _u8 val = rg->regsel;
  if (val == 0)
    val = 8;

  switch(rg->argsize)
  {
  case 0: { _u8 dst = loadB(rg->memadr);
        _u32 resultC = dst + val;
        _u8 half = (dst & 0xF) + val;
        _u8 result = (_u8)(resultC & 0xFF);
        SETFLAG_Z(result == 0);
        SETFLAG_H(half > 0xF);
        SETFLAG_S(result & 0x80);
        SETFLAG_N0;

        if (((_s8)dst >= 0) && ((_s8)result < 0))
        {SETFLAG_V1} else {SETFLAG_V0}

        storeB(rg->memadr, result);
        break; }

  case 1: { _u16 dst = loadW(rg->memadr);
        _u32 resultC = dst + val;
        _u8 half = (dst & 0xF) + val;
        _u16 result = (_u16)(resultC & 0xFFFF);
        SETFLAG_Z(result == 0);
        SETFLAG_H(half > 0xF);
        SETFLAG_S(result & 0x8000);
        SETFLAG_N0;

        if (((_s16)dst >= 0) && ((_s16)result < 0))
        {SETFLAG_V1} else {SETFLAG_V0}

        storeW(rg->memadr, result);
        break; }
  }

  rg->timer += 6;
}

//===== DEC #3,(rg->memadr)
__inline void srcDEC(tw*rg)
{
  _u8 val = rg->regsel;
  if (val == 0)
    val = 8;

  switch(rg->argsize)
  {
  case 0: { _u8 dst = loadB(rg->memadr);
        _u32 resultC = dst - val;
        _u8 half = (dst & 0xF) - val;
        _u8 result = (_u8)(resultC & 0xFF);
        SETFLAG_Z(result == 0);
        SETFLAG_H(half > 0xF);
        SETFLAG_S(result & 0x80);
        SETFLAG_N1;

        if (((_s8)dst < 0) && ((_s8)result >= 0))
        {SETFLAG_V1} else {SETFLAG_V0}

        storeB(rg->memadr, result);
        break; }

  case 1: { _u16 dst = loadW(rg->memadr);
        _u32 resultC = dst - val;
        _u8 half = (dst & 0xF) - val;
        _u16 result = (_u16)(resultC & 0xFFFF);
        SETFLAG_Z(result == 0);
        SETFLAG_H(half > 0xF);
        SETFLAG_S(result & 0x8000);
        SETFLAG_N1;

        if (((_s16)dst < 0) && ((_s16)result >= 0))
        {SETFLAG_V1} else {SETFLAG_V0}

        storeW(rg->memadr, result);
        break; }
  }

  rg->timer += 6;
}

//===== RLC (rg->memadr)
__inline void srcRLC(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = loadB(rg->memadr);
        SETFLAG_C(result & 0x80);
        result <<= 1;
        if (FLAG_C) result |= 1;
        storeB(rg->memadr, result);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        break; }
    
  case 1: { _u16 result = loadW(rg->memadr);
        SETFLAG_C(result & 0x8000);
        result <<= 1;
        if (FLAG_C) result |= 1;
        storeW(rg->memadr, result);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;

  rg->timer += 8;
}

//===== RRC (rg->memadr)
__inline void srcRRC(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 data = loadB(rg->memadr), result;
        SETFLAG_C(data & 1);
        result = data >> 1;
        if (FLAG_C) result |= 0x80;
        storeB(rg->memadr, result);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        break; }
    
  case 1: { _u16 data = loadW(rg->memadr), result;
        SETFLAG_C(data & 1);
        result = data >> 1;
        if (FLAG_C) result |= 0x8000;
        storeW(rg->memadr, result);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;

  rg->timer += 8;
}

//===== RL (rg->memadr)
__inline void srcRL(tw*rg)
{
  BOOL tem_pc;

  switch(rg->argsize)
  {
  case 0: { _u8 result = loadB(rg->memadr);
        tem_pc = FLAG_C;
        SETFLAG_C(result & 0x80);
        result <<= 1;
        if (tem_pc) result |= 1;
        storeB(rg->memadr, result);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        break; }
    
  case 1: { _u16 result = loadW(rg->memadr);
        tem_pc = FLAG_C;
        SETFLAG_C(result & 0x8000);
        result <<= 1;
        if (tem_pc) result |= 1;
        storeW(rg->memadr, result);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        break; }
  }

  rg->timer += 8;
}

//===== RR (rg->memadr)
__inline void srcRR(tw*rg)
{
  BOOL tem_pc;

  switch(rg->argsize)
  {
  case 0: { _u8 result = loadB(rg->memadr);
        tem_pc = FLAG_C;
        SETFLAG_C(result & 1);
        result >>= 1;
        if (tem_pc) result |= 0x80;
        storeB(rg->memadr, result);
        SETFLAG_S(result & 0x80);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        break; }
    
  case 1: { _u16 result = loadW(rg->memadr);
        tem_pc = FLAG_C;
        SETFLAG_C(result & 1);
        result >>= 1;
        if (tem_pc) result |= 0x8000;
        storeW(rg->memadr, result);
        SETFLAG_S(result & 0x8000);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        break; }
  }

  rg->timer += 8;
}

//===== SLA (rg->memadr)
__inline void srcSLA(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result, data = loadB(rg->memadr);
        SETFLAG_C(data & 0x80);
        result = ((_s8)data << 1);
        SETFLAG_S(result & 0x80);
        storeB(rg->memadr, result);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        break;  }

  case 1: { _u16 result, data = loadW(rg->memadr);
        SETFLAG_C(data & 0x8000);
        result = ((_s16)data << 1);
        SETFLAG_S(result & 0x8000);
        storeW(rg->memadr, result);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        break;  }
  }

  SETFLAG_H0;
  SETFLAG_N0;

  rg->timer += 8;
}

//===== SRA (rg->memadr)
__inline void srcSRA(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result, data = loadB(rg->memadr);
        SETFLAG_C(data & 0x1);
        result = ((_s8)data >> 1);
        SETFLAG_S(result & 0x80);
        storeB(rg->memadr, result);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        break;  }
  
  case 1: { _u16 result, data = loadW(rg->memadr);
        SETFLAG_C(data & 0x1);
        result = ((_s16)data >> 1);
        SETFLAG_S(result & 0x8000);
        storeW(rg->memadr, result);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        break;  }
  }

  SETFLAG_H0;
  SETFLAG_N0;

  rg->timer += 8;
}

//===== SLL (rg->memadr)
__inline void srcSLL(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result, data = loadB(rg->memadr);
        SETFLAG_C(data & 0x80);
        result = (data << 1);
        SETFLAG_S(result & 0x80);
        storeB(rg->memadr, result);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        break;  }
  
  case 1: { _u16 result, data = loadW(rg->memadr);
        SETFLAG_C(data & 0x8000);
        result = (data << 1);
        SETFLAG_S(result & 0x8000);
        storeW(rg->memadr, result);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        break;  }
  }

  SETFLAG_H0;
  SETFLAG_N0;

  rg->timer += 8;
}

//===== SRL (rg->memadr)
__inline void srcSRL(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result, data = loadB(rg->memadr);
        SETFLAG_C(data & 0x01);
        result = (data >> 1);
        SETFLAG_S(result & 0x80);
        storeB(rg->memadr, result);
        SETFLAG_Z(result == 0);
        parityB(rg,result);
        break;  }

  case 1: { _u16 result, data = loadW(rg->memadr);
        SETFLAG_C(data & 0x0001);
        result = (data >> 1);
        SETFLAG_S(result & 0x8000);
        storeW(rg->memadr, result);
        SETFLAG_Z(result == 0);
        parityW(rg,result);
        break;  }
  }

  SETFLAG_H0;
  SETFLAG_N0;

  rg->timer += 8;
}

//===== ADD rg->regsel,(rg->memadr)
__inline void srcADDRm(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = generic_ADD_B(rg,regB(rg->regsel), loadB(rg->memadr)); rg->timer += 4;break;
  case 1: regW(rg->regsel) = generic_ADD_W(rg,regW(rg->regsel), loadW(rg->memadr)); rg->timer += 4;break;
  case 2: regL(rg->regsel) = generic_ADD_L(rg,regL(rg->regsel), loadL(rg->memadr)); rg->timer += 6;break;
  }
}

//===== ADD (rg->memadr),rg->regsel
__inline void srcADDmR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(rg->memadr, generic_ADD_B(rg,loadB(rg->memadr), regB(rg->regsel))); rg->timer += 6;break;
  case 1: storeW(rg->memadr, generic_ADD_W(rg,loadW(rg->memadr), regW(rg->regsel))); rg->timer += 6;break;
  case 2: storeL(rg->memadr, generic_ADD_L(rg,loadL(rg->memadr), regL(rg->regsel))); rg->timer += 10;break;
  }
}

//===== ADC rg->regsel,(rg->memadr)
__inline void srcADCRm(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = generic_ADC_B(rg,regB(rg->regsel), loadB(rg->memadr)); rg->timer += 4;break;
  case 1: regW(rg->regsel) = generic_ADC_W(rg,regW(rg->regsel), loadW(rg->memadr)); rg->timer += 4;break;
  case 2: regL(rg->regsel) = generic_ADC_L(rg,regL(rg->regsel), loadL(rg->memadr)); rg->timer += 6;break;
  }
}

//===== ADC (rg->memadr),rg->regsel
__inline void srcADCmR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(rg->memadr, generic_ADC_B(rg,loadB(rg->memadr), regB(rg->regsel))); rg->timer += 6;break;
  case 1: storeW(rg->memadr, generic_ADC_W(rg,loadW(rg->memadr), regW(rg->regsel))); rg->timer += 6;break;
  case 2: storeL(rg->memadr, generic_ADC_L(rg,loadL(rg->memadr), regL(rg->regsel))); rg->timer += 10;break;
  }
}

//===== SUB rg->regsel,(rg->memadr)
__inline void srcSUBRm(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = generic_SUB_B(rg,regB(rg->regsel), loadB(rg->memadr)); rg->timer += 4;break;
  case 1: regW(rg->regsel) = generic_SUB_W(rg,regW(rg->regsel), loadW(rg->memadr)); rg->timer += 4;break;
  case 2: regL(rg->regsel) = generic_SUB_L(rg,regL(rg->regsel), loadL(rg->memadr)); rg->timer += 6;break;
  }
}

//===== SUB (rg->memadr),rg->regsel
__inline void srcSUBmR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(rg->memadr, generic_SUB_B(rg,loadB(rg->memadr), regB(rg->regsel))); rg->timer += 6;break;
  case 1: storeW(rg->memadr, generic_SUB_W(rg,loadW(rg->memadr), regW(rg->regsel))); rg->timer += 6;break;
  case 2: storeL(rg->memadr, generic_SUB_L(rg,loadL(rg->memadr), regL(rg->regsel))); rg->timer += 10;break;
  }
}

//===== SBC rg->regsel,(rg->memadr)
__inline void srcSBCRm(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: regB(rg->regsel) = generic_SBC_B(rg,regB(rg->regsel), loadB(rg->memadr)); rg->timer += 4;break;
  case 1: regW(rg->regsel) = generic_SBC_W(rg,regW(rg->regsel), loadW(rg->memadr)); rg->timer += 4;break;
  case 2: regL(rg->regsel) = generic_SBC_L(rg,regL(rg->regsel), loadL(rg->memadr)); rg->timer += 6;break;
  }
}

//===== SBC (rg->memadr),rg->regsel
__inline void srcSBCmR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: storeB(rg->memadr, generic_SBC_B(rg,loadB(rg->memadr), regB(rg->regsel))); rg->timer += 6;break;
  case 1: storeW(rg->memadr, generic_SBC_W(rg,loadW(rg->memadr), regW(rg->regsel))); rg->timer += 6;break;
  case 2: storeL(rg->memadr, generic_SBC_L(rg,loadL(rg->memadr), regL(rg->regsel))); rg->timer += 10;break;
  }
}

//===== AND rg->regsel,(rg->memadr)
__inline void srcANDRm(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) & loadB(rg->memadr);
        regB(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80);
        parityB(rg,result);
        rg->timer += 4;
        break; }
  
  case 1: { _u16 result = regW(rg->regsel) & loadW(rg->memadr);
        regW(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x8000);
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = regL(rg->regsel) & loadL(rg->memadr);
        regL(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80000000);
        rg->timer += 6;
        break; }
  }

  SETFLAG_H1;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== AND (rg->memadr),rg->regsel
__inline void srcANDmR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) & loadB(rg->memadr);
        storeB(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80);
        parityB(rg,result);
        rg->timer += 6;
        break; }
  
  case 1: { _u16 result = regW(rg->regsel) & loadW(rg->memadr);
        storeW(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x8000);
        parityW(rg,result);
        rg->timer += 6;
        break; }

  case 2: { _u32 result = regL(rg->regsel) & loadL(rg->memadr);
        storeL(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80000000);
        rg->timer += 10;
        break; }
  }

  SETFLAG_H1;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== XOR rg->regsel,(rg->memadr)
__inline void srcXORRm(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) ^ loadB(rg->memadr);
        regB(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80);
        parityB(rg,result);
        rg->timer += 4;
        break; }
  
  case 1: { _u16 result = regW(rg->regsel) ^ loadW(rg->memadr);
        regW(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x8000);
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = regL(rg->regsel) ^ loadL(rg->memadr);
        regL(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80000000);
        rg->timer += 6;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== XOR (rg->memadr),rg->regsel
__inline void srcXORmR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) ^ loadB(rg->memadr);
        storeB(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80);
        parityB(rg,result);
        rg->timer += 6;
        break; }
  
  case 1: { _u16 result = regW(rg->regsel) ^ loadW(rg->memadr);
        storeW(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x8000);
        parityW(rg,result);
        rg->timer += 6;
        break; }

  case 2: { _u32 result = regL(rg->regsel) ^ loadL(rg->memadr);
        storeL(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80000000);
        rg->timer += 10;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== OR rg->regsel,(rg->memadr)
__inline void srcORRm(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) | loadB(rg->memadr);
        regB(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80);
        parityB(rg,result);
        rg->timer += 4;
        break; }
  
  case 1: { _u16 result = regW(rg->regsel) | loadW(rg->memadr);
        regW(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x8000);
        parityW(rg,result);
        rg->timer += 4;
        break; }

  case 2: { _u32 result = regL(rg->regsel) | loadL(rg->memadr);
        regL(rg->regsel) = result;
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80000000);
        rg->timer += 6;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== OR (rg->memadr),rg->regsel
__inline void srcORmR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: { _u8 result = regB(rg->regsel) | loadB(rg->memadr);
        storeB(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80);
        parityB(rg,result);
        rg->timer += 6;
        break; }
  
  case 1: { _u16 result = regW(rg->regsel) | loadW(rg->memadr);
        storeW(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x8000);
        parityW(rg,result);
        rg->timer += 6;
        break; }

  case 2: { _u32 result = regL(rg->regsel) | loadL(rg->memadr);
        storeL(rg->memadr, result);
        SETFLAG_Z(result == 0);
        SETFLAG_S(result & 0x80000000);
        rg->timer += 10;
        break; }
  }

  SETFLAG_H0;
  SETFLAG_N0;
  SETFLAG_C0;
}

//===== CP rg->regsel,(rg->memadr)
__inline void srcCPRm(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: generic_SUB_B(rg,regB(rg->regsel), loadB(rg->memadr)); rg->timer += 4; break;
  case 1: generic_SUB_W(rg,regW(rg->regsel), loadW(rg->memadr)); rg->timer += 4; break;
  case 2: generic_SUB_L(rg,regL(rg->regsel), loadL(rg->memadr)); rg->timer += 6; break;
  }
}

//===== CP (rg->memadr),rg->regsel
__inline void srcCPmR(tw*rg)
{
  switch(rg->argsize)
  {
  case 0: generic_SUB_B(rg,loadB(rg->memadr), regB(rg->regsel));   break;
  case 1: generic_SUB_W(rg,loadW(rg->memadr), regW(rg->regsel));   break;
  case 2: generic_SUB_L(rg,loadL(rg->memadr), regL(rg->regsel));   break;
  }
  
  rg->timer += 6;
}

//=============================================================================


// REGISTER



//=============================================================================

void reset_registers(tw*rg)
{
  memset(rg->gprBank, 0, sizeof(rg->gprBank));
  memset(rg->gprBank[4], 0, sizeof(rg->gprBank[4]));
  
  if (rom.data)
    set_pc(rg,rom_header->startPC & 0xFFFFFF);
  else
    set_pc(rg,0xFFFFFE);

  (rg->status) = 0xF800;    // = %11111000???????? (?) are undefined in the manual)
  
  // Note de POKE : He ben moi je sais ;)
  // Le upper byte du SR c'est 
  // 15: SYSM   0=normal mode/1=system mode
  // 14-12: IFF	1=enable interrupts level (0-7)
  // 11: MAX	1=enable maxmode (4banques de registres)
  // 10-8: FPF	Selection courante de la banque de registre
  //			de 03 en maxmode / 07 sinon
  // 
  // donc mettre F8 dedans c'est surtout mettre system_mode+maxmode+all interrupt

  // Initialisation de la zone de conversion d'adresse des registres byte  

  rg->rptrBtrans[0] = 0x1;
  rg->rptrBtrans[1] = 0x0;
  rg->rptrBtrans[2] = 0x5;
  rg->rptrBtrans[3] = 0x4;
  rg->rptrBtrans[4] = 0x9;
  rg->rptrBtrans[5] = 0x8;
  rg->rptrBtrans[6] = 0xD;
  rg->rptrBtrans[7] = 0xC;
  
  inchangedSP(rg);
/*  rg->halfBank[0] = &rg->gprBank[0][0];
  rg->halfBank[1] = &rg->gprBank[0][1];
  rg->halfBank[2] = &rg->gprBank[0][2];
  rg->halfBank[3] = &rg->gprBank[0][3];
  rg->halfBank[4] = &rg->gprBank[4][0];
  rg->halfBank[5] = &rg->gprBank[4][1];
  rg->halfBank[6] = &rg->gprBank[4][2];
  rg->halfBank[7] = &rg->gprBank[4][3];
*/

  //Bank 0
  rg->index[0x00] = 0x00;
  rg->index[0x01] = 0x04;
  rg->index[0x02] = 0x08;
  rg->index[0x03] = 0x0C;

  //Bank 1
  rg->index[0x04] = 0x10;
  rg->index[0x05] = 0x14;
  rg->index[0x06] = 0x18;
  rg->index[0x07] = 0x1C;

  //Bank 2
  rg->index[0x08] = 0x20;
  rg->index[0x09] = 0x24;
  rg->index[0x0A] = 0x28;
  rg->index[0x0B] = 0x2C;

  //Bank 3
  rg->index[0x0C] = 0x30;
  rg->index[0x0D] = 0x34;
  rg->index[0x0E] = 0x38;
  rg->index[0x0F] = 0x3C;

  //Hole
  rg->index[0x10] = 0x50;
  rg->index[0x11] = 0x54;
  rg->index[0x12] = 0x58;
  rg->index[0x13] = 0x5C;

  //Previous
  rg->index[0x14] = 0x30;
  rg->index[0x15] = 0x34;
  rg->index[0x16] = 0x38;
  rg->index[0x17] = 0x3C;

  //Current
  rg->index[0x18] = 0x00;
  rg->index[0x19] = 0x04;
  rg->index[0x1A] = 0x08;
  rg->index[0x1B] = 0x0C;

  //Index registers
  rg->index[0x1C] = 0x40;
  rg->index[0x1D] = 0x44;
  rg->index[0x1E] = 0x48;
  rg->index[0x1F] = 0x4C;
    
  f_dash = 00;

  rErr = RERR_VALUE;

  REGXSP = 0x00006C00; //Confirmed from BIOS, 
            //immediately changes value from default of 0x100
}

//=============================================================================



//

/*
	#DEFINE PUTFLAG(tw*rg)\
	{
		
		if ( result<arg1 )
			flags |= CFLAG;
		if ( result==0 )
			flags |= ZFLAG;
		if ( (result&arg1)^(result|arg2) )
			flags |= VFLAG;
		if ( result>=0x80000000 )
			flags |= SFLAG;
		if ( (arg1<<(28-dec)+arg2<<(28-dec))<arg1<<(28-dec) )
			flags |= HFLAG;
	
		else if ( arg1^arg2^result^&0x80000000 )
		
	}

	#DEFINE PUTFLAGC(tw*rg)\
	{
		if ( (arg1&arg2)|( )
			flags |= FLAGC;
		else if ( arg1^arg2^result^&0x80000000 )
		
	}
	
	#define ADD(z,a,b,dec,cast)\
	{\
		int  result = (a<<dec)+(b<<dec);\
		_u16 flags = (z->sr)&~(FLAGV|FLAGN|FLAGZ|FLAGC|FLAGH);\
		int  arg1=(a<<dec);\
		int  arg2=(b<<dec);\
		
		if ( (a^b)>=0x8	
		
	}\
	
	
	
	ADD W,#
	{
		arg1=0xFE;
	}	


8 banques de 4 registres 16 bits = 64 octets
4 banques de 4 registres 32 bits = 64 octets

	
*/

