/*
	File:			Application.cpp	

	Description:	Contains the 68K portion of the Palm ARMlet.  It sets up a form so that
					the UI works with the Palm UI, and it calls the ARMlet.

	Author:		

	Copyright:		Copyright  2003 by Tapwave, Inc.

	Disclaimer:		IMPORTANT:  This Tapwave software is provided by Tapwave, Inc. ("Tapwave").  Your 
					use is subject to and governed by terms and conditions of the Software Development 
					Kit Agreement ("SDK Agreement") between you and Tapwave.  If you have not entered 
					into Tapwaves standard SDK Agreement with Tapwave, you have no right or license 
					to use, reproduce, modify, distribute or otherwise exploit this Tapwave software.  
					You may obtain a copy of Tapwaves standard SDK Agreement by calling 650-960-1817
					or visiting Tapwave at http://www.tapwave.com/developers/. 

	Change History (most recent first):
				
*/

#ifndef __App_Cst_h__
#define __App_Cst_h__

//#define TESTING_ONLY


#define __LJP_DIR__ "/PALM/Programs/LJP/"

#define __NES_ROMS_DIR__ __LJP_DIR__ "NES/Roms/"
#define __SNES_ROMS_DIR__ __LJP_DIR__ "SNES/Roms/"
#define __GB_ROMS_DIR__ __LJP_DIR__ "GB/Roms/"
#define __GENZ_ROMS_DIR__ __LJP_DIR__ "GENZ/Roms/"
#define __NEOPOPZ_ROMS_DIR__ __LJP_DIR__ "NGP/Roms/"
#define __OSWANZ_ROMS_DIR__ __LJP_DIR__ "WS/Roms/"
#define __TG16Z_ROMS_DIR__ __LJP_DIR__ "TG16/Roms/"
#define __SMS_ROMS_DIR__ __LJP_DIR__ "SMS/Roms/"
#define __GG_ROMS_DIR__ __LJP_DIR__ "GG/Roms/"
#define __VCS_ROMS_DIR__ __LJP_DIR__ "VCS/Roms/"


#define WELCOME_MESSAGE "Welcome to LJP 1.0RC2"

#define LJP_OSD_TITLE "[LJP] OSD"

#define FORM_LISTROM_ID 5000
#define FORM_LISTGGenie_ID 5001
#define FORM_LISTCAT_ID 5002
#define FORM_TRIGGCAT_ID 5003

#define FTR_PNO 0
#define FTR_ROM_FILENAME_ID 1
#define FTR_ROM_ID 2 //for loading rom in ftr mem
#define FTR_OPT_SMOOTHING_ID 3
#define FTR_OPT_SCREENMODE_ID 4
#define FTR_OPT_FSKIP_ID 5
#define FTR_OPT_CPUCORE_ID 6
#define FTR_OPT_EMU_ACCURACY_ID 7
#define FTR_OPT_SOUND_ID 8
#define FTR_OPT_SOUNDFREQ_ID 9

#define FTR_OPT_SNESRENDER_ID 10
#define FTR_OPT_SNESTRANSP_ID 11
#define FTR_OPT_FAST_SPR_ID 12

#define FTR_REALPNO 13

#define FTR_OPT_INPUTCONF_ID 14

#define FTR_OPT_SOUNDVOLUME_ID 15

#define FTR_OPT_SHOWFRAMERATE_ID 16

#define FTR_NES_PATTERN2PIX_ID 100

#define FTR_PREF_CRASHINFO_ID 0x0002

#define FTR_EMU_GOODINFO_ID 17

#define FTR_OPT_CATEGORY_ID 18

#define FTR_OPT_SHOWBELTBAR_ID 19

#define FTR_OPT_SMSGG_SYS_ID 20

#define FTR_OPT_SHOWBATTMODE_ID 21

#define FTR_OPT_ISLOWRES_ID 22

#define FTR_OPT_CONFIRMOW_ID 23
#define FTR_OPT_CONFIRMSL_ID 24

#define FTR_OPT_SNESHACKS_ID 25

#define FTR_ZNOSIGN_LIB_ID 90   //zodiac no-sign stuff
#define FTR_ZNOSIGN_GINFO_ID 91
#define FTR_ZNOSIGN_RET_ID 92

//#define SCR_ADJ(n) (ljp_isLowRes ? (n/2) : n)

#define SYS_NES     1
#define SYS_SNES    2
#define SYS_GB      4
#define SYS_GENZ    8
#define SYS_NEOPOPZ 16
#define SYS_OSWANZ  32
#define SYS_TG16Z   64
#define SYS_SMS     128
#define SYS_GG      256
#define SYS_VCS     512

#define _ZOD_SMOOTHING_ 128
#define _SMOOTH_MASK_ 127

#define _CONSOLE_BMP_Y_ 123
#define _CONSOLE_BMP_X_	5


/*#define BTN_Red		0x01
#define BTN_Green	0x02
#define BTN_Yellow	0x03
#define BTN_Blue	0x04
#define BTN_L		0x05
#define BTN_R		0x06
#define BTN_Func	0x07
#define BTN_Home	0x08
#define BTN_Up		0x09
#define BTN_Down	0x0A
#define BTN_Left	0x0B
#define BTN_Right	0x0C*/
#define BTN_TL		0x11111111L
#define BTN_BL		0x22222222L
#define BTN_TR		0x44444444L
#define BTN_BR		0x88888888L
//#define BTN_Anal	0x11


extern char g_helpmsg[];

//SNES hacks
#define PPU_IGNORE_FIXEDCOLCHANGES 	(1<<0)
#define PPU_IGNORE_WINDOW			(1<<1)
#define PPU_IGNORE_ADDSUB			(1<<2)
#define PPU_IGNORE_PALWRITE			(1<<3)

typedef struct {
UInt16 version;
UInt16 g_SnesFastSprite;
UInt16 g_SnesTransparency;
UInt16 g_SnesRender;
UInt16 g_SnesSound;
UInt16 g_SnesSmoothing;
UInt16 g_SnesScreenMode;
UInt16 g_SnesFSkip;
UInt16 g_SnesSoundFreq;
UInt16 g_SnesASMCPU;
UInt16 g_SnesSoundVol;
UInt16 g_SnesHack;

char g_SnesLastCat[32];

UInt16 g_NesSound;
UInt16 g_NesSmoothing;
UInt16 g_NesScreenMode;
UInt16 g_NesFSkip;
UInt16 g_NesSoundFreq;
UInt16 g_NesSoundVol;

char g_NesLastCat[32];

UInt16 g_GBSound;
UInt16 g_GBSmoothing;
UInt16 g_GBScreenMode;
UInt16 g_GBFSkip;
UInt16 g_GBSoundFreq;
UInt16 g_GBSoundVol;

char g_GBLastCat[32];

UInt16 g_GENZSound;
UInt16 g_GENZSmoothing;
UInt16 g_GENZScreenMode;
UInt16 g_GENZFSkip;
UInt16 g_GENZSoundFreq;
UInt16 g_GENZASMCPU;
UInt16 g_GENZSoundVol;

char g_GENZLastCat[32];

UInt16 g_NEOPOPZSound;
UInt16 g_NEOPOPZSmoothing;
UInt16 g_NEOPOPZScreenMode;
UInt16 g_NEOPOPZFSkip;
UInt16 g_NEOPOPZSoundFreq;
UInt16 g_NEOPOPZEmuAccuracy;
UInt16 g_NEOPOPZSoundVol;

char g_NEOPOPZLastCat[32];

UInt16 g_OSWANZSound;
UInt16 g_OSWANZSmoothing;
UInt16 g_OSWANZScreenMode;
UInt16 g_OSWANZFSkip;
UInt16 g_OSWANZSoundFreq;
UInt16 g_OSWANZSoundVol;

char g_OSWANZLastCat[32];

UInt16 g_TG16ZSound;
UInt16 g_TG16ZSmoothing;
UInt16 g_TG16ZScreenMode;
UInt16 g_TG16ZFSkip;
UInt16 g_TG16ZSoundFreq;
UInt16 g_TG16ZSoundVol;

char g_TG16ZLastCat[32];

UInt16 g_SMSSound;
UInt16 g_SMSSmoothing;
UInt16 g_SMSScreenMode;
UInt16 g_SMSFSkip;
UInt16 g_SMSSoundFreq;
UInt16 g_SMSSoundVol;

char g_SMSLastCat[32];

UInt16 g_GGSound;
UInt16 g_GGSmoothing;
UInt16 g_GGScreenMode;
UInt16 g_GGFSkip;
UInt16 g_GGSoundFreq;
UInt16 g_GGSoundVol;

char g_GGLastCat[32];

UInt16 g_VCSSound;
UInt16 g_VCSSmoothing;
UInt16 g_VCSScreenMode;
UInt16 g_VCSFSkip;
UInt16 g_VCSSoundFreq;
UInt16 g_VCSSoundVol;

char g_VCSLastCat[32];


UInt16 g_sysfilter;//|SYS_SNES|SYS_GB|SYS_GENZ;
UInt16 g_conf_system;
UInt32 g_inputconf[10][20];
char g_lastrom[256];
UInt8 g_firsttime;
UInt8 g_showFramerate;
UInt8 g_showBeltbar;
UInt8 g_showBattmode;
UInt8 g_showLaunchFX;
UInt8 g_BGMusic;
//UInt8 g_noDAA;
UInt8 g_confirmOW;
UInt8 g_confirmSL;
} t_ljp_pref;

typedef struct {
	char description[100];
	char system;
	char code[11];
	char active;
} t_ggenie_code;

#define FLUSH_D_CACHE {int i,j;UInt8 *tmpPtr;\
		tmpPtr=MemPtrNew(32768);j=0;\
		for (i=0;i<32768;i++) j+=(int)tmpPtr[i];\
		MemPtrFree(tmpPtr);tmpPtr=MemPtrNew(32768);\
		j=0;for (i=0;i<32768;i++) j+=(int)tmpPtr[i];\
		MemPtrFree(tmpPtr);\
	}


#endif
