/*
	File:			LJP_Main.c	

	Description:	Contains the 68K portion of the Palm ARMlet.  It sets up a form so that
					the UI works with the Palm UI, and it calls the ARMlet.

	Author:		

	Copyright:		Copyright  2003 by Tapwave, Inc.

	Disclaimer:		IMPORTANT:  This Tapwave software is provided by Tapwave, Inc. ("Tapwave").  Your 
					use is subject to and governed by terms and conditions of the Software Development 
					Kit Agreement ("SDK Agreement") between you and Tapwave.  If you have not entered 
					into Tapwaves standard SDK Agreement with Tapwave, you have no right or license 
					to use, reproduce, modify, distribute or otherwise exploit this Tapwave software.  
					You may obtain a copy of Tapwaves standard SDK Agreement by calling 650-960-1817
					or visiting Tapwave at http://www.tapwave.com/developers/. 

	Change History (most recent first):
				
*/
//#define TESTGUI
#define  NO_MOD_PLAYBACK
//#define COMPACT_MEM

#define WARNING_MESSAGE "This version should be more stable. Crashes are now handled."

#define winDisplayChangedEvent 0x4101

#include <PalmOS.h>
#include <VFSMgr.h>
#include <StringMgr.h>
#include <PCENativeCall.h>
#include "ljp_pnoload.h"
#include "pnobridge.h"

#include <coretraps.h>

#include <PenInputMgr.h>

#include "TapWave/TwChars.h"
#include "stdfile.h"
#include "host68k.h"
#include "display68k.h"
#include "ljPRsc.h"

#include "palm5way.h"

#include "App_Cst.h"
#include "App_FX.h"
#include "App_Func.h"
#include "LJP_GGenie.h"

#include "LJP_mac.h"


// Define the minimum OS version we support (2.0 for now).
#define kPalmOS10Version	sysMakeROMVersion(1,0,0,sysROMStageRelease,0)

UInt8 g_lowmem;

PnoDescriptor mod_pno;
char mod_started;
char current_mod;
char mod_init;
char mod_launch;

UInt32 ljp_isLowRes=0; // **** LOW-RES GLOBAL **** 



char device_type;

Int16 g_prev_form;
int g_launch_emu;
char **g_listchoice=NULL;
char **g_catlistchoice=NULL;



int g_num_entries,g_num_cat_entries;

/*static char g_llbutton[0x12][10]=
{"none","Red","Green","Yellow","Blue","L","R","Func","Home",
"Up","Down","Left","Right","TL","BL","TR","BR","Analog"};*/

char g_selectedfilename[255];

char g_inputfld[255];

char g_lastQuickRomChar;


int g_mod;
unsigned char* g_modData;
MemHandle g_modDataH;

int g_config_mode=0;
int g_rom_system;
Int32 g_autoload;

t_ljp_pref g_ljp_pref;

extern t_ljp_pref palm_default_pref;
extern t_ljp_pref zodiac_default_pref;

extern UInt32 hw_flags;
extern char str_month[12][4];
/**********************************/

	

void Init_Mod();
void Start_Mod(UInt32 num);
void Stop_Mod(void);
void DeInit_Mod(void);
void garbage_collect ( void );

void AppStop(int savepref);


void LoadZippedModuleFromCard(char *name);
UInt32 LoadZippedModule(char *name,PnoDescriptor *pno);
UInt32 CallModule(int flags,UInt8 *mod_data,UInt32 size,PnoDescriptor pno);
void UnloadModule(PnoDescriptor pno);
UInt32 UnzipToFtr(char *name,UInt16 Ftr);

void ResetQuickRomLabel(FormType *frmP)
{
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LauncherFrm0BButton) ),"_ab");
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LauncherFrmCFButton) ),"cdef");
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LauncherFrmGJButton) ),"ghij");
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LauncherFrmKNButton) ),"klmn");
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LauncherFrmORButton) ),"opqr");
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LauncherFrmSVButton) ),"stuv");
	CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LauncherFrmWZButton) ),"wxyz");
}






void	drawList	(Int16	i,RectangleType	*bounds,Char		**items)
	{
	Char *p,q[64];	
	Int16 j=0;
	Int16 wid;
	Boolean notruncated;
	IndexedColorType selectColor = UIColorGetTableEntryIndex(UIObjectSelectedForeground);
	IndexedColorType myColor=0;
	IndexedColorType itemColor = WinSetForeColor(myColor);	
	RGBColorType fg,bg;	
	
	WinSetForeColor(itemColor);	
	if (i>=g_num_entries) return;	
	p=g_listchoice[i]+3;
		
	while (p[j++]);
	
	WinPushDrawState();	
    WinSetDrawMode(winPaint);
    
	j--;    
	
	switch (g_listchoice[i][0])
	{
		case 3: //SLOT 2
			fg.r=100;fg.g=50;fg.b=200;
		break;
		case 2: //SLOT 1
			fg.r=120;fg.g=140;fg.b=40;
		break;
		case 1:
		default:  //SLOT 0 (internal)
			fg.r=50;fg.g=150;fg.b=70;
		break;
	}
	
	bg.r=255;bg.g=255;bg.b=255;       
	
    if (((p[j-1]=='P')||(p[j-1]=='p'))&&((p[j-2]=='I')||(p[j-2]=='i'))&&((p[j-3]=='Z')||(p[j-3]=='z')))
    {
	    //FntSetFont(boldFont);
	}
	else
	{
	    UInt16 cr=(UInt16)(fg.r)*4/3;
	    UInt16 cg=(UInt16)(fg.g)*4/3;
	    UInt16 cb=(UInt16)(fg.b)*4/3;
	    if (cr>255) cr=255;if (cg>255) cg=255;if (cb>255) cb=255;
	    fg.r=cr;fg.b=cb;fg.b=cb;
//		fg.r<<=1;fg.g<<=1;fg.b<<=1;
	}   
	
	if (itemColor == selectColor)
		{fg.r^=255;fg.g^=255;fg.b^=255;
		bg.r^=255;bg.g^=255;bg.b^=255;}
	        	
    WinSetTextColorRGB(&fg,NULL);    
//    WinSetBackColorRGB(&bg,NULL);


	wid=100;
	FntCharsInWidth(p,&wid,&j,&notruncated);
	if (!notruncated)
	{
		if (j>63) {j=63;DEBUGS("drawList => truncated string with > 63chars");}
		p=q;//(Char*)MemPtrNew(j);
		MemMove(p,g_listchoice[i]+3,j);
		p[j]=0;
		p[j-1]='.';p[j-2]='.';p[j-3]='.';
	}
	
	
	WinSetCoordinateSystem(kCoordinatesNative);
	
	WinPaintChars(p,j,SCR_ADJ(bounds->topLeft.x*2),
			SCR_ADJ(bounds->topLeft.y*2));
			
	WinSetDrawMode(winOverlay);
	
	if ( (itemColor == selectColor) && (!ljp_isLowRes))
	{
	fg.r<<=1;fg.g<<=1;fg.b<<=1;
    WinSetTextColorRGB(&fg,NULL);
	WinPaintChars(p,j,SCR_ADJ(bounds->topLeft.x*2-1),
			SCR_ADJ(bounds->topLeft.y*2-1));
	}		
//	if (!notruncated) MemPtrFree(p);
	WinPopDrawState();	
	}



/***********************************************************************
 *
 * FUNCTION:    LauncherFrmHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "LauncherForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean LauncherFrmHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err				err = errNone;



	switch (eventP->eType) 
	{
		case frmOpenEvent:
		{	
			ListType *list;
			char cat[32];
			int i;

			{
				UInt32 freeMem,maxMem;
				Char strtmp[32];
				MemHeapFreeBytes(0,&freeMem,&maxMem);	
				StrPrintF(strtmp,"Free RAM : %ldK",freeMem/1024);
				FrmCopyLabel  (frmP,LauncherFrmRAM,strtmp);
			}  

			//Form has to be drawn once before changing color or else
			//palmsim doesn't like it
			
			FrmDrawForm(frmP);
			UPDATE_UI_COLORS(g_ljp_pref.g_sysfilter)						
			
			ResetQuickRomLabel(frmP);
			g_lastQuickRomChar='0';
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LauncherFrm0BButton) ),"#ab");
			
			// Setup the form state			
			/*WinSetConstraintsSize(FrmGetWindowHandle(frmP), 160, 160, 160, 160, 160, 160);			
			FrmSetDIAPolicyAttr( frmP, frmDIAPolicyCustom );			
			// Check to make sure that the device we're running on supports
			// version 1.1 of the Pin Input Manager before making our calls.
			err = FtrGet( pinCreator, pinFtrAPIVersion, &pinMgrVersion );
			if (!err && pinMgrVersion == pinAPIVersion1_1)
			{
				flags = FtrGet( sysFtrCreator, sysFtrNumInputAreaFlags, &flags );								
				if (flags & grfFtrInputAreaFlagCollapsible)
					PINSetInputAreaState(pinInputAreaUser);
				if (flags & grfFtrInputAreaFlagCollapsible)
					StatShow();
				if (flags & grfFtrInputAreaFlagCollapsible)
					PINSetInputTriggerState(pinInputTriggerEnabled);								
				SysSetOrientationTriggerState(sysOrientationTriggerEnabled);									
				SysSetOrientation(sysOrientationLandscape);
			}	
			StatShow();
			PINSetInputAreaState(pinInputAreaClosed);*/
			
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_SYSTEM_ICON(g_ljp_pref.g_sysfilter,_CONSOLE_BMP_X_,_CONSOLE_BMP_Y_)
			if (scr) WinScreenUnlock();
			}			
						
			if (!g_ljp_pref.g_firsttime)
			{
				g_ljp_pref.g_firsttime=1;				
				menu_inform(WELCOME_MESSAGE);
				DEBUGS(WARNING_MESSAGE);
			}
			
			LstNewList((void**)&frmP,FORM_LISTROM_ID,43,25,112,120,FntGetFont(),11,0);
			list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );			
			LstSetDrawFunction (list, (ListDrawDataFuncPtr) drawList);						
			
			LstNewList((void**)&frmP,FORM_LISTCAT_ID,92,13,65,46,FntGetFont(),4,CategoryPopup);
//			list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTCAT_ID) );			
//			LstSetDrawFunction (list, (ListDrawDataFuncPtr) drawList);
			
			
			//InitRomList(list,g_ljp_pref.g_sysfilter,"unarchived");			
			
						
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemList) );
			switch (g_ljp_pref.g_sysfilter)
			{
				/*case (SYS_NES|SYS_SNES|SYS_GB|SYS_GENZ):LstSetSelection(list,0);
				break;*/
				case SYS_NES:LstSetSelection(list,0);g_ljp_pref.g_conf_system=SYS_NES;StrCopy(cat,g_ljp_pref.g_NesLastCat);
				break;
				case SYS_SNES:LstSetSelection(list,1);g_ljp_pref.g_conf_system=SYS_SNES;StrCopy(cat,g_ljp_pref.g_SnesLastCat);
				break;
				case SYS_GB:LstSetSelection(list,2);g_ljp_pref.g_conf_system=SYS_GB;StrCopy(cat,g_ljp_pref.g_GBLastCat);
				break;
				case SYS_GENZ:LstSetSelection(list,3);g_ljp_pref.g_conf_system=SYS_GENZ;StrCopy(cat,g_ljp_pref.g_GENZLastCat);
				break;
				case SYS_NEOPOPZ:LstSetSelection(list,4);g_ljp_pref.g_conf_system=SYS_NEOPOPZ;StrCopy(cat,g_ljp_pref.g_NEOPOPZLastCat);
				break;
				case SYS_OSWANZ:LstSetSelection(list,5);g_ljp_pref.g_conf_system=SYS_OSWANZ;StrCopy(cat,g_ljp_pref.g_OSWANZLastCat);
				break;
				case SYS_TG16Z:LstSetSelection(list,6);g_ljp_pref.g_conf_system=SYS_TG16Z;StrCopy(cat,g_ljp_pref.g_TG16ZLastCat);
				break;
				case SYS_SMS:LstSetSelection(list,7);g_ljp_pref.g_conf_system=SYS_SMS;StrCopy(cat,g_ljp_pref.g_SMSLastCat);
				break;
				case SYS_GG:LstSetSelection(list,8);g_ljp_pref.g_conf_system=SYS_GG;StrCopy(cat,g_ljp_pref.g_GGLastCat);
				break;
				case SYS_VCS:LstSetSelection(list,9);g_ljp_pref.g_conf_system=SYS_VCS;StrCopy(cat,g_ljp_pref.g_VCSLastCat);
				break;
			}
			CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
			
			Stop_Mod();			
			
			ASK_FOR_UPDATE			
				
				list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTCAT_ID) );
				
				InitCategoryList(list,g_ljp_pref.g_sysfilter);
				
				CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,CategoryPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
				
				//DEBUGS("init rom list");
				list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );	
				
				InitRomList(list,g_ljp_pref.g_sysfilter,cat);
				
			ASK_FOR_UPDATE
			
			switch (g_ljp_pref.g_sysfilter)	{
				case SYS_NES:i=0;break;
				case SYS_SNES:i=1;break;
				case SYS_GB:i=2;break;
				case SYS_GENZ:i=3;break;
				case SYS_NEOPOPZ:i=4;break;
				case SYS_OSWANZ:i=5;break;
				case SYS_TG16Z:i=6;break;
				case SYS_SMS:i=7;break;
				case SYS_GG:i=8;break;
				case SYS_VCS:i=9;break;
			}
			Start_Mod(i);
						
			handled = true;
			break;
		}
		case frmCloseEvent:							
		{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );	
			if (list) 
			{
				LstEraseList(list);
				LstSetListChoices(list,(char**)NULL,0);										
				if (g_listchoice) 
				{
					int i;
					for (i=0;i<g_num_entries;i++)
						MemPtrFree(g_listchoice[i]);
					MemPtrFree(g_listchoice);
					g_listchoice=NULL;
				}				
				//garbage_collect();
			}													
			list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTCAT_ID) );	
			if (list) 
			{
				LstEraseList(list);
				LstSetListChoices(list,(char**)NULL,0);										
				if (g_catlistchoice) 
				{
					int i;
					for (i=0;i<g_num_cat_entries;i++)
						MemPtrFree(g_catlistchoice[i]);
					MemPtrFree(g_catlistchoice);
					g_catlistchoice=NULL;
				}				
				//garbage_collect();
			}		
			garbage_collect();											
			break;
		}
		case keyDownEvent:
			handled = HandleKeyDownEvent(eventP); //weird linking bug
				handled=true;
			break;
		case popSelectEvent:
			switch ( eventP->data.ctlSelect.controlID ) 
			{
				case SystemPopup:
				{
					int oldsys=g_ljp_pref.g_sysfilter;
					ListType *list;
					char cat[16];
					
					switch (eventP->data.popSelect.selection)
					{
						case 0:g_ljp_pref.g_sysfilter=SYS_NES;g_ljp_pref.g_conf_system=SYS_NES;break;
						case 1:g_ljp_pref.g_sysfilter=SYS_SNES;g_ljp_pref.g_conf_system=SYS_SNES;break;
						case 2:g_ljp_pref.g_sysfilter=SYS_GB;g_ljp_pref.g_conf_system=SYS_GB;break;
						case 3:g_ljp_pref.g_sysfilter=SYS_GENZ;g_ljp_pref.g_conf_system=SYS_GENZ;break;
						case 4:
							g_ljp_pref.g_sysfilter=SYS_NEOPOPZ;g_ljp_pref.g_conf_system=SYS_NEOPOPZ;
							break;
						case 5:
							g_ljp_pref.g_sysfilter=SYS_OSWANZ;g_ljp_pref.g_conf_system=SYS_OSWANZ;
							break;
						case 6:
							g_ljp_pref.g_sysfilter=SYS_TG16Z;g_ljp_pref.g_conf_system=SYS_TG16Z;
							menu_inform("Not implemented yet...");
							break;
						case 7:g_ljp_pref.g_sysfilter=SYS_SMS;g_ljp_pref.g_conf_system=SYS_SMS;break;
						case 8:g_ljp_pref.g_sysfilter=SYS_GG;g_ljp_pref.g_conf_system=SYS_GG;break;
						case 9:
							g_ljp_pref.g_sysfilter=SYS_VCS;g_ljp_pref.g_conf_system=SYS_VCS;
							break;
					}
										
										
					UPDATE_UI_COLORS(g_ljp_pref.g_sysfilter)
					
					if (oldsys!=g_ljp_pref.g_sysfilter)
					{
						int i;						
						Stop_Mod();
						switch (g_ljp_pref.g_sysfilter)	{
							case SYS_NES:i=0;StrCopy(cat,g_ljp_pref.g_NesLastCat);break;
							case SYS_SNES:i=1;StrCopy(cat,g_ljp_pref.g_SnesLastCat);break;
							case SYS_GB:i=2;StrCopy(cat,g_ljp_pref.g_GBLastCat);break;
							case SYS_GENZ:i=3;StrCopy(cat,g_ljp_pref.g_GENZLastCat);break;
							case SYS_NEOPOPZ:i=4;StrCopy(cat,g_ljp_pref.g_NEOPOPZLastCat);break;
							case SYS_OSWANZ:i=5;StrCopy(cat,g_ljp_pref.g_OSWANZLastCat);break;
							case SYS_TG16Z:i=6;StrCopy(cat,g_ljp_pref.g_TG16ZLastCat);break;
							case SYS_SMS:i=7;StrCopy(cat,g_ljp_pref.g_SMSLastCat);break;
							case SYS_GG:i=8;StrCopy(cat,g_ljp_pref.g_GGLastCat);break;
							case SYS_VCS:i=9;StrCopy(cat,g_ljp_pref.g_VCSLastCat);break;
						}
						
					

					//update categories					
						
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemList) );
					if (list) CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
					
					list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
					if (list) 
					{
						/*ListType* listpop = (ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,CategoryList) );
						if (listpop) LstSetSelection(listpop,0);
						if (listpop) CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SystemPopup) ),LstGetSelectionText(listpop,LstGetSelection(listpop)));*/
					
						LstEraseList(list);
						LstSetListChoices(list,(char**)NULL,0);								
						if (g_listchoice) 
						{
							int i;
							for (i=0;i<g_num_entries;i++)
								MemPtrFree(g_listchoice[i]);
							MemPtrFree(g_listchoice);
							g_listchoice=NULL;
						}
						
						//categories
						list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTCAT_ID) );
						LstEraseList(list);
						LstSetListChoices(list,(char**)NULL,0);								
						if (g_catlistchoice) {
							int i;
							for (i=0;i<g_num_cat_entries;i++)
								MemPtrFree(g_catlistchoice[i]);
							MemPtrFree(g_catlistchoice);
							g_catlistchoice=NULL;
						}
						//garbage_collect();
						//InitRomList(list,g_ljp_pref.g_sysfilter,LstGetSelectionText(listpop,LstGetSelection(listpop)));
						//InitRomList(list,g_ljp_pref.g_sysfilter,"Unarchived");												
						
						InitCategoryList(list,g_ljp_pref.g_sysfilter);
						CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,CategoryPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
			
						//DEBUGS("init rom list");
						list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );	
						InitRomList(list,g_ljp_pref.g_sysfilter,cat);
					}
					
						
						Start_Mod(i);
					
					}
					
					
					
					ASK_FOR_UPDATE
/*					{UInt8 *scr=WinScreenLock(winLockCopy);
						FrmDrawForm(frmP);
						DRAW_SYSTEM_ICON(g_ljp_pref.g_sysfilter,_CONSOLE_BMP_X_,_CONSOLE_BMP_Y_)
						{	UInt32 freeMem,maxMem;
							Char strtmp[32];
							MemHeapFreeBytes(0,&freeMem,&maxMem);	
							StrPrintF(strtmp,"Free RAM : %ldK",freeMem/1024);
							FrmCopyLabel  (frmP,LauncherFrmRAM,strtmp);
						}  			
						if (scr) WinScreenUnlock();
					}*/
					
					
					handled = true;													
					break;
				}
				case CategoryPopup:
				{
					ListType* list;
					char cat[32];
					int i;
				
					//categories
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTCAT_ID) );
					//InitCategoryList(list,g_ljp_pref.g_sysfilter);
					//LstDrawList(list);
					CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,CategoryPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
					
					StrCopy(cat,LstGetSelectionText(list,LstGetSelection(list)));
					
//					DEBUGS(cat);
					
					//DEBUGS("init rom list");
					list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );	
					if (list){
						LstEraseList(list);
						LstSetListChoices(list,(char**)NULL,0);										
						if (g_listchoice) 
						{
							int i;
							for (i=0;i<g_num_entries;i++)
								MemPtrFree(g_listchoice[i]);
							MemPtrFree(g_listchoice);
							g_listchoice=NULL;
						}				
						//garbage_collect();
					}
					
					
					Stop_Mod();
					switch (g_ljp_pref.g_sysfilter)	{
						case SYS_NES:i=0;break;
						case SYS_SNES:i=1;break;
						case SYS_GB:i=2;break;
						case SYS_GENZ:i=3;break;
						case SYS_NEOPOPZ:i=4;break;
						case SYS_OSWANZ:i=5;break;
						case SYS_TG16Z:i=6;break;
						case SYS_SMS:i=7;break;
						case SYS_GG:i=8;break;
						case SYS_VCS:i=9;break;
					}
											
					InitRomList(list,g_ljp_pref.g_sysfilter,cat);	
					Start_Mod(i);
					
					switch (g_ljp_pref.g_sysfilter)
						{
							case SYS_NES:StrCopy(g_ljp_pref.g_NesLastCat,cat);break;
							case SYS_SNES:StrCopy(g_ljp_pref.g_SnesLastCat,cat);break;
							case SYS_GB:StrCopy(g_ljp_pref.g_GBLastCat,cat);break;
							case SYS_GENZ:StrCopy(g_ljp_pref.g_GENZLastCat,cat);break;
							case SYS_NEOPOPZ:StrCopy(g_ljp_pref.g_NEOPOPZLastCat,cat);break;
							case SYS_OSWANZ:StrCopy(g_ljp_pref.g_OSWANZLastCat,cat);break;
							case SYS_TG16Z:StrCopy(g_ljp_pref.g_TG16ZLastCat,cat);break;
							case SYS_SMS:StrCopy(g_ljp_pref.g_SMSLastCat,cat);break;
							case SYS_GG:StrCopy(g_ljp_pref.g_GGLastCat,cat);break;
							case SYS_VCS:StrCopy(g_ljp_pref.g_VCSLastCat,cat);break;
						}
						
					
					
					ASK_FOR_UPDATE
					
					handled = true;													
					break;
				}
			}
			break;
		case lstSelectEvent:
		{
			switch ( eventP->data.lstSelect.listID)
			{
				case FORM_LISTROM_ID:
				
				if (eventP->data.lstSelect.selection<g_num_entries)
					StrCopy(g_ljp_pref.g_lastrom,g_listchoice[eventP->data.lstSelect.selection]);
				break;
			}			
		}
		case ctlSelectEvent:
		{
			switch ( eventP->data.ctlSelect.controlID ) 
			{
				case LauncherFrmHELPButton:
					g_prev_form=LauncherForm;
					
					FrmGotoForm(HelpForm);					
					handled=true;
					break;
				case LauncherFrmOTHERButton:
					g_prev_form=LauncherForm;					
					FrmGotoForm(OtherForm);					
					handled=true;
					break;
				case LauncherFrmGGENIEButton:
					g_prev_form=LauncherForm;
					FrmGotoForm(GGenieForm);					
					handled=true;
					ASK_FOR_UPDATE					
					break;
				case LauncherFrmLOADButton:{
					ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
					if ((LstGetSelection(list)<g_num_entries)&&(LstGetSelection(list)>=0)){
						StrCopy(g_selectedfilename,g_listchoice[LstGetSelection(list)]);
						g_prev_form=LauncherForm;					
						FrmGotoForm(LoadForm);
					}
					handled=true;
					ASK_FOR_UPDATE			
					}		
					break;
				case LauncherFrmDELETEButton:{
					ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
					if ((LstGetSelection(list)<g_num_entries)&&(LstGetSelection(list)>=0)) {
						char *name;
						name=(char*)MemPtrNew(256);
						StrPrintF(name,"Delete %s ?",g_listchoice[LstGetSelection(list)]+3);
						if (FrmCustomAlert ( MsgConfirm, name, NULL, NULL )==0){
							char *filename=g_listchoice[LstGetSelection(list)];
							switch (filename[1]) {
								case 'N':if (StrCaselessCompare( g_ljp_pref.g_NesLastCat,"unarchived"))
									StrPrintF(name,"NES/Roms/%s/%s",g_ljp_pref.g_NesLastCat,filename+3);
								else StrPrintF(name,"NES/Roms/%s",filename+3);
									break;									
								case 'S':if (StrCaselessCompare( g_ljp_pref.g_SnesLastCat,"unarchived"))
									StrPrintF(name,"SNES/Roms/%s/%s",g_ljp_pref.g_SnesLastCat,filename+3);
								else StrPrintF(name,"SNES/Roms/%s",filename+3);
									break;
								case 'G':if (StrCaselessCompare( g_ljp_pref.g_GBLastCat,"unarchived"))
									StrPrintF(name,"GB/Roms/%s/%s",g_ljp_pref.g_GBLastCat,filename+3);
								else StrPrintF(name,"GB/Roms/%s",filename+3);
									break;
								case 'M':if (StrCaselessCompare( g_ljp_pref.g_GENZLastCat,"unarchived"))
									StrPrintF(name,"GENZ/Roms/%s/%s",g_ljp_pref.g_GENZLastCat,filename+3);
								else StrPrintF(name,"GENZ/Roms/%s",filename+3);
									break;
								case 'P':if (StrCaselessCompare( g_ljp_pref.g_NEOPOPZLastCat,"unarchived"))
									StrPrintF(name,"NGP/Roms/%s/%s",g_ljp_pref.g_NEOPOPZLastCat,filename+3);
								else StrPrintF(name,"NGP/Roms/%s",filename+3);
									break;
								case 'W':if (StrCaselessCompare( g_ljp_pref.g_OSWANZLastCat,"unarchived"))
									StrPrintF(name,"WS/Roms/%s/%s",g_ljp_pref.g_OSWANZLastCat,filename+3);
								else StrPrintF(name,"WS/Roms/%s",filename+3);
									break;
								case 'T':if (StrCaselessCompare( g_ljp_pref.g_TG16ZLastCat,"unarchived"))
									StrPrintF(name,"TG16/Roms/%s/%s",g_ljp_pref.g_TG16ZLastCat,filename+3);
								else StrPrintF(name,"TG16/Roms/%s",filename+3);
									break;
								case 'A':if (StrCaselessCompare( g_ljp_pref.g_SMSLastCat,"unarchived"))
									StrPrintF(name,"SMS/Roms/%s/%s",g_ljp_pref.g_SMSLastCat,filename+3);
								else StrPrintF(name,"SMS/Roms/%s",filename+3);
									break;
								case 'R':if (StrCaselessCompare( g_ljp_pref.g_GGLastCat,"unarchived"))
									StrPrintF(name,"GG/Roms/%s/%s",g_ljp_pref.g_GGLastCat,filename+3);
								else StrPrintF(name,"GG/Roms/%s",filename+3);
									break;
								case 'V':if (StrCaselessCompare( g_ljp_pref.g_VCSLastCat,"unarchived"))
									StrPrintF(name,"VCS/Roms/%s/%s",g_ljp_pref.g_VCSLastCat,filename+3);
								else StrPrintF(name,"VCS/Roms/%s",filename+3);
									break;
							}
							remove(name);
							if (list) {
								char old_mod=current_mod;
								LstEraseList(list);
								LstSetListChoices(list,(char**)NULL,0);
								if (g_listchoice) {
									int i;
									for (i=0;i<g_num_entries;i++)
										MemPtrFree(g_listchoice[i]);
									MemPtrFree(g_listchoice);
									g_listchoice=NULL;
								}
								
								//garbage_collect();								
								if (old_mod<255) Stop_Mod();
								InitRomList(list,g_ljp_pref.g_sysfilter,"Unarchived");
								if (old_mod<255) Start_Mod(old_mod);
							}
							ASK_FOR_UPDATE
						}
						MemPtrFree(name);
					}
					}
					handled=true;
					break;
				case LauncherFrmRESETButton:
					//SysNotifyRegister (0,CREATORID,sysNotifyResetFinishedEvent,NULL,128,NULL);
					
					AppStop(1);
					SysReset();
									
					handled=true;
					break;
				case LauncherFrmCONFButton:
					
					FrmGotoForm(ConfigForm);
					handled=true;
					break;
				case LauncherFrmLAUNCHButton:
				{
					ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
					if ((LstGetSelection(list)<g_num_entries)&&(LstGetSelection(list)>=0))
					{
						g_autoload=0;
						LAUNCH_ROM(g_listchoice[LstGetSelection(list)])
					}										
					handled = true;
					break;
				}				
				case LauncherFrm0BButton:
				{					
					ListType *list;
					Int16 currentItem=0;
					FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,LauncherFrm0BButton),0);
					handled = true;
					
					ResetQuickRomLabel(frmP);
					if (g_lastQuickRomChar=='0') {g_lastQuickRomChar='a';CtlSetLabel(eventP->data.ctlSelect.pControl,"#Ab");}
					else if (g_lastQuickRomChar=='a') {g_lastQuickRomChar='b';CtlSetLabel(eventP->data.ctlSelect.pControl,"aB#");}
					else {g_lastQuickRomChar='0';CtlSetLabel(eventP->data.ctlSelect.pControl,"b#a");}
					
					
					
					list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );					
					
					if (!list) break;
					if (g_lastQuickRomChar!='0')
					{						
						Char p[256];
						while (1)
						{
							if (currentItem>=LstGetNumberOfItems(list)-1) break;
							StrToLower(p,g_listchoice[currentItem]);
							if (p[3]>=g_lastQuickRomChar) break;
							currentItem++;						
						}									
					}
					if (currentItem<LstGetNumberOfItems(list)-1) LstSetTopItem(list,currentItem);
					ASK_FOR_UPDATE
					break;
				}
				case LauncherFrmCFButton:
				{	
					ListType *list;
					Int16 currentItem=0;
					Char p[256];
					FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,LauncherFrmCFButton),0);
					handled = true;
					
					ResetQuickRomLabel(frmP);
					if (g_lastQuickRomChar=='c') {g_lastQuickRomChar='d';CtlSetLabel(eventP->data.ctlSelect.pControl,"cDef");}
					else if (g_lastQuickRomChar=='d') {g_lastQuickRomChar='e';CtlSetLabel(eventP->data.ctlSelect.pControl,"dEfc");}
					else if (g_lastQuickRomChar=='e') {g_lastQuickRomChar='f';CtlSetLabel(eventP->data.ctlSelect.pControl,"eFcd");}
					else {g_lastQuickRomChar='c';CtlSetLabel(eventP->data.ctlSelect.pControl,"fCde");}
					
					list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );					
					
					
					if (!list) break;
					
					while (1)
					{
						if (currentItem>=LstGetNumberOfItems(list)-1) break;
						StrToLower(p,g_listchoice[currentItem]);
						if (p[3]>=g_lastQuickRomChar) break;
						currentItem++;						
					}
					if (currentItem<LstGetNumberOfItems(list)-1) LstSetTopItem(list,currentItem);
					ASK_FOR_UPDATE					
					break;
				}
				case LauncherFrmGJButton:
				{	
					ListType *list;
					Int16 currentItem=0;
					Char p[256];
					FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,LauncherFrmGJButton),0);
					handled = true;
					
					ResetQuickRomLabel(frmP);
					if (g_lastQuickRomChar=='g') {g_lastQuickRomChar='h';CtlSetLabel(eventP->data.ctlSelect.pControl,"gHij");}
					else if (g_lastQuickRomChar=='h') {g_lastQuickRomChar='i';CtlSetLabel(eventP->data.ctlSelect.pControl,"hIjg");}
					else if (g_lastQuickRomChar=='i') {g_lastQuickRomChar='j';CtlSetLabel(eventP->data.ctlSelect.pControl,"iJgh");}
					else {g_lastQuickRomChar='g';CtlSetLabel(eventP->data.ctlSelect.pControl,"jGhi");}
					
					list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
					
					if (!list) break;
					while (1)
					{
						if (currentItem>=LstGetNumberOfItems(list)-1) break;
						StrToLower(p,g_listchoice[currentItem]);
						if (p[3]>=g_lastQuickRomChar) break;
						currentItem++;						
					}
					if (currentItem<LstGetNumberOfItems(list)-1) LstSetTopItem(list,currentItem);
					ASK_FOR_UPDATE
					break;
				}
				case LauncherFrmKNButton:
				{		
					ListType *list;	
					Int16 currentItem=0;
					Char p[256];		
					FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,LauncherFrmKNButton),0);
					handled = true;
					
					ResetQuickRomLabel(frmP);
					if (g_lastQuickRomChar=='k') {g_lastQuickRomChar='l';CtlSetLabel(eventP->data.ctlSelect.pControl,"kLmn");}
					else if (g_lastQuickRomChar=='l') {g_lastQuickRomChar='m';CtlSetLabel(eventP->data.ctlSelect.pControl,"lMnk");}
					else if (g_lastQuickRomChar=='m') {g_lastQuickRomChar='n';CtlSetLabel(eventP->data.ctlSelect.pControl,"mNkl");}
					else {g_lastQuickRomChar='k';CtlSetLabel(eventP->data.ctlSelect.pControl,"nKlm");}
					
					list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
					
					if (!list) break;
					while (1)
					{
						if (currentItem>=LstGetNumberOfItems(list)-1) break;
						StrToLower(p,g_listchoice[currentItem]);
						if (p[3]>=g_lastQuickRomChar) break;
						currentItem++;						
					}
					if (currentItem<LstGetNumberOfItems(list)-1) LstSetTopItem(list,currentItem);
					ASK_FOR_UPDATE					
					break;
				}
				case LauncherFrmORButton:
				{					
					ListType *list;	
					Int16 currentItem=0;
					Char p[256];		
					FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,LauncherFrmORButton),0);
					handled = true;
					
					ResetQuickRomLabel(frmP);
					if (g_lastQuickRomChar=='o') {g_lastQuickRomChar='p';CtlSetLabel(eventP->data.ctlSelect.pControl,"oPqr");}
					else if (g_lastQuickRomChar=='p') {g_lastQuickRomChar='q';CtlSetLabel(eventP->data.ctlSelect.pControl,"pQro");}
					else if (g_lastQuickRomChar=='q') {g_lastQuickRomChar='r';CtlSetLabel(eventP->data.ctlSelect.pControl,"qRop");}
					else {g_lastQuickRomChar='o';CtlSetLabel(eventP->data.ctlSelect.pControl,"rOpq");}
					
					list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );
					if (!list) break;
					while (1)
					{
						if (currentItem>=LstGetNumberOfItems(list)-1) break;
						StrToLower(p,g_listchoice[currentItem]);
						if (p[3]>=g_lastQuickRomChar) break;
						currentItem++;						
					}
					if (currentItem<LstGetNumberOfItems(list)-1) LstSetTopItem(list,currentItem);
					ASK_FOR_UPDATE					
					break;
				}
				case LauncherFrmSVButton:
				{			
					ListType *list;
					Int16 currentItem=0;
					Char p[256];
	
					FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,LauncherFrmSVButton),0);
					handled = true;
					
					ResetQuickRomLabel(frmP);
					if (g_lastQuickRomChar=='s') {g_lastQuickRomChar='t';CtlSetLabel(eventP->data.ctlSelect.pControl,"sTuv");}
					else if (g_lastQuickRomChar=='t') {g_lastQuickRomChar='u';CtlSetLabel(eventP->data.ctlSelect.pControl,"tUvs");}
					else if (g_lastQuickRomChar=='u') {g_lastQuickRomChar='v';CtlSetLabel(eventP->data.ctlSelect.pControl,"uVst");}
					else {g_lastQuickRomChar='s';CtlSetLabel(eventP->data.ctlSelect.pControl,"vStu");}
					
					list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );					
					if (!list) break;
					while (1)
					{
						if (currentItem>=LstGetNumberOfItems(list)-1) break;
						StrToLower(p,g_listchoice[currentItem]);
						if (p[3]>=g_lastQuickRomChar) break;
						currentItem++;						
					}
					if (currentItem<LstGetNumberOfItems(list)-1) LstSetTopItem(list,currentItem);
					ASK_FOR_UPDATE					
					break;
				}
				case LauncherFrmWZButton:
				{				
					ListType *list;
					Int16 currentItem=0;
					Char p[256];
		
					FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,LauncherFrmWZButton),0);
					handled = true;
						
					ResetQuickRomLabel(frmP);				
					if (g_lastQuickRomChar=='w') {g_lastQuickRomChar='x';CtlSetLabel(eventP->data.ctlSelect.pControl,"wXyz");}
					else if (g_lastQuickRomChar=='x') {g_lastQuickRomChar='y';CtlSetLabel(eventP->data.ctlSelect.pControl,"xYzw");}
					else if (g_lastQuickRomChar=='y') {g_lastQuickRomChar='z';CtlSetLabel(eventP->data.ctlSelect.pControl,"yZwx");}
					else {g_lastQuickRomChar='w';CtlSetLabel(eventP->data.ctlSelect.pControl,"zWxy");}
					
					list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTROM_ID) );					
					if (!list) break;
					while (1)
					{											
						if (currentItem>=LstGetNumberOfItems(list)-1) break;
						StrToLower(p,g_listchoice[currentItem]);
						if (p[3]>=g_lastQuickRomChar) break;
						currentItem++;
					}					
					
					if (currentItem<LstGetNumberOfItems(list)-1) LstSetTopItem(list,currentItem);
					ASK_FOR_UPDATE					
					break;
				}
			}	
			break;			
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
		{
			UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_SYSTEM_ICON(g_ljp_pref.g_sysfilter,_CONSOLE_BMP_X_,_CONSOLE_BMP_Y_)
			{	UInt32 freeMem,maxMem;
				Char strtmp[32];
				MemHeapFreeBytes(0,&freeMem,&maxMem);	
				StrPrintF(strtmp,"Free RAM : %ldK",freeMem/1024);
				FrmCopyLabel  (frmP,LauncherFrmTitle,"LJP Launcher " VERSION);
				FrmCopyLabel  (frmP,LauncherFrmRAM,strtmp);
			}  			
			
			
			if (scr) WinScreenUnlock();
			
			
			
			handled=true;
		}
			break;
		
	}
    
	return handled;}




/***********************************************************************
 *
 * FUNCTION:    HelpFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "HelpForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean HelpFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;

	switch (eventP->eType) 
	{
		case frmOpenEvent:
		{	
			UInt16 scrollPos,textHeight,fieldHeight,maxValue;
				
			FieldType *field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,HelpHelpTxtField) );
			ScrollBarType *sb;
			FldSetTextPtr(field,g_helpmsg);
			FldRecalculateField (field,1);
//			FldMakeFullyVisible(field);			
			sb=(ScrollBarType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,SBHELP) );
			 
			
			FldGetScrollValues (field, &scrollPos,&textHeight, &fieldHeight);
			if (textHeight > fieldHeight)
				maxValue = textHeight - fieldHeight;
			else if (scrollPos)
				maxValue = scrollPos;
			else
				maxValue = 0;
			SclSetScrollBar (sb, scrollPos, 0, maxValue,fieldHeight-1);
			
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (scr) WinScreenUnlock();
			}			
						
			handled = true;
			break;
		}
		case sclRepeatEvent:
		{
			FieldType *field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,HelpHelpTxtField) );
			int line=eventP->data.sclExit.newValue-eventP->data.sclExit.value;
			if (line>0)
			{
				FldScrollField (field, line,winDown);
			}
			else
			{
				FldScrollField (field, -line,winUp);
			}
		}
			break;
		case ctlSelectEvent:
		{
			switch ( eventP->data.ctlSelect.controlID ) 
			{
				case HelpFrmHOMEButton:																			
					FrmGotoForm(g_prev_form);															
					handled=true;
					break;
				case HelpFrmABOUTButton:{
					char old_mod=current_mod;
					if (old_mod<255) Stop_Mod();
					Start_Mod(31);
					LoadZippedModuleFromCard("ljp-stuff.zem");
					Stop_Mod();
					if (old_mod<255) Start_Mod(old_mod);
					handled=true;
					break;
				}
			}
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (scr) WinScreenUnlock();
			}			
			handled=true;
			break;
			
		
	}
    
	return handled;
}


/***********************************************************************
 *
 * FUNCTION:    OtherFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "OtherForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean OtherFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			    err = errNone;
	int             g_othermode = 0;

	switch (eventP->eType) 
	{
		case frmOpenEvent:
		{				
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (scr) WinScreenUnlock();
			}			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmLaunchFXCheckbox),g_ljp_pref.g_showLaunchFX);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmSoundCheckbox),g_ljp_pref.g_BGMusic);
			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmConfirmOWCheckbox),g_ljp_pref.g_confirmOW);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmConfirmSLCheckbox),g_ljp_pref.g_confirmSL);
			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmFramerateCheckbox),g_ljp_pref.g_showFramerate);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmBeltbarCheckbox),g_ljp_pref.g_showBeltbar);
//			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmNoDAACheckbox),g_ljp_pref.g_noDAA);
			
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmGrpLauncherButton),1);
			g_othermode=0;
			OtherUpdateControls(&g_othermode,frmP,0);
			ASK_FOR_UPDATE
						
			handled = true;
			break;
		}
		case ctlSelectEvent:
		{
			switch ( eventP->data.ctlSelect.controlID ) 
			{
				case OtherFrmFramerateCheckbox:
					g_ljp_pref.g_showFramerate=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmFramerateCheckbox));
					handled=true;
					break;
				case OtherFrmBeltbarCheckbox:
					g_ljp_pref.g_showBeltbar=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmBeltbarCheckbox));
					handled=true;
					break;
				case OtherFrmLaunchFXCheckbox:
					g_ljp_pref.g_showLaunchFX=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmLaunchFXCheckbox));
					handled=true;
					break;
//				case OtherFrmNoDAACheckbox:
//					g_ljp_pref.g_noDAA=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmNoDAACheckbox));
//					handled=true;
//					break;
				case OtherFrmConfirmOWCheckbox:
					g_ljp_pref.g_confirmOW=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmConfirmOWCheckbox));
					handled=true;
					break;
				case OtherFrmConfirmSLCheckbox:
					g_ljp_pref.g_confirmSL=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmConfirmSLCheckbox));
					handled=true;
					break;
				case OtherFrmSoundCheckbox:{
#ifdef NO_MOD_PLAYBACK
	DEBUGS("Currently no bg music since it causes crashes");
	FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmSoundCheckbox),0);
#else	
					UInt16 oldval=g_ljp_pref.g_BGMusic;
					g_ljp_pref.g_BGMusic=FrmGetControlValue (frmP,FrmGetObjectIndex(frmP,OtherFrmSoundCheckbox));
					if (oldval&&(!g_ljp_pref.g_BGMusic)){
						Stop_Mod();
						DeInit_Mod();
					}
					if ((!oldval)&&g_ljp_pref.g_BGMusic){
						if (g_ljp_pref.g_BGMusic){
							int i;
							switch (g_ljp_pref.g_sysfilter)	{
								case SYS_NES:i=0;break;
								case SYS_SNES:i=1;break;
								case SYS_GB:i=2;break;
								case SYS_GENZ:i=3;break;
								case SYS_NEOPOPZ:i=4;break;
								case SYS_OSWANZ:i=5;break;
								case SYS_TG16Z:i=6;break;
								case SYS_SMS:i=7;break;
								case SYS_GG:i=8;break;
								case SYS_VCS:i=9;break;
							}
						Init_Mod();
						Start_Mod(i);
						}
					}
#endif					
					}
					handled=true;
					break;
				case OtherFrmHOMEButton:
					FrmGotoForm(LauncherForm);
					handled=true;
					break;
				case OtherFrmHELPButton:
					g_prev_form=OtherForm;
					FrmGotoForm(HelpForm);										
					handled=true;
					break;
				case OtherFrmGrpLauncherButton:
					g_othermode=0;
					OtherUpdateControls(&g_othermode,frmP,0);
					ASK_FOR_UPDATE
					handled=true;
					break;
				case OtherFrmGrpGUIButton:
				g_othermode=1;
					OtherUpdateControls(&g_othermode,frmP,0);
					ASK_FOR_UPDATE
					handled=true;
					break;
				case OtherFrmGrpMiscButton:
				g_othermode=2;
					OtherUpdateControls(&g_othermode,frmP,0);
					ASK_FOR_UPDATE
					handled=true;
					break;
			}
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (scr) WinScreenUnlock();
			}			
			handled=true;
			break;
			
		
	}
    
	return handled;
}


Boolean IsUsedSlot(UInt16 slot,Char *filename,UInt32 *date){
	char fname[128],name[128],*p,*q;
	FILE *f;

	StrCopy(fname,filename+3);
	p=StrChr(fname,'.');  
	if (p){
		q=p;
		while (p){
		  	q=p;
  			p=StrChr(p+1,'.');
		}
		*q=0;
	}
	switch (filename[1]){
		case 'N':StrPrintF(name,"NES/Saves/%s.ss%d",fname,slot);break;
		case 'S':if (slot<4) StrPrintF(name,"SNES/Saves/%s.za%d",fname,slot);
		else StrPrintF(name,"SNES/Saves/%s.zst",fname);break;
		case 'G':StrPrintF(name,"GB/Saves/%s.ss%d",fname,slot);break;
		case 'M':StrPrintF(name,"GENZ/Saves/%s.gs%d",fname,slot);break;
		case 'P':StrPrintF(name,"NGP/Saves/%s.ns%d",fname,slot);break;
		case 'W':StrPrintF(name,"WS/Saves/%s.sw%d",fname,slot);break;
		case 'T':StrPrintF(name,"TG16/Saves/%s",fname,slot);break;
		case 'A':
			StrPrintF(name,"SMS/Saves/%s.ss%d",fname,slot);
			break;
		case 'R':
			StrPrintF(name,"GG/Saves/%s.ss%d",fname,slot);
			break;
		case 'V':StrPrintF(name,"VCS/Saves/%s.ss%d",fname,slot);break;
	}
	if (fgetdate(name,date)) return false;
	return true;
}

/***********************************************************************
 *
 * FUNCTION:    LoadFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "LoadForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean LoadFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;
	UInt32 date;
	DateTimeType date_time;		
	char str[255];		

	switch (eventP->eType) 
	{
		case frmOpenEvent:
		{				
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
					

			if (IsUsedSlot(0,g_selectedfilename,&date)){
				CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmQUICKSLOTButton) ));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,LoadFrmQUICKSLOTLabel));				
				TimSecondsToDateTime(date,&date_time);
				StrPrintF(str,"%02d/%s/%02d %02d:%02d",
				date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);				
				FrmCopyLabel(frmP,LoadFrmQUICKSLOTLabel,str);
				
			}
			else{
				CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmQUICKSLOTButton) ));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,LoadFrmQUICKSLOTLabel));
			}
			if (IsUsedSlot(1,g_selectedfilename,&date)){
				CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT1Button) ));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT1Label));
				TimSecondsToDateTime(date,&date_time);
				StrPrintF(str,"%02d/%s/%02d %02d:%02d",
				date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);				
				FrmCopyLabel(frmP,LoadFrmSLOT1Label,str);
			}
			else{
				CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT1Button) ));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT1Label));
			}
			if (IsUsedSlot(2,g_selectedfilename,&date)){
				CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT2Button) ));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT2Label));
				TimSecondsToDateTime(date,&date_time);
				StrPrintF(str,"%02d/%s/%02d %02d:%02d",
				date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);				
				FrmCopyLabel(frmP,LoadFrmSLOT2Label,str);
			}
			else{
				CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT2Button) ));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT2Label));
			}
			if (IsUsedSlot(3,g_selectedfilename,&date)){
				CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT3Button) ));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT3Label));
				TimSecondsToDateTime(date,&date_time);
				StrPrintF(str,"%02d/%s/%02d %02d:%02d",
				date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);				
				FrmCopyLabel(frmP,LoadFrmSLOT3Label,str);
			}
			else{
				CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT3Button) ));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,LoadFrmSLOT3Label));
			}
			if (IsUsedSlot(4,g_selectedfilename,&date)){
				CtlShowControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmZSNESButton) ));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,LoadFrmZSNESSLOTLabel));
				TimSecondsToDateTime(date,&date_time);
				StrPrintF(str,"%02d/%s/%02d %02d:%02d",
				date_time.day,str_month[date_time.month-1],date_time.year%100,date_time.hour,date_time.minute);
				FrmCopyLabel(frmP,LoadFrmZSNESSLOTLabel,str);
			}
			else{
				CtlHideControl((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,LoadFrmZSNESButton) ));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,LoadFrmZSNESSLOTLabel));
			}
			
			if (scr) WinScreenUnlock();
			}							
						
			handled = true;
			break;
		}
		case ctlSelectEvent:
		{
			switch ( eventP->data.ctlSelect.controlID ) 
			{
				case LoadFrmHOMEButton:
					FrmGotoForm(LauncherForm);
					handled=true;
					break;
				case LoadFrmHELPButton:
					g_prev_form=LoadForm;
					FrmGotoForm(HelpForm);										
					handled=true;
					break;				
				case LoadFrmQUICKSLOTButton:
					g_autoload=1;
					LAUNCH_ROM(g_selectedfilename)
					handled=true;
					break;
				case LoadFrmSLOT1Button:
					g_autoload=2;
					LAUNCH_ROM(g_selectedfilename)
					handled=true;
					break;
				case LoadFrmSLOT2Button:
					g_autoload=3;
					LAUNCH_ROM(g_selectedfilename)
					handled=true;
					break;
				case LoadFrmSLOT3Button:
					g_autoload=4;
					LAUNCH_ROM(g_selectedfilename)
					handled=true;
					break;
			}
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (scr) WinScreenUnlock();
			}			
			handled=true;
			break;
			
		
	}
    
	return handled;
}


/***********************************************************************
 *
 * FUNCTION:    BlankFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "BlankForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean BlankFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;

	switch (eventP->eType) 
	{
		case frmOpenEvent:
		{	
			g_launch_emu=1;			
			{
			RGBColorType col;
			col.r=0;col.g=0;col.b=0;
			
																
			UIColorSetTableEntry(UIFormFill,&col);
			UIColorSetTableEntry(UIFormFrame,&col);
			
			FrmDrawForm(frmP);
			
			
			/*err = FtrGet( pinCreator, pinFtrAPIVersion, &pinMgrVersion );
			if (!err && pinMgrVersion == pinAPIVersion1_1)
			{
				flags = FtrGet( sysFtrCreator, sysFtrNumInputAreaFlags, &flags );								
				if (flags & grfFtrInputAreaFlagCollapsible)
					PINSetInputAreaState(pinInputAreaClosed);
				if (flags & grfFtrInputAreaFlagCollapsible)
					StatHide();
				if (flags & grfFtrInputAreaFlagCollapsible)
					PINSetInputTriggerState(pinInputTriggerEnabled);											
			}*/	
															
			ljp_WinScreenUnlock();
			
			//draw beltbar
				
			
			}
			
			handled = true;
			break;
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
			/*{ljp_WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			ljp_WinScreenUnlock();
			}*/			
			handled=true;
			break;
			
		}
	
    
	return handled;
}



/***********************************************************************
 *
 * FUNCTION:    AppHandleEvent
 *
 * DESCRIPTION: This routine loads form resources and set the event
 * 				handler for the form loaded.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should not be passed
 *				to a higher level handler.
 *
 ***********************************************************************/
Boolean AppHandleEvent(EventType* eventP)
{
	UInt16 formId;
	FormType * frmP= FrmGetActiveForm();
	
	if (eventP->eType == frmLoadEvent)
	{
		/* Load the form resource. */
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);
		/* 
		 * Set the event handler for the form.  The handler of the
		 * currently active form is called by FrmHandleEvent each
		 * time is receives an event. 
		 */
		switch (formId)
		{
			case LauncherForm:
				FrmSetEventHandler( frmP, LauncherFrmHandleEvent );
				break;
			case ConfigForm:
				FrmSetEventHandler( frmP, ConfigFrmHandleEvent );
				break;
			case GGenieForm:
				FrmSetEventHandler( frmP, GGenieFormHandleEvent );
				break;
			case GGenieCodeForm:
				FrmSetEventHandler( frmP, GGenieCodeFormHandleEvent );
				break;
			case OtherForm:
				FrmSetEventHandler( frmP, OtherFormHandleEvent );
				break;
			case LoadForm:
				FrmSetEventHandler( frmP, LoadFormHandleEvent );
				break;
			case HelpForm:
				FrmSetEventHandler( frmP, HelpFormHandleEvent );
				break;
			case BlankForm:
				FrmSetEventHandler( frmP, BlankFormHandleEvent );
				break;
		}
		return true;
	}		
	return false;
}


void AppEventLoop(void)
{
	UInt16 error;
	EventType event;

	g_launch_emu=0;
	g_rom_system=0;	


	do 
	{
		/* change timeout if you need periodic nilEvents */
		EvtGetEvent(&event, evtWaitForever);				

		if (! SysHandleEvent(&event))
		{
			if (! AppHandleEvent(&event))
			{
				if (! MenuHandleEvent(0, &event, &error))
				{
					FrmDispatchEvent(&event);
				}	
			}		
		}		
		if (g_launch_emu) 
		{ break;}
	} while (event.eType != appStopEvent);
}

void AppStop(int savepref)
{
	Stop_Mod();
	DeInit_Mod();


	if (savepref) {
		/*SAVE PREF*/
		//PrefSetAppPreferences(CREATORID,0x0001,(short)VERSION_DB,(void*)NULL,(short)0,(unsigned char)1);
		//PrefSetAppPreferences(CREATORID,0x0001,(short)VERSION_DB,(void*)&g_ljp_pref,(short)sizeof(g_ljp_pref),(unsigned char)1);
		
		FILE *f;
		UInt16 volRefNum;			
		UInt32 volIterator; 
		Err err;
		char name[256];
			
		volIterator = vfsIteratorStart;
		while (volIterator != vfsIteratorStop) 
		{
		  	err = VFSVolumeEnumerate(&volRefNum, &volIterator);
			if (!err) {			
				StrPrintF(name,"%1d:%sljp.ini",volRefNum,__LJP_DIR__);
				f = fopen ( name, "wf" ); // 'f' means: full path specified (not only file name) --Tinnus
		    	if ( f ) {
					break;
		      	}
	    	}
		}				
		if (f){
			fwrite(&g_ljp_pref,sizeof(g_ljp_pref),1,f);					
			fclose(f);
		} else {DEBUGS("Cannot write LJP ini file, preferences won't be saved.");}		 
	}
	//crash detection stuff
	PrefSetAppPreferences(CREATORID,0x0002,(short)VERSION_DB,(void*)NULL,(short)0,(unsigned char)1);
		
	if (!g_launch_emu)
	{
//		PINSetInputAreaState(pinInputAreaUser);
//		SysSetOrientation(sysOrientationUser);

		//crash detection stuff	
		//put flag to "LJP exits"
		UInt32 val32;
		val32=0;
		PrefSetAppPreferences(CREATORID,0x0002,(short)VERSION_DB,(void*)&val32,(short)4,(unsigned char)1);
		FrmCloseAllForms();	
	}
			/**/							
}

void CheckDirs(void)
{
	UInt16 volRefNum;			
	UInt32 volIterator; 
	Err err;
	
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/NES/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/NES/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/NES/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/SNES/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/SNES/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/SNES/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GB/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GB/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GB/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GENZ/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GENZ/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GENZ/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/NGP/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/NGP/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/NGP/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/WS/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/WS/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/WS/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/TG16/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/TG16/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/TG16/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/SMS/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/SMS/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/SMS/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GG/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GG/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/GG/Saves/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/VCS/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/VCS/Roms/");
		    VFSDirCreate(volRefNum, "/PALM/Programs/LJP/VCS/Saves/");
		 }
	}
}

MemHandle readModData(UInt32 num/*char* Path*/) {
	MemHandle hRsc=NULL;

	int rd=SysRandom(0);
	switch (num)
	{
		case 0:
			if (rd&1) hRsc = DmGetResource('MODS', MOD_NES1);
			else hRsc = DmGetResource('MODS', MOD_NES2);
		break;
		case 1:
			if ((rd&1)==0) hRsc = DmGetResource('MODS', MOD_SNES1);		
			else hRsc = DmGetResource('MODS', MOD_SNES2);
		break;
		case 2:
			if ((rd&1)==0) hRsc = DmGetResource('MODS', MOD_GB1);
			else hRsc = DmGetResource('MODS', MOD_GB2);
		break;
		case 3:
			if (rd&1) hRsc = DmGetResource('MODS', MOD_GENESIS1);
			else hRsc = DmGetResource('MODS', MOD_GENESIS2);
		break;
/*		case 4:
			if (rd&1) hRsc = DmGetResource('MODS', MOD_NGP2);
			else hRsc = DmGetResource('MODS', MOD_NGP1);
		break;*/
		case 5:
			if (rd&1) hRsc = DmGetResource('MODS', MOD_WS1);
			else hRsc = DmGetResource('MODS', MOD_WS2);
			break;
		case 31:
			if (rd&1) hRsc = DmGetResource('MODS', MOD_STUFF);
			else hRsc = DmGetResource('MODS', MOD_STUFF);
		break;
	}	
    return hRsc;
}

void Init_Mod()
{
#ifdef NO_MOD_PLAYBACK
	return;
#endif	
	if (mod_init) return;
	/* init mod player*/
   	if (!LoadZippedModule("ljp-mikmod.zem",&mod_pno)) {	
   		mod_init=1;	
   		current_mod=255;
	   	CallModule(BF_INITMOD,NULL,0,mod_pno);
	} else DEBUGS("Error : init mod");
}

void DeInit_Mod()
{
#ifdef NO_MOD_PLAYBACK
	return;
#endif	
	if (!mod_init) return;
	/* uninit mod player*/
	CallModule(BF_FREEMOD,NULL,0,mod_pno);
   	UnloadModule(mod_pno);
   	mod_init=0;
}


void Start_Mod(UInt32 num)
{
#ifdef NO_MOD_PLAYBACK
	return;
#endif	
	if (mod_started||(!mod_init)) return;
	g_modDataH=readModData(num);
    if (g_modDataH) {
		g_modData=MemHandleLock(g_modDataH);
		CallModule(BF_PLAYMOD,(UInt8*)g_modData,(UInt32)MemHandleSize(g_modDataH),mod_pno);
		MemHandleUnlock(g_modDataH);
		DmReleaseResource(g_modDataH);
		current_mod=num;
		mod_started=1;		
	}
}

void Stop_Mod(void)
{
#ifdef NO_MOD_PLAYBACK
	return;
#endif	
	/*stop mod*/
	if ((!mod_started)||(!mod_init)) return;
	CallModule(BF_STOPMOD,NULL,0,mod_pno);
	mod_started=0;	
}

void VerifyPrefValues()
{
	UInt16 		volRefNum;			
	UInt32 		volIterator;
	Err			err;
	char 		name[256];
	
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) {
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err)  {
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			#define TEST_DIR(mod_dir,mod_cat) {\
				mod_cat[31]=0; \
				StrPrintF(name,"%s%s",mod_dir,mod_cat);\
				if (VFSFileOpen(volRefNum, name, vfsModeRead, &dirRef) != errNone) StrCopy(mod_cat,"Unarchived");\
				else VFSFileClose (dirRef);}
			
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_SnesLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_NesLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_GBLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_GENZLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_NEOPOPZLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_OSWANZLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_TG16ZLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_GGLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_SMSLastCat);
			TEST_DIR(__NES_ROMS_DIR__,g_ljp_pref.g_VCSLastCat);
			

		} else break;
	}

#define CHECK_VAL(a,max,def) if (a>max) a=def;

//	MemSet(g_ljp_pref.g_inputconf,7*20*4,0);
	
	CHECK_VAL(g_ljp_pref.g_SnesFastSprite,1,0);
	CHECK_VAL(g_ljp_pref.g_SnesTransparency,1,0);
	CHECK_VAL(g_ljp_pref.g_SnesRender,1,0);
	CHECK_VAL(g_ljp_pref.g_SnesSound,2,0);
//	CHECK_VAL(g_ljp_pref.g_SnesSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_SnesScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_SnesFSkip,11,0);
	CHECK_VAL(g_ljp_pref.g_SnesSoundFreq,2,2);
	CHECK_VAL(g_ljp_pref.g_SnesASMCPU,1,1);
	CHECK_VAL(g_ljp_pref.g_SnesSoundVol,128,64);
//	CHECK_VAL(g_ljp_pref.g_SnesHack,1,0);
									
	CHECK_VAL(g_ljp_pref.g_NesSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_NesSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_NesScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_NesFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_NesSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_NesSoundVol,128,64);		

	CHECK_VAL(g_ljp_pref.g_GBSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_GBSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_GBScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_GBFSkip,11,1);
	CHECK_VAL(g_ljp_pref.g_GBSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_GBSoundVol,128,64);
	
	CHECK_VAL(g_ljp_pref.g_GENZSound,2|8,2|8);
//	CHECK_VAL(g_ljp_pref.g_GENZSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_GENZScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_GENZFSkip,11,0);
	CHECK_VAL(g_ljp_pref.g_GENZSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_GENZASMCPU,1,1);
	CHECK_VAL(g_ljp_pref.g_GENZSoundVol,128,64);

	CHECK_VAL(g_ljp_pref.g_NEOPOPZSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_NEOPOPZSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZEmuAccuracy,2,0);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZSoundVol,128,64);

	CHECK_VAL(g_ljp_pref.g_OSWANZSound,2,0);
//	CHECK_VAL(g_ljp_pref.g_OSWANZSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_OSWANZScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_OSWANZFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_OSWANZSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_OSWANZSoundVol,128,64);
	
	CHECK_VAL(g_ljp_pref.g_TG16ZSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_TG16ZSmoothing=0;
	CHECK_VAL(g_ljp_pref.g_TG16ZScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_TG16ZFSkip,11,1);
	CHECK_VAL(g_ljp_pref.g_TG16ZSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_TG16ZSoundVol,128,64);
	
	CHECK_VAL(g_ljp_pref.g_SMSSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_SMSSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_SMSScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_SMSFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_SMSSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_SMSSoundVol,128,64);

	CHECK_VAL(g_ljp_pref.g_GGSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_GGSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_GGScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_GGFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_GGSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_GGSoundVol,128,64);
	
	CHECK_VAL(g_ljp_pref.g_VCSSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_VCSSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_VCSScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_VCSFSkip,11,1);
	CHECK_VAL(g_ljp_pref.g_VCSSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_VCSSoundVol,128,64);

	if (!((g_ljp_pref.g_sysfilter==SYS_SNES)||
		(g_ljp_pref.g_sysfilter==SYS_NES)||
		(g_ljp_pref.g_sysfilter==SYS_GB)||
		(g_ljp_pref.g_sysfilter==SYS_GENZ)||
		(g_ljp_pref.g_sysfilter==SYS_NEOPOPZ)||
		(g_ljp_pref.g_sysfilter==SYS_OSWANZ)||
		(g_ljp_pref.g_sysfilter==SYS_TG16Z)||
		(g_ljp_pref.g_sysfilter==SYS_SMS)||
		(g_ljp_pref.g_sysfilter==SYS_GG)||
		(g_ljp_pref.g_sysfilter==SYS_VCS))) g_ljp_pref.g_sysfilter=SYS_NES;
	
	if (!((g_ljp_pref.g_conf_system==SYS_SNES)||
		(g_ljp_pref.g_conf_system==SYS_NES)||
		(g_ljp_pref.g_conf_system==SYS_GB)||
		(g_ljp_pref.g_conf_system==SYS_GENZ)||
		(g_ljp_pref.g_conf_system==SYS_NEOPOPZ)||
		(g_ljp_pref.g_conf_system==SYS_OSWANZ)||
		(g_ljp_pref.g_conf_system==SYS_TG16Z)||
		(g_ljp_pref.g_conf_system==SYS_SMS)||
		(g_ljp_pref.g_conf_system==SYS_GG)||
		(g_ljp_pref.g_conf_system==SYS_VCS))) g_ljp_pref.g_conf_system=g_ljp_pref.g_sysfilter;
			
	g_ljp_pref.g_lastrom[255]='\0';
	
	CHECK_VAL(g_ljp_pref.g_firsttime,1,0);
	CHECK_VAL(g_ljp_pref.g_showFramerate,1,1);
	CHECK_VAL(g_ljp_pref.g_showBeltbar,1,1);
	CHECK_VAL(g_ljp_pref.g_showBattmode,1,1);
	CHECK_VAL(g_ljp_pref.g_showLaunchFX,1,1);
	CHECK_VAL(g_ljp_pref.g_BGMusic,1,0);
	CHECK_VAL(g_ljp_pref.g_confirmOW,1,1);
	CHECK_VAL(g_ljp_pref.g_confirmSL,1,1);
	
	//until it's fixed, no BG music
	g_ljp_pref.g_BGMusic=0;
}


void InitPrefDefaultValues()
{
#define CHECK_VAL(a,max,def) if (a>max) a=def;

//	MemSet(g_ljp_pref.g_inputconf,7*20*4,0);
	
	CHECK_VAL(g_ljp_pref.g_SnesFastSprite,1,0);
	CHECK_VAL(g_ljp_pref.g_SnesTransparency,1,0);
	CHECK_VAL(g_ljp_pref.g_SnesRender,1,0);
	CHECK_VAL(g_ljp_pref.g_SnesSound,2,0);
//	CHECK_VAL(g_ljp_pref.g_SnesSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_SnesScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_SnesFSkip,11,0);
	CHECK_VAL(g_ljp_pref.g_SnesSoundFreq,2,2);
	CHECK_VAL(g_ljp_pref.g_SnesASMCPU,1,1);
	CHECK_VAL(g_ljp_pref.g_SnesSoundVol,128,64);
//	CHECK_VAL(g_ljp_pref.g_SnesHack,1,0);
	
	StrCopy(g_ljp_pref.g_SnesLastCat,"Unarchived");

	CHECK_VAL(g_ljp_pref.g_NesSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_NesSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_NesScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_NesFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_NesSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_NesSoundVol,128,64);
	
	StrCopy(g_ljp_pref.g_NesLastCat,"Unarchived");

	CHECK_VAL(g_ljp_pref.g_GBSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_GBSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_GBScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_GBFSkip,11,1);
	CHECK_VAL(g_ljp_pref.g_GBSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_GBSoundVol,128,64);
	
	StrCopy(g_ljp_pref.g_GBLastCat,"Unarchived");

	CHECK_VAL(g_ljp_pref.g_GENZSound,2|8,2|8);
//	CHECK_VAL(g_ljp_pref.g_GENZSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_GENZScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_GENZFSkip,11,0);
	CHECK_VAL(g_ljp_pref.g_GENZSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_GENZASMCPU,1,1);
	CHECK_VAL(g_ljp_pref.g_GENZSoundVol,128,64);

	StrCopy(g_ljp_pref.g_GENZLastCat,"Unarchived");

	CHECK_VAL(g_ljp_pref.g_NEOPOPZSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_NEOPOPZSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZEmuAccuracy,2,0);
	CHECK_VAL(g_ljp_pref.g_NEOPOPZSoundVol,128,64);

	StrCopy(g_ljp_pref.g_NEOPOPZLastCat,"Unarchived");

	CHECK_VAL(g_ljp_pref.g_OSWANZSound,2,0);
//	CHECK_VAL(g_ljp_pref.g_OSWANZSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_OSWANZScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_OSWANZFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_OSWANZSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_OSWANZSoundVol,128,64);
	
	StrCopy(g_ljp_pref.g_OSWANZLastCat,"Unarchived");
	
	CHECK_VAL(g_ljp_pref.g_TG16ZSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_TG16ZSmoothing=0;
	CHECK_VAL(g_ljp_pref.g_TG16ZScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_TG16ZFSkip,11,1);
	CHECK_VAL(g_ljp_pref.g_TG16ZSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_TG16ZSoundVol,128,64);
	
	StrCopy(g_ljp_pref.g_TG16ZLastCat,"Unarchived");
	
	CHECK_VAL(g_ljp_pref.g_SMSSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_SMSSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_SMSScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_SMSFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_SMSSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_SMSSoundVol,128,64);

	StrCopy(g_ljp_pref.g_SMSLastCat,"Unarchived");
	
	CHECK_VAL(g_ljp_pref.g_GGSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_GGSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_GGScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_GGFSkip,12,0);
	CHECK_VAL(g_ljp_pref.g_GGSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_GGSoundVol,128,64);
	
	StrCopy(g_ljp_pref.g_GGLastCat,"Unarchived");
	
	CHECK_VAL(g_ljp_pref.g_VCSSound,2,2);
//	CHECK_VAL(g_ljp_pref.g_VCSSmoothing,1,0);
	CHECK_VAL(g_ljp_pref.g_VCSScreenMode,4,0);
	CHECK_VAL(g_ljp_pref.g_VCSFSkip,11,1);
	CHECK_VAL(g_ljp_pref.g_VCSSoundFreq,2,1);
	CHECK_VAL(g_ljp_pref.g_VCSSoundVol,128,64);

	StrCopy(g_ljp_pref.g_VCSLastCat,"Unarchived");

	g_ljp_pref.g_sysfilter=SYS_NES;//|SYS_SNES|SYS_GB|SYS_GENZ;
	g_ljp_pref.g_conf_system=g_ljp_pref.g_sysfilter;
	
	g_ljp_pref.g_lastrom[0]='\0';
	
	CHECK_VAL(g_ljp_pref.g_firsttime,1,0);
	CHECK_VAL(g_ljp_pref.g_showFramerate,1,1);
	CHECK_VAL(g_ljp_pref.g_showBeltbar,1,1);
	CHECK_VAL(g_ljp_pref.g_showBattmode,1,1);
	CHECK_VAL(g_ljp_pref.g_showLaunchFX,1,1);
	CHECK_VAL(g_ljp_pref.g_BGMusic,1,0);
	CHECK_VAL(g_ljp_pref.g_confirmOW,1,1);
	CHECK_VAL(g_ljp_pref.g_confirmSL,1,1);
}

UInt32 query_heap_free ( void ) {
  UInt16 heapid = 0;
  UInt32 max, bytes;

  MemHeapFreeBytes ( heapid, &bytes, &max );

  //DEBUGS ( "heapfree" );
  //DEBUGU32 ( bytes );

  return ( max );
}


void garbage_collect ( void ) {

  /* on failure, compact memory */
  //MemHeapCompact ( MemPtrHeapID ( true_head() ) );

#ifdef COMPACT_MEM
  UInt16 heap_id;
  MemPtr ptr=MemPtrNew(8);	
  if (!ptr) {DEBUGS("garbage collector error : cannot allocate ptr");return;}
  heap_id=MemPtrHeapID(ptr);
  MemPtrFree(ptr);
  MemHeapCompact ( heap_id );
#endif

  return;
}


/*Boolean HwrEnableDataWrites ( void )
               SYS_TRAP(sysTrapHwrEnableDataWrites);

Boolean HwrDisableDataWrites ( void )
               SYS_TRAP(sysTrapHwrDisableDataWrites); */



void LoadZippedModuleFromCard(char *_name)
{	
  UInt32 processor;
  UInt32 flags = 0;
  ControlType *c;
  UInt8 filetype;
  Err res;
  UInt16 initDelay,old_initDelay,old_initDblDelay;
  UInt16 period,old_period;
  UInt32 old_mask;
  Boolean queueAhead,old_queueAhead;
  MemPtr pnoPtr;
  PnoDescriptor pno;
  char name[256];  
  
  UInt16 		volRefNum;			
  UInt32 		volIterator;
  Err			err = errNone;
  FILE          *f;
  
  // does emu module exist?
  volIterator = vfsIteratorStart;
  while (volIterator != vfsIteratorStop) 
  {
  	err = VFSVolumeEnumerate(&volRefNum, &volIterator);
	if (!err) {
		StrPrintF(name,"%1d:%s%s",volRefNum,__LJP_DIR__,_name);
		f = fopen ( name, "rf" ); // 'f' means: full path specified (not only file name) --Tinnus
    	if ( f ) {
      		break;
      	}
    }
  }
    if (! f ) {
      DEBUGS ( "The emulation module to run this game is not present." );
      DEBUGS (name);
      return;
    }
    fclose ( f );
	
  
  
  // clear background
  {
    RectangleType r;
    IndexedColorType c;
    r.topLeft.x = 0;
    r.topLeft.y = 0;
    r.extent.x = 160;
    r.extent.y = 160 - (g_ljp_pref.g_showBeltbar*16);
    c = WinSetBackColor ( 0 );
    WinDrawRectangle ( &r, 0 );
    WinSetBackColor ( c );
  }
  // call the PACE Native Object
  FtrGet(sysFtrCreator, sysFtrNumProcessorID, &processor);
  // rearrange memory
  garbage_collect();
  // fire up pno
  if ( sysFtrNumProcessorIsARM ( processor ) )
  {
    pnobridge_t *bridge = (pnobridge_t*) MemPtrNew ( sizeof(pnobridge_t) );
    MemHandle mh;
    UInt8 *tmpPtr;
    UInt16 pitch, width, height;
    Err error;
    UInt32 pnoSize;
    UInt16 version;


	UnzipToFtr(name,FTR_PNO);
	FtrGet(CREATORID, FTR_PNO, (void*)&pnoPtr);		
	
	//check version
	version=((UInt16*)pnoPtr)[0];
	if (version!=VERSION_DB){
		char st[64];
		DEBUGS(".zem file has wrong version number. Please check your install.");
		StrPrintF(st," Version got/wanted : %02X/%02X",version,VERSION_DB);
		DEBUGS(st);
		FtrPtrFree ( CREATORID, FTR_PNO );
		return ;
	} else {
		pnoSize = MemPtrSize(pnoPtr)-4;
		pnoPtr=(MemPtr)((char*)(pnoPtr)+4);
	}

    hw_guess_screen_dimensions ( &width, &height, &pitch );
    bridge -> vfs_max = palm_vfs_count();
    bridge -> vfs_vol = palm_vfs_iter();
    bridge -> vram = (UInt32) hw_query_vram();
    bridge -> eventf = (UInt32) host_event_handler;
    bridge -> display_width = width;
    bridge -> display_height = height;
    bridge -> display_pitch = pitch;
    bridge -> game_rom = g_autoload;
    bridge -> audio_buf = NULL;
    
    bridge -> flags = (hw_flags&hf_pin_present?BF_HASPIN:0)|
    				(device_type&_ZODIAC_DEVICE_?BF_ZODIAC:0)|
    				(device_type&_HIRES_PLUS_DEVICE_?BF_HIRESPLUS:0);

    res=ljp_PnoLoad ( &pno, pnoPtr,pnoSize );
    FtrPtrFree ( CREATORID, FTR_PNO ); 
    if (res) {
		DEBUGS("Error while loading PNO");
		DEBUGU32(res);
		MemPtrFree(bridge);
		return;    	
    }
	#ifndef _ZIRE31_KEYS_
	old_mask=KeySetMask(~keyBitsAll);		
	#endif
	initDelay=slowestKeyDelayRate;
	period=slowestKeyPeriodRate;
	queueAhead=false;
	KeyRates(false,&old_initDelay,&old_period,&old_initDblDelay,&old_queueAhead);
	KeyRates(true,&initDelay,&period,&initDelay,&queueAhead);
	//read memory to flush D cache
	FLUSH_D_CACHE	
	FtrSet(CREATORID, FTR_OPT_SHOWFRAMERATE_ID,g_ljp_pref.g_showFramerate);
	FtrSet(CREATORID, FTR_OPT_SHOWBELTBAR_ID,g_ljp_pref.g_showBeltbar);
	FtrSet(CREATORID, FTR_OPT_SHOWBATTMODE_ID,g_ljp_pref.g_showBattmode);
	FtrSet(CREATORID, FTR_OPT_ISLOWRES_ID,ljp_isLowRes);
	FtrSet(CREATORID, FTR_OPT_CONFIRMOW_ID,g_ljp_pref.g_confirmOW);
	FtrSet(CREATORID, FTR_OPT_CONFIRMSL_ID,g_ljp_pref.g_confirmSL);
#ifndef TESTGUI	
    res = ljp_PnoCall ( &pno, bridge );        

#endif    
    FtrUnregister(CREATORID, FTR_OPT_SHOWFRAMERATE_ID);
    FtrUnregister(CREATORID, FTR_OPT_SHOWBELTBAR_ID);
    FtrUnregister(CREATORID, FTR_OPT_SHOWBATTMODE_ID);
    FtrUnregister(CREATORID, FTR_OPT_ISLOWRES_ID);
    FtrUnregister(CREATORID, FTR_OPT_CONFIRMOW_ID);
    FtrUnregister(CREATORID, FTR_OPT_CONFIRMSL_ID);

	//free sys event
	{
		EventType myevent;
		for (;;)
		{
			EvtGetEvent(&myevent,0);
			if (myevent.eType==nilEvent) break;
			//SysHandleEvent(&myevent);
		}
	}
	#ifndef _ZIRE31_KEYS_
	KeySetMask(old_mask/*keyBitsAll*/);
	#endif
	KeyRates(true,&old_initDelay,&old_period,&old_initDblDelay,&old_queueAhead);	
	//unload pno
	res=ljp_PnoUnload ( &pno );
    if (res) {DEBUGS("Error while unloading PNO, probably not enough free ram.");DEBUGS(_name);}    	

    MemPtrFree(bridge);

   // rearrange memory   
    garbage_collect();

  } // is arm and rom picked

}

UInt32 UnzipToFtr(char *name,UInt16 Ftr){
	MemHandle memh;
	MemPtr ptr;
	PnoDescriptor pno;
	UInt32 res;
	pnobridge_t *bridge;	
	UInt16 pitch, width, height;

	memh = DmGetResource('LJPC', LJPC_ZLIB);
	if (!memh) {DEBUGS("Error while accessing zlib resource");return 1;}

	ptr = MemHandleLock(memh);

	if (!ptr){DEBUGS("Error while locking zlib resource");return 2;}	

	res=ljp_PnoLoad ( &pno, ptr,MemPtrSize(ptr) );
    FtrPtrFree ( CREATORID, FTR_PNO ); 
    if (res) {DEBUGS("Error while loading zlib pno");return 3;}
	//read memory to flush D cache
	FLUSH_D_CACHE

    bridge = (pnobridge_t*) MemPtrNew ( sizeof(pnobridge_t) );
    hw_guess_screen_dimensions ( &width, &height, &pitch );
    bridge -> vfs_max = palm_vfs_count();
    bridge -> vfs_vol = palm_vfs_iter();
    bridge -> vram = (UInt32) hw_query_vram();
    bridge -> eventf = (UInt32) host_event_handler;
    bridge -> display_width = width;
    bridge -> display_height = height;
    bridge -> display_pitch = pitch;
    bridge -> game_rom = (unsigned long)name;
    bridge -> audio_buf = (unsigned long)Ftr;
    bridge -> flags = BF_UNZIP;

    if (res=ljp_PnoCall ( &pno, bridge )) {DEBUGS("Error while unzipping");DEBUGU32(res);return 4;}
    MemPtrFree(bridge);
	//unload pno

	res=ljp_PnoUnload ( &pno );    		
    if (res) {DEBUGS("Error while unloading PNO(ZIP), probably not enough free ram.");}
   // rearrange memory

	garbage_collect();
	 		
	MemHandleUnlock(memh);
	DmReleaseResource(memh);
}

UInt32 LoadZippedModule(char *_name,PnoDescriptor *_pno){	
  UInt32 processor;
  FormPtr frmP = FrmGetActiveForm();
  UInt8 filetype;
  Err res;
  UInt16 initDelay;
  UInt16 period;
  Boolean queueAhead;
  MemPtr pnoPtr;
  char name[256];  
  
  
  UInt16 		volRefNum;			
  UInt32 		volIterator;
  Err			err = errNone;
  FILE          *f;
  
  // does emu module exist?
  volIterator = vfsIteratorStart;
  while (volIterator != vfsIteratorStop) 
  {
  	err = VFSVolumeEnumerate(&volRefNum, &volIterator);
	if (!err) {
		StrPrintF(name,"%1d:%s%s",volRefNum,__LJP_DIR__,_name);
		f = fopen ( name, "rf" ); // 'f' means: full path specified (not only file name) --Tinnus
    	if ( f ) {
      		break;
      	}
    }
  }
  
  if ( ! f ) {
      DEBUGS ( "File not found" );
      DEBUGS (name);
      return 1;
    }
  fclose(f);
    
  // call the PACE Native Object
  FtrGet(sysFtrCreator, sysFtrNumProcessorID, &processor);

  // rearrange memory
  garbage_collect();

  // fire up pno
  if ( sysFtrNumProcessorIsARM ( processor ) )
  {       	
	UInt32 pnoSize;
	UInt16 version;
  	UnzipToFtr(name,FTR_PNO);

	FtrGet(CREATORID, FTR_PNO, (void*)&pnoPtr);
	//check version
	version=((UInt16*)pnoPtr)[0];
	if (version!=VERSION_DB){
		char st[64];
		DEBUGS(".zem file has wrong version number. Please check your install.");
		StrPrintF(st," Version got/wanted : %02X/%02X",version,VERSION_DB);
		DEBUGS(st);
		FtrPtrFree ( CREATORID, FTR_PNO );
		return -1;
	} else {
		pnoSize = MemPtrSize(pnoPtr)-4;
		pnoPtr=(MemPtr)((char*)(pnoPtr)+4);
	}
	
	
    res=ljp_PnoLoad ( _pno, pnoPtr,pnoSize );
    FtrPtrFree ( CREATORID, FTR_PNO ); 
    if (res) {
		DEBUGS("Error while loading PNO, probably not enough free ram.");
		DEBUGS(_name);
		return 4;
    }
	//read memory to flush D cache
	FLUSH_D_CACHE
	return 0;
  }

  return 4;
}

UInt32 CallModule(int flags,UInt8 *mod_data,UInt32 size,PnoDescriptor _pno)
{
	UInt32 result;
	pnobridge_t *bridge = (pnobridge_t*) MemPtrNew ( sizeof(pnobridge_t) );
	UInt16 pitch, width, height;
	hw_guess_screen_dimensions ( &width, &height, &pitch );
	
    bridge -> vfs_max = palm_vfs_count();
    bridge -> vfs_vol = palm_vfs_iter();
    bridge -> vram = (UInt32) hw_query_vram();
    bridge -> eventf = (UInt32) host_event_handler;
    bridge -> display_width = width;
    bridge -> display_height = height;
    bridge -> display_pitch = pitch;
    bridge -> game_rom = (unsigned long)size;
    bridge -> audio_buf = (unsigned long)mod_data;
    bridge -> flags = flags;
    return ljp_PnoCall ( &_pno, bridge );        
}
	
void UnloadModule(PnoDescriptor _pno)
{
	UInt32 res;
	res=ljp_PnoUnload ( &_pno );    		
    if (res) {DEBUGS("Error while unloading pno");}    	
   // rearrange memory
    garbage_collect(); 	
}


UInt32 LJPLaunchModule(UInt16 system)
{
	DmSearchStateType sst;

	
	UInt32 res;
	res=0;		
	
	if (device_type&_ZODIAC_DEVICE_) {
		if (res=tw_gfx_init()) {DEBUGS("Cannot init Zodiac gfx");DEBUGU32(res);}
	}

	switch (system)
	{
		case SYS_SNES:
		LoadZippedModuleFromCard("ljp-snes.zem");
		break;
		case SYS_NES:
		LoadZippedModuleFromCard("ljp-nes.zem");				
		break;
		case SYS_GB:
		LoadZippedModuleFromCard("ljp-gb.zem");
		break;
		case SYS_NEOPOPZ:
		LoadZippedModuleFromCard("ljp-ngp.zem");
		break;
		case SYS_OSWANZ:
		LoadZippedModuleFromCard("ljp-ws.zem");
		break;
		case SYS_GENZ:
		LoadZippedModuleFromCard("ljp-gen.zem");
		break;
		case SYS_TG16Z:
		//LoadZippedModuleFromCard("ljp-tg16.zem");
		break;
		case SYS_SMS:
		case SYS_GG:
		LoadZippedModuleFromCard("ljp-sms.zem");
		break;
		case SYS_VCS:
		LoadZippedModuleFromCard("ljp-vcs.zem");
		break;
	}		

	if (device_type&_ZODIAC_DEVICE_) tw_gfx_close();

	return res;
}

UInt32 LJPMain(int recover_from_crash)
{
	UInt32 res = errNone;
	UInt16 exit_emu=0;
	unsigned short val,valbis;
	UInt32 val32;
	char c;
	
	//crash detection stuff	
	val=4;
	if (PrefGetAppPreferences(CREATORID,0x0002,(void*)&val32,(unsigned short*)&val,(unsigned char)1)!=VERSION_DB) val32=2;
	
	if (val32) {
		//LJP wasn't exit correctly
		DEBUGS("Recover from crash or first time launched :-)");
		g_launch_emu=0;
		AppStop(0);
		return 1;
	}
	//crash detection stuff	
	//put flag to "LJP is running"
	PrefSetAppPreferences(CREATORID,0x0002,(short)VERSION_DB,(void*)NULL,(short)0,(unsigned char)1);
	val32=1;
	PrefSetAppPreferences(CREATORID,0x0002,(short)VERSION_DB,(void*)&val32,(short)4,(unsigned char)1);
	
		
		if ( ! hw_set16bpp() ) {
   			 DEBUGS ( "Couldn't set to 16 bit colour!" );
   			 exit_emu=1;
   		}

   		device_type=0;  		
		{	UInt16 pitch, width, height;	
	    	hw_guess_screen_dimensions ( &width, &height, &pitch );
	    	/*if ((pitch>320)||(width>320)||(height>320)) */
	    	if (/*(pitch>320)||(width>320)||(height>320)*/hw_flags & hf_pin_present) 	    	
	    	{
	    		char text[64];
	    		//StrPrintF(text,"p%dw%dh%d : hi+ detected",pitch,width,height);
	    		//DEBUGS(text);
	    		device_type=_HIRES_PLUS_DEVICE_;
	    	}
	    	
	    	if ( (width==160) && (height==160) ) ljp_isLowRes=1;
	    }	    	    
	    if (is_zodiac()) device_type|=_ZODIAC_DEVICE_;
   		if (is_clie()) device_type|=_CLIE_DEVICE_;
   		

		if (!exit_emu)
		{						
			/*Setup dir if necessary*/
			CheckDirs();
			
			RegisterDirs();

			/* DEFAULT PREF */
			if (device_type&_ZODIAC_DEVICE_) {
				MemMove(&g_ljp_pref,&zodiac_default_pref,sizeof(t_ljp_pref));
			} else MemMove(&g_ljp_pref,&palm_default_pref,sizeof(t_ljp_pref));//InitPrefDefaultValues();
									
			/* LOAD PREF IF AVAILABLE WITH GOOD VERSION NUMBER*/
			
			/*val=1;
			if (PrefGetAppPreferences(CREATORID,0x0001,(void*)&c,(unsigned short*)&val,(unsigned char)1)==VERSION_DB) {
				val=sizeof(g_ljp_pref);
				PrefGetAppPreferences(CREATORID,0x0001,(void*)&g_ljp_pref,(unsigned short*)&val,(unsigned char)1);
			}*/
			{
				FILE *f;
				UInt16 volRefNum;			
				UInt32 volIterator; 
				Err err;
				char name[256];
			
				volIterator = vfsIteratorStart;
				while (volIterator != vfsIteratorStop) 
				{
				  	err = VFSVolumeEnumerate(&volRefNum, &volIterator);
					if (!err) {			
						StrPrintF(name,"%1d:%sljp.ini",volRefNum,__LJP_DIR__);
						f = fopen ( name, "rf" ); // 'f' means: full path specified (not only file name) --Tinnus
				    	if ( f ) {
      						break;
				      	}
			    	}
				}				
				if (f){
					UInt16 version=0;
					fread(&version,2,1,f);
					if (version==VERSION_DB){
						fseek(f,0,SEEK_SET);
						fread(&g_ljp_pref,sizeof(g_ljp_pref),1,f);
					} else {DEBUGS("Wrong version for ini file, reverting to default");}
					fclose(f);
				}
			}
			
			if (recover_from_crash) {
				InitPrefDefaultValues();
			} else {
				VerifyPrefValues();
			}
			
			/* init random seed */
			SysRandom(TimGetTicks());
			
			

			mod_started=0;
			mod_init=0;
			mod_launch=1;
			g_lowmem=0;
			g_num_entries=0;
			for (;;)
			{
						/*Start music*/
				if (g_ljp_pref.g_BGMusic){
					int i;
					switch (g_ljp_pref.g_sysfilter) {
						case SYS_NES:i=0;break;
						case SYS_SNES:i=1;break;
						case SYS_GB:i=2;break;
						case SYS_GENZ:i=3;break;
						case SYS_NEOPOPZ:i=4;break;
						case SYS_OSWANZ:i=5;break;					
						case SYS_TG16Z:i=6;break;
						case SYS_SMS:i=7;break;
						case SYS_GG:i=8;break;
						case SYS_VCS:i=9;break;
					}				
					
					Init_Mod();
					
					//Start_Mod(i);
					
				}											

				if (FrmGetActiveFormID()!=LauncherForm) {

					FrmGotoForm( LauncherForm );
				}
				else {

					FrmUpdateForm( LauncherForm ,0);
				}
				AppEventLoop();
				AppStop(1);			
																												
				if (g_launch_emu) 
				{									
					char *ptr;
					UInt32 val;													
  					  					  					  					
					RectangleType rclip;
					UInt16 err;
					WinHandle runningWnd,oldWnd;
					rclip.topLeft.x=0;
					rclip.topLeft.y=0;
					rclip.extent.x=160;
					rclip.extent.y=160;
					oldWnd=WinGetActiveWindow();
					runningWnd=WinCreateWindow( &rclip,noFrame,false,true, &err );
					if (err) runningWnd=NULL;									
					
					if (runningWnd)
					{
						
					
						//WinSetActiveWindow(runningWnd);
//#ifndef TESTING_ONLY								

						//draw beltbar	
						if (g_ljp_pref.g_showBeltbar) drawBeltBar();

						switch (g_rom_system)
						{

							case SYS_SNES:						
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[1][0]),20*4);
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_SnesLastCat),32);
							
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_SnesSmoothing);
							
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_SnesSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_SnesSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_SnesSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_SnesScreenMode);
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_SnesFSkip);
							FtrSet(CREATORID, FTR_OPT_CPUCORE_ID,g_ljp_pref.g_SnesASMCPU);
							FtrSet(CREATORID, FTR_OPT_FAST_SPR_ID, g_ljp_pref.g_SnesFastSprite);
							FtrSet(CREATORID, FTR_OPT_SNESRENDER_ID,g_ljp_pref.g_SnesRender);
							FtrSet(CREATORID, FTR_OPT_SNESTRANSP_ID,g_ljp_pref.g_SnesTransparency);
							FtrSet(CREATORID, FTR_OPT_SNESHACKS_ID,g_ljp_pref.g_SnesHack);
							
							if (g_ljp_pref.g_SnesScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_SNES);
							if (g_ljp_pref.g_SnesScreenMode>=2) {hw_set_FullscreenGraf(0);}
							
							/*res = TwLoadModule(0, 0, 0, 1, twLoadFlagTNA|twLoadFlagQuickRun, &entry);*/
							

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID, &val);g_ljp_pref.g_SnesSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_SnesSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_SnesSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_SnesSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_SnesScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_SnesFSkip=val;
							FtrGet(CREATORID, FTR_OPT_CPUCORE_ID,&val);g_ljp_pref.g_SnesASMCPU=val;
							FtrGet(CREATORID, FTR_OPT_FAST_SPR_ID, &val);g_ljp_pref.g_SnesFastSprite=val;
							FtrGet(CREATORID, FTR_OPT_SNESRENDER_ID,&val);g_ljp_pref.g_SnesRender=val;
							FtrGet(CREATORID, FTR_OPT_SNESTRANSP_ID,&val);g_ljp_pref.g_SnesTransparency=val;														
							FtrGet(CREATORID, FTR_OPT_SNESHACKS_ID,&val);g_ljp_pref.g_SnesHack=val;														
							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);														
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrUnregister(CREATORID, FTR_OPT_CPUCORE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FAST_SPR_ID);
							FtrUnregister(CREATORID, FTR_OPT_SNESRENDER_ID);
							FtrUnregister(CREATORID, FTR_OPT_SNESTRANSP_ID);
							FtrUnregister(CREATORID, FTR_OPT_SNESHACKS_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
							break;
							case SYS_NES:															
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,&(g_ljp_pref.g_inputconf[0][0]),20*4);
														
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_NesSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_NesSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_NesSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_NesSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_NesScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_NesFSkip);	
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_NesLastCat),32);
							
							//res = TwLoadModule(0, 0, 0, 2, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_NesScreenMode>=2) {hw_set_FullscreenGraf(1);}							
							res = LJPLaunchModule(SYS_NES);							
							if (g_ljp_pref.g_NesScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_NesSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_NesSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_NesSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_NesSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_NesScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_NesFSkip=val;	
							
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);							
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
							break;
							case SYS_GB:	
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[2][0]),20*4);
							
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_GBSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_GBSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_GBSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_GBSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_GBScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_GBFSkip);

							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_GBLastCat),32);
							
							//res = TwLoadModule(0, 0, 0, 3, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_GBScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_GB);
							if (g_ljp_pref.g_GBScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_GBSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_GBSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_GBSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_GBSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_GBScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_GBFSkip=val;

							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
							break;
							case SYS_GENZ:	
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[3][0]),20*4);
							
						
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_GENZSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_GENZSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_GENZSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_GENZSoundVol);							
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_GENZScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_GENZFSkip);	
							FtrSet(CREATORID, FTR_OPT_CPUCORE_ID,g_ljp_pref.g_GENZASMCPU);	
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_GENZLastCat),32);
							
							//res = TwLoadModule(0, 0, 0, 4, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_GENZScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_GENZ);
							if (g_ljp_pref.g_GENZScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_GENZSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_GENZSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_GENZSoundFreq=val;							
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_GENZSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_GENZScreenMode=val;							
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_GENZFSkip=val;
							FtrGet(CREATORID, FTR_OPT_CPUCORE_ID,&val);g_ljp_pref.g_GENZASMCPU=val;
							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrUnregister(CREATORID, FTR_OPT_CPUCORE_ID);	
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);						
							break;
						
							case SYS_NEOPOPZ:	
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[4][0]),20*4);
							
						
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_NEOPOPZSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_NEOPOPZSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_NEOPOPZSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_NEOPOPZSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_NEOPOPZScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_NEOPOPZFSkip);															
							FtrSet(CREATORID, FTR_OPT_EMU_ACCURACY_ID,g_ljp_pref.g_NEOPOPZEmuAccuracy);
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_NEOPOPZLastCat),32);
							
							//res = TwLoadModule(0, 0, 0, 5, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_NEOPOPZScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_NEOPOPZ);
							if (g_ljp_pref.g_NEOPOPZScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_NEOPOPZSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_NEOPOPZSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_NEOPOPZSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_NEOPOPZSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_NEOPOPZScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_NEOPOPZFSkip=val;
							FtrGet(CREATORID, FTR_OPT_EMU_ACCURACY_ID,&val);g_ljp_pref.g_NEOPOPZEmuAccuracy=val;
							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrUnregister(CREATORID, FTR_OPT_EMU_ACCURACY_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
							break;
										
					
							case SYS_OSWANZ:	
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[5][0]),20*4);
							
						
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_OSWANZSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_OSWANZSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_OSWANZSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_OSWANZSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_OSWANZScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_OSWANZFSkip);	
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_OSWANZLastCat),32);
							
							//res = TwLoadModule(0, 0, 0, 6, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_OSWANZScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_OSWANZ);
							if (g_ljp_pref.g_OSWANZScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_OSWANZSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_OSWANZSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_OSWANZSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_OSWANZSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_OSWANZScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_OSWANZFSkip=val;
							
							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);							
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
							break;
							
							case SYS_TG16Z:	
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[6][0]),20*4);
							
						
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_TG16ZSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_TG16ZSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_TG16ZSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_TG16ZSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_TG16ZScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_TG16ZFSkip);	
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_TG16ZLastCat),32);
							
							//res = TwLoadModule(0, 0, 0, 7, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_TG16ZScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_TG16Z);
							if (g_ljp_pref.g_TG16ZScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_TG16ZSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_TG16ZSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_TG16ZSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_TG16ZSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_TG16ZScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_TG16ZFSkip=val;

							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
							break;
							
							case SYS_SMS:	
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[7][0]),20*4);
							
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_SMSSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_SMSSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_SMSSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_SMSSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_SMSScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_SMSFSkip);
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_SMSLastCat),32);

							FtrSet(CREATORID, FTR_OPT_SMSGG_SYS_ID,1);	//1=SMS
							
							//res = TwLoadModule(0, 0, 0, 3, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_SMSScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_SMS);
							if (g_ljp_pref.g_SMSScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_SMSSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_SMSSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_SMSSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_SMSSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_SMSScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_SMSFSkip=val;

							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrUnregister(CREATORID, FTR_OPT_SMSGG_SYS_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
							break;
							
							case SYS_GG:	
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[8][0]),20*4);
							
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_GGSmoothing);
							
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_GGSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_GGSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_GGSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_GGSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_GGScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_GGFSkip);	
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_GGLastCat),32);
							
							FtrSet(CREATORID, FTR_OPT_SMSGG_SYS_ID,2);	//2=GG
							
							//res = TwLoadModule(0, 0, 0, 3, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_GGScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_GG);
							if (g_ljp_pref.g_GGScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_GGSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_GGSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_GGSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_GGSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_GGScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_GGFSkip=val;

							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrUnregister(CREATORID, FTR_OPT_SMSGG_SYS_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);
							break;
							
							case SYS_VCS:	
							FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_inputconf[9][0]),20*4);
							
							FtrSet(CREATORID, FTR_OPT_SMOOTHING_ID, g_ljp_pref.g_VCSSmoothing);
							FtrSet(CREATORID, FTR_OPT_SOUND_ID,g_ljp_pref.g_VCSSound);
							FtrSet(CREATORID, FTR_OPT_SOUNDFREQ_ID,g_ljp_pref.g_VCSSoundFreq);
							FtrSet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,g_ljp_pref.g_VCSSoundVol);
							FtrSet(CREATORID, FTR_OPT_SCREENMODE_ID,g_ljp_pref.g_VCSScreenMode);	
							FtrSet(CREATORID, FTR_OPT_FSKIP_ID,g_ljp_pref.g_VCSFSkip);	
							
							FtrPtrNew(CREATORID, FTR_OPT_CATEGORY_ID, 32, (void**)&ptr);
							DmWrite(ptr,0,(void*)&(g_ljp_pref.g_VCSLastCat),32);
							
							//res = TwLoadModule(0, 0, 0, 3, twLoadFlagTNA|twLoadFlagQuickRun, &entry);
							if (g_ljp_pref.g_VCSScreenMode>=2) {hw_set_FullscreenGraf(1);}
							res = LJPLaunchModule(SYS_VCS);

							if (g_ljp_pref.g_VCSScreenMode>=2) {hw_set_FullscreenGraf(0);}

							FtrGet(CREATORID, FTR_OPT_SMOOTHING_ID,&val);g_ljp_pref.g_VCSSmoothing=val;
							FtrGet(CREATORID, FTR_OPT_SOUND_ID,&val);g_ljp_pref.g_VCSSound=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDFREQ_ID,&val);g_ljp_pref.g_VCSSoundFreq=val;
							FtrGet(CREATORID, FTR_OPT_SOUNDVOLUME_ID,&val);g_ljp_pref.g_VCSSoundVol=val;
							FtrGet(CREATORID, FTR_OPT_SCREENMODE_ID,&val);g_ljp_pref.g_VCSScreenMode=val;
							FtrGet(CREATORID, FTR_OPT_FSKIP_ID,&val);g_ljp_pref.g_VCSFSkip=val;

							FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);

							FtrUnregister(CREATORID, FTR_OPT_SMOOTHING_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUND_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDFREQ_ID);
							FtrUnregister(CREATORID, FTR_OPT_SOUNDVOLUME_ID);
							FtrUnregister(CREATORID, FTR_OPT_SCREENMODE_ID);
							FtrUnregister(CREATORID, FTR_OPT_FSKIP_ID);
							FtrPtrFree(CREATORID, FTR_OPT_CATEGORY_ID);

							break;
						}

					FtrPtrFree(CREATORID, FTR_ROM_FILENAME_ID );						


					if (runningWnd) WinDeleteWindow(runningWnd,false);
					else
					{menu_inform("cannot free window");}
					WinSetActiveWindow(oldWnd);
					}			
					
					
					
				}
				else 
				{
					//FrmCloseAllForms();	
					break; //tmp bug fixes due to snes bug when snes launched 2 times
				}
				
			}								

        }


}

/***********************************************************************
 *
 * FUNCTION:    RomVersionCompatible
 *
 * DESCRIPTION: This routine checks that a ROM version is meet your
 *              minimum requirement.
 *
 * PARAMETERS:  requiredVersion - minimum rom version required
 *                                (see sysFtrNumROMVersion in SystemMgr.h 
 *                                for format)
 *              launchFlags     - flags that indicate if the application 
 *                                UI is initialized.
 *
 * RETURNED:    error code or zero if rom is compatible
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 romVersion;

	// See if we're on in minimum required version of the ROM or later.
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
		{
		if ((launchFlags & (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
			{
			FrmAlert (RomIncompatibleAlert);
		
			// Palm OS 1.0 will continuously relaunch this app unless we switch to 
			// another safe one.
			if (romVersion <= kPalmOS10Version)
				{
				AppLaunchWithCommand(sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL);
				}
			}
		
		return sysErrRomIncompatible;
		}

	return errNone;
}


/***********************************************************************
 *
 * FUNCTION:    PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    NativeFuncType* entry;
    UInt32 res;
	
	if (cmd == sysAppLaunchCmdNormalLaunch) 
	{	
		res=0;
		if (!RomVersionCompatible(kOurMinVersion, launchFlags)) 
			res=LJPMain(0);
		if (res==1) res=LJPMain(1);
		
	}
	
	
	/*if (cmd == sysAppLaunchCmdNotify) 
	{	
		SysNotifyUnregister(0,CREATORID,sysNotifyResetFinishedEvent,128);
	
		res=0;
		if (!RomVersionCompatible(kOurMinVersion, launchFlags)) 
			res=LJPMain();		
		
	}*/
	
	return res;
}


